/*
Navicat MySQL Data Transfer

Source Server         : localhost
Source Server Version : 50152
Source Host           : localhost:3306
Source Database       : chopdb

Target Server Type    : MYSQL
Target Server Version : 50152
File Encoding         : 65001

Date: 2011-04-21 21:15:39
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for `badges`
-- ----------------------------
DROP TABLE IF EXISTS `badges`;
CREATE TABLE `badges` (
  `userid` int(10) NOT NULL,
  `id` varchar(10) NOT NULL,
  `current` enum('0','1') NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of badges
-- ----------------------------
INSERT INTO badges VALUES ('1', 'ADM', '1');
INSERT INTO badges VALUES ('1', 'HC1', '0');

-- ----------------------------
-- Table structure for `bans`
-- ----------------------------
DROP TABLE IF EXISTS `bans`;
CREATE TABLE `bans` (
  `habboid` int(10) NOT NULL,
  `ip` varchar(40) NOT NULL,
  `message` varchar(50) NOT NULL,
  `expires` varchar(10) NOT NULL,
  PRIMARY KEY (`habboid`,`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of bans
-- ----------------------------

-- ----------------------------
-- Table structure for `bobbafilter`
-- ----------------------------
DROP TABLE IF EXISTS `bobbafilter`;
CREATE TABLE `bobbafilter` (
  `word` varchar(30) NOT NULL,
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of bobbafilter
-- ----------------------------
INSERT INTO bobbafilter VALUES ('bieber');
INSERT INTO bobbafilter VALUES ('cock');
INSERT INTO bobbafilter VALUES ('fuck');
INSERT INTO bobbafilter VALUES ('pussy');

-- ----------------------------
-- Table structure for `catalogue_deals`
-- ----------------------------
DROP TABLE IF EXISTS `catalogue_deals`;
CREATE TABLE `catalogue_deals` (
  `id` int(10) NOT NULL COMMENT 'The ID of this deal [the part after "deal"]',
  `tid` int(10) NOT NULL COMMENT 'The template ID of the item that should be in this deal',
  `amount` int(10) NOT NULL COMMENT 'The amount, of how many items of the type _TID should be in this deal',
  KEY `id` (`id`),
  KEY `tid` (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of catalogue_deals
-- ----------------------------
INSERT INTO catalogue_deals VALUES ('2249', '272', '1');
INSERT INTO catalogue_deals VALUES ('2249', '325', '1');
INSERT INTO catalogue_deals VALUES ('2249', '485', '1');
INSERT INTO catalogue_deals VALUES ('2249', '270', '2');
INSERT INTO catalogue_deals VALUES ('2249', '484', '1');
INSERT INTO catalogue_deals VALUES ('2249', '69', '3');
INSERT INTO catalogue_deals VALUES ('2249', '72', '1');
INSERT INTO catalogue_deals VALUES ('2249', '318', '2');
INSERT INTO catalogue_deals VALUES ('2249', '76', '1');
INSERT INTO catalogue_deals VALUES ('2249', '410', '1');
INSERT INTO catalogue_deals VALUES ('2249', '328', '1');
INSERT INTO catalogue_deals VALUES ('2249', '312', '1');
INSERT INTO catalogue_deals VALUES ('2249', '313', '3');
INSERT INTO catalogue_deals VALUES ('2249', '402', '1');
INSERT INTO catalogue_deals VALUES ('2249', '352', '4');
INSERT INTO catalogue_deals VALUES ('2249', '41', '6');
INSERT INTO catalogue_deals VALUES ('2249', '42', '6');
INSERT INTO catalogue_deals VALUES ('2249', '43', '6');
INSERT INTO catalogue_deals VALUES ('2249', '44', '6');
INSERT INTO catalogue_deals VALUES ('2249', '0', '0');

-- ----------------------------
-- Table structure for `catalogue_items`
-- ----------------------------
DROP TABLE IF EXISTS `catalogue_items`;
CREATE TABLE `catalogue_items` (
  `tid` int(10) NOT NULL AUTO_INCREMENT COMMENT 'The template ID of this item. Unique',
  `name_cct` varchar(110) COLLATE latin1_general_ci NOT NULL COMMENT 'The CCT name [sprite] of this item',
  `typeid` int(1) NOT NULL COMMENT 'The typeid of this item. 0 = poster/null, 1 = solid, 2 = seat, 3 = bed, 4 = rug',
  `length` int(2) NOT NULL COMMENT 'The length of this item',
  `width` int(2) NOT NULL COMMENT 'The width of this item',
  `top` double(4,2) NOT NULL COMMENT 'The top of this item, used with stacking/sitting [the height of this item]',
  `colour` varchar(100) COLLATE latin1_general_ci NOT NULL COMMENT 'The colour of this item, default = 0,0,0, but HTML colors are useable too',
  `door` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0' COMMENT 'Specifies if this item can be used as door true/false.',
  `tradeable` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '1' COMMENT 'Specifies if this item can be traded between users',
  `recycleable` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '1' COMMENT 'Specifies if this item is allowed to put in the Recycler',
  `catalogue_id_page` int(3) NOT NULL COMMENT 'Specifies the ID of the catalogue page this item is on. -1 = on no page, set this for items that arent''in catalogue but have to be cached [or previous bought instances will appear as PH boxes]',
  `catalogue_id_index` int(5) NOT NULL COMMENT 'The index of this item on _CATALOGUE_ID_PAGE. If this is 1, then it appears as first on the page. Sorted ascending',
  `catalogue_name` varchar(100) COLLATE latin1_general_ci NOT NULL DEFAULT '' COMMENT 'The displayname of this item in the catalogue',
  `catalogue_description` varchar(200) COLLATE latin1_general_ci NOT NULL COMMENT 'The description of this item in the catalogue',
  `catalogue_cost` int(5) NOT NULL COMMENT 'The price of this item in the catalogue',
  PRIMARY KEY (`tid`)
) ENGINE=MyISAM AUTO_INCREMENT=1002 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of catalogue_items
-- ----------------------------
INSERT INTO catalogue_items VALUES ('1', 'rare_parasol*0', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#94f718', '0', '1', '1', '6', '1', 'Green Parasol', 'Block those rays!', '25');
INSERT INTO catalogue_items VALUES ('2', 'floor', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '2', 'floor', 'Floor', '3');
INSERT INTO catalogue_items VALUES ('3', 'wallpaper 1', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '3', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('4', 'wallpaper 2', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '4', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('5', 'wallpaper 3', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '5', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('6', 'wallpaper 4', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '6', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('7', 'wallpaper 5', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '7', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('8', 'wallpaper 6', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '8', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('9', 'wallpaper 7', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '9', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('10', 'wallpaper 8', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '10', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('11', 'wallpaper 9', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '11', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('12', 'wallpaper 10', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '12', 'wallpaper', 'wallpaper', '3');
INSERT INTO catalogue_items VALUES ('13', 'wallpaper 11', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '13', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('14', 'wallpaper 12', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '14', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('15', 'wallpaper 13', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '15', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('16', 'wallpaper 14', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '16', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('17', 'wallpaper 15', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '17', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('18', 'wallpaper 16', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '18', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('19', 'wallpaper 17', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '19', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('20', 'wallpaper 18', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '20', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('21', 'wallpaper 19', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '21', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('22', 'wallpaper 20', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '22', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('23', 'wallpaper 21', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '23', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('24', 'wallpaper 22', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '24', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('25', 'wallpaper 23', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '25', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('26', 'wallpaper 24', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '26', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('27', 'wallpaper 25', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '27', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('28', 'wallpaper 26', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '28', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('29', 'wallpaper 27', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '29', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('30', 'wallpaper 28', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '30', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('31', 'wallpaper 29', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '31', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('32', 'wallpaper 30', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '32', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('33', 'wallpaper 31', '0', '0', '0', '0.00', '0', '0', '0', '0', '7', '33', 'wallpaper', 'wallpaper', '5');
INSERT INTO catalogue_items VALUES ('34', 'nest', '1', '1', '1', '0.00', '0,0,0', '0', '0', '1', '8', '34', 'Basket', 'Night, night', '20');
INSERT INTO catalogue_items VALUES ('35', 'nest', '1', '1', '1', '0.00', '0,0,0', '0', '0', '1', '8', '35', 'Basket', 'Night, night', '20');
INSERT INTO catalogue_items VALUES ('36', 'nest', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '8', '36', 'Basket', 'Night, night', '20');
INSERT INTO catalogue_items VALUES ('37', 'deal97', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '0', '37', 'Doggy Bones', 'Natural nutrition for the barking one', '2');
INSERT INTO catalogue_items VALUES ('38', 'deal98', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '0', '38', 'Sardines', 'Fresh catch of the day', '2');
INSERT INTO catalogue_items VALUES ('39', 'deal99', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '0', '39', 'Cabbage', 'Health food for pets', '2');
INSERT INTO catalogue_items VALUES ('40', 'deal96', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '0', '40', 'T-Bones', 'For the croc!', '2');
INSERT INTO catalogue_items VALUES ('41', 'petfood1', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '9', '41', 'Doggy Bones', 'Natural nutrition for the barking one', '1');
INSERT INTO catalogue_items VALUES ('42', 'petfood2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '9', '42', 'Sardines', 'Fresh catch of the day', '1');
INSERT INTO catalogue_items VALUES ('43', 'petfood3', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '9', '43', 'Cabbage', 'Health food for pets', '1');
INSERT INTO catalogue_items VALUES ('44', 'petfood4', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '9', '44', 'T-Bones', 'For the croc!', '1');
INSERT INTO catalogue_items VALUES ('45', 'waterbowl*1', '1', '1', '1', '0.00', '#ff3f3f,#ffffff,#ffffff', '0', '1', '1', '9', '45', 'Red Water Bowl', 'Aqua unlimited', '2');
INSERT INTO catalogue_items VALUES ('46', 'waterbowl*2', '1', '1', '1', '0.00', '#3fff3f,#ffffff,#ffffff', '0', '1', '1', '9', '46', 'Green Water Bowl', 'Aqua unlimited', '2');
INSERT INTO catalogue_items VALUES ('47', 'waterbowl*3', '1', '1', '1', '0.00', '#ffff00,#ffffff,#ffffff', '0', '1', '1', '9', '47', 'Yellow Water Bowl', 'Aqua unlimited', '2');
INSERT INTO catalogue_items VALUES ('48', 'waterbowl*4', '1', '1', '1', '0.00', '#0099ff,#ffffff,#ffffff', '0', '1', '1', '9', '48', 'Blue Water Bowl', 'Aqua unlimited', '2');
INSERT INTO catalogue_items VALUES ('49', 'waterbowl*5', '1', '1', '1', '0.00', '#bf7f00,#ffffff,#ffffff', '0', '1', '1', '9', '49', 'Brown Water Bowl', 'Aqua unlimited', '2');
INSERT INTO catalogue_items VALUES ('50', 'goodie2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '9', '50', 'Chocolate Mouse', 'For gourmet kittens', '1');
INSERT INTO catalogue_items VALUES ('51', 'goodie1', '1', '1', '1', '0.00', '#ff4cbf,#ffffff', '0', '1', '1', '9', '51', 'Marzipan Man', 'Crunchy Dog Treat', '1');
INSERT INTO catalogue_items VALUES ('52', 'goodie1*1', '1', '1', '1', '0.00', '#3fffff,#ffffff', '0', '1', '1', '9', '52', 'Marzipan Man', 'Crunchy Dog Treat', '1');
INSERT INTO catalogue_items VALUES ('53', 'goodie1*2', '1', '1', '1', '0.00', '#ffbf00,#ffffff', '0', '1', '1', '9', '53', 'Marzipan Man', 'Crunchy Dog Treat', '1');
INSERT INTO catalogue_items VALUES ('54', 'toy1', '1', '1', '1', '0.00', '#ff0000,#ffff00,#ffffff,#ffffff', '0', '1', '1', '9', '54', 'Rubber Ball', 'it\'s bouncy-tastic', '2');
INSERT INTO catalogue_items VALUES ('55', 'toy1*1', '1', '1', '1', '0.00', '#ff7f00,#007f00,#ffffff,#ffffff', '0', '1', '1', '9', '55', 'Rubber Ball', 'it\'s bouncy-tastic', '2');
INSERT INTO catalogue_items VALUES ('56', 'toy1*2', '1', '1', '1', '0.00', '#003f7f,#ff00bf,#ffffff,#ffffff', '0', '1', '1', '9', '56', 'Rubber Ball', 'it\'s bouncy-tastic', '2');
INSERT INTO catalogue_items VALUES ('57', 'toy1*3', '1', '1', '1', '0.00', '#bf1900,#00bfbf,#ffffff,#ffffff', '0', '1', '1', '9', '57', 'Rubber Ball', 'it\'s bouncy-tastic', '2');
INSERT INTO catalogue_items VALUES ('58', 'toy1*4', '1', '1', '1', '0.00', '#000000,#ffffff,#ffffff,#ffffff', '0', '1', '1', '9', '58', 'Rubber Ball', 'it\'s bouncy-tastic', '2');
INSERT INTO catalogue_items VALUES ('59', 'silo_studydesk', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '10', '59', 'Area Quest Desk', 'For the true Habbo Scholars', '15');
INSERT INTO catalogue_items VALUES ('60', 'bed_silo_two', '3', '2', '3', '2.00', '0,0,0', '0', '1', '1', '10', '60', 'Double Bed', 'Plain and simple x2', '3');
INSERT INTO catalogue_items VALUES ('61', 'bed_silo_one', '3', '1', '3', '2.00', '0,0,0', '0', '1', '1', '10', '61', 'Single Bed', 'Plain and simple', '3');
INSERT INTO catalogue_items VALUES ('62', 'shelves_silo', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '10', '62', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('63', 'sofa_silo', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#A2C6C8,#A2C6C8,#A2C6C8,#A2C6C8', '0', '1', '1', '10', '63', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('64', 'sofachair_silo', '1', '1', '1', '1.00', '#ffffff,#ffffff,#A2C6C8,#A2C6C8,#ffffff', '0', '1', '1', '10', '64', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('65', 'table_silo_small', '1', '1', '1', '1.10', '#ffffff,#A2C6C8,#ffffff,#A2C6C8', '0', '1', '1', '10', '65', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('66', 'divider_silo3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#A2C6C8', '1', '1', '1', '10', '66', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('67', 'divider_silo2', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '10', '67', 'Screen', 'Stylish sectioning', '3');
INSERT INTO catalogue_items VALUES ('68', 'divider_silo1', '1', '1', '1', '0.00', '#ffffff,#A2C6C8,0,#A2C6C8', '0', '1', '1', '10', '68', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('69', 'chair_silo', '2', '1', '1', '1.10', '#ffffff,#ffffff,#A2C6C8,#A2C6C8,#ffffff', '0', '1', '1', '10', '69', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('70', 'safe_silo', '1', '1', '1', '1.20', '#ffffff,#A2C6C8,#ffffff', '0', '1', '1', '10', '70', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('71', 'barchair_silo', '1', '1', '1', '0.90', '#ffffff,#A2C6C8,#ffffff', '0', '1', '1', '10', '71', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('72', 'table_silo_med', '1', '2', '2', '0.90', '#ffffff,#8FAEAF', '0', '1', '1', '10', '72', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('73', 'tv_luxus', '1', '1', '3', '0.00', '0,0,0', '0', '1', '1', '11', '73', 'Digital TV', 'Bang up to date', '6');
INSERT INTO catalogue_items VALUES ('74', 'wood_tv', '1', '1', '2', '0.00', '0,0,0', '0', '1', '1', '11', '74', 'Large TV', 'For family viewing', '4');
INSERT INTO catalogue_items VALUES ('75', 'red_tv', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '75', 'Portable TV', 'Don\'t miss those soaps', '3');
INSERT INTO catalogue_items VALUES ('76', 'post.it', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '11', '76', 'Pad of stickies', 'Pad of stickies', '3');
INSERT INTO catalogue_items VALUES ('77', 'pizza', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '77', 'Pizza Box', 'You dirty Habbo', '3');
INSERT INTO catalogue_items VALUES ('78', 'drinks', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '78', 'Empty Cans', 'Are you a slob too?', '3');
INSERT INTO catalogue_items VALUES ('79', 'bottle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '79', 'Empty Spinning Bottle', 'For interesting games!', '3');
INSERT INTO catalogue_items VALUES ('80', 'edice', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '80', 'Holo-dice', 'What\'s your lucky number?', '6');
INSERT INTO catalogue_items VALUES ('81', 'habbocake', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '81', 'Cake', 'Save me a slice!', '4');
INSERT INTO catalogue_items VALUES ('82', 'menorah', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '82', 'Menorah', 'Light up your room', '3');
INSERT INTO catalogue_items VALUES ('83', 'bunny', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '83', 'Squidgy Bunny', 'Yours to cuddle up to', '3');
INSERT INTO catalogue_items VALUES ('84', 'poster 44', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '11', '84', 'Mummy', 'Beware the curse...', '3');
INSERT INTO catalogue_items VALUES ('85', 'wcandleset', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '85', 'White Candle Plate', 'Simple but stylish', '3');
INSERT INTO catalogue_items VALUES ('86', 'rcandleset', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '86', 'Red Candle Plate', 'Simple but stylish', '3');
INSERT INTO catalogue_items VALUES ('87', 'ham', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '87', 'Joint of Ham', 'Tuck in', '3');
INSERT INTO catalogue_items VALUES ('88', 'hockey_light', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '11', '88', 'Lert', 'Set it off.', '5');
INSERT INTO catalogue_items VALUES ('89', 'wall_china', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '12', '89', 'Drakenscherm', 'Voor je eigen Grote Muur', '8');
INSERT INTO catalogue_items VALUES ('90', 'corner_china', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '12', '90', 'Voor Grote Muur', 'Stevig en vuurvast', '8');
INSERT INTO catalogue_items VALUES ('91', 'china_shelve', '2', '2', '1', '0.00', '0,0,0', '0', '1', '1', '12', '91', 'Lakwerk boekenkast', 'Bewaarder van je boekenschat', '8');
INSERT INTO catalogue_items VALUES ('92', 'china_table', '1', '1', '1', '0.90', '0,0,0', '0', '1', '1', '12', '92', 'Yin Yang tafel', 'Exotic and classy', '5');
INSERT INTO catalogue_items VALUES ('93', 'chair_china', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '12', '93', 'Yin Yang stoel', 'Zitten in evenwicht', '5');
INSERT INTO catalogue_items VALUES ('94', 'poster 57', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '12', '94', 'Kalligrafie', 'Een kwast, vaste hand en concentratie', '3');
INSERT INTO catalogue_items VALUES ('95', 'poster 58', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '12', '95', 'Chinese rode knopen', 'Veel geluk!', '5');
INSERT INTO catalogue_items VALUES ('96', 'cn_sofa', '2', '3', '1', '1.00', '0,0,0', '0', '1', '1', '12', '96', 'Yin Yang bank', 'Zitten in evenwicht!', '10');
INSERT INTO catalogue_items VALUES ('97', 'cn_lamp', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '12', '97', 'Rode lantaarn', 'Zacht licht voor je Habbo Kamer', '15');
INSERT INTO catalogue_items VALUES ('98', 'bath', '2', '1', '2', '1.00', '0,0,0', '0', '1', '1', '13', '98', 'Bubble Bath', 'The ultimate in pampering', '6');
INSERT INTO catalogue_items VALUES ('99', 'sink', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '13', '99', 'Sink', 'Hot and cold thrown in for no charge', '3');
INSERT INTO catalogue_items VALUES ('100', 'duck', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '13', '100', 'Rubber Duck', 'Every bather needs one', '1');
INSERT INTO catalogue_items VALUES ('101', 'toilet', '2', '1', '1', '1.10', '0,0,0', '0', '1', '1', '13', '101', 'Loo Seat', 'Loo Seat', '4');
INSERT INTO catalogue_items VALUES ('102', 'toilet_red', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '13', '102', 'Loo Seat', 'Loo Seat', '4');
INSERT INTO catalogue_items VALUES ('103', 'toilet_yell', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '13', '103', 'Loo Seat', 'Loo Seat', '4');
INSERT INTO catalogue_items VALUES ('104', 'tile', '4', '4', '4', '0.00', '0,0,0', '0', '1', '1', '13', '104', 'Floor Tiles', 'In a choice of colours', '3');
INSERT INTO catalogue_items VALUES ('105', 'tile_red', '4', '4', '4', '0.00', '0,0,0', '0', '1', '1', '13', '105', 'Floor Tiles', 'In a choice of colours', '3');
INSERT INTO catalogue_items VALUES ('106', 'tile_yell', '4', '4', '4', '0.00', '0,0,0', '0', '1', '1', '13', '106', 'Floor Tiles', 'In a choice of colours', '3');
INSERT INTO catalogue_items VALUES ('107', 'bardesk_polyfon*5', '1', '2', '1', '1.00', '#ffffff,#ffffff,#FF9BBD,#FF9BBD', '0', '1', '1', '14', '107', 'Candy Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('108', 'bardeskcorner_polyfon*5', '1', '1', '1', '1.10', '#ffffff,#FF9BBD', '0', '1', '1', '14', '108', 'Candy Corner', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('109', 'divider_poly3*5', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '14', '109', 'Candy Hatch (lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('110', 'sofachair_polyfon_girl', '2', '1', '1', '1.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '14', '110', 'Armchair', 'Think pink', '3');
INSERT INTO catalogue_items VALUES ('111', 'sofa_polyfon_girl', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#E', '0', '1', '1', '14', '111', 'Two-seater Sofa', 'Romantic pink for two', '4');
INSERT INTO catalogue_items VALUES ('112', 'carpet_polar*1', '4', '2', '3', '0.00', '#ffbbcf,#ffbbcf,#ffddef', '0', '1', '1', '14', '112', 'Pink Faux-Fur', 'Bear Rug Cute', '4');
INSERT INTO catalogue_items VALUES ('113', 'bed_polyfon_girl_one', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '14', '113', 'Armchair', 'Think pink', '3');
INSERT INTO catalogue_items VALUES ('114', 'bed_polyfon_girl', '3', '2', '3', '2.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '14', '114', 'Double Bed', 'Snuggle down in princess pink', '4');
INSERT INTO catalogue_items VALUES ('115', 'camera', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '15', '115', 'Camera', 'Smile!', '10');
INSERT INTO catalogue_items VALUES ('116', 'photo_film', '0', '0', '0', '0.00', '0,0,0', '0', '0', '0', '15', '116', 'Film', 'Film for five photos', '6');
INSERT INTO catalogue_items VALUES ('117', 'poster 500', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '117', 'Union Jack', 'The UK flag', '3');
INSERT INTO catalogue_items VALUES ('118', 'poster 501', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '118', 'Jolly Roger', 'For pirates everywhere', '3');
INSERT INTO catalogue_items VALUES ('119', 'poster 502', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '119', 'The Stars and Stripes', 'The US flag', '3');
INSERT INTO catalogue_items VALUES ('120', 'poster 503', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '120', 'The Swiss flag', 'There\'s no holes in this...', '3');
INSERT INTO catalogue_items VALUES ('121', 'poster 504', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '121', 'The Bundesflagge', 'The German flag', '3');
INSERT INTO catalogue_items VALUES ('122', 'poster 505', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '122', 'The Maple Leaf', 'The Canadian flag', '3');
INSERT INTO catalogue_items VALUES ('123', 'poster 506', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '123', 'The flag of Finland', 'To \'Finnish\' your decor...', '3');
INSERT INTO catalogue_items VALUES ('124', 'poster 507', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '124', 'The French Tricolore', 'The French flag', '3');
INSERT INTO catalogue_items VALUES ('125', 'poster 508', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '125', 'The Spanish flag', 'The flag of Spain', '3');
INSERT INTO catalogue_items VALUES ('126', 'poster 509', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '126', 'The Jamaican flag', 'The flag of Jamaica', '3');
INSERT INTO catalogue_items VALUES ('127', 'poster 510', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '127', 'The Italian flag', 'The flag of Italy', '3');
INSERT INTO catalogue_items VALUES ('128', 'poster 511', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '128', 'The Dutch flag', 'The flag of The Netherlands', '3');
INSERT INTO catalogue_items VALUES ('129', 'poster 512', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '129', 'The Irish flag', 'The flag of Ireland', '3');
INSERT INTO catalogue_items VALUES ('130', 'poster 513', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '130', 'The Australian flag', 'Aussies rule!', '3');
INSERT INTO catalogue_items VALUES ('131', 'poster 514', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '131', 'The EU flag', 'Be proud to be in the Union!', '3');
INSERT INTO catalogue_items VALUES ('132', 'poster 515', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '132', 'The Swedish flag', 'Waved by Swedes everywhere', '3');
INSERT INTO catalogue_items VALUES ('133', 'poster 516', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '133', 'The English flag', 'Eng-er-land', '3');
INSERT INTO catalogue_items VALUES ('134', 'poster 517', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '134', 'The Scottish flag', 'Where\'s your kilt?', '3');
INSERT INTO catalogue_items VALUES ('135', 'poster 518', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '135', 'The Welsh flag', 'A fiery dragon for your wall', '3');
INSERT INTO catalogue_items VALUES ('136', 'poster 520', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '136', 'The Rainbow Flag', 'Every colour for everyone', '3');
INSERT INTO catalogue_items VALUES ('137', 'poster 521', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '137', 'Flag of Brazil', 'The flag of Brazil', '3');
INSERT INTO catalogue_items VALUES ('138', 'poster 522', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '138', 'The flag of Japan', 'The flag of Japan', '3');
INSERT INTO catalogue_items VALUES ('139', 'poster 523', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '16', '139', 'The flag of India', 'The flag of India', '3');
INSERT INTO catalogue_items VALUES ('140', 'poster 2001', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '140', 'Rug on the wall', 'Rug', '10');
INSERT INTO catalogue_items VALUES ('141', 'poster 2004', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '141', 'Rastaman', 'Rasta tarjoaa rakkautta', '3');
INSERT INTO catalogue_items VALUES ('142', 'poster 2002', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '142', 'Presidentin Muotokuva', 'Presidentin Muotokuva', '10');
INSERT INTO catalogue_items VALUES ('143', 'poster 7', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '143', 'Hammer Cabinet', 'for emergencies only', '3');
INSERT INTO catalogue_items VALUES ('144', 'poster 12', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '144', 'Skyline Poster', 'skyscrapers at night', '3');
INSERT INTO catalogue_items VALUES ('145', 'poster 13', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '145', 'BW Skyline Poster', 'skyscrapers in arty black and white', '3');
INSERT INTO catalogue_items VALUES ('146', 'poster 14', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '146', 'Fox Poster', 'a truly cunning design', '3');
INSERT INTO catalogue_items VALUES ('147', 'poster 17', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '147', 'Butterfly Cabinet', 'beautiful reproduction butterfly', '3');
INSERT INTO catalogue_items VALUES ('148', 'poster 18', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '148', 'Butterfly Cabinet (blue)', 'beautiful reproduction butterfly', '3');
INSERT INTO catalogue_items VALUES ('149', 'poster 16', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '149', 'Bars', 'high security for your room', '3');
INSERT INTO catalogue_items VALUES ('150', 'poster 1003', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '150', 'UK Map', 'get the lovely isles on your walls', '3');
INSERT INTO catalogue_items VALUES ('151', 'poster 15', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '151', 'Himalaya Poster', 'marvellous mountains', '3');
INSERT INTO catalogue_items VALUES ('152', 'poster 1006', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '152', 'Hoot Poster', 'The eyes follow you...', '3');
INSERT INTO catalogue_items VALUES ('153', 'poster 32', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '153', 'Siva Poster', 'The Auspicious One', '3');
INSERT INTO catalogue_items VALUES ('154', 'poster 33', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '154', 'Save the Panda', 'We can\'t bear to lose them', '3');
INSERT INTO catalogue_items VALUES ('155', 'poster 2', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '155', 'Carrot Plaque', 'take pride in your veg!', '3');
INSERT INTO catalogue_items VALUES ('156', 'poster 3', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '156', 'Fish Plaque', 'smells fishy, looks cool', '3');
INSERT INTO catalogue_items VALUES ('157', 'poster 4', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '157', 'Bear Plaque', 'fake of course!', '3');
INSERT INTO catalogue_items VALUES ('158', 'poster 5', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '158', 'Duck Poster', 'quacking good design!', '3');
INSERT INTO catalogue_items VALUES ('159', 'poster 1', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '159', 'Ancestor Poster', 'a touch of history', '3');
INSERT INTO catalogue_items VALUES ('160', 'poster 6', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '160', 'Abstract Poster', 'but is it the right way up?', '3');
INSERT INTO catalogue_items VALUES ('161', 'poster 1002', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '161', 'Queen Mum Poster', 'aw, bless...', '3');
INSERT INTO catalogue_items VALUES ('162', 'poster 1001', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '162', 'Prince Charles Poster', 'Even walls have ears', '3');
INSERT INTO catalogue_items VALUES ('163', 'poster 8', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '163', 'Habbo Colours Poster', 'Habbos come in all colours', '3');
INSERT INTO catalogue_items VALUES ('164', 'poster 9', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '164', 'Rainforest Poster', 'do your bit for the environment', '3');
INSERT INTO catalogue_items VALUES ('165', 'poster 1004', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '165', 'Eid Mubarak', 'Celebrate with us', '3');
INSERT INTO catalogue_items VALUES ('166', 'poster 2006', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '166', 'DJ Throne', 'He is the magic Habbo', '3');
INSERT INTO catalogue_items VALUES ('167', 'poster 2008', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '167', 'Green Gecko Art', 'Like a gecko it wont fall of your wall', '3');
INSERT INTO catalogue_items VALUES ('168', 'poster 11', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '168', 'Certificate', 'award, charter or the Habbo Way - you decide', '3');
INSERT INTO catalogue_items VALUES ('169', 'poster 41', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '169', 'Habbo Golden Record', 'For the best music-makers', '3');
INSERT INTO catalogue_items VALUES ('170', 'poster 40', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '170', 'Bonnie Blonde', 'The one and only. Adore her!', '3');
INSERT INTO catalogue_items VALUES ('171', 'poster 35', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '171', 'The Habbo Babes 1', 'The Hotel\'s girlband. Dream on!', '3');
INSERT INTO catalogue_items VALUES ('172', 'poster 36', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '172', 'The Habbo Babes 2', 'The Hotel\'s girlband. Dream on!', '3');
INSERT INTO catalogue_items VALUES ('173', 'poster 37', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '173', 'The Habbo Babes 3', 'The Hotel\'s girlband. Dream on!', '3');
INSERT INTO catalogue_items VALUES ('174', 'poster 1005', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '174', 'Johnny Squabble', 'The muscly movie hero', '3');
INSERT INTO catalogue_items VALUES ('175', 'poster 34', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '175', 'Scamme\'d', 'Habbo-punk for the never-agreeing', '3');
INSERT INTO catalogue_items VALUES ('176', 'poster 39', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '176', 'Screaming Furnies', 'The rock masters of virtual music', '3');
INSERT INTO catalogue_items VALUES ('177', 'poster 2000', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '177', 'Suomen kartta', 'Suomen kartta', '3');
INSERT INTO catalogue_items VALUES ('178', 'poster 38', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '178', 'Smiling Headbangerz', 'For really TOUGH Habbos!', '3');
INSERT INTO catalogue_items VALUES ('179', 'poster 2008', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '179', 'Habbo Cola Poster', 'For serious bubblers', '3');
INSERT INTO catalogue_items VALUES ('180', 'poster 2007', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '180', 'The Father Of Habbo', 'The legendary founder of the Hotel', '3');
INSERT INTO catalogue_items VALUES ('181', 'poster 2003', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '181', 'Dodgy Geezer', 'Would you trust this man?', '3');
INSERT INTO catalogue_items VALUES ('182', 'poster 31', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '182', 'System of a Ban', 'Pure and unbridled nu-metal', '3');
INSERT INTO catalogue_items VALUES ('183', 'poster 55', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '17', '183', 'Beach Tree Poster', 'Natural', '3');
INSERT INTO catalogue_items VALUES ('184', 'glass_shelf', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '18', '184', 'Glass shelf', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('185', 'glass_sofa', '2', '2', '1', '1.10', '#ffffff,#ABD0D2,#ABD0D2,#ffffff,#ffffff,#ABD0D2,#ffffff,#ABD0D2', '0', '1', '1', '18', '185', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('186', 'glass_table', '1', '2', '2', '0.90', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '0', '1', '1', '18', '186', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('187', 'glass_chair', '2', '1', '1', '1.10', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '0', '1', '1', '18', '187', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('188', 'glass_stool', '2', '1', '1', '1.10', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '0', '1', '1', '18', '188', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('189', 'glass_sofa*2', '2', '2', '1', '1.10', '#ffffff,#525252,#525252,#ffffff,#ffffff,#525252,#ffffff,#525252', '0', '1', '1', '18', '189', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('190', 'glass_table*2', '1', '2', '2', '0.90', '#ffffff,#525252,#525252,#ffffff', '0', '1', '1', '18', '190', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('191', 'glass_chair*2', '2', '1', '1', '1.10', '#ffffff,#525252,#525252,#ffffff', '0', '1', '1', '18', '191', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('192', 'glass_stool*2', '2', '1', '1', '1.10', '#ffffff,#525252,#525252,#ffffff', '0', '1', '1', '18', '192', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('193', 'glass_sofa*3', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '18', '193', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('194', 'glass_table*3', '1', '2', '2', '0.90', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '18', '194', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('195', 'glass_chair*3', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '18', '195', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('196', 'glass_stool*3', '2', '1', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '18', '196', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('197', 'glass_sofa*4', '2', '2', '1', '1.10', '#ffffff,#F7EBBC,#F7EBBC,#ffffff,#ffffff,#F7EBBC,#ffffff,#F7EBBC', '0', '1', '1', '18', '197', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('198', 'glass_table*4', '1', '2', '2', '0.90', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '0', '1', '1', '18', '198', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('199', 'glass_chair*4', '2', '1', '1', '1.10', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '0', '1', '1', '18', '199', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('200', 'glass_stool*4', '2', '1', '1', '1.10', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '0', '1', '1', '18', '200', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('201', 'glass_sofa*5', '2', '2', '1', '1.10', '#ffffff,#FF99BC,#FF99BC,#ffffff,#ffffff,#FF99BC,#ffffff,#FF99BC', '0', '1', '1', '18', '201', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('202', 'glass_table*5', '1', '2', '2', '0.90', '#ffffff,#FF99BC,#FF99BC,#ffffff', '0', '1', '1', '18', '202', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('203', 'glass_chair*5', '2', '1', '1', '1.10', '#ffffff,#FF99BC,#FF99BC,#ffffff', '0', '1', '1', '18', '203', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('204', 'glass_stool*5', '2', '1', '1', '1.10', '#ffffff,#FF99BC,#FF99BC,#ffffff', '0', '1', '1', '18', '204', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('205', 'glass_sofa*6', '2', '2', '1', '1.10', '#ffffff,#5EAAF8,#5EAAF8,#ffffff,#ffffff,#5EAAF8,#ffffff,#5EAAF8', '0', '1', '1', '18', '205', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('206', 'glass_table*6', '1', '2', '2', '0.90', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '0', '1', '1', '18', '206', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('207', 'glass_chair*6', '2', '1', '1', '1.10', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '0', '1', '1', '18', '207', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('208', 'glass_stool*6', '2', '1', '1', '1.10', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '0', '1', '1', '18', '208', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('209', 'glass_sofa*7', '2', '2', '1', '1.10', '#ffffff,#92D13D,#92D13D,#ffffff,#ffffff,#92D13D,#ffffff,#92D13D', '0', '1', '1', '18', '209', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('210', 'glass_table*7', '1', '2', '2', '0.90', '#ffffff,#92D13D,#92D13D,#ffffff', '0', '1', '1', '18', '210', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('211', 'glass_chair*7', '2', '1', '1', '1.10', '#ffffff,#92D13D,#92D13D,#ffffff', '0', '1', '1', '18', '211', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('212', 'glass_stool*7', '2', '1', '1', '1.10', '#ffffff,#92D13D,#92D13D,#ffffff', '0', '1', '1', '18', '212', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('213', 'glass_sofa*8', '2', '2', '1', '1.10', '#ffffff,#FFD837,#FFD837,#ffffff,#ffffff,#FFD837,#ffffff,#FFD837', '0', '1', '1', '18', '213', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('214', 'glass_table*8', '1', '2', '2', '0.90', '#ffffff,#FFD837,#FFD837,#ffffff', '0', '1', '1', '18', '214', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('215', 'glass_chair*8', '2', '1', '1', '1.10', '#ffffff,#FFD837,#FFD837,#ffffff', '0', '1', '1', '18', '215', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('216', 'glass_stool*8', '2', '1', '1', '1.10', '#ffffff,#FFD837,#FFD837,#ffffff', '0', '1', '1', '18', '216', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('217', 'glass_sofa*9', '2', '2', '1', '1.10', '#ffffff,#E14218,#E14218,#ffffff,#ffffff,#E14218,#ffffff,#E14218', '0', '1', '1', '18', '217', 'Glass sofa', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('218', 'glass_table*9', '1', '2', '2', '0.90', '#ffffff,#E14218,#E14218,#ffffff', '0', '1', '1', '18', '218', 'Glass table', 'Translucent beauty', '4');
INSERT INTO catalogue_items VALUES ('219', 'glass_chair*9', '2', '1', '1', '1.10', '#ffffff,#E14218,#E14218,#ffffff', '0', '1', '1', '18', '219', 'Glass chair', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('220', 'glass_stool*9', '2', '1', '1', '1.10', '#ffffff,#E14218,#E14218,#ffffff', '0', '1', '1', '18', '220', 'Glass stool', 'Translucent beauty', '3');
INSERT INTO catalogue_items VALUES ('221', 'gothic_chair*3', '2', '1', '1', '1.10', '#ffffff,#dd0000,#ffffff,#dd0000', '0', '1', '1', '19', '221', 'Red Gothic Chair', 'The head of the table', '10');
INSERT INTO catalogue_items VALUES ('222', 'gothic_sofa*3', '2', '2', '1', '1.10', '#ffffff,#dd0000,#ffffff,#ffffff,#dd0000,#ffffff', '0', '1', '1', '19', '222', 'Red Gothic Sofa', 'Not great for hiding behind', '7');
INSERT INTO catalogue_items VALUES ('223', 'gothic_stool*3', '1', '1', '1', '1.10', '#ffffff,#dd0000,#ffffff', '0', '1', '1', '19', '223', 'Red Gothic Stool', 'Be calm. Be seated', '5');
INSERT INTO catalogue_items VALUES ('224', 'gothic_carpet', '4', '2', '4', '0.00', '0,0,0', '0', '1', '1', '19', '224', 'Cobbled Path', 'The route less travelled', '5');
INSERT INTO catalogue_items VALUES ('225', 'gothic_carpet2', '4', '2', '4', '0.00', '0,0,0', '0', '1', '1', '19', '225', 'Dungeon Floor', 'What lies beneath?', '5');
INSERT INTO catalogue_items VALUES ('226', 'goth_table', '1', '1', '5', '1.00', '0,0,0', '0', '1', '1', '19', '226', 'Gothic Table', 'A table with two heads', '15');
INSERT INTO catalogue_items VALUES ('227', 'gothrailing', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '19', '227', 'Gothic Railing', 'Keep out!', '8');
INSERT INTO catalogue_items VALUES ('228', 'torch', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '19', '228', 'Gothic Torch', 'Keeping dungeons light', '10');
INSERT INTO catalogue_items VALUES ('229', 'gothicfountain', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '19', '229', 'Gothic Fountain', 'The dark side of Habbo', '10');
INSERT INTO catalogue_items VALUES ('230', 'gothiccandelabra', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '19', '230', 'Gothic Candleabra', 'Through darkness came light', '10');
INSERT INTO catalogue_items VALUES ('231', 'gothgate', '1', '2', '1', '0.00', '0,0,0', '1', '1', '1', '19', '231', 'Gothic Portcullis', 'Don\'t get caught beneath!', '10');
INSERT INTO catalogue_items VALUES ('232', 'industrialfan', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '19', '232', 'Industrial Turbine', 'Powerful and resilient', '10');
INSERT INTO catalogue_items VALUES ('233', 'grunge_barrel', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '20', '233', 'Flaming Barrel', 'Beacon of light!', '3');
INSERT INTO catalogue_items VALUES ('234', 'grunge_bench', '2', '3', '1', '1.10', '0,0,0', '0', '1', '1', '20', '234', 'Bench', 'Laid back seating', '3');
INSERT INTO catalogue_items VALUES ('235', 'grunge_candle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '20', '235', 'Candle Box', 'Late night debate', '2');
INSERT INTO catalogue_items VALUES ('236', 'grunge_chair', '2', '1', '1', '1.10', '0,0,0', '0', '1', '1', '20', '236', 'Grunge Chair', 'Alternative chair for alternative people', '4');
INSERT INTO catalogue_items VALUES ('237', 'grunge_mattress', '2', '3', '1', '0.80', '0,0,0', '0', '1', '1', '20', '237', 'Grunge Mattress', 'Beats sleeping on the floor!', '3');
INSERT INTO catalogue_items VALUES ('238', 'grunge_radiator', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '20', '238', 'Radiator', 'Started cool but now it\'s hot!', '3');
INSERT INTO catalogue_items VALUES ('239', 'grunge_shelf', '1', '3', '1', '0.00', '0,0,0', '0', '1', '1', '20', '239', 'Grunge Bookshelf', 'Scrap books and photo albums', '5');
INSERT INTO catalogue_items VALUES ('240', 'grunge_sign', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '20', '240', 'Road Sign', 'Bought legitimately from an M1 cafe.', '3');
INSERT INTO catalogue_items VALUES ('241', 'grunge_table', '1', '2', '2', '1.00', '0,0,0', '0', '1', '1', '20', '241', 'Grunge Table', 'Students of the round table!', '4');
INSERT INTO catalogue_items VALUES ('242', 'CF_1_coin_bronze', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '21', '242', 'Bronze Coin', 'Worth: 1 Habbo Credit', '1');
INSERT INTO catalogue_items VALUES ('243', 'CF_5_coin_silver', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '21', '243', 'Silver Coin', 'Worth: 5 Habbo Credits', '5');
INSERT INTO catalogue_items VALUES ('244', 'CF_10_coin_gold', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '21', '244', 'Gold Coin', 'Worth: 10 Habbo Credits', '10');
INSERT INTO catalogue_items VALUES ('245', 'CF_20_moneybag', '1', '1', '1', '1.00', '0,0,0', '0', '1', '1', '21', '245', 'Money Bag', 'Worth: 20 Habbo Credits', '20');
INSERT INTO catalogue_items VALUES ('246', 'CF_50_goldbar', '1', '1', '1', '0.60', '0,0,0', '0', '1', '1', '21', '246', 'Gold Bars', 'Worth: 50 Habbo Credits', '50');
INSERT INTO catalogue_items VALUES ('247', 'habbowood_chair', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '22', '247', 'Habbowood Chair', 'null', '5');
INSERT INTO catalogue_items VALUES ('248', 'rope_divider', '1', '2', '1', '0.00', '0,0,0', '1', '1', '1', '22', '248', 'Rope Divider', 'null', '5');
INSERT INTO catalogue_items VALUES ('249', 'spotlight', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '22', '249', 'Spotlight', 'Light, camera, action!', '15');
INSERT INTO catalogue_items VALUES ('250', 'theatre_seat', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '22', '250', 'Theatre Seat', 'It\'s a Theatre Seat', '10');
INSERT INTO catalogue_items VALUES ('251', 'rare_icecream_campaign', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '22', '251', 'Icecream Machine', 'null', '25');
INSERT INTO catalogue_items VALUES ('252', 'habw_mirror', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '22', '252', 'Habbowood Mirror', 'Starts only!', '10');
INSERT INTO catalogue_items VALUES ('253', 'chair_norja', '2', '1', '1', '1.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '23', '253', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('254', 'couch_norja', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '23', '254', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('255', 'table_norja_med', '1', '2', '2', '0.90', '#ffffff,#F7EBBC', '0', '1', '1', '23', '255', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('256', 'shelves_norja', '1', '1', '1', '0.00', '#ffffff,#F7EBBC', '0', '1', '1', '23', '256', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('257', 'soft_sofachair_norja', '2', '1', '1', '1.00', '#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '23', '257', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('258', 'soft_sofa_norja', '2', '2', '1', '1.00', '#ffffff,#F7EBBC,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '23', '258', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('259', 'divider_nor2', '1', '2', '1', '0.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '23', '259', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('260', 'divider_nor1', '1', '1', '1', '0.00', '#ffffff,#F7EBBC', '0', '1', '1', '23', '260', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('261', 'divider_nor3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '1', '23', '261', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('262', 'divider_nor4', '1', '2', '1', '0.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '1', '23', '262', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('263', 'divider_nor5', '1', '1', '1', '0.00', '#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '1', '23', '263', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('264', 'jp_bamboo', '4', '2', '2', '0.00', '0,0,0', '0', '1', '1', '24', '264', 'Bamboo Forest', 'Don\'t get lost', '25');
INSERT INTO catalogue_items VALUES ('265', 'jp_pillow', '2', '1', '1', '0.70', '0,0,0', '0', '1', '1', '24', '265', 'Pillow', 'null', '5');
INSERT INTO catalogue_items VALUES ('266', 'jp_irori', '1', '2', '2', '0.00', '0,0,0', '0', '1', '1', '24', '266', 'Sushi Bar', 'null', '10');
INSERT INTO catalogue_items VALUES ('267', 'jp_tatami', '4', '2', '2', '0.00', '0,0,0', '0', '1', '1', '24', '267', 'Tatami', 'null', '6');
INSERT INTO catalogue_items VALUES ('268', 'jp_tatami2', '4', '2', '4', '0.00', '0,0,0', '0', '1', '1', '24', '268', 'Tatami', 'null', '8');
INSERT INTO catalogue_items VALUES ('269', 'jp_lantern', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '24', '269', 'Lantern', 'null', '10');
INSERT INTO catalogue_items VALUES ('270', 'jp_drawer', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '24', '270', 'Drawers', 'null', '6');
INSERT INTO catalogue_items VALUES ('271', 'jp_ninjastars', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '24', '271', 'Ninjastars', 'Ouch!', '10');
INSERT INTO catalogue_items VALUES ('272', 'bed_armas_two', '3', '2', '3', '2.00', '0,0,0', '0', '1', '1', '25', '272', 'Double Bed', 'King-sized pine comfort', '3');
INSERT INTO catalogue_items VALUES ('273', 'bed_armas_one', '3', '1', '3', '2.00', '0,0,0', '0', '1', '1', '25', '273', 'Single Bed', 'Rustic charm for one', '3');
INSERT INTO catalogue_items VALUES ('274', 'fireplace_armas', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '25', '274', 'Fireplace', 'Authentic, real flame fire', '4');
INSERT INTO catalogue_items VALUES ('275', 'bartable_armas', '1', '1', '3', '1.20', '0,0,0', '0', '1', '1', '25', '275', 'Bardesk', 'Bar-Style Table - essential for extra guests', '3');
INSERT INTO catalogue_items VALUES ('276', 'table_armas', '1', '2', '2', '1.00', '0,0,0', '0', '1', '1', '25', '276', 'Dining Table', 'For informal dining', '3');
INSERT INTO catalogue_items VALUES ('277', 'bench_armas', '2', '2', '1', '1.10', '0,0,0', '0', '1', '1', '25', '277', 'Bench', 'To complete the dining set', '3');
INSERT INTO catalogue_items VALUES ('278', 'divider_arm3', '1', '1', '1', '0.00', '0,0,0', '1', '1', '1', '25', '278', 'Gate (lockable)', 'Knock, knock...', '6');
INSERT INTO catalogue_items VALUES ('279', 'divider_arm1', '1', '1', '1', '1.20', '0,0,0', '0', '1', '1', '25', '279', 'Corner plinth', 'Good solid wood', '3');
INSERT INTO catalogue_items VALUES ('280', 'divider_arm2', '1', '2', '1', '1.20', '0,0,0', '0', '1', '1', '25', '280', 'Room divider', 'I wooden go there', '3');
INSERT INTO catalogue_items VALUES ('281', 'shelves_armas', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '25', '281', 'Bookcase', 'For all those fire-side stories', '3');
INSERT INTO catalogue_items VALUES ('282', 'bar_armas', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '25', '282', 'Barrel Minibar', 'It\'s a barrel of laughs and a great talking point', '4');
INSERT INTO catalogue_items VALUES ('283', 'bar_chair_armas', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '25', '283', 'Barrel Stool', 'The ultimate recycled furniture', '1');
INSERT INTO catalogue_items VALUES ('284', 'lamp_armas', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '25', '284', 'Table Lamp', 'Ambient lighting is essential', '3');
INSERT INTO catalogue_items VALUES ('285', 'lamp2_armas', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '25', '285', 'Lodge Candle', 'Wax lyrical with some old-world charm', '3');
INSERT INTO catalogue_items VALUES ('286', 'small_table_armas', '1', '1', '1', '1.10', '0,0,0', '0', '1', '1', '25', '286', 'Occasional Table', 'Practical and beautiful', '2');
INSERT INTO catalogue_items VALUES ('287', 'small_chair_armas', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '25', '287', 'Stool', 'Rustic charm at it\'s best', '1');
INSERT INTO catalogue_items VALUES ('288', 'bed_polyfon', '3', '2', '3', '2.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '26', '288', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('289', 'bed_polyfon_one', '3', '1', '3', '2.00', 'ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '26', '289', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('290', 'fireplace_polyfon', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '26', '290', 'Fireplace', 'Comfort in stainless steel', '5');
INSERT INTO catalogue_items VALUES ('291', 'sofa_polyfon', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '26', '291', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('292', 'sofachair_polyfon', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '26', '292', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('293', 'bar_polyfon', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '26', '293', 'Mini-Bar', 'You naughty Habbo!', '5');
INSERT INTO catalogue_items VALUES ('294', 'divider_poly3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '1', '26', '294', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('295', 'bardesk_polyfon', '1', '2', '1', '1.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '26', '295', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('296', 'bardeskcorner_polyfon', '1', '1', '1', '0.00', '#ffffff,#ABD0D2', '0', '1', '1', '26', '296', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('297', 'chair_polyfon', '2', '1', '1', '1.10', '0,0,0', '0', '1', '1', '26', '297', 'Dining Chair', 'Metallic seating experience', '3');
INSERT INTO catalogue_items VALUES ('298', 'table_polyfon', '1', '2', '2', '0.80', '0,0,0', '0', '1', '1', '26', '298', 'Large Coffee Table', 'For larger gatherings', '4');
INSERT INTO catalogue_items VALUES ('299', 'table_polyfon_med', '1', '2', '2', '1.00', '0,0,0', '0', '1', '1', '26', '299', 'Large Coffee Table', 'For larger gatherings', '3');
INSERT INTO catalogue_items VALUES ('300', 'table_polyfon_small', '1', '2', '2', '0.90', '0,0,0', '0', '1', '1', '26', '300', 'Small Coffee Table', 'For serving a stylish latte', '1');
INSERT INTO catalogue_items VALUES ('301', 'smooth_table_polyfon', '1', '2', '2', '0.90', '0,0,0', '0', '1', '1', '26', '301', 'Large Dining Table', 'For larger gatherings', '4');
INSERT INTO catalogue_items VALUES ('302', 'stand_polyfon_z', '1', '1', '1', '0.70', '0,0,0', '0', '1', '1', '26', '302', 'Shelf', 'Tidy up', '1');
INSERT INTO catalogue_items VALUES ('303', 'shelves_polyfon', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '26', '303', 'Bookcase', 'For the arty pad', '4');
INSERT INTO catalogue_items VALUES ('304', 'present_gen1', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('305', 'present_gen2', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('306', 'present_gen3', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('307', 'present_gen4', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('308', 'present_gen5', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('309', 'present_gen6', '1', '1', '1', '1.00', '0,0,0', '0', '0', '0', '-1', '0', '', '', '0');
INSERT INTO catalogue_items VALUES ('313', 'giftflowers', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '313', 'Vase of Flowers', 'Guaranteed to stay fresh', '4');
INSERT INTO catalogue_items VALUES ('314', 'plant_rose', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '314', 'Cut Roses', 'Sleek and chic', '3');
INSERT INTO catalogue_items VALUES ('315', 'plant_sunflower', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '315', 'Cut Sunflower', 'For happy Habbos', '3');
INSERT INTO catalogue_items VALUES ('316', 'plant_yukka', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '316', 'Yukka Plant', 'Easy to care for', '3');
INSERT INTO catalogue_items VALUES ('317', 'plant_pineapple', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '317', 'Pineapple Plant', 'Needs loving glances', '3');
INSERT INTO catalogue_items VALUES ('318', 'plant_bonsai', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '318', 'Bonsai Tree', 'You can be sure it lives', '3');
INSERT INTO catalogue_items VALUES ('319', 'plant_big_cactus', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '319', 'Mature Cactus', 'Habbo Dreams monster in hiding!  Shhhh', '3');
INSERT INTO catalogue_items VALUES ('320', 'plant_fruittree', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '320', 'Fruit Tree', 'Great yield and sweet fruit', '3');
INSERT INTO catalogue_items VALUES ('321', 'plant_small_cactus', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '321', 'Small Cactus', 'Even less watering than the real world', '1');
INSERT INTO catalogue_items VALUES ('322', 'plant_maze', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '28', '322', 'Maze shrubbery', 'Labyrinths Galore!', '5');
INSERT INTO catalogue_items VALUES ('323', 'plant_mazegate', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '28', '323', 'Maze Shrubbery Gate', 'Labyrinths Galore!', '6');
INSERT INTO catalogue_items VALUES ('324', 'plant_bulrush', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '28', '324', 'Bulrush', 'Ideal for the riverside', '3');
INSERT INTO catalogue_items VALUES ('325', 'chair_plasto*16', '2', '1', '1', '1.00', '#ffffff,#CC3399,#ffffff,#CC3399', '0', '1', '1', '29', '325', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('326', 'chair_plasto*15', '2', '1', '1', '1.00', '#ffffff,#FF97BA,#ffffff,#FF97BA', '0', '1', '1', '29', '326', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('327', 'chair_plasto*5', '2', '1', '1', '1.00', '#ffffff,#54ca00,#ffffff,#54ca00', '0', '1', '1', '29', '327', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('328', 'chair_plasto', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '29', '328', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('329', 'chair_plasto*8', '2', '1', '1', '1.00', '#ffffff,#c38d1a,#ffffff,#c38d1a', '0', '1', '1', '29', '329', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('330', 'chair_plasto*7', '2', '1', '1', '1.00', '#ffffff,#ff6d00,#ffffff,#ff6d00', '0', '1', '1', '29', '330', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('331', 'chair_plasto*1', '2', '1', '1', '1.00', '#ffffff,#ff1f08,#ffffff,#ff1f08', '0', '1', '1', '29', '331', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('332', 'chair_plasto*4', '2', '1', '1', '1.00', '#ffffff,#ccddff,#ffffff,#ccddff', '0', '1', '1', '29', '332', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('333', 'chair_plasto*6', '2', '1', '1', '1.00', '#ffffff,#3444ff,#ffffff,#3444ff', '0', '1', '1', '29', '333', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('334', 'chair_plasto*3', '2', '1', '1', '1.00', '#ffffff,#ffee00,#ffffff,#ffee00', '0', '1', '1', '29', '334', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('335', 'chair_plasto*2', '2', '1', '1', '1.00', '#ffffff,#99DCCC,#ffffff,#99DCCc', '0', '1', '1', '29', '335', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('336', 'table_plasto_square*15', '1', '1', '1', '1.10', '#ffffff,#FF97BA', '0', '1', '1', '29', '336', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('337', 'table_plasto_square*14', '1', '1', '1', '1.10', '#ffffff,#CC3399', '0', '1', '1', '29', '337', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('338', 'table_plasto_square*1', '1', '1', '1', '1.10', '#ffffff,#ff1f08', '0', '1', '1', '29', '338', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('339', 'table_plasto_square*7', '1', '1', '1', '1.10', '#ffffff,#ff6d00', '0', '1', '1', '29', '339', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('340', 'table_plasto_square', '1', '1', '1', '1.10', '0,0,0', '0', '1', '1', '29', '340', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('341', 'table_plasto_square*2', '1', '1', '1', '1.10', '#ffffff,#99DCCC', '0', '1', '1', '29', '341', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('342', 'table_plasto_square*4', '1', '1', '1', '1.10', '#ffffff,#ccddff', '0', '1', '1', '29', '342', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('343', 'table_plasto_square*6', '1', '1', '1', '1.10', '#ffffff,#3444ff', '0', '1', '1', '29', '343', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('344', 'table_plasto_square*3', '1', '1', '1', '1.10', '#ffffff,#ffee00', '0', '1', '1', '29', '344', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('345', 'table_plasto_square*9', '1', '1', '1', '1.10', '#ffffff,#533e10', '0', '1', '1', '29', '345', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('346', 'table_plasto_square*5', '1', '1', '1', '1.10', '#ffffff,#54ca00', '0', '1', '1', '29', '346', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('347', 'table_plasto_square*8', '1', '1', '1', '1.10', '#ffffff,#c38d1a', '0', '1', '1', '29', '347', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('348', 'table_plasto_round*15', '1', '2', '2', '1.10', '#ffffff,#FF97BA', '0', '1', '1', '29', '348', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('349', 'table_plasto_round*14', '1', '2', '2', '1.10', '#ffffff,#CC3399', '0', '1', '1', '29', '349', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('350', 'table_plasto_round*7', '1', '2', '2', '1.10', '#ffffff,#ff6d00', '0', '1', '1', '29', '350', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('351', 'table_plasto_round*1', '1', '2', '2', '1.10', '#ffffff,#ff1f08', '0', '1', '1', '29', '351', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('352', 'table_plasto_round*2', '1', '2', '2', '1.10', '#ffffff,#99DCCC', '0', '1', '1', '29', '352', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('353', 'table_plasto_round*4', '1', '2', '2', '1.10', '#ffffff,#ccddff', '0', '1', '1', '29', '353', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('354', 'table_plasto_round*6', '1', '2', '2', '1.10', '#ffffff,#3444ff', '0', '1', '1', '29', '354', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('355', 'table_plasto_round*3', '1', '2', '2', '1.10', '#ffffff,#ffee00', '0', '1', '1', '29', '355', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('356', 'table_plasto_round*9', '1', '2', '2', '1.10', '#ffffff,#533e10', '0', '1', '1', '29', '356', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('357', 'table_plasto_round', '1', '2', '2', '1.10', '0,0,0', '0', '1', '1', '29', '357', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('358', 'table_plasto_round*5', '1', '2', '2', '1.10', '#ffffff,#54ca00', '0', '1', '1', '29', '358', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('359', 'table_plasto_round*8', '1', '2', '2', '1.10', '#ffffff,#c38d1a', '0', '1', '1', '29', '359', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('360', 'table_plasto_bigsquare*15', '1', '2', '2', '1.10', '#ffffff,#FF97BA', '0', '1', '1', '29', '360', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('361', 'table_plasto_bigsquare*14', '1', '2', '2', '1.10', '#ffffff,#CC3399', '0', '1', '1', '29', '361', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('362', 'table_plasto_bigsquare*7', '1', '2', '2', '1.10', '#ffffff,#ff6d00', '0', '1', '1', '29', '362', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('363', 'table_plasto_bigsquare*1', '1', '2', '2', '1.10', '#ffffff,#ff1f08', '0', '1', '1', '29', '363', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('364', 'table_plasto_bigsquare*2', '1', '2', '2', '1.10', '#ffffff,#99DCCC', '0', '1', '1', '29', '364', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('365', 'table_plasto_bigsquare', '1', '2', '2', '1.10', '0,0,0', '0', '1', '1', '29', '365', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('366', 'table_plasto_bigsquare*8', '1', '2', '2', '1.10', '#ffffff,#c38d1a', '0', '1', '1', '29', '366', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('367', 'table_plasto_bigsquare*5', '1', '2', '2', '1.10', '#ffffff,#54ca00', '0', '1', '1', '29', '367', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('368', 'table_plasto_bigsquare*9', '1', '2', '2', '1.10', '#ffffff,#533e10', '0', '1', '1', '29', '368', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('369', 'table_plasto_bigsquare*3', '1', '2', '2', '1.10', '#ffffff,#ffee00', '0', '1', '1', '29', '369', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('370', 'table_plasto_bigsquare*6', '1', '2', '2', '1.10', '#ffffff,#3444ff', '0', '1', '1', '29', '370', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('371', 'table_plasto_bigsquare*4', '1', '2', '2', '1.10', '#ffffff,#ccddff', '0', '1', '1', '29', '371', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('372', 'table_plasto_4leg*6', '1', '2', '2', '1.10', '#ffffff,#3444ff', '0', '1', '1', '29', '372', 'Occasional table Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('373', 'table_plasto_4leg*1', '1', '2', '2', '1.10', '#ffffff,#ff1f08', '0', '1', '1', '29', '373', 'Square Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('374', 'table_plasto_4leg*3', '1', '2', '2', '1.10', '#ffffff,#ffee00', '0', '1', '1', '29', '374', 'Round Dining Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('375', 'table_plasto_4leg*9', '1', '2', '2', '1.10', '#ffffff,#533e10', '0', '1', '1', '29', '375', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('376', 'table_plasto_4leg', '1', '2', '2', '1.10', '0,0,0', '0', '1', '1', '29', '376', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('377', 'table_plasto_4leg*5', '1', '2', '2', '1.10', '#ffffff,#54ca00', '0', '1', '1', '29', '377', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('378', 'table_plasto_4leg*2', '1', '2', '2', '1.10', '#ffffff,#99DCCC', '0', '1', '1', '29', '378', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('379', 'table_plasto_4leg*8', '1', '2', '2', '1.10', '#ffffff,#c38d1a', '0', '1', '1', '29', '379', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('380', 'table_plasto_4leg*7', '1', '2', '2', '1.10', '#ffffff,#ff6d00', '0', '1', '1', '29', '380', 'Occasional table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('381', 'table_plasto_4leg*10', '1', '2', '2', '1.10', '#ffffff,#ccddff', '0', '1', '1', '29', '381', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('382', 'table_plasto_4leg*15', '1', '2', '2', '1.10', '#ffffff,#FF97BA', '0', '1', '1', '29', '382', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('383', 'table_plasto_4leg*16', '1', '2', '2', '1.10', '#ffffff,#CC3399', '0', '1', '1', '29', '383', 'Occasional Table', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('384', 'chair_plasty', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '29', '384', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('385', 'chair_plasty*1', '2', '1', '1', '1.00', '#ffffff,#8EB5D1,#ffffff,#8EB5D1', '0', '1', '1', '29', '385', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('386', 'chair_plasty*2', '2', '1', '1', '1.00', '#ffffff,#ff9900,#ffffff,#ff9900', '0', '1', '1', '29', '386', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('387', 'chair_plasty*3', '2', '1', '1', '1.00', '#ffffff,#ff2200,#ffffff,#ff2200', '0', '1', '1', '29', '387', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('388', 'chair_plasty*4', '2', '1', '1', '1.00', '#ffffff,#00cc00,#ffffff,#00cc00', '0', '1', '1', '29', '388', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('389', 'chair_plasty*4', '2', '1', '1', '1.00', '#ffffff,#0033CC,#ffffff,#0033CC', '0', '1', '1', '29', '389', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('390', 'chair_plasty*4', '2', '1', '1', '1.00', '#ffffff,#333333,#ffffff,#333333', '0', '1', '1', '29', '390', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('391', 'chair_plasty*7', '2', '1', '1', '1.00', '#ffffff,#99DCCc,#ffffff,#99DCCc', '0', '1', '1', '29', '391', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('392', 'chair_plasty*8', '2', '1', '1', '1.00', '#ffffff,#c38d1a,#ffffff,#c38d1a', '0', '1', '1', '29', '392', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('393', 'chair_plasty*9', '2', '1', '1', '1.00', '#ffffff,#533e10,#ffffff,#533e10', '0', '1', '1', '29', '393', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('394', 'chair_plasty*10', '2', '1', '1', '1.00', '#ffffff,#CC3399,#ffffff,#CC3399', '0', '1', '1', '29', '394', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('395', 'chair_plasty*11', '2', '1', '1', '1.00', '#ffffff,#FF97BA,#ffffff,#FF97BA', '0', '1', '1', '29', '395', 'Plastic Pod Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('396', 'chair_plasto*9', '2', '1', '1', '1.00', '#ffffff,#533e10,#ffffff,#533e10', '0', '1', '1', '29', '396', 'Chair', 'Hip plastic furniture', '3');
INSERT INTO catalogue_items VALUES ('397', 'shelves_basic', '1', '2', '1', '1.00', '0,0,0', '0', '1', '1', '31', '397', 'Pura Shelves', 'Pura Series 404 shelves', '3');
INSERT INTO catalogue_items VALUES ('398', 'bar_basic', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '31', '398', 'A Pura Minibar', 'A Pura series 300 minibar', '4');
INSERT INTO catalogue_items VALUES ('399', 'fridge', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '31', '399', 'Pura Refridgerator', 'Keep cool with a chilled snack or drink', '6');
INSERT INTO catalogue_items VALUES ('400', 'lamp_basic', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '31', '400', 'Pura Lamp', 'Switch on the atmosphere with this sophisticated light', '3');
INSERT INTO catalogue_items VALUES ('401', 'bed_budgetb', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '31', '401', 'White Plain Double Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('402', 'bed_budgetb_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '31', '402', 'White Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('403', 'bed_budget', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '31', '403', 'Aqua Plain Double Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('404', 'bed_budget_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '31', '404', 'Aqua Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('405', 'bed_budgetb', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '0', '1', '1', '31', '405', 'Pink Plain Double Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('406', 'bed_budgetb_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '0', '1', '1', '31', '406', 'Pink Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('407', 'bed_budget', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#525252,#525252,#525252', '0', '1', '1', '31', '407', 'Black Plain Double Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('408', 'bed_budget_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#525252,#525252,#525252', '0', '1', '1', '31', '408', 'Black Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('409', 'bed_budgetb', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '31', '409', 'Beige Plain Double Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('410', 'bed_budgetb_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '31', '410', 'Beige Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('411', 'bed_budget', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '31', '411', 'Blue Plain Single Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('412', 'bed_budget_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '31', '412', 'Blue Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('413', 'bed_budgetb', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#92D13D,#92D13D,#92D13D', '0', '1', '1', '31', '413', 'Green Plain Single Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('414', 'bed_budgetb_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#92D13D,#92D13D,#92D13D', '0', '1', '1', '31', '414', 'Green Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('415', 'bed_budget', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFD837,#FFD837,#FFD837', '0', '1', '1', '31', '415', 'Yellow Plain Single Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('416', 'bed_budget_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFD837,#FFD837,#FFD837', '0', '1', '1', '31', '416', 'Yellow Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('417', 'bed_budgetb', '3', '2', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#E14218,#E14218,#E14218', '0', '1', '1', '31', '417', 'Red Plain Single Bed', 'Sweet dreams for two', '3');
INSERT INTO catalogue_items VALUES ('418', 'bed_budgetb_one', '3', '1', '3', '2.00', '#FFFFFF,#FFFFFF,#FFFFFF,#E14218,#E14218,#E14218', '0', '1', '1', '31', '418', 'Red Plain Single Bed', 'All you need for a good night\'s kip', '3');
INSERT INTO catalogue_items VALUES ('419', 'rclr_sofa', '2', '2', '1', '1.00', '0,0,0', '0', '1', '1', '-1', '419', 'Recycler Sofa', 'Handmade...', '25');
INSERT INTO catalogue_items VALUES ('420', 'rclr_chair', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '-1', '420', 'Recycler Chair', 'Handmade...', '25');
INSERT INTO catalogue_items VALUES ('421', 'rclr_garden', '1', '1', '3', '0.00', '0,0,0', '0', '1', '1', '-1', '421', 'Recycler Garden', 'Give them water!', '25');
INSERT INTO catalogue_items VALUES ('422', 'queue_tile1*0', '1', '1', '1', '0.20', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '33', '422', 'White Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('423', 'queue_tile1*1', '1', '1', '1', '0.20', '#ffffff,#FF7C98,#ffffff,#ffffff', '0', '1', '1', '33', '423', 'Pink Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('424', 'queue_tile1*2', '1', '1', '1', '0.20', '#ffffff,#FF3333,#ffffff,#ffffff', '0', '1', '1', '33', '424', 'Red Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('425', 'queue_tile1*3', '1', '1', '1', '0.20', '#ffffff,#67c39c,#ffffff,#ffffff', '0', '1', '1', '33', '425', 'Aqua Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('426', 'queue_tile1*4', '1', '1', '1', '0.20', '#ffffff,#FFAA2B,#ffffff,#ffffff', '0', '1', '1', '33', '426', 'Gold Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('427', 'queue_tile1*5', '1', '1', '1', '0.20', '#ffffff,#555A37,#ffffff,#ffffff', '0', '1', '1', '33', '427', 'Knight Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('428', 'queue_tile1*6', '1', '1', '1', '0.20', '#ffffff,#A2E8FA,#ffffff,#ffffff', '0', '1', '1', '33', '428', 'Blue Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('429', 'queue_tile1*7', '1', '1', '1', '0.20', '#ffffff,#FC5AFF,#ffffff,#ffffff', '0', '1', '1', '33', '429', 'Purple Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('430', 'queue_tile1*8', '1', '1', '1', '0.20', '#ffffff,#1E8AA5,#ffffff,#ffffff', '0', '1', '1', '33', '430', 'Navy Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('431', 'queue_tile1*9', '1', '1', '1', '0.20', '#ffffff,#9AFF60,#ffffff,#ffffff', '0', '1', '1', '33', '431', 'Green Habbo Roller', 'The power of movement', '5');
INSERT INTO catalogue_items VALUES ('432', 'grand_piano*1', '1', '2', '2', '0.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '34', '432', 'Rose Quartz Grand Piano', 'Chopin\'s revolutionary instrument', '10');
INSERT INTO catalogue_items VALUES ('433', 'romantique_pianochair*1', '2', '1', '1', '1.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '34', '433', 'Rose Quartz Piano Stool', 'Here sat the legend of 1900', '2');
INSERT INTO catalogue_items VALUES ('434', 'romantique_divan*1', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FF8B8B', '0', '1', '1', '34', '434', 'Rose Quartz Chaise-Longue', 'Recline in continental comfort', '6');
INSERT INTO catalogue_items VALUES ('435', 'romantique_chair*1', '2', '1', '1', '1.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '34', '435', 'Rose Quartz Chair', 'Elegant seating for elegant Habbos', '5');
INSERT INTO catalogue_items VALUES ('436', 'romantique_divider*1', '1', '2', '1', '0.00', '#FF8B8B,#FF8B8B,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '34', '436', 'Rose Quartz Screen', 'Beauty lies within', '6');
INSERT INTO catalogue_items VALUES ('437', 'romantique_smalltabl*1', '1', '1', '1', '1.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '34', '437', 'Rose Quartz Tray Table', 'Every tray needs a table...', '4');
INSERT INTO catalogue_items VALUES ('438', 'wallmirror', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '34', '438', 'Wall Mirror', 'Mirror, mirror on the wall', '4');
INSERT INTO catalogue_items VALUES ('439', 'romantique_tray2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '34', '439', 'Treats Tray', 'Spoil yourself', '5');
INSERT INTO catalogue_items VALUES ('440', 'rom_lamp', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '34', '440', 'Crystal Lamp', 'Light up your life', '6');
INSERT INTO catalogue_items VALUES ('441', 'romantique_mirrortabl', '1', '1', '1', '1.00', '0,0,0', '0', '1', '1', '34', '441', 'Dressing Table', 'Get ready for your big date', '8');
INSERT INTO catalogue_items VALUES ('442', 'carpet_standard', '4', '3', '5', '0.00', '0,0,0', '0', '1', '1', '35', '442', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('443', 'carpet_standard*a', '4', '3', '5', '0.00', '#55AC00,#55AC00,#55AC00', '0', '1', '1', '35', '443', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('444', 'carpet_standard*b', '4', '3', '5', '0.00', '#336666,#336666,#336666', '0', '1', '1', '35', '444', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('445', 'carpet_standard*1', '4', '3', '5', '0.00', '#ff1f08', '0', '1', '1', '35', '445', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('446', 'carpet_standard*2', '4', '3', '5', '0.00', '#99DCCC', '0', '1', '1', '35', '446', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('447', 'carpet_standard*3', '4', '3', '5', '0.00', '#ffee00', '0', '1', '1', '35', '447', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('448', 'carpet_standard*4', '4', '3', '5', '0.00', '#ccddff', '0', '1', '1', '35', '448', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('449', 'carpet_standard*5', '4', '3', '5', '0.00', '#ddccff', '0', '1', '1', '35', '449', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('450', 'carpet_standard*6', '4', '3', '5', '0.00', '#777777', '0', '1', '1', '35', '450', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('451', 'carpet_standard*7', '4', '3', '5', '0.00', '#99CCFF,#99CCFF,#99CCFF', '0', '1', '1', '35', '451', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('452', 'carpet_standard*8', '4', '3', '5', '0.00', '#999966,#999966,#999966', '0', '1', '1', '35', '452', 'Floor Rug', 'Available in a variety of colours', '3');
INSERT INTO catalogue_items VALUES ('453', 'carpet_soft', '4', '2', '4', '0.00', '', '0', '1', '1', '35', '453', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('454', 'carpet_soft*1', '4', '2', '4', '0.00', '#CC3333', '0', '1', '1', '35', '454', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('455', 'carpet_soft*2', '4', '2', '4', '0.00', '#66FFFF', '0', '1', '1', '35', '455', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('456', 'carpet_soft*3', '4', '2', '4', '0.00', '#FFCC99', '0', '1', '1', '35', '456', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('457', 'carpet_soft*4', '4', '2', '4', '0.00', '#FFCCFF', '0', '1', '1', '35', '457', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('458', 'carpet_soft*5', '4', '2', '4', '0.00', '#FFFF66', '0', '1', '1', '35', '458', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('459', 'carpet_soft*6', '4', '2', '4', '0.00', '#669933', '0', '1', '1', '35', '459', 'Soft Wool Rug', 'Soft Wool Rug', '3');
INSERT INTO catalogue_items VALUES ('460', 'doormat_love', '4', '1', '1', '0.00', '0,0,0', '0', '1', '1', '35', '460', 'Doormat', 'Welcome Habbos in style', '1');
INSERT INTO catalogue_items VALUES ('461', 'doormat_plain', '4', '1', '1', '0.00', '0,0,0', '0', '1', '1', '35', '461', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('462', 'doormat_plain*1', '4', '1', '1', '0.00', '#ff1f08', '0', '1', '1', '35', '462', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('463', 'doormat_plain*2', '4', '1', '1', '0.00', '#99DCCC', '0', '1', '1', '35', '463', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('464', 'doormat_plain*3', '4', '1', '1', '0.00', '#ffee00', '0', '1', '1', '35', '464', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('465', 'doormat_plain*4', '4', '1', '1', '0.00', '#ccddff', '0', '1', '1', '35', '465', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('466', 'doormat_plain*5', '4', '1', '1', '0.00', '#ddccff', '0', '1', '1', '35', '466', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('467', 'doormat_plain*6', '4', '1', '1', '0.00', '#777777', '0', '1', '1', '35', '467', 'Doormat', 'Available in a variety of colours', '1');
INSERT INTO catalogue_items VALUES ('468', 'carpet_armas', '4', '2', '4', '0.00', '0,0,0', '0', '1', '1', '35', '468', 'Hand-Woven Rug', 'Adds instant warmth', '3');
INSERT INTO catalogue_items VALUES ('469', 'carpet_polar', '4', '2', '3', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '35', '469', 'Faux-Fur Bear Rug', 'For cuddling up on', '4');
INSERT INTO catalogue_items VALUES ('470', 'carpet_polar*2', '4', '2', '3', '0.00', '#ccddff,#ccddff,#ffffff', '0', '1', '1', '35', '470', 'Blue Bear Rug', 'Snuggle up on a Funky bear rug...', '10');
INSERT INTO catalogue_items VALUES ('471', 'carpet_polar*3', '4', '2', '3', '0.00', '#ffee99,#ffee99,#ffffff', '0', '1', '1', '35', '471', 'Yellow Bear Rug', 'Snuggle up on a Funky bear rug...', '10');
INSERT INTO catalogue_items VALUES ('472', 'carpet_polar*4', '4', '2', '3', '0.00', '#ddffaa,#ddffaa,#ffffff', '0', '1', '1', '35', '472', 'Green Bear Rug', 'Snuggle up on a Funky bear rug...', '10');
INSERT INTO catalogue_items VALUES ('473', 'poster 52', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '36', '473', 'Hockey stick', 'whack that ball!', '3');
INSERT INTO catalogue_items VALUES ('474', 'poster 53', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '36', '474', 'Hockey stick', 'whack that ball!', '3');
INSERT INTO catalogue_items VALUES ('475', 'poster 54', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '36', '475', 'Hockey stick', 'whack that ball!', '3');
INSERT INTO catalogue_items VALUES ('476', 'hockey_score', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '36', '476', 'Scoreboard', '...for keeping your score', '6');
INSERT INTO catalogue_items VALUES ('477', 'legotrophy', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '36', '477', 'Basketball Trophy', 'For the winning team', '3');
INSERT INTO catalogue_items VALUES ('478', 'poster 51', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '36', '478', 'Basketball Hoop', '2 points for every basket', '3');
INSERT INTO catalogue_items VALUES ('479', 'carpet_legocourt', '4', '3', '3', '0.00', '0,0,0', '0', '1', '1', '36', '479', 'Basketball Court', 'Line up your slam dunk', '3');
INSERT INTO catalogue_items VALUES ('480', 'bench_lego', '2', '4', '1', '1.00', '0,0,0', '0', '1', '1', '36', '480', 'Team Bench', 'For your reserve players', '6');
INSERT INTO catalogue_items VALUES ('481', 'sporttrack1*1', '4', '2', '2', '0.00', '#ffffff,#e4592d,#ffffff', '0', '1', '1', '36', '481', 'Sport track straight', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('482', 'sporttrack1*2', '4', '2', '2', '0.00', '#ffffff,#62818b,#ffffff', '0', '1', '1', '36', '482', 'Sport track straight asphalt', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('483', 'sporttrack1*3', '4', '2', '2', '0.00', '#ffffff,#5cb800,#ffffff', '0', '1', '1', '36', '483', 'Sport track straight grass', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('484', 'sporttrack2*1', '4', '2', '2', '0.00', '#ffffff,#e4592d,#ffffff', '0', '1', '1', '36', '484', 'Sport corner', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('485', 'sporttrack2*2', '4', '2', '2', '0.00', '#ffffff,#62818b,#ffffff', '0', '1', '1', '36', '485', 'Sport corner asphalt', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('486', 'sporttrack2*3', '4', '2', '2', '0.00', '#ffffff,#5cb800,#ffffff', '0', '1', '1', '36', '486', 'Sport corner grass', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('488', 'sporttrack3*1', '4', '2', '2', '0.00', '#ffffff,#e4592d,#ffffff', '0', '1', '1', '36', '488', 'Sport goal', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('487', 'sporttrack3*3', '4', '2', '2', '0.00', '#ffffff,#5cb800,#ffffff', '0', '1', '1', '36', '487', 'Sport goal grass', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('489', 'sporttrack3*2', '4', '2', '2', '0.00', '#ffffff,#62818b,#ffffff', '0', '1', '1', '36', '489', 'Sport goal asphalt', 'Let\'s get sporty!', '3');
INSERT INTO catalogue_items VALUES ('490', 'footylamp', '4', '2', '2', '0.00', '0,0,0', '0', '1', '1', '36', '490', 'Football Lamp', 'Let\'s get sporty!', '10');
INSERT INTO catalogue_items VALUES ('491', 'door', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '37', '491', 'Telephone Box', 'Dr Who?', '5');
INSERT INTO catalogue_items VALUES ('492', 'doorC', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '37', '492', 'Portaloo', 'In a hurry?', '4');
INSERT INTO catalogue_items VALUES ('493', 'doorB', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '37', '493', 'Wardrobe', 'Narnia this way!', '3');
INSERT INTO catalogue_items VALUES ('494', 'teleport_door', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '37', '494', 'Teleport Door', 'Teleport Door', '6');
INSERT INTO catalogue_items VALUES ('495', 'sound_machine', '1', '1', '1', '0.00', '#FFFFFF,#FFFFFF,#828282,#FFFFFF', '0', '1', '1', '38', '495', 'Sound Machine', 'Creating fancy sounds', '8');
INSERT INTO catalogue_items VALUES ('496', 'sound_set_4', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '496', 'Ambient 1', 'Chilled out beats', '5');
INSERT INTO catalogue_items VALUES ('497', 'sound_set_8', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '497', 'Ambient 2', 'Mellow electric grooves', '5');
INSERT INTO catalogue_items VALUES ('498', 'sound_set_6', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '498', 'Ambient 3', 'Background ambience loops', '5');
INSERT INTO catalogue_items VALUES ('499', 'sound_set_5', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '499', 'Ambient 4', 'The dark side of Habbo', '5');
INSERT INTO catalogue_items VALUES ('500', 'sound_set_26', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '500', 'Groove 1', 'Bollywood Beats!', '5');
INSERT INTO catalogue_items VALUES ('501', 'sound_set_27', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '501', 'Groove 2', 'Jingle Bells will never be the same...', '5');
INSERT INTO catalogue_items VALUES ('502', 'sound_set_17', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '502', 'Groove 3', 'Jive\'s Alive!', '5');
INSERT INTO catalogue_items VALUES ('503', 'sound_set_18', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '503', 'Groove 4', 'Listen while you tan', '5');
INSERT INTO catalogue_items VALUES ('504', 'sound_set_3', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '504', 'Electronic 1', 'Chilled grooves', '5');
INSERT INTO catalogue_items VALUES ('505', 'sound_set_9', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '38', '505', 'Electronic 2', 'Mystical ambient soundscapes', '5');
INSERT INTO catalogue_items VALUES ('506', 'jukebox*1', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '39', '506', 'Jukebox', 'For your Happy Days!', '5');
INSERT INTO catalogue_items VALUES ('507', 'sound_set_46', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '507', 'Club 1', 'De bada bada bo!', '5');
INSERT INTO catalogue_items VALUES ('508', 'sound_set_47', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '508', 'Club 2', 'Storm the UKCharts!', '5');
INSERT INTO catalogue_items VALUES ('509', 'sound_set_48', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '509', 'Club 3', 'Sweet party beat', '5');
INSERT INTO catalogue_items VALUES ('510', 'sound_set_49', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '510', 'Club 4', 'You will belong', '5');
INSERT INTO catalogue_items VALUES ('511', 'sound_set_50', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '511', 'Club 5', 'The harder generation', '5');
INSERT INTO catalogue_items VALUES ('512', 'sound_set_51', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '512', 'Club 6', 'Bop to the beat', '5');
INSERT INTO catalogue_items VALUES ('513', 'sound_set_25', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '513', 'Dance 1', 'Actually, it\'s Partay!', '5');
INSERT INTO catalogue_items VALUES ('514', 'sound_set_29', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '514', 'Dance 2', 'Electronic house', '5');
INSERT INTO catalogue_items VALUES ('515', 'sound_set_31', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '515', 'Dance 3', 'House loops', '5');
INSERT INTO catalogue_items VALUES ('516', 'sound_set_11', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '516', 'Dance 4', 'Music you can really sink your teeth into', '5');
INSERT INTO catalogue_items VALUES ('517', 'sound_set_13', '1', '1', '1', '0.10', '0,0,0', '0', '1', '1', '39', '517', 'Dance 5', 'Let Music be the food of Habbo', '5');
INSERT INTO catalogue_items VALUES ('518', 'sound_set_35', '1', '0', '1', '0.10', '0,0,0', '0', '1', '1', '39', '518', 'Dance 6', 'Groovelicious', '5');
INSERT INTO catalogue_items VALUES ('519', 'jukebox*1', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '40', '519', 'Jukebox', 'For your Happy Days!', '5');
INSERT INTO catalogue_items VALUES ('520', 'guitar_v', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '40', '520', 'V-Guitar', 'V-Guitar', '5');
INSERT INTO catalogue_items VALUES ('521', 'guitar_skull', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '40', '521', 'Skull-Guitar', 'Skull-Guitar', '5');
INSERT INTO catalogue_items VALUES ('522', 'sound_set_21', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '522', 'Rock 1', 'Headbanging riffs', '5');
INSERT INTO catalogue_items VALUES ('523', 'sound_set_28', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '523', 'Rock 2', 'Head for the pit!', '5');
INSERT INTO catalogue_items VALUES ('524', 'sound_set_33', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '524', 'Rock 3', 'Guitar solo set', '5');
INSERT INTO catalogue_items VALUES ('525', 'sound_set_40', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '525', 'Rock 4', 'Dude? Cheese!', '5');
INSERT INTO catalogue_items VALUES ('526', 'sound_set_34', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '526', 'Rock 5', 'For guitar heroes', '5');
INSERT INTO catalogue_items VALUES ('527', 'sound_set_38', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '527', 'Rock 6', 'Rock and Roses!', '5');
INSERT INTO catalogue_items VALUES ('528', 'sound_set_39', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '528', 'Rock 7', 'Rock with a roll', '5');
INSERT INTO catalogue_items VALUES ('529', 'sound_set_41', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '40', '529', 'Rock 8', 'Burning Riffs', '5');
INSERT INTO catalogue_items VALUES ('530', 'jukebox*1', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '41', '530', 'Jukebox', 'For your Happy Days!', '5');
INSERT INTO catalogue_items VALUES ('531', 'sound_set_1', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '531', 'Habbo Sounds 1', 'Get the party started!', '5');
INSERT INTO catalogue_items VALUES ('532', 'sound_set_12', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '532', 'Habbo Sounds 2', 'Unusual as Standard', '5');
INSERT INTO catalogue_items VALUES ('533', 'sound_set_2', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '533', 'Habbo Sounds 3', 'Get the party started!', '5');
INSERT INTO catalogue_items VALUES ('534', 'sound_set_24', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '534', 'Habbo Sounds 4', 'It\'s all about the Pentiums, baby!', '5');
INSERT INTO catalogue_items VALUES ('535', 'sound_set_43', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '535', 'SFX 1', 'Beware zombies!', '5');
INSERT INTO catalogue_items VALUES ('536', 'sound_set_20', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '536', 'SFX 2', 'Musical heaven', '5');
INSERT INTO catalogue_items VALUES ('537', 'sound_set_22', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '537', 'SFX 3', 'With a hamper full of sounds, not sarnies', '5');
INSERT INTO catalogue_items VALUES ('538', 'sound_set_23', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '538', 'SFX 4', 'Don\'t be afraid of the dark', '5');
INSERT INTO catalogue_items VALUES ('539', 'sound_set_7', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '539', 'SFX 5', 'Sound effects for Furni', '5');
INSERT INTO catalogue_items VALUES ('540', 'sound_set_30', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '540', 'Instrumental 1', 'Moments in love', '5');
INSERT INTO catalogue_items VALUES ('541', 'sound_set_32', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '41', '541', 'Instrumental 2', 'Piano concert set', '5');
INSERT INTO catalogue_items VALUES ('542', 'sound_set_36', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '542', 'Latin Love 1', 'For adult minded', '5');
INSERT INTO catalogue_items VALUES ('543', 'sound_set_60', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '543', 'Latin Love 2', 'Love and affection!', '5');
INSERT INTO catalogue_items VALUES ('544', 'sound_set_61', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '544', 'Latin Love 3', 'Straight from the heart', '5');
INSERT INTO catalogue_items VALUES ('545', 'sound_set_55', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '545', 'RnB Grooves 1', 'Can you fill me in?', '5');
INSERT INTO catalogue_items VALUES ('546', 'sound_set_56', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '546', 'RnB Grooves 2', 'Get down tonight!', '5');
INSERT INTO catalogue_items VALUES ('547', 'sound_set_57', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '547', 'RnB Grooves 3', 'Feel the groove', '5');
INSERT INTO catalogue_items VALUES ('548', 'sound_set_58', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '548', 'RnB Grooves 4', 'Sh-shake it!', '5');
INSERT INTO catalogue_items VALUES ('549', 'sound_set_59', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '549', 'RnB Grooves 5', 'Urban break beats', '5');
INSERT INTO catalogue_items VALUES ('550', 'sound_set_15', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '550', 'RnB Grooves 6', 'Unadulterated essentials', '5');
INSERT INTO catalogue_items VALUES ('551', 'sound_set_10', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '551', 'Hip Hop Beats 1', 'Made from real Boy Bands!', '5');
INSERT INTO catalogue_items VALUES ('552', 'sound_set_14', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '552', 'Hip Hop Beats 2', 'Rock them bodies', '5');
INSERT INTO catalogue_items VALUES ('553', 'sound_set_16', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '553', 'Hip Hop Beats 3', 'Ferry, ferry good!', '5');
INSERT INTO catalogue_items VALUES ('554', 'sound_set_19', '0', '0', '0', '0.10', '0,0,0', '0', '1', '1', '42', '554', 'Hip Hop Beats 4', 'Shake your body!', '5');
INSERT INTO catalogue_items VALUES ('555', 'prizetrophy6*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '555', 'Champion trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('556', 'prizetrophy6*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '556', 'Champion trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('557', 'prizetrophy6*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '557', 'Champion trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('558', 'prizetrophy3*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '558', 'Globe trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('559', 'prizetrophy3*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '559', 'Globe trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('560', 'prizetrophy3*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '560', 'Globe trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('561', 'prizetrophy4*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '561', 'Fish trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('562', 'prizetrophy4*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '562', 'Fish trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('563', 'prizetrophy4*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '563', 'Fish trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('564', 'prizetrophy*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '564', 'Classic trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('565', 'prizetrophy*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '565', 'Classic trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('566', 'prizetrophy*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '566', 'Classic trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('567', 'prizetrophy5*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '567', 'Duo trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('568', 'prizetrophy5*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '568', 'Duo trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('569', 'prizetrophy5*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '569', 'Duo trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('570', 'prizetrophy2*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '570', 'Duck trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('571', 'prizetrophy2*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '43', '571', 'Duck trophy', 'Shiny silver', '10');
INSERT INTO catalogue_items VALUES ('572', 'prizetrophy2*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#996600', '0', '1', '1', '43', '572', 'Duck trophy', 'Breathtaking bronze', '8');
INSERT INTO catalogue_items VALUES ('573', 'prizetrophy8*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '573', 'Duo trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('574', 'prizetrophy9*1', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFDD3F', '0', '1', '1', '43', '574', 'Champion trophy', 'Glittery gold', '12');
INSERT INTO catalogue_items VALUES ('575', 'poster 20', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '575', 'Snowman Poster', 'A new use for carrots!', '3');
INSERT INTO catalogue_items VALUES ('576', 'poster 21', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '576', 'Angel Poster', 'See that halo gleam!', '3');
INSERT INTO catalogue_items VALUES ('577', 'poster 22', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '577', 'Winter Wonderland Poster', 'A chilly snowy scene', '3');
INSERT INTO catalogue_items VALUES ('578', 'poster 23', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '578', 'Santa Poster Poster', 'The jolly fat man himself', '3');
INSERT INTO catalogue_items VALUES ('579', 'poster 24', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '579', 'Three Wise Men Poster', 'Following the star!', '3');
INSERT INTO catalogue_items VALUES ('580', 'poster 25', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '580', 'Reindeer Poster', 'Doing a hard night\'s work', '3');
INSERT INTO catalogue_items VALUES ('581', 'poster 26', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '581', 'Stocking', 'Hung yours up yet?', '3');
INSERT INTO catalogue_items VALUES ('582', 'poster 27', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '582', 'Holly Garland', 'Deck the halls!', '3');
INSERT INTO catalogue_items VALUES ('583', 'poster 28', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '583', 'Tinsel (silver)', 'A touch of festive sparkle', '3');
INSERT INTO catalogue_items VALUES ('584', 'poster 29', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '584', 'Tinsel (gold)', 'A touch of festive sparkle', '3');
INSERT INTO catalogue_items VALUES ('585', 'poster 30', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '585', 'Mistletoe', 'Pucker up', '3');
INSERT INTO catalogue_items VALUES ('586', 'poster 46', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '586', 'Small gold star', 'Twinkle, twinkle', '3');
INSERT INTO catalogue_items VALUES ('587', 'poster 47', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '587', 'Small silver star', 'Twinkle, twinkle', '3');
INSERT INTO catalogue_items VALUES ('588', 'poster 48', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '588', 'Large gold star', 'All that glitters...', '3');
INSERT INTO catalogue_items VALUES ('589', 'poster 49', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '44', '589', 'Large silver star', 'All that glitters...', '3');
INSERT INTO catalogue_items VALUES ('590', 'tree3', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '590', 'Christmas Tree 1', 'Any presents under it yet?', '6');
INSERT INTO catalogue_items VALUES ('591', 'tree4', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '591', 'Christmas Tree 2', 'Any presents under it yet?', '6');
INSERT INTO catalogue_items VALUES ('592', 'tree5', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '592', 'Christmas Tree 3', 'Any presents under it yet?', '6');
INSERT INTO catalogue_items VALUES ('593', 'triplecandle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '593', 'Electric Candles', 'No need to worry about wax drips', '3');
INSERT INTO catalogue_items VALUES ('594', 'turkey', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '594', 'Roast Turkey', 'Where\'s the cranberry sauce?', '3');
INSERT INTO catalogue_items VALUES ('595', 'house', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '595', 'Gingerbread House', 'Good enough to eat', '3');
INSERT INTO catalogue_items VALUES ('596', 'pudding', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '596', 'Christmas Pudding', 'Will you get the lucky sixpence?', '3');
INSERT INTO catalogue_items VALUES ('597', 'xmasduck', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '597', 'Christmas Rubber Duck', 'A right Christmas quacker!', '2');
INSERT INTO catalogue_items VALUES ('598', 'hyacinth1', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '598', 'Pink Hyacinth', 'Beautiful bulb', '3');
INSERT INTO catalogue_items VALUES ('599', 'hyacinth2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '599', 'Blue Hyacinth', 'Beautiful bulb', '3');
INSERT INTO catalogue_items VALUES ('600', 'joulutahti', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '600', 'Poinsetta', 'Christmas in a pot', '3');
INSERT INTO catalogue_items VALUES ('601', 'rcandle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '601', 'Red Candle', 'Xmas tea light', '3');
INSERT INTO catalogue_items VALUES ('602', 'wcandle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '44', '602', 'White Candle', 'Xmas tea light', '3');
INSERT INTO catalogue_items VALUES ('603', 'easterduck', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '45', '603', 'Wannabe bunny', 'Can you tell what it is yet?', '2');
INSERT INTO catalogue_items VALUES ('604', 'birdie', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '45', '604', 'Pop-up Egg', 'Cheep (!) and cheerful', '5');
INSERT INTO catalogue_items VALUES ('605', 'basket', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '45', '605', 'Basket Of Eggs', 'Eggs-actly what you want for Easter', '4');
INSERT INTO catalogue_items VALUES ('606', 'bunny', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '45', '606', 'Squidgy Bunny', 'Yours to cuddle up to', '3');
INSERT INTO catalogue_items VALUES ('607', 'pumpkin', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '607', 'Pumpkin Lamp', 'Cast a spooky glow', '6');
INSERT INTO catalogue_items VALUES ('608', 'poster 42', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '608', 'Spiderweb', 'Not something you want to run into', '3');
INSERT INTO catalogue_items VALUES ('609', 'poster 43', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '609', 'Chains', 'Shake, rattle and roll!', '4');
INSERT INTO catalogue_items VALUES ('610', 'skullcandle', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '610', 'Skull Candle Holder', 'Alas poor Yorrick...', '4');
INSERT INTO catalogue_items VALUES ('611', 'poster 45', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '611', 'Skeleton', 'Needs a few more Habburgers', '3');
INSERT INTO catalogue_items VALUES ('612', 'poster 44', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '612', 'Mummy', 'Beware the curse...', '3');
INSERT INTO catalogue_items VALUES ('613', 'deadduck', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '613', 'Dead Duck', 'Blood, but no guts', '2');
INSERT INTO catalogue_items VALUES ('614', 'deadduck2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '614', 'Dead Duck 2', 'Someone forgot to feed me...', '2');
INSERT INTO catalogue_items VALUES ('615', 'deadduck3', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '615', 'Dead Duck 3', 'With added ectoplasm', '2');
INSERT INTO catalogue_items VALUES ('616', 'poster 50', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '616', 'Bat Poster', 'flap, flap, screech, screech...', '3');
INSERT INTO catalogue_items VALUES ('617', 'poster 501', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '46', '617', 'Jolly Roger', 'For pirates everywhere', '3');
INSERT INTO catalogue_items VALUES ('618', 'ham2', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '618', 'Eaten Ham', 'Looks like you\'re too late!', '3');
INSERT INTO catalogue_items VALUES ('619', 'habboween_crypt', '1', '2', '2', '0.00', '0,0,0', '0', '1', '1', '46', '619', 'HabboWheen Crypt', 'HabboWheen Crypt', '5');
INSERT INTO catalogue_items VALUES ('625', 'habboween_grass', '4', '2', '2', '0.00', '0,0,0', '0', '1', '1', '46', '625', 'HabboWheen Grass', 'HabboWheen Grass', '5');
INSERT INTO catalogue_items VALUES ('620', 'valeduck', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '47', '620', 'Valentine\'s Duck', 'He\'s lovestruck', '2');
INSERT INTO catalogue_items VALUES ('621', 'hal_cauldron', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '621', 'HabboWheen Cauldron', 'HabboWheen Cauldron', '5');
INSERT INTO catalogue_items VALUES ('622', 'hal_grave', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '46', '622', 'HabboWheen Grave', 'HabboWheen Grave', '5');
INSERT INTO catalogue_items VALUES ('623', 'heartsofa', '2', '2', '1', '1.00', '0,0,0', '0', '1', '1', '47', '623', 'Heart Sofa', 'Perfect for snuggling up on', '5');
INSERT INTO catalogue_items VALUES ('624', 'statue', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '47', '624', 'Cupid Statue', 'Watch out for those arrows!', '3');
INSERT INTO catalogue_items VALUES ('626', 'heart', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '47', '626', 'Giant Heart', 'Full of love', '6');
INSERT INTO catalogue_items VALUES ('627', 'post.it.vd', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '47', '627', 'Heart stickies', 'Heart stickies', '3');
INSERT INTO catalogue_items VALUES ('628', 'carpet_valentine', '4', '2', '7', '0.00', '0,0,0', '0', '1', '1', '47', '628', 'Red Carpet', 'For making an entrance.', '15');
INSERT INTO catalogue_items VALUES ('629', 'val_heart', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '47', '629', 'Valentine\'s lamp', 'Valentine\'s lamp', '10');
INSERT INTO catalogue_items VALUES ('630', 'plant_valentinerose*1', '1', '1', '1', '0.00', '#FFFFFF,#FF1E1E,#FFFFFF,#FFFFFF', '0', '1', '1', '47', '630', 'Valentine rose Red', 'For a love that it true', '8');
INSERT INTO catalogue_items VALUES ('631', 'plant_valentinerose*2', '1', '1', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '47', '631', 'White Valentine Rose', 'Your secret love', '8');
INSERT INTO catalogue_items VALUES ('632', 'plant_valentinerose*3', '1', '1', '1', '0.00', '#FFFFFF,#ffee00,#FFFFFF,#FFFFFF', '0', '1', '1', '47', '632', 'Yellow Valentine Rose', 'Relight your passions', '8');
INSERT INTO catalogue_items VALUES ('633', 'plant_valentinerose*4', '1', '1', '1', '0.00', '#FFFFFF,#ffbbcf,#FFFFFF,#FFFFFF', '0', '1', '1', '47', '633', 'Pink Valentine\'s Rose', 'Be mine!', '8');
INSERT INTO catalogue_items VALUES ('634', 'plant_valentinerose*5', '1', '1', '1', '0.00', '#FFFFFF,#CC3399,#FFFFFF,#FFFFFF', '0', '1', '1', '47', '634', 'Purple Valentine Rose', 'For that special pixel', '8');
INSERT INTO catalogue_items VALUES ('635', 'sofa_silo*2', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '0', '1', '1', '48', '635', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('636', 'sofachair_silo*2', '1', '1', '1', '1.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '48', '636', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('637', 'table_silo_small*2', '1', '1', '1', '1.10', '#ffffff,#525252', '0', '1', '1', '48', '637', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('638', 'divider_silo3*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#525252', '1', '1', '1', '48', '638', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('639', 'divider_silo1*2', '1', '1', '1', '1.00', '#ffffff,#525252', '0', '1', '1', '48', '639', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('640', 'chair_silo*2', '2', '1', '1', '1.10', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '48', '640', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('641', 'safe_silo*2', '1', '1', '1', '1.20', '#ffffff,#525252', '0', '1', '1', '48', '641', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('642', 'barchair_silo*2', '1', '1', '1', '0.90', '#ffffff,#525252', '0', '1', '1', '48', '642', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('643', 'table_silo_med*2', '1', '2', '2', '0.90', '#ffffff,#525252', '0', '1', '1', '48', '643', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('644', 'sofa_silo*3', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '48', '644', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('645', 'sofachair_silo*3', '1', '1', '1', '1.00', '#ffffff,#ffffff,#FFFFFF,#FFFFFF', '0', '1', '1', '48', '645', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('646', 'table_silo_small*3', '1', '1', '1', '1.10', '#ffffff,#FFFFFF', '0', '1', '1', '48', '646', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('647', 'divider_silo3*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#FFFFFF', '1', '1', '1', '48', '647', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('648', 'divider_silo1*3', '1', '1', '1', '1.00', '#ffffff,#FFFFFF', '0', '1', '1', '48', '648', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('649', 'chair_silo*3', '2', '1', '1', '1.10', '#ffffff,#ffffff,#FFFFFF,#FFFFFF', '0', '1', '1', '48', '649', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('650', 'safe_silo*3', '1', '1', '1', '1.20', '#ffffff,#FFFFFF', '0', '1', '1', '48', '650', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('651', 'barchair_silo*3', '1', '1', '1', '0.90', '#ffffff,#FFFFFF', '0', '1', '1', '48', '651', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('652', 'table_silo_med*3', '1', '2', '2', '0.90', '#ffffff,#FFFFFF', '0', '1', '1', '48', '652', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('653', 'sofa_silo*4', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '48', '653', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('654', 'sofachair_silo*4', '1', '1', '1', '1.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '48', '654', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('655', 'table_silo_small*4', '1', '1', '1', '1.10', '#ffffff,#F7EBBC', '0', '1', '1', '48', '655', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('656', 'divider_silo3*4', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#F7EBBC', '1', '1', '1', '48', '656', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('657', 'divider_silo1*4', '1', '1', '1', '1.00', '#ffffff,#F7EBBC', '0', '1', '1', '48', '657', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('658', 'chair_silo*4', '2', '1', '1', '1.10', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '48', '658', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('659', 'safe_silo*4', '1', '1', '1', '1.20', '#ffffff,#F7EBBC', '0', '1', '1', '48', '659', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('660', 'barchair_silo*4', '1', '1', '1', '0.90', '#ffffff,#F7EBBC', '0', '1', '1', '48', '660', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('661', 'table_silo_med*4', '1', '2', '2', '0.90', '#ffffff,#F7EBBC', '0', '1', '1', '48', '661', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('662', 'sofa_silo*5', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC,#FF99BC,#FF99BC,#FF99BC', '0', '1', '1', '48', '662', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('663', 'sofachair_silo*5', '1', '1', '1', '1.00', '#ffffff,#ffffff,#FF99BC,#FF99BC', '0', '1', '1', '48', '663', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('664', 'table_silo_small*5', '1', '1', '1', '1.10', '#ffffff,#FF99BC', '0', '1', '1', '48', '664', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('665', 'divider_silo3*5', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#FF99BC', '1', '1', '1', '48', '665', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('666', 'divider_silo1*5', '1', '1', '1', '1.00', '#ffffff,#FF99BC', '0', '1', '1', '48', '666', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('667', 'chair_silo*5', '2', '1', '1', '1.10', '#ffffff,#ffffff,#FF99BC,#FF99BC', '0', '1', '1', '48', '667', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('668', 'safe_silo*5', '1', '1', '1', '1.20', '#ffffff,#FF99BC', '0', '1', '1', '48', '668', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('669', 'barchair_silo*5', '1', '1', '1', '0.90', '#ffffff,#FF99BC', '0', '1', '1', '48', '669', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('670', 'table_silo_med*5', '1', '2', '2', '0.90', '#ffffff,#FF99BC', '0', '1', '1', '48', '670', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('671', 'sofa_silo*6', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '48', '671', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('672', 'sofachair_silo*6', '1', '1', '1', '1.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '48', '672', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('673', 'table_silo_small*6', '1', '1', '1', '1.10', '#ffffff,#5EAAF8', '0', '1', '1', '48', '673', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('674', 'divider_silo3*6', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#5EAAF8', '1', '1', '1', '48', '674', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('675', 'divider_silo1*6', '1', '1', '1', '1.00', '#ffffff,#5EAAF8', '0', '1', '1', '48', '675', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('676', 'chair_silo*6', '2', '1', '1', '1.10', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '48', '676', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('677', 'safe_silo*6', '1', '1', '1', '1.20', '#ffffff,#5EAAF8', '0', '1', '1', '48', '677', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('678', 'barchair_silo*6', '1', '1', '1', '0.90', '#ffffff,#5EAAF8', '0', '1', '1', '48', '678', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('679', 'table_silo_med*6', '1', '2', '2', '0.90', '#ffffff,#5EAAF8', '0', '1', '1', '48', '679', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('680', 'sofa_silo*7', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D,#92D13D', '0', '1', '1', '48', '680', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('681', 'sofachair_silo*7', '1', '1', '1', '1.00', '#ffffff,#ffffff,#92D13D,#92D13D', '0', '1', '1', '48', '681', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('682', 'table_silo_small*7', '1', '1', '1', '1.10', '#ffffff,#92D13D', '0', '1', '1', '48', '682', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('683', 'divider_silo3*7', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#92D13D', '1', '1', '1', '48', '683', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('684', 'divider_silo1*7', '1', '1', '1', '1.00', '#ffffff,#92D13D', '0', '1', '1', '48', '684', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('685', 'chair_silo*7', '2', '1', '1', '1.10', '#ffffff,#ffffff,#92D13D,#92D13D', '0', '1', '1', '48', '685', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('686', 'safe_silo*7', '1', '1', '1', '1.20', '#ffffff,#92D13D', '0', '1', '1', '48', '686', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('687', 'barchair_silo*7', '1', '1', '1', '0.90', '#ffffff,#92D13D', '0', '1', '1', '48', '687', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('688', 'table_silo_med*7', '1', '2', '2', '0.90', '#ffffff,#92D13D', '0', '1', '1', '48', '688', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('689', 'sofa_silo*8', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '0', '1', '1', '48', '689', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('690', 'sofachair_silo*8', '1', '1', '1', '1.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '48', '690', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('691', 'table_silo_small*8', '1', '1', '1', '1.10', '#ffffff,#FFD837', '0', '1', '1', '48', '691', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('692', 'divider_silo3*8', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#FFD837', '1', '1', '1', '48', '692', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('693', 'divider_silo1*8', '1', '1', '1', '1.00', '#ffffff,#FFD837', '0', '1', '1', '48', '693', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('694', 'chair_silo*8', '2', '1', '1', '1.10', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '48', '694', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('695', 'safe_silo*8', '1', '1', '1', '1.20', '#ffffff,#FFD837', '0', '1', '1', '48', '695', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('696', 'barchair_silo*8', '1', '1', '1', '0.90', '#ffffff,#FFD837', '0', '1', '1', '48', '696', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('697', 'table_silo_med*8', '1', '2', '2', '0.90', '#ffffff,#FFD837', '0', '1', '1', '48', '697', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('698', 'sofa_silo*9', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '0', '1', '1', '48', '698', 'Two-Seater Sofa', 'Cushioned, understated comfort', '3');
INSERT INTO catalogue_items VALUES ('699', 'sofachair_silo*9', '1', '1', '1', '1.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '48', '699', 'Armchair', 'Large, but worth it', '3');
INSERT INTO catalogue_items VALUES ('700', 'table_silo_small*9', '1', '1', '1', '1.10', '#ffffff,#E14218', '0', '1', '1', '48', '700', 'Occasional Table', 'For those random moments', '1');
INSERT INTO catalogue_items VALUES ('701', 'divider_silo3*9', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#E14218', '1', '1', '1', '48', '701', 'Gate (lockable)', 'Form following function', '6');
INSERT INTO catalogue_items VALUES ('702', 'divider_silo1*9', '1', '1', '1', '1.00', '#ffffff,#E14218', '0', '1', '1', '48', '702', 'Corner Shelf', 'Neat and natty', '3');
INSERT INTO catalogue_items VALUES ('703', 'chair_silo*9', '2', '1', '1', '1.10', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '48', '703', 'Dining Chair', 'Keep it simple', '3');
INSERT INTO catalogue_items VALUES ('704', 'safe_silo*9', '1', '1', '1', '1.20', '#ffffff,#E14218', '0', '1', '1', '48', '704', 'Safe Minibar', 'Totally shatter-proof!', '3');
INSERT INTO catalogue_items VALUES ('705', 'barchair_silo*9', '1', '1', '1', '0.90', '#ffffff,#E14218', '0', '1', '1', '48', '705', 'Bar Stool', 'Practical and convenient', '3');
INSERT INTO catalogue_items VALUES ('706', 'table_silo_med*9', '1', '2', '2', '0.90', '#ffffff,#E14218', '0', '1', '1', '48', '706', 'Coffee Table', 'Wipe clean and unobtrusive', '3');
INSERT INTO catalogue_items VALUES ('707', 'chair_norja*2', '2', '1', '1', '1.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '49', '707', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('708', 'couch_norja*2', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '0', '1', '1', '49', '708', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('709', 'table_norja_med*2', '1', '2', '2', '0.90', '#ffffff,#525252', '0', '1', '1', '49', '709', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('710', 'shelves_norja*2', '1', '1', '1', '0.00', '#ffffff,#525252', '0', '1', '1', '49', '710', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('711', 'soft_sofachair_norja*2', '2', '1', '1', '1.00', '#ffffff,#525252,#525252', '0', '1', '1', '49', '711', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('712', 'soft_sofa_norja*2', '2', '2', '1', '1.00', '#ffffff,#525252,#ffffff,#525252,#525252,#525252', '0', '1', '1', '49', '712', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('713', 'divider_nor2*2', '1', '2', '1', '0.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '49', '713', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('714', 'divider_nor1*2', '1', '1', '1', '0.00', '#ffffff,#525252', '0', '1', '1', '49', '714', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('715', 'divider_nor3*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#525252,#525252', '1', '1', '1', '49', '715', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('716', 'divider_nor4*2', '1', '2', '1', '0.00', '#ffffff,#ffffff,#525252,#525252,#525252,#525252', '1', '1', '1', '49', '716', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('717', 'divider_nor5*2', '1', '1', '1', '0.00', '#ffffff,#525252,#525252,#525252,#525252,#525252', '1', '1', '1', '49', '717', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('718', 'chair_norja*3', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '49', '718', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('719', 'couch_norja*3', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '49', '719', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('720', 'table_norja_med*3', '1', '2', '2', '0.90', '#ffffff,#ffffff', '0', '1', '1', '49', '720', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('721', 'shelves_norja*3', '1', '1', '1', '0.00', '#ffffff,#ffffff', '0', '1', '1', '49', '721', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('722', 'soft_sofachair_norja*3', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '49', '722', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('723', 'soft_sofa_norja*3', '2', '2', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '49', '723', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('724', 'divider_nor2*3', '1', '2', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '49', '724', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('725', 'divider_nor1*3', '1', '1', '1', '0.00', '#ffffff,#ffffff', '0', '1', '1', '49', '725', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('726', 'divider_nor3*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '49', '726', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('727', 'divider_nor4*3', '1', '2', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '49', '727', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('728', 'divider_nor5*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '49', '728', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('729', 'chair_norja*4', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '49', '729', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('730', 'couch_norja*4', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '49', '730', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('731', 'table_norja_med*4', '1', '2', '2', '0.90', '#ffffff,#ABD0D2', '0', '1', '1', '49', '731', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('732', 'shelves_norja*4', '1', '1', '1', '0.00', '#ffffff,#ABD0D2', '0', '1', '1', '49', '732', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('733', 'soft_sofachair_norja*4', '2', '1', '1', '1.00', '#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '49', '733', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('734', 'soft_sofa_norja*4', '2', '2', '1', '1.00', '#ffffff,#ABD0D2,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '49', '734', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('735', 'divider_nor2*4', '1', '2', '1', '0.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '0', '1', '1', '49', '735', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('736', 'divider_nor1*4', '1', '1', '1', '0.00', '#ffffff,#ABD0D2', '0', '1', '1', '49', '736', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('737', 'divider_nor3*4', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '1', '49', '737', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('738', 'divider_nor4*4', '1', '2', '1', '0.00', '#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '1', '49', '738', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('739', 'divider_nor5*4', '1', '1', '1', '0.00', '#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '1', '49', '739', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('740', 'chair_norja*5', '2', '1', '1', '1.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '49', '740', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('741', 'couch_norja*5', '2', '2', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '0', '1', '1', '49', '741', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('742', 'table_norja_med*5', '1', '2', '2', '0.90', '#ffffff,#EE7EA4', '0', '1', '1', '49', '742', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('743', 'shelves_norja*5', '1', '1', '1', '0.00', '#ffffff,#EE7EA4', '0', '1', '1', '49', '743', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('744', 'soft_sofachair_norja*5', '2', '1', '1', '1.00', '#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '49', '744', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('745', 'soft_sofa_norja*5', '2', '2', '1', '1.00', '#ffffff,#EE7EA4,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4', '0', '1', '1', '49', '745', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('746', 'divider_nor2*5', '1', '2', '1', '0.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '0', '1', '1', '49', '746', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('747', 'divider_nor1*5', '1', '1', '1', '0.00', '#ffffff,#EE7EA4', '0', '1', '1', '49', '747', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('748', 'divider_nor3*5', '1', '1', '1', '0.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '1', '49', '748', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('749', 'divider_nor4*5', '1', '2', '1', '0.00', '#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '1', '49', '749', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('750', 'divider_nor5*5', '1', '1', '1', '0.00', '#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '1', '49', '750', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('751', 'chair_norja*6', '2', '1', '1', '1.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '49', '751', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('752', 'couch_norja*6', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '49', '752', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('753', 'table_norja_med*6', '1', '2', '2', '0.90', '#ffffff,#5EAAF8', '0', '1', '1', '49', '753', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('754', 'shelves_norja*6', '1', '1', '1', '0.00', '#ffffff,#5EAAF8', '0', '1', '1', '49', '754', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('755', 'soft_sofachair_norja*6', '2', '1', '1', '1.00', '#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '49', '755', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('756', 'soft_sofa_norja*6', '2', '2', '1', '1.00', '#ffffff,#5EAAF8,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '49', '756', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('757', 'divider_nor2*6', '1', '2', '1', '0.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '49', '757', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('758', 'divider_nor1*6', '1', '1', '1', '0.00', '#ffffff,#5EAAF8', '0', '1', '1', '49', '758', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('759', 'divider_nor3*6', '1', '1', '1', '0.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '1', '49', '759', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('760', 'divider_nor4*6', '1', '2', '1', '0.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '1', '49', '760', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('761', 'divider_nor5*6', '1', '1', '1', '0.00', '#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '1', '49', '761', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('762', 'chair_norja*7', '2', '1', '1', '1.00', '#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '49', '762', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('763', 'couch_norja*7', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '0', '1', '1', '49', '763', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('764', 'table_norja_med*7', '1', '2', '2', '0.90', '#ffffff,#7CB135', '0', '1', '1', '49', '764', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('765', 'shelves_norja*7', '1', '1', '1', '0.00', '#ffffff,#7CB135', '0', '1', '1', '49', '765', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('766', 'soft_sofachair_norja*7', '2', '1', '1', '1.00', '#ffffff,#7CB135,#7CB135', '0', '1', '1', '49', '766', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('767', 'soft_sofa_norja*7', '2', '2', '1', '1.00', '#ffffff,#7CB135,#ffffff,#7CB135,#7CB135,#7CB135', '0', '1', '1', '49', '767', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('768', 'divider_nor2*7', '1', '2', '1', '0.00', '#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '49', '768', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('769', 'divider_nor1*7', '1', '1', '1', '0.00', '#ffffff,#7CB135', '0', '1', '1', '49', '769', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('770', 'divider_nor3*7', '1', '1', '1', '0.00', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '1', '49', '770', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('771', 'divider_nor4*7', '1', '2', '1', '0.00', '#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '1', '49', '771', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('772', 'divider_nor5*7', '1', '1', '1', '0.00', '#ffffff,#7CB135,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '1', '49', '772', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('773', 'chair_norja*8', '2', '1', '1', '1.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '49', '773', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('774', 'couch_norja*8', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '0', '1', '1', '49', '774', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('775', 'table_norja_med*8', '1', '2', '2', '0.90', '#ffffff,#FFD837', '0', '1', '1', '49', '775', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('776', 'shelves_norja*8', '1', '1', '1', '0.00', '#ffffff,#FFD837', '0', '1', '1', '49', '776', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('777', 'soft_sofachair_norja*8', '2', '1', '1', '1.00', '#ffffff,#FFD837,#FFD837', '0', '1', '1', '49', '777', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('778', 'soft_sofa_norja*8', '2', '2', '1', '1.00', '#ffffff,#FFD837,#ffffff,#FFD837,#FFD837,#FFD837', '0', '1', '1', '49', '778', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('779', 'divider_nor2*8', '1', '2', '1', '0.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '49', '779', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('780', 'divider_nor1*8', '1', '1', '1', '0.00', '#ffffff,#FFD837', '0', '1', '1', '49', '780', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('781', 'divider_nor3*8', '1', '1', '1', '0.00', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '1', '49', '781', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('782', 'divider_nor4*8', '1', '2', '1', '0.00', '#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '1', '49', '782', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('783', 'divider_nor5*8', '1', '1', '1', '0.00', '#ffffff,#FFD837,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '1', '49', '783', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('784', 'chair_norja*9', '2', '1', '1', '1.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '49', '784', 'Chair', 'Sleek and chic for each cheek', '3');
INSERT INTO catalogue_items VALUES ('785', 'couch_norja*9', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '0', '1', '1', '49', '785', 'Bench', 'Two can perch comfortably', '3');
INSERT INTO catalogue_items VALUES ('786', 'table_norja_med*9', '1', '2', '2', '0.90', '#ffffff,#E14218', '0', '1', '1', '49', '786', 'Coffee Table', 'Elegance embodied', '3');
INSERT INTO catalogue_items VALUES ('787', 'shelves_norja*9', '1', '1', '1', '0.00', '#ffffff,#E14218', '0', '1', '1', '49', '787', 'Bookcase', 'For nic naks and art deco books', '3');
INSERT INTO catalogue_items VALUES ('788', 'soft_sofachair_norja*9', '2', '1', '1', '1.00', '#ffffff,#E14218,#E14218', '0', '1', '1', '49', '788', 'iced sofachair', 'Soft iced sofachair', '3');
INSERT INTO catalogue_items VALUES ('789', 'soft_sofa_norja*9', '2', '2', '1', '1.00', '#ffffff,#E14218,#ffffff,#E14218,#E14218,#E14218', '0', '1', '1', '49', '789', 'iced sofa', 'A soft iced sofa', '4');
INSERT INTO catalogue_items VALUES ('790', 'divider_nor2*9', '1', '2', '1', '0.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '49', '790', 'Ice Bar-Desk', 'Strong, yet soft looking', '3');
INSERT INTO catalogue_items VALUES ('791', 'divider_nor1*9', '1', '1', '1', '0.00', '#ffffff,#E14218', '0', '1', '1', '49', '791', 'Ice Corner', 'Looks squishy, but isn\'t', '3');
INSERT INTO catalogue_items VALUES ('792', 'divider_nor3*9', '1', '1', '1', '0.00', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '1', '49', '792', 'Door (Lockable)', 'Do go through...', '6');
INSERT INTO catalogue_items VALUES ('793', 'divider_nor4*9', '1', '2', '1', '0.00', '#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '1', '1', '1', '49', '793', 'Iced Auto Shutter', 'Habbos, roll out!', '3');
INSERT INTO catalogue_items VALUES ('794', 'divider_nor5*9', '1', '1', '1', '0.00', '#ffffff,#E14218,#E14218,#E14218,#E14218,#E14218', '1', '1', '1', '49', '794', 'Iced Angle', 'Cool cornering for you!', '3');
INSERT INTO catalogue_items VALUES ('795', 'bed_polyfon*2', '3', '2', '3', '2.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '50', '795', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('796', 'bed_polyfon_one*2', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '50', '796', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('797', 'sofa_polyfon*2', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '0', '1', '1', '50', '797', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('798', 'sofachair_polyfon*2', '2', '1', '1', '1.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '50', '798', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('799', 'divider_poly3*2', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#525252,#525252', '1', '1', '1', '50', '799', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('800', 'bardesk_polyfon*2', '1', '2', '1', '1.00', '#ffffff,#ffffff,#525252,#525252', '0', '1', '1', '50', '800', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('801', 'bardeskcorner_polyfon*2', '1', '1', '1', '1.00', '#ffffff,#525252', '0', '1', '1', '50', '801', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('802', 'bed_polyfon*3', '3', '2', '3', '2.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '50', '802', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('803', 'bed_polyfon_one*3', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '50', '803', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('804', 'sofa_polyfon*3', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '50', '804', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('805', 'sofachair_polyfon*3', '2', '1', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '50', '805', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('806', 'divider_poly3*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '50', '806', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('807', 'bardesk_polyfon*3', '1', '2', '1', '1.00', '#ffffff,#ffffff,#ffffff,#ffffff', '0', '1', '1', '50', '807', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('808', 'bardeskcorner_polyfon*3', '1', '1', '1', '1.00', '#ffffff,#ffffff', '0', '1', '1', '50', '808', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('809', 'bed_polyfon*4', '3', '2', '3', '2.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '50', '809', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('810', 'bed_polyfon_one*4', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '50', '810', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('811', 'sofa_polyfon*4', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '50', '811', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('812', 'sofachair_polyfon*4', '2', '1', '1', '1.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '50', '812', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('813', 'divider_poly3*4', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '1', '50', '813', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('814', 'bardesk_polyfon*4', '1', '2', '1', '1.00', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '0', '1', '1', '50', '814', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('815', 'bardeskcorner_polyfon*4', '1', '1', '1', '1.00', '#ffffff,#F7EBBC', '0', '1', '1', '50', '815', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('816', 'bed_polyfon*6', '3', '2', '3', '2.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '50', '816', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('817', 'bed_polyfon_one*6', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '50', '817', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('818', 'sofa_polyfon*6', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '50', '818', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('819', 'sofachair_polyfon*6', '2', '1', '1', '1.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '50', '819', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('820', 'divider_poly3*6', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '1', '50', '820', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('821', 'bardesk_polyfon*6', '1', '2', '1', '1.00', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '0', '1', '1', '50', '821', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('822', 'bardeskcorner_polyfon*6', '1', '1', '1', '1.00', '#ffffff,#5EAAF8', '0', '1', '1', '50', '822', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('823', 'bed_polyfon*7', '3', '2', '3', '2.00', '#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '50', '823', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('824', 'bed_polyfon_one*7', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '50', '824', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('825', 'sofa_polyfon*7', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '0', '1', '1', '50', '825', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('826', 'sofachair_polyfon*7', '2', '1', '1', '1.00', '#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '50', '826', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('827', 'divider_poly3*7', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '1', '50', '827', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('828', 'bardesk_polyfon*7', '1', '2', '1', '1.00', '#ffffff,#ffffff,#7CB135,#7CB135', '0', '1', '1', '50', '828', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('829', 'bardeskcorner_polyfon*7', '1', '1', '1', '1.00', '#ffffff,#7CB135', '0', '1', '1', '50', '829', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('830', 'bed_polyfon*8', '3', '2', '3', '2.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '50', '830', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('831', 'bed_polyfon_one*8', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '50', '831', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('832', 'sofa_polyfon*8', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '0', '1', '1', '50', '832', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('833', 'sofachair_polyfon*8', '2', '1', '1', '1.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '50', '833', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('834', 'divider_poly3*8', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '1', '50', '834', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('835', 'bardesk_polyfon*8', '1', '2', '1', '1.00', '#ffffff,#ffffff,#FFD837,#FFD837', '0', '1', '1', '50', '835', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('836', 'bardeskcorner_polyfon*8', '1', '1', '1', '1.00', '#ffffff,#FFD837', '0', '1', '1', '50', '836', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('837', 'bed_polyfon*9', '3', '2', '3', '2.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '50', '837', 'Double Bed', 'Give yourself space to stretch out', '4');
INSERT INTO catalogue_items VALUES ('838', 'bed_polyfon_one*9', '3', '1', '3', '2.00', '#ffffff,#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '50', '838', 'Single Bed', 'Cot of the artistic', '3');
INSERT INTO catalogue_items VALUES ('839', 'sofa_polyfon*9', '2', '2', '1', '1.10', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '0', '1', '1', '50', '839', 'Two-seater Sofa', 'Comfort for stylish couples', '4');
INSERT INTO catalogue_items VALUES ('840', 'sofachair_polyfon*9', '2', '1', '1', '1.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '50', '840', 'Armchair', 'Loft-style comfort', '3');
INSERT INTO catalogue_items VALUES ('841', 'divider_poly3*9', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#E14218,#E14218', '1', '1', '1', '50', '841', 'Hatch (Lockable)', 'All bars should have one', '6');
INSERT INTO catalogue_items VALUES ('842', 'bardesk_polyfon*9', '1', '2', '1', '1.00', '#ffffff,#ffffff,#E14218,#E14218', '0', '1', '1', '50', '842', 'Bar/desk', 'Perfect for work or play', '3');
INSERT INTO catalogue_items VALUES ('843', 'bardeskcorner_polyfon*9', '1', '1', '1', '1.00', '#ffffff,#E14218', '0', '1', '1', '50', '843', 'Corner Cabinet/Desk', 'Tuck it away', '3');
INSERT INTO catalogue_items VALUES ('844', 'pura_mdl1*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '0', '1', '1', '51', '844', 'Aqua Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('845', 'pura_mdl2*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '0', '1', '1', '51', '845', 'Aqua Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('846', 'pura_mdl3*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '0', '1', '1', '51', '846', 'Aqua Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('847', 'pura_mdl4*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '0', '1', '1', '51', '847', 'Aqua Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('848', 'pura_mdl5*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#FFFFFF', '0', '1', '1', '51', '848', 'Aqua Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('849', 'pura_mdl1*2', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '0', '1', '1', '51', '849', 'Pink Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('850', 'pura_mdl2*2', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '0', '1', '1', '51', '850', 'Pink Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('851', 'pura_mdl3*2', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '0', '1', '1', '51', '851', 'Pink Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('852', 'pura_mdl4*2', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '0', '1', '1', '51', '852', 'Pink Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('853', 'pura_mdl5*2', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '0', '1', '1', '51', '853', 'Pink Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('854', 'pura_mdl1*3', '2', '1', '1', '1.00', '#FFFFFF,#525252,#525252,#FFFFFF', '0', '1', '1', '51', '854', 'Black Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('855', 'pura_mdl2*3', '2', '1', '1', '1.00', '#FFFFFF,#525252,#525252,#FFFFFF', '0', '1', '1', '51', '855', 'Black Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('856', 'pura_mdl3*3', '2', '1', '1', '1.00', '#FFFFFF,#525252,#525252,#FFFFFF', '0', '1', '1', '51', '856', 'Black Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('857', 'pura_mdl4*3', '2', '1', '1', '1.00', '#FFFFFF,#525252,#525252,#525252', '0', '1', '1', '51', '857', 'Black Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('858', 'pura_mdl5*3', '2', '1', '1', '1.00', '#FFFFFF,#525252,#525252,#FFFFFF', '0', '1', '1', '51', '858', 'Black Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('859', 'pura_mdl1*4', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '859', 'White Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('860', 'pura_mdl2*4', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '860', 'White Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('861', 'pura_mdl3*4', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '861', 'White Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('862', 'pura_mdl4*4', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '862', 'White Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('863', 'pura_mdl5*4', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '863', 'White Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('864', 'pura_mdl1*5', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '0', '1', '1', '51', '864', 'Beige Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('865', 'pura_mdl2*5', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '0', '1', '1', '51', '865', 'Beige Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('866', 'pura_mdl3*5', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '0', '1', '1', '51', '866', 'Beige Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('867', 'pura_mdl4*5', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '0', '1', '1', '51', '867', 'Beige Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('868', 'pura_mdl5*5', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '0', '1', '1', '51', '868', 'Beige Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('869', 'pura_mdl1*6', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '0', '1', '1', '51', '869', 'Blue Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('870', 'pura_mdl2*6', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '0', '1', '1', '51', '870', 'Blue Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('871', 'pura_mdl3*6', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '0', '1', '1', '51', '871', 'Blue Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('872', 'pura_mdl4*6', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '0', '1', '1', '51', '872', 'Blue Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('873', 'pura_mdl5*6', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '0', '1', '1', '51', '873', 'Blue Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('874', 'pura_mdl1*7', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '0', '1', '1', '51', '874', 'Green Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('875', 'pura_mdl2*7', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '0', '1', '1', '51', '875', 'Green Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('876', 'pura_mdl3*7', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '0', '1', '1', '51', '876', 'Green Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('877', 'pura_mdl4*7', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#92D13D,#92D13D', '0', '1', '1', '51', '877', 'Green Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('878', 'pura_mdl5*7', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '0', '1', '1', '51', '878', 'Green Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('879', 'pura_mdl1*8', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '0', '1', '1', '51', '879', 'Yellow Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('880', 'pura_mdl2*8', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '0', '1', '1', '51', '880', 'Yellow Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('881', 'pura_mdl3*8', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '0', '1', '1', '51', '881', 'Yellow Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('882', 'pura_mdl4*8', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFD837,#FFD837', '0', '1', '1', '51', '882', 'Yellow Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('883', 'pura_mdl5*8', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '0', '1', '1', '51', '883', 'Yellow Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('884', 'pura_mdl1*9', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#E14218,#FFFFFF', '0', '1', '1', '51', '884', 'Red Pura module 1', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('885', 'pura_mdl2*9', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#E14218,#FFFFFF', '0', '1', '1', '51', '885', 'Red Pura module 2', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('886', 'pura_mdl3*9', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#E14218,#FFFFFF', '0', '1', '1', '51', '886', 'Red Pura module 3', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('887', 'pura_mdl4*9', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#E14218,#E14218', '0', '1', '1', '51', '887', 'Red Pura module 4', 'Endless fun!', '2');
INSERT INTO catalogue_items VALUES ('888', 'pura_mdl5*9', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#E14218,#FFFFFF', '0', '1', '1', '51', '888', 'Red Pura module 5', 'Endless fun!', '1');
INSERT INTO catalogue_items VALUES ('889', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#ABD0D2,#FFFFFF', '0', '1', '1', '51', '889', 'Aqua Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('890', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#FF99BC,#FFFFFF', '0', '1', '1', '51', '890', 'Pink Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('891', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#525252,#FFFFFF', '0', '1', '1', '51', '891', 'Black Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('892', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '51', '892', 'White Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('893', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#F7EBBC,#FFFFFF', '0', '1', '1', '51', '893', 'Beige Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('894', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#5EAAF8,#FFFFFF', '0', '1', '1', '51', '894', 'Blue Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('895', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#92D13D,#FFFFFF', '0', '1', '1', '51', '895', 'Green Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('896', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#FFD837,#FFFFFF', '0', '1', '1', '51', '896', 'Yellow Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('897', 'chair_basic*1', '2', '1', '1', '1.00', '#FFFFFF,#E14218,#FFFFFF', '0', '1', '1', '51', '897', 'Red Retro Chair', 'Sitback and relax', '5');
INSERT INTO catalogue_items VALUES ('898', 'grand_piano*1', '1', '2', '2', '0.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '52', '898', 'Rose Grand Piano', 'Rose Grand Piano', '10');
INSERT INTO catalogue_items VALUES ('899', 'romantique_pianochair*1', '2', '1', '1', '1.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '52', '899', 'Rose Quartz Piano Stool', 'Here sat the legend of 1900', '2');
INSERT INTO catalogue_items VALUES ('900', 'romantique_chair*1', '2', '1', '1', '1.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '52', '900', 'Rose Quartz Chair', 'Elegant seating for elegant Habbos', '5');
INSERT INTO catalogue_items VALUES ('901', 'romantique_divan*1', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FF8B8B', '0', '1', '1', '52', '901', 'Rose Romantique Divan', 'null', '6');
INSERT INTO catalogue_items VALUES ('902', 'romantique_divider*1', '1', '2', '1', '0.00', '#FF8B8B,#FF8B8B,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '52', '902', 'Rose Quartz Screen', 'Beauty lies within', '6');
INSERT INTO catalogue_items VALUES ('903', 'romantique_smalltabl*1', '1', '1', '1', '0.00', '#FFFFFF,#FF8B8B,#FFFFFF', '0', '1', '1', '52', '903', 'Rose Quartz Tray Table', 'Every tray needs a table...', '4');
INSERT INTO catalogue_items VALUES ('904', 'grand_piano*2', '1', '2', '2', '0.00', '#FFFFFF,#A1DC67,#FFFFFF', '0', '1', '1', '52', '904', 'Lime Grand Piano', 'Lime Grand Piano', '10');
INSERT INTO catalogue_items VALUES ('905', 'romantique_pianochair*2', '2', '1', '1', '1.00', '#FFFFFF,#A1DC67,#FFFFFF', '0', '1', '1', '52', '905', 'Lime Piano Chair', 'Let the music begin', '2');
INSERT INTO catalogue_items VALUES ('906', 'romantique_chair*2', '2', '1', '1', '1.00', '#FFFFFF,#A1DC67,#FFFFFF', '0', '1', '1', '52', '906', 'Lime Romantique Chair', 'null', '5');
INSERT INTO catalogue_items VALUES ('907', 'romantique_divan*2', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#A1DC67', '0', '1', '1', '52', '907', 'Emerald Chaise-Longue', 'Recline in continental comfort', '6');
INSERT INTO catalogue_items VALUES ('908', 'romantique_divider*2', '1', '2', '1', '0.00', '#A1DC67,#A1DC67,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '52', '908', 'Green Screen', 'Keeping things separated', '6');
INSERT INTO catalogue_items VALUES ('909', 'romantique_smalltabl*2', '1', '1', '1', '1.00', '#FFFFFF,#A1DC67,#FFFFFF', '0', '1', '1', '52', '909', 'Lime Tray Table', 'Every tray needs a table...', '4');
INSERT INTO catalogue_items VALUES ('910', 'grand_piano*3', '1', '2', '2', '0.00', '#FFFFFF,#5BD1D2,#FFFFFF', '0', '1', '1', '52', '910', 'Pink Grand Piano', 'Make sure you play in key!', '10');
INSERT INTO catalogue_items VALUES ('911', 'romantique_pianochair*3', '2', '1', '1', '1.00', '#FFFFFF,#5BD1D2,#FFFFFF', '0', '1', '1', '52', '911', 'Turquoise Piano Chair', 'null', '2');
INSERT INTO catalogue_items VALUES ('912', 'romantique_chair*3', '2', '1', '1', '1.00', '#FFFFFF,#5BD1D2,#FFFFFF', '0', '1', '1', '52', '912', 'Turquoise Chair', 'null', '5');
INSERT INTO catalogue_items VALUES ('913', 'romantique_divan*3', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#5BD1D2', '0', '1', '1', '52', '913', 'Turquoise Divan', 'null', '6');
INSERT INTO catalogue_items VALUES ('914', 'romantique_divider*3', '1', '2', '1', '0.00', '#5BD1D2,#5BD1D2,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '52', '914', 'Turquoise Screen', 'Keeping things separated', '6');
INSERT INTO catalogue_items VALUES ('915', 'romantique_smalltabl*3', '1', '1', '1', '1.00', '#FFFFFF,#5BD1D2,#FFFFFF', '0', '1', '1', '52', '915', 'Turquoise Tray Table', 'Every tray needs a table...', '4');
INSERT INTO catalogue_items VALUES ('916', 'grand_piano*4', '1', '2', '2', '0.00', '#FFFFFF,#FFC924,#FFFFFF', '0', '1', '1', '52', '916', 'Amber Grand Piano', 'Why is that key green?', '10');
INSERT INTO catalogue_items VALUES ('917', 'romantique_pianochair*4', '2', '1', '1', '1.00', '#FFFFFF,#FFC924,#FFFFFF', '0', '1', '1', '52', '917', 'Amber Piano Stool', 'I can feel air coming through...', '2');
INSERT INTO catalogue_items VALUES ('918', 'romantique_chair*4', '2', '1', '1', '1.00', '#FFFFFF,#FFC924,#FFFFFF', '0', '1', '1', '52', '918', 'Amber Chair', 'What does this button do?', '5');
INSERT INTO catalogue_items VALUES ('919', 'romantique_divan*4', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFC924', '0', '1', '1', '52', '919', 'Amber Chaise-Longue', 'Is that a cape hanging there?', '6');
INSERT INTO catalogue_items VALUES ('920', 'romantique_divider*4', '1', '2', '1', '0.00', '#FFC924,#FFC924,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '52', '920', 'Ochre Screen', 'Keeping things separated', '6');
INSERT INTO catalogue_items VALUES ('921', 'romantique_smalltabl*4', '1', '1', '1', '1.00', '#FFFFFF,#FFC924,#FFFFFF', '0', '1', '1', '52', '921', 'Amber Tray Table', 'Why is one leg different?', '4');
INSERT INTO catalogue_items VALUES ('922', 'grand_piano*5', '1', '2', '2', '0.00', '#FFFFFF,#323C46,#FFFFFF', '0', '1', '1', '52', '922', 'Onyx Grand Piano', 'Why is that key green?', '10');
INSERT INTO catalogue_items VALUES ('923', 'romantique_pianochair*5', '2', '1', '1', '1.00', '#FFFFFF,#323C46,#FFFFFF', '0', '1', '1', '52', '923', 'Onyx Piano Stool', 'I can feel air coming through...', '2');
INSERT INTO catalogue_items VALUES ('924', 'romantique_chair*5', '2', '1', '1', '1.00', '#FFFFFF,#323C46,#FFFFFF', '0', '1', '1', '52', '924', 'Onyx Chair', 'What does this button do?', '5');
INSERT INTO catalogue_items VALUES ('925', 'romantique_divan*5', '2', '2', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#323C46', '0', '1', '1', '52', '925', 'Onyx Chaise-Longue', 'Is that a cape hanging there?', '6');
INSERT INTO catalogue_items VALUES ('926', 'romantique_divider*5', '1', '2', '1', '0.00', '#323C46,#323C46,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '52', '926', 'Onyx Quartz Screen', 'Beauty lies within', '6');
INSERT INTO catalogue_items VALUES ('927', 'romantique_smalltabl*5', '1', '1', '1', '1.00', '#FFFFFF,#323C46,#FFFFFF', '0', '1', '1', '52', '927', 'Onyx Tray Table', 'Why is one leg different?', '4');
INSERT INTO catalogue_items VALUES ('928', 'club_sofa', '2', '2', '1', '1.00', '0,0,0', '0', '1', '1', '53', '928', 'Club sofa', 'Importants habbos only', '25');
INSERT INTO catalogue_items VALUES ('929', 'chair_plasto*14', '2', '1', '1', '1.00', '#ffffff,#3CB4F0,#ffffff,#3CB4F0', '0', '1', '1', '53', '929', 'HC chair', 'Aqua chair', '3');
INSERT INTO catalogue_items VALUES ('930', 'table_plasto_4leg*14', '1', '2', '2', '1.10', '#ffffff,#3CB4F0,#ffffff,#3CB4F0', '0', '1', '1', '53', '930', 'HC table', 'Aqua table', '3');
INSERT INTO catalogue_items VALUES ('931', 'mocchamaster', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '931', 'Mochamaster', 'Wake up and smell it!', '25');
INSERT INTO catalogue_items VALUES ('932', 'edicehc', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '932', 'Dicemaster', 'Click and roll!', '25');
INSERT INTO catalogue_items VALUES ('933', 'hcamme', '2', '1', '2', '1.00', '0,0,0', '0', '1', '1', '53', '933', 'Tubmaster', 'Time for a soak', '25');
INSERT INTO catalogue_items VALUES ('934', 'doorD', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '934', 'Imperial Teleport', 'Let\'s go over tzar!', '25');
INSERT INTO catalogue_items VALUES ('935', 'hcsohva', '2', '2', '1', '1.00', '0,0,0', '0', '1', '1', '53', '935', 'Throne Sofa', 'For royal bottoms...', '25');
INSERT INTO catalogue_items VALUES ('936', 'hc_lmp', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '936', 'Oil Lamp', 'Be enlightened', '25');
INSERT INTO catalogue_items VALUES ('937', 'hc_tbl', '1', '1', '3', '1.00', '0,0,0', '0', '1', '1', '53', '937', 'Nordic Table', 'Perfect for banquets', '25');
INSERT INTO catalogue_items VALUES ('938', 'hc_chr', '2', '1', '1', '1.00', '0,0,0', '0', '1', '1', '53', '938', 'Majestic Chair', 'Royal comfort', '25');
INSERT INTO catalogue_items VALUES ('939', 'hc_dsk', '1', '1', '2', '0.00', '0,0,0', '0', '1', '1', '53', '939', 'Study Desk', 'For Habbo scholars', '25');
INSERT INTO catalogue_items VALUES ('940', 'hc_trll', '1', '1', '2', '0.00', '0,0,0', '0', '1', '1', '53', '940', 'Drinks Trolley', 'For swanky dinners only', '25');
INSERT INTO catalogue_items VALUES ('941', 'hc_crpt', '4', '3', '5', '0.00', '0,0,0', '0', '1', '1', '53', '941', 'Persian Carpet', 'Ultimate craftsmanship', '25');
INSERT INTO catalogue_items VALUES ('942', 'hc_lmpst', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '942', 'Victorian Street Light', 'Somber and atmospheric', '25');
INSERT INTO catalogue_items VALUES ('943', 'hc_crtn', '1', '2', '1', '0.00', '0,0,0', '1', '1', '1', '53', '943', 'Antique Drapery', 'Topnotch privacy protection', '25');
INSERT INTO catalogue_items VALUES ('944', 'hc_tv', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '53', '944', 'Mega TV Set', 'Forget plasma, go HC!', '25');
INSERT INTO catalogue_items VALUES ('945', 'hc_btlr', '1', '1', '1', '0.00', '0,0,0', '0', '1', '1', '53', '945', 'Electric Butler', 'Your personal caretaker', '25');
INSERT INTO catalogue_items VALUES ('946', 'hc_bkshlf', '1', '1', '4', '0.00', '0,0,0', '0', '1', '1', '53', '946', 'Medieval Bookcase', 'For the scholarly ones', '25');
INSERT INTO catalogue_items VALUES ('947', 'hc_rntgn', '1', '2', '1', '0.00', '0,0,0', '0', '1', '1', '53', '947', 'X-Ray Divider', 'Believe it or not!', '25');
INSERT INTO catalogue_items VALUES ('948', 'hc_machine', '1', '1', '3', '0.00', '0,0,0', '0', '1', '1', '53', '948', 'Weird Science Machine', 'By and for mad inventors', '25');
INSERT INTO catalogue_items VALUES ('949', 'hc_frplc', '1', '1', '3', '0.00', '0,0,0', '0', '1', '1', '53', '949', 'Heavy Duty Fireplace', 'Pixel-powered for maximum heating', '25');
INSERT INTO catalogue_items VALUES ('950', 'hc_djset', '1', '3', '1', '0.00', '0,0,0', '0', '1', '1', '53', '950', 'The Grammophon', 'Very old skool scratch\'n\'spin', '25');
INSERT INTO catalogue_items VALUES ('951', 'hc_wall_lamp', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '53', '951', 'Retro Wall Lamp', 'Tres chic!', '25');
INSERT INTO catalogue_items VALUES ('952', 'roomdimmer', '0', '0', '0', '0.00', '0,0,0', '0', '1', '1', '54', '952', 'Moodlight', 'Turn this off when you\'re gonna bend her over', '25');
INSERT INTO catalogue_items VALUES ('953', 'rare_dragonlamp*0', '1', '1', '1', '0.00', '#ffffff,#fa2d00,#fa2d00', '0', '1', '1', '55', '953', 'Fire Dragon Lamp', 'George and the...', '25');
INSERT INTO catalogue_items VALUES ('954', 'rare_dragonlamp*1', '1', '1', '1', '0.00', '#ffffff,#3470ff,#3470ff', '0', '1', '1', '55', '954', 'Sea Dragon Lamp', 'Out of the deep blue!', '25');
INSERT INTO catalogue_items VALUES ('955', 'rare_dragonlamp*2', '1', '1', '1', '0.00', '#ffffff,#02bb70,#02bb70', '0', '1', '1', '55', '955', 'Jade Dragon Lamp', 'Oriental beast of legends', '25');
INSERT INTO catalogue_items VALUES ('956', 'rare_dragonlamp*3', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff', '0', '1', '1', '55', '956', 'Silver Dragon Lamp', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('957', 'rare_dragonlamp*4', '1', '1', '1', '0.00', '#ffffff,#3e3d40,#3e3d40', '0', '1', '1', '55', '957', 'Serpent of Doom', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('958', 'rare_dragonlamp*5', '1', '1', '1', '0.00', '#ffffff,#589a03,#589a03', '0', '1', '1', '55', '958', 'Elf Green Dragon Lamp', 'Roast your chestnuts here!', '25');
INSERT INTO catalogue_items VALUES ('959', 'rare_dragonlamp*6', '1', '1', '1', '0.00', '#ffffff,#ffbc00,#ffbc00', '0', '1', '1', '55', '959', 'Gold Dragon Lamp', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('960', 'rare_dragonlamp*7', '1', '1', '1', '0.00', '#ffffff,#83aeff,#83aeff', '0', '1', '1', '55', '960', 'Sky Dragon Lamp', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('961', 'rare_dragonlamp*8', '1', '1', '1', '0.00', '#ffffff,#ff5f01,#ff5f01', '0', '1', '1', '55', '961', 'Bronze Dragon Lamp', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('962', 'rare_dragonlamp*9', '1', '1', '1', '0.00', '#FFFFFF,#B357FF,#B357FF', '0', '1', '1', '55', '962', 'Purple Dragon Lamp', 'Scary and scorching!', '25');
INSERT INTO catalogue_items VALUES ('963', 'rare_fan*0', '1', '1', '1', '0.00', '#F43100,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '963', 'Festive Fan', 'As red as Rudolph\'s nose', '25');
INSERT INTO catalogue_items VALUES ('964', 'rare_fan*1', '1', '1', '1', '0.00', '#3C75FF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '964', 'Blue Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('965', 'rare_fan*2', '1', '1', '1', '0.00', '#55CD01,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '965', 'Green Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('966', 'rare_fan*3', '1', '1', '1', '0.00', '#BC9BFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '966', 'Purple Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('967', 'rare_fan*4', '1', '1', '1', '0.00', '#e78b8b,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '967', 'SUPERLOVE Fan', 'Fanning the fires of SUPERLOVE...', '25');
INSERT INTO catalogue_items VALUES ('968', 'rare_fan*5', '1', '1', '1', '0.00', '#ffcc00,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '968', 'Yellow Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('969', 'rare_fan*6', '1', '1', '1', '0.00', '#FF8000,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '969', 'Ochre Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('970', 'rare_fan*7', '1', '1', '1', '0.00', '#682B00,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '970', 'Brown Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('971', 'rare_fan*8', '1', '1', '1', '0.00', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '971', 'Habbo Wind Turbine', 'Stylish, Eco-Energy!', '25');
INSERT INTO catalogue_items VALUES ('972', 'rare_fan*9', '1', '1', '1', '0.00', '#FF60B0,#FFFFFF,#FFFFFF,#FFFFFF', '0', '1', '1', '56', '972', 'Fucsia Powered Fan', 'It\'ll blow you away!', '25');
INSERT INTO catalogue_items VALUES ('973', 'rare_icecream*0', '1', '1', '1', '0.00', '#FFFFFF,#d02a1f', '0', '1', '1', '57', '973', 'Cherry Ice Cream', 'Virtual cherry rocks!', '25');
INSERT INTO catalogue_items VALUES ('974', 'rare_icecream*1', '1', '1', '1', '0.00', '#FFFFFF,#55c4de', '0', '1', '1', '57', '974', 'Blueberry Ice Cream', 'Virtual blueberry rocks!', '25');
INSERT INTO catalogue_items VALUES ('975', 'rare_icecream*2', '1', '1', '1', '0.00', '#FFFFFF,#94f718', '0', '1', '1', '57', '975', 'Pistachio Ice Cream', 'Virtual pistachio rocks!', '25');
INSERT INTO catalogue_items VALUES ('976', 'rare_icecream*3', '1', '1', '1', '0.00', '#FFFFFF,#B357FF', '0', '1', '1', '57', '976', 'Blackcurrant Ice Cream', 'Virtual blackcurrant rocks!', '25');
INSERT INTO catalogue_items VALUES ('977', 'rare_icecream*4', '1', '1', '1', '0.00', '#FFFFFF,#e78b8b', '0', '1', '1', '57', '977', 'Strawberry Ice Cream', 'Virtual strawberry rocks!', '25');
INSERT INTO catalogue_items VALUES ('978', 'rare_icecream*5', '1', '1', '1', '0.00', '#FFFFFF,#E1CC00', '0', '1', '1', '57', '978', 'Vanilla Ice Cream', 'Virtual vanilla rocks!', '25');
INSERT INTO catalogue_items VALUES ('979', 'rare_icecream*6', '1', '1', '1', '0.00', '#FFFFFF,#FF8000', '0', '1', '1', '57', '979', 'Toffee Ice Cream', 'Virtual toffee rocks!', '25');
INSERT INTO catalogue_items VALUES ('980', 'rare_icecream*7', '1', '1', '1', '0.00', '#FFFFFF,#97420C', '0', '1', '1', '57', '980', 'Chocolate Ice Cream', 'Virtual chocolate rocks!', '25');
INSERT INTO catalogue_items VALUES ('981', 'rare_icecream*8', '1', '1', '1', '0.00', '#FFFFFF,#00E5E2', '0', '1', '1', '57', '981', 'Peppermint Ice Cream', 'Virtual peppermint rocks!', '25');
INSERT INTO catalogue_items VALUES ('982', 'rare_icecream*9', '1', '1', '1', '0.00', '#FFFFFF,#FF60B0', '0', '1', '1', '57', '982', 'Bubblegum Ice Cream', 'Virtual bubblegum rocks!', '25');
INSERT INTO catalogue_items VALUES ('983', 'rubberchair*1', '2', '1', '1', '1.00', '#0080FF,0,0', '0', '1', '1', '58', '983', 'Blue Inflatable Chair', 'Soft and stylish HC chair', '25');
INSERT INTO catalogue_items VALUES ('984', 'rubberchair*2', '2', '1', '1', '1.00', '#FF8B8B,0,0', '0', '1', '1', '58', '984', 'Pink Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('985', 'rubberchair*3', '2', '1', '1', '1.00', '#FF8000,0,0', '0', '1', '1', '58', '985', 'Orange Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('986', 'rubberchair*4', '2', '1', '1', '1.00', '#00E5E2,0,0', '0', '1', '1', '58', '986', 'Ocean Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('987', 'rubberchair*5', '2', '1', '1', '1.00', '#A1DC67,0,0', '0', '1', '1', '58', '987', 'Lime Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('988', 'rubberchair*6', '2', '1', '1', '1.00', '#B357FF,0,0', '0', '1', '1', '58', '988', 'Violet Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('989', 'rubberchair*7', '2', '1', '1', '1.00', '#CFCFCF,0,0', '0', '1', '1', '58', '989', 'White Inflatable Chair', 'Soft and tearproof!', '25');
INSERT INTO catalogue_items VALUES ('990', 'rubberchair*8', '2', '1', '1', '1.00', '#333333,0,0', '0', '1', '1', '58', '990', 'Black Inflatable Chair', 'Soft and tearproof for HC!', '25');
INSERT INTO catalogue_items VALUES ('991', 'scifiport*0', '1', '1', '1', '0.00', '#ffffff,#F43100,#ffffff,#ffffff,#ffffff,#F43100', '1', '1', '1', '59', '991', 'Red Laser Door', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('992', 'scifiport*1', '1', '1', '1', '0.00', '#ffffff,#ffbc00,#ffffff,#ffffff,#ffffff,#ffbc00', '1', '1', '1', '59', '992', 'Gold Laser Gate', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('993', 'scifiport*2', '1', '1', '1', '0.00', '#ffffff,#5599ff,#ffffff,#ffffff,#ffffff,#5599ff', '1', '1', '1', '59', '993', 'Blue Laser Gate', 'Get in the ring!', '25');
INSERT INTO catalogue_items VALUES ('994', 'scifiport*3', '1', '1', '1', '0.00', '#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70', '1', '1', '1', '59', '994', 'Jade Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('995', 'scifiport*4', '1', '1', '1', '0.00', '#ffffff,#e78b8b,#ffffff,#ffffff,#ffffff,#e78b8b', '1', '1', '1', '59', '995', 'Pink Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('996', 'scifiport*5', '1', '1', '1', '0.00', '#ffffff,#555555,#ffffff,#ffffff,#ffffff,#555555', '1', '1', '1', '59', '996', 'Security Fence', 'Recovered from Roswell', '25');
INSERT INTO catalogue_items VALUES ('997', 'scifiport*6', '1', '1', '1', '0.00', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '59', '997', 'White Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('998', 'scifiport*7', '1', '1', '1', '0.00', '#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc', '1', '1', '1', '59', '998', 'Turquoise Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('999', 'scifiport*8', '1', '1', '1', '0.00', '#ffffff,#bb55cc,#ffffff,#ffffff,#ffffff,#bb55cc', '1', '1', '1', '59', '999', 'Purple Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('1000', 'scifiport*9', '1', '1', '1', '0.00', '#ffffff,#B357FF,#ffffff,#ffffff,#ffffff,#B357FF', '1', '1', '1', '59', '1000', 'Violet Sci-Fi Port', 'Energy beams. No trespassers!', '25');
INSERT INTO catalogue_items VALUES ('1001', 'song_disk', '1', '1', '1', '0.20', '0,0,0', '0', '1', '1', '-1', '0', '', '', '0');

-- ----------------------------
-- Table structure for `catalogue_pages`
-- ----------------------------
DROP TABLE IF EXISTS `catalogue_pages`;
CREATE TABLE `catalogue_pages` (
  `indexid` tinyint(3) NOT NULL,
  `orderid` tinyint(3) NOT NULL DEFAULT '0',
  `minrank` tinyint(1) NOT NULL,
  `indexname` varchar(100) COLLATE latin1_general_ci NOT NULL,
  `displayname` varchar(100) COLLATE latin1_general_ci NOT NULL,
  `style_layout` varchar(100) COLLATE latin1_general_ci NOT NULL,
  `img_header` varchar(100) COLLATE latin1_general_ci DEFAULT NULL,
  `img_side` text COLLATE latin1_general_ci,
  `label_description` text COLLATE latin1_general_ci,
  `label_misc` text COLLATE latin1_general_ci,
  `label_moredetails` varchar(150) COLLATE latin1_general_ci DEFAULT NULL,
  PRIMARY KEY (`indexid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of catalogue_pages
-- ----------------------------
INSERT INTO catalogue_pages VALUES ('1', '0', '1', 'Frontpage', 'Frontpage', 'ctlg_frontpage2', 'catal_fp_header', 'catal_fp_pic4,catal_fp_pic5,', 'Need some Furni for your Habbo room?  Well, you?re in the right place!  This Catalogue is packed FULL of funky Furni, just click the tabs on the right to browse.<br><br>We regularly add and remove Furni, so check back regularly for new items.', 's:Need some Funky Furni for your Habbo room?', 't1:You need Habbo Credits to buy Furni for your room, click the Purse at the bottom of your screen for more information about Credits.');
INSERT INTO catalogue_pages VALUES ('5', '0', '1', 'no rares', 'Rare', 'ctlg_norares', 'catalog_rares_headline1', 'ctlg_norare_char1,', 'There isn\'t a rare item to buy at the moment, but it\'s coming soon! Please don\'t email us about it - we\'re keeping it secret...<br>', '', '');
INSERT INTO catalogue_pages VALUES ('6', '0', '7', 'Rare', 'Rare', 'ctlg_productpage1', 'catalog_rares_headline1', '', 'It\'s Spring, and it\'s the best time to stock up on Parasols! Go get your Green Parasol Now!:', 's:Only for 2 weeks!!!', '');
INSERT INTO catalogue_pages VALUES ('7', '0', '1', 'Spaces', 'Spaces', 'ctlg_spaces', 'catalog_spaces_headline1', null, 'Are your walls looking a little grey?  What you need is a splash of paint and this is the place to get it!  <br><br>A splash of colour on the walls and a nice carpet can make all the difference. Use our virtual room below to test out the combinations before you buy.', 't1:Wall\rt2:Floor\rt3:Pattern\rt4:Colour\rt5:Pattern\rt6:Colour\rt7:Preview', null);
INSERT INTO catalogue_pages VALUES ('8', '0', '1', 'Pets', 'Pets', 'ctlg_pets', 'catalog_pet_headline1', 'catalog_pets_teaser1,', 'Fluff, scales and whiskers, meows, snaps and woofs!  Anyone can have a pet on Habbo!  Select your new pet from our ever changing selection, just click to page two then click back, to see more pets!', 'u:Pets2', 'Adopt a Pet today!');
INSERT INTO catalogue_pages VALUES ('9', '0', '1', 'Pet Accesories', 'Pet Accessories', 'ctlg_layout2', 'catalog_pet_headline2', 'ctlg_pet_teaser1,', 'You\'ll need to take care of your pet to keep it happy and healthy. This section of the Catalogue has EVERYTHING you?ll need to satisfy your pet?s needs.', 's:You\'ll have to share it!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('10', '0', '1', 'Area', 'Area', 'ctlg_layout2', 'catalog_area_headline1', 'catalog_area_teaser1,', 'Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. It\'s beautiful in its simplicity, and welcoming to everyone.', 's:2: Beautiful in it\'s simplicity!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('11', '0', '1', 'Accessories', 'Accessories', 'ctlg_layout2', 'catalog_extra_headline1', 'catalog_extra_teaser1,', 'Is your room missing something?  Well, now you can add the finishing touches that express your true personality. And don\'t forget, like everything else, these accessories can be moved about to suit your mood.', 's:2: I love my rabbit...', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('12', '0', '1', 'Asian', 'Asian', 'ctlg_layout2', 'catalog_asian_headline1', 'catalog_asian_teaser1,', 'Dit pure haandwerk uit de eeuwenoude oosterse pixeltraditie brengt balans in elk Habbointerieur. Jin en Yang vloeien samen met Feng en Shui in een uitgebalanceerde collectie meubi. ', 's:2: Oh, look there! Is Mulan the girl of Disney xD', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('13', '0', '1', 'Bathroom', 'Bathroom', 'ctlg_layout2', 'catalog_bath_headline1', 'catalog_bath_teaser1,', 'Introducing the Bathroom Collection...  Have some fun with the cheerful bathroom collection. Give yourself and your guests somewhere to freshen up - vital if you want to avoid nasty niffs. Put your loo in a corner though...', 's:2: Every Habbo needs one!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('14', '0', '1', 'Candy', 'Candy', 'ctlg_layout2', 'catalog_candy_headline1', 'catalog_candy_teaser1,', 'Introducing the Candy Collection...  Candy combines the cool, clean lines of the Mode collection with a softer, more soothing style. It\'s urban sharpness with a hint of the feminine.', 's:2: Relax! It\'s faux-fur.', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('16', '0', '1', 'Flags', 'Flags', 'ctlg_layout2', 'catalog_flags_headline1', 'catalog_flags_teaser1,', 'If you\'re feeling patriotic, get a flag to prove it. Our finest cloth flags will brighten up the dullest walls.', 's:2: Flag this section for later!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('17', '0', '1', 'Gallery', 'Gallery', 'ctlg_layout2', 'catalog_gallery_headline1', 'catalog_posters_teaser1,', 'Adorn your walls with wondrous works of art, posters, plaques and wall hangings. We have items to suit all tastes, from kitsch to cool, traditional to modern.', 's:2: Brighten up your walls!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('18', '0', '1', 'Glass', 'Glass', 'ctlg_layout2', 'catalog_glass_headline1', 'catalog_glass_teaser1,', 'Glass: Habbo Hotels exclusive furni line made from plexiglass, in different colors! Buy here your furni for a modern lounge!', 's:2: Oh My God, it\'s transparant!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('19', '0', '1', 'Gothic', 'Gothic', 'ctlg_layout2', 'catalog_gothic_headline1', 'catalog_gothic_teaser1,', 'The Gothic section is full of medieval looking Furni. Check back for additions to this section as there are still some unreleased items to come!', 's:Gothic is my style.', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('20', '0', '1', 'Grunge', 'Grunge', 'ctlg_layout2', 'catalog_gru_headline1', 'catalog_gru_teaser,', 'Introducing the Grunge Range. Alternative Habbos with alternative style or rebellious students with a point to prove. The Grunge range will get your bedroom looking just the way you like it - organised, neat and tidy!', '', 'New! Flaming Barrels out now!');
INSERT INTO catalogue_pages VALUES ('21', '0', '1', 'Habbo Exchange', 'Habbo Exchange', 'ctlg_layout2', 'catalog_bank_headline1', 'catalog_bank_teaser,', 'The Habbo Exchange is where you can convert your Habbo Credits into a tradable currency. You can use this tradable currency to exchange Habbo Credits for Furni!', 's:Refundable goods!', 'Click on an item to see more details');
INSERT INTO catalogue_pages VALUES ('22', '0', '1', 'Habbowood', 'Habbowood', 'ctlg_layout2', 'catalog_limited_headline1', 'catalog_limited_teaser1,', 'Exclusive: the new Habbowood furni, collect them all!', 's:1: Light, Camera, Action!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('23', '0', '1', 'Iced', 'Iced', 'ctlg_layout2', 'catalog_iced_headline1', 'catalog_iced_teaser1,', 'Introducing the Iced Collection...  For the Habbo who needs no introduction. It\'s so chic, it says everything and nothing. It\'s a blank canvas, let your imagination to run wild!', 's:2: These chairs are so comfy.', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('24', '0', '1', 'Japanese', 'Japanese', 'ctlg_layout2', 'catalog_jap_headline2', 'catalog_jap_teaser3,', 'Here you can find the new Japanese furni! Get them now!', 's:1: Brand new furni!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('25', '0', '1', 'Lodge', 'Lodge', 'ctlg_layout2', 'catalog_lodge_headline1', 'catalog_lodge_teaser1,', 'Introducing the Lodge Collection...  Do you appreciate the beauty of wood?  For that ski lodge effect, or to match that open fire... Lodge is the Furni of choice for Habbos with that no frills approach to decorating.  <br>', 's:2: I LOVE this wood Furni!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('26', '0', '1', 'Mode', 'Mode', 'ctlg_layout2', 'catalog_mode_headline1', 'catalog_mode_teaser1,', 'Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.', 's:2: So shiny and new...', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('27', '0', '1', 'Offers', 'Offers', 'ctlg_layout2', 'catalog_deals_headline1', 'catalog_deals_teaser1,', 'Special Offers are great if you?re just starting out. Take a look at our special collections, all at a great price.<br><br>Check them out!', '', 'Click on a deal to find out what\'s included and how much it costs.');
INSERT INTO catalogue_pages VALUES ('28', '0', '1', 'Plants', 'Plants', 'ctlg_layout2', 'catalog_plants_headline1', 'catalog_plants_teaser1,', 'New, never before seen Bulrush Plant is here for a limited time only. Buy it now!<br>Introducing the Plant Collection...  Every room needs a plant! Not only do they bring a bit of the outside inside, they also enhance the air quality!', 's:2: I am at one with the trees', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('29', '0', '1', 'Plastic', 'Plastic', 'ctlg_plasto', 'catalog_plasto_headline1', null, 'Introducing The Plastic Collection...  Can you feel that 1970s vibe?  Decorate with Plastic and add some colour to your life. Choose a colour that reflect your mood, or just pick your favourite shade.', 't2:Select The Colour\rs:New colours!\rt3:Preview\rt1:Choose An Item', 'Select an item and a colour and buy!');
INSERT INTO catalogue_pages VALUES ('30', '0', '1', 'Presents', 'Presents', 'ctlg_presents', 'catalog_gifts_headline1', 'catalog_presents_teaser1,catalog_presents_teaser2,', 'Show your Habbo friends just how much you care and send them a gift from the Habbo Catalogue.  ANY Catalogue item can be sent as a gift to ANY Habbo, all you need is their Habbo name!', 't1:Buying an item as a gift couldn?to be simpler...  <br><br>Buy an item from the Catalogue in the normal way, but tick \'buy as a gift\'. Tell us which Habbo you want to give the gift to and we\'ll gift wrap it and deliver it straight to their hand.', '');
INSERT INTO catalogue_pages VALUES ('31', '0', '1', 'Pura', 'Pura', 'ctlg_layout2', 'catalog_pura_headline1', 'catalog_pura_teaser1,', 'Introducing the Pura Collection...  This collection breathes fresh, clean air and cool tranquility. The Pura Waltzer has arrived!  Check back regularly to see  new colours of Pura on sale!', '', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('32', '0', '1', 'Recycler', 'Recycler', 'ctlg_recycler', 'catalog_recycler_headline1', null, null, '', null);
INSERT INTO catalogue_pages VALUES ('33', '0', '1', 'Rollers', 'Rollers', 'ctlg_layout2', 'catalog_roller_headline1', '', 'Move your imagination, while you move your Habbo!  Perfect for mazes, games, for keeping your queue moving or making your pet go round in circles for hours.  Available in multi-packs ? the more you buy the cheaper the Roller! Pink Rollers out now!', 's:You can fit 35 Rollers in a Guest Room!', 'Click on a Roller to see more information!');
INSERT INTO catalogue_pages VALUES ('34', '0', '1', 'Romantique', 'Romantique', 'ctlg_layout2', 'catalog_romantique_headline1', 'catalog_rom_teaser,', 'The Romantique range features Grand Pianos, old antique lamps and tables. It is the ideal range for setting a warm and loving mood in your room. Spruce up your room and invite that special someone over. Now featuring the extra special COLOUR edition.', '', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('35', '0', '1', 'Rugs', 'Rugs', 'ctlg_layout2', 'catalog_rugs_headline1', 'catalog_rugs_teaser1,', 'We have rugs for all occasions.  All rugs are non-slip and washable.', 's:2: Rugs, rugs and more rugs!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('36', '0', '1', 'Sports', 'Sports', 'ctlg_layout2', 'catalog_sports_headline1', 'catalog_sports_teaser1,', 'For the sporty habbos, here is the sports section!', null, 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('37', '0', '1', 'Teleport', 'Teleport', 'ctlg_layout2', 'catalog_doors_headline1', 'catalog_teleports_teaser2,catalog_door_c,catalog_door_b,', 'Beam your Habbo from one room to another with one of our cunningly disguised, space age teleports. Now you can link any two rooms together! Teleports are sold in pairs, so if you trade for them, check you\'re getting a linked pair.', 's:Teleport!', 'Select an item by clicking one of the icons on the left.');
INSERT INTO catalogue_pages VALUES ('38', '0', '1', 'Trax Ambient', 'Trax Ambient', 'ctlg_soundmachine', 'catalog_trx_header1', 'catalog_trx_teaser1,', 'Welcome to the Ambient Trax Store! With groovy beats and chilled out melodies, this is the section for some cool and relaxing tunes.', null, null);
INSERT INTO catalogue_pages VALUES ('39', '0', '1', 'Trax Dance', 'Trax Dance', 'ctlg_soundmachine', 'catalog_trx_header2', 'catalog_trx_teaser2,', 'Welcome to the Dance Trax Store! With funky beats and catchy melodies, this is the section for every clubber  to indulge in.', null, null);
INSERT INTO catalogue_pages VALUES ('40', '0', '1', 'Trax Rock', 'Trax Rock', 'ctlg_soundmachine', 'catalog_trx_header3', 'catalog_trx_teaser3,', 'Welcome to the Rock Trax Store! With heavy beats and rockin\' riffs, this is the section for every rock fan to experiment with.', null, null);
INSERT INTO catalogue_pages VALUES ('41', '0', '1', 'Trax SFX', 'Trax SFX', 'ctlg_soundmachine', 'catalog_trx_header4', 'catalog_trx_teaser4,', 'Welcome to the SFX Trax Store! With crazy sounds and weird noises, this is the section for every creative room builder  to indulge in.', null, null);
INSERT INTO catalogue_pages VALUES ('42', '0', '1', 'Trax Urban', 'Trax Urban', 'ctlg_soundmachine', 'catalog_trx_header5', 'catalog_trx_teaser5,', 'Welcome to the Urban Trax Store! With hip hop beats and RnB vocals, this is the section for every city bopper  to indulge in.', null, null);
INSERT INTO catalogue_pages VALUES ('43', '0', '1', 'Trophies', 'Trophies', 'ctlg_trophies', 'catalog_trophies_headline1', '', 'Reward your Habbo friends, or yourself with one of our fabulous glittering array of bronze, silver and gold trophies.<br><br>First choose the trophy model (click on the arrows to see all the different styles) and then the metal (click on the seal below the trophy). Type your inscription below and we\'ll engrave it on the trophy along with your name and today\'s date.', 't1:Type your inscription CAREFULLY, it\'s permanent!', null);
INSERT INTO catalogue_pages VALUES ('44', '0', '7', 'Christmas', 'Christmas', 'ctlg_layout2', 'catalog_xmas_headline1', 'catalog_xmas_teaser,', 'The Habbo Christmas catalogue has everything you need to make the perfect festive room: Trees, ducks with santa hats on, puddings and of course, Menorahs!', 's:2:Tuck into Christmas!', 'Click on an item to see a bigger version of it!');
INSERT INTO catalogue_pages VALUES ('45', '0', '7', 'Easter', 'Easter', 'ctlg_layout2', 'catalog_easter_headline1', 'catalog_easter_teaser1,', '\'Egg\'cellent furni - Bouncing bunnies, fluffy chicks, choccy eggs... Yep, it\'s Easter! Celebrate with something \'eggs\'tra special from our Easter range. But hurry - it\'s not here for long this year!', 's:2: \'Egg\'-Tastic!', 'Click on an item for more details.');
INSERT INTO catalogue_pages VALUES ('46', '0', '7', 'Halloween', 'Halloween', 'ctlg_layout2', 'catalog_halloween_headline1', 'catalog_halloween_teaser,', 'Yes, it\'s a spookfest! Get your boney hands on our creepy collection of ghoulish goodies. But be quick - they\'ll be gone from the Catalogue after two weeks!', 's:2:Halloween is My day!', 'Click on an item to see a bigger version of it!');
INSERT INTO catalogue_pages VALUES ('47', '0', '7', 'Love', 'Love', 'ctlg_layout2', 'catalog_love_headline1', 'catalog_love_teaser1,', 'The love collection has everything to create the perfect love room, for a good price!', 's:2:Oh! Comes Valentine\'s Day!', 'Click on an item to see a bigger version of it!');
INSERT INTO catalogue_pages VALUES ('48', '0', '7', 'Area Colour', 'Area Colour', 'ctlg_layout2', 'catalog_area_headline1', 'catalog_area_teaser1,', 'Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. It\'s beautiful in its simplicity, and welcoming to everyone.', 's:Much More Colours!!!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('49', '0', '7', 'Iced Colour', 'Iced Colour', 'ctlg_layout2', 'catalog_iced_headline1', 'catalog_iced_teaser1,', 'Introducing the Iced Collection...  For the Habbo who needs no introduction. It\'s so chic, it says everything and nothing. It\'s a blank canvas, let your imagination to run wild!', 's:Much More Colours!!!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('50', '0', '7', 'Mode Colour', 'Mode Colour', 'ctlg_layout2', 'catalog_mode_headline1', 'catalog_mode_teaser1,', 'Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.', 's:Much More Colours!!!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('51', '0', '7', 'Pura Colour', 'Pura Colour', 'ctlg_layout2', 'catalog_pura_headline1', 'catalog_pura_teaser1,', 'Introducing the Pura Collection...  This collection breathes fresh, clean air and cool tranquility. The Pura Waltzer has arrived!  Check back regularly to see  new colours of Pura on sale!', 's:Much More Colours!!!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('52', '0', '7', 'Romantique Colour', 'Romantique Colour', 'ctlg_layout2', 'catalog_romantique_headline1', 'catalog_rom_teaser,', 'The Romantique range features Grand Pianos, old antique lamps and tables. It is the ideal range for setting a warm and loving mood in your room. Spruce up your room and invite that special someone over. Now featuring the extra special COLOUR edition.', 's:Much More Colours!!!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('53', '0', '7', 'Club Furni', 'Club Furni', 'ctlg_layout2', 'catalog_club_headline1', 'catalog_hc_teaser,', 'Welcome to the club furni page. Here you can buy any club furni for just 25 credits!', 's:For Habbo Club members only!', 'Click on an item to see more details');
INSERT INTO catalogue_pages VALUES ('54', '0', '7', 'Club Shop', 'Club Shop', 'ctlg_layout2', 'catalog_club_headline1', 'catalog_hc_teaser,', 'Welcome to the Brand New Habbo Club Shop, where Habbo Club members can purchase exclusive items!<br>The Furni in this section can only be purchased by Habbos who have joined Habbo Club.', 's:For Habbo Club members only!', 'Click on an item to see more details');
INSERT INTO catalogue_pages VALUES ('55', '0', '7', 'Dragons', 'Dragons', 'ctlg_layout2', 'catalog_jap_headline2', 'catalog_jap_teaser3,', 'Here you can find the Power of Dragons! Get them now!', 's:1: All Colours!', 'Click on the item you want for more information.');
INSERT INTO catalogue_pages VALUES ('56', '0', '7', 'Fans', 'Fans', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('57', '0', '7', 'Ice Cream Rare', 'Ice Cream Rare', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('58', '0', '7', 'Inflatables', 'Inflatables', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('59', '0', '7', 'Laser Gates', 'Laser Gates', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('60', '0', '7', 'Marquee', 'Marquee', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('61', '0', '7', 'Monoliths', 'Monoliths', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('62', '0', '7', 'Oriental Screen', 'Oriental Screen', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('63', '0', '7', 'Pilars Rare', 'Pilars Rare', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('64', '0', '7', 'Pillow Rare', 'Pillow Rare', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('65', '0', '7', 'Smoke Machines', 'Smoke Machines', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('66', '0', '7', 'Summer Pools', 'Summer Pools', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('67', '0', '7', 'Rares', 'Rares', 'ctlg_layout2', 'catalog_rares_headline1', '', 'Hm... You have permission to stay here? Oh! if you don\'t have permission, please go away!!!', 's:Restricted Zone', 'Select a item, and see more details');
INSERT INTO catalogue_pages VALUES ('68', '0', '7', 'Trophies Rare', 'Tropies Rare', '', '', '', '', '', '');
INSERT INTO catalogue_pages VALUES ('69', '0', '7', 'Limited Edition', 'Limited Edition', 'ctlg_layout2', 'catalog_limited_headline1', 'catalog_limited_teaser1,', 'Get it while its hot.. <br><br>LIMITED EDITION FURNITURE!', '', 'For a limited time only!');

-- ----------------------------
-- Table structure for `catalogue_products`
-- ----------------------------
DROP TABLE IF EXISTS `catalogue_products`;
CREATE TABLE `catalogue_products` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(30) NOT NULL,
  `description` varchar(100) NOT NULL,
  `pageid` tinyint(3) NOT NULL,
  `templateid` int(10) NOT NULL,
  `cost` int(5) NOT NULL,
  `deal` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2898 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of catalogue_products
-- ----------------------------
INSERT INTO catalogue_products VALUES ('1900', 'Green Parasol', 'Block those rays!', '6', '1', '25', '0');
INSERT INTO catalogue_products VALUES ('1901', 'floor', 'Floor', '7', '2', '3', '0');
INSERT INTO catalogue_products VALUES ('1902', 'wallpaper', 'wallpaper', '7', '3', '3', '0');
INSERT INTO catalogue_products VALUES ('1903', 'wallpaper', 'wallpaper', '7', '4', '3', '0');
INSERT INTO catalogue_products VALUES ('1904', 'wallpaper', 'wallpaper', '7', '5', '3', '0');
INSERT INTO catalogue_products VALUES ('1905', 'wallpaper', 'wallpaper', '7', '6', '3', '0');
INSERT INTO catalogue_products VALUES ('1906', 'wallpaper', 'wallpaper', '7', '7', '3', '0');
INSERT INTO catalogue_products VALUES ('1907', 'wallpaper', 'wallpaper', '7', '8', '3', '0');
INSERT INTO catalogue_products VALUES ('1908', 'wallpaper', 'wallpaper', '7', '9', '3', '0');
INSERT INTO catalogue_products VALUES ('1909', 'wallpaper', 'wallpaper', '7', '10', '3', '0');
INSERT INTO catalogue_products VALUES ('1910', 'wallpaper', 'wallpaper', '7', '11', '3', '0');
INSERT INTO catalogue_products VALUES ('1911', 'wallpaper', 'wallpaper', '7', '12', '3', '0');
INSERT INTO catalogue_products VALUES ('1912', 'wallpaper', 'wallpaper', '7', '13', '5', '0');
INSERT INTO catalogue_products VALUES ('1913', 'wallpaper', 'wallpaper', '7', '14', '5', '0');
INSERT INTO catalogue_products VALUES ('1914', 'wallpaper', 'wallpaper', '7', '15', '5', '0');
INSERT INTO catalogue_products VALUES ('1915', 'wallpaper', 'wallpaper', '7', '16', '5', '0');
INSERT INTO catalogue_products VALUES ('1916', 'wallpaper', 'wallpaper', '7', '17', '5', '0');
INSERT INTO catalogue_products VALUES ('1917', 'wallpaper', 'wallpaper', '7', '18', '5', '0');
INSERT INTO catalogue_products VALUES ('1918', 'wallpaper', 'wallpaper', '7', '19', '5', '0');
INSERT INTO catalogue_products VALUES ('1919', 'wallpaper', 'wallpaper', '7', '20', '5', '0');
INSERT INTO catalogue_products VALUES ('1920', 'wallpaper', 'wallpaper', '7', '21', '5', '0');
INSERT INTO catalogue_products VALUES ('1921', 'wallpaper', 'wallpaper', '7', '22', '5', '0');
INSERT INTO catalogue_products VALUES ('1922', 'wallpaper', 'wallpaper', '7', '23', '5', '0');
INSERT INTO catalogue_products VALUES ('1923', 'wallpaper', 'wallpaper', '7', '24', '5', '0');
INSERT INTO catalogue_products VALUES ('1924', 'wallpaper', 'wallpaper', '7', '25', '5', '0');
INSERT INTO catalogue_products VALUES ('1925', 'wallpaper', 'wallpaper', '7', '26', '5', '0');
INSERT INTO catalogue_products VALUES ('1926', 'wallpaper', 'wallpaper', '7', '27', '5', '0');
INSERT INTO catalogue_products VALUES ('1927', 'wallpaper', 'wallpaper', '7', '28', '5', '0');
INSERT INTO catalogue_products VALUES ('1928', 'wallpaper', 'wallpaper', '7', '29', '5', '0');
INSERT INTO catalogue_products VALUES ('1929', 'wallpaper', 'wallpaper', '7', '30', '5', '0');
INSERT INTO catalogue_products VALUES ('1930', 'wallpaper', 'wallpaper', '7', '31', '5', '0');
INSERT INTO catalogue_products VALUES ('1931', 'wallpaper', 'wallpaper', '7', '32', '5', '0');
INSERT INTO catalogue_products VALUES ('1932', 'wallpaper', 'wallpaper', '7', '33', '5', '0');
INSERT INTO catalogue_products VALUES ('1933', 'Basket', 'Night, night', '8', '34', '20', '0');
INSERT INTO catalogue_products VALUES ('1934', 'Basket', 'Night, night', '8', '35', '20', '0');
INSERT INTO catalogue_products VALUES ('1935', 'Basket', 'Night, night', '8', '36', '20', '0');
INSERT INTO catalogue_products VALUES ('1936', 'Doggy Bones', 'Natural nutrition for the barking one', '0', '37', '2', '0');
INSERT INTO catalogue_products VALUES ('1937', 'Sardines', 'Fresh catch of the day', '0', '38', '2', '0');
INSERT INTO catalogue_products VALUES ('1938', 'Cabbage', 'Health food for pets', '0', '39', '2', '0');
INSERT INTO catalogue_products VALUES ('1939', 'T-Bones', 'For the croc!', '0', '40', '2', '0');
INSERT INTO catalogue_products VALUES ('1940', 'Doggy Bones', 'Natural nutrition for the barking one', '9', '41', '1', '0');
INSERT INTO catalogue_products VALUES ('1941', 'Sardines', 'Fresh catch of the day', '9', '42', '1', '0');
INSERT INTO catalogue_products VALUES ('1942', 'Cabbage', 'Health food for pets', '9', '43', '1', '0');
INSERT INTO catalogue_products VALUES ('1943', 'T-Bones', 'For the croc!', '9', '44', '1', '0');
INSERT INTO catalogue_products VALUES ('1944', 'Red Water Bowl', 'Aqua unlimited', '9', '45', '2', '0');
INSERT INTO catalogue_products VALUES ('1945', 'Green Water Bowl', 'Aqua unlimited', '9', '46', '2', '0');
INSERT INTO catalogue_products VALUES ('1946', 'Yellow Water Bowl', 'Aqua unlimited', '9', '47', '2', '0');
INSERT INTO catalogue_products VALUES ('1947', 'Blue Water Bowl', 'Aqua unlimited', '9', '48', '2', '0');
INSERT INTO catalogue_products VALUES ('1948', 'Brown Water Bowl', 'Aqua unlimited', '9', '49', '2', '0');
INSERT INTO catalogue_products VALUES ('1949', 'Chocolate Mouse', 'For gourmet kittens', '9', '50', '1', '0');
INSERT INTO catalogue_products VALUES ('1950', 'Marzipan Man', 'Crunchy Dog Treat', '9', '51', '1', '0');
INSERT INTO catalogue_products VALUES ('1951', 'Marzipan Man', 'Crunchy Dog Treat', '9', '52', '1', '0');
INSERT INTO catalogue_products VALUES ('1952', 'Marzipan Man', 'Crunchy Dog Treat', '9', '53', '1', '0');
INSERT INTO catalogue_products VALUES ('1953', 'Rubber Ball', 'it\'s bouncy-tastic', '9', '54', '2', '0');
INSERT INTO catalogue_products VALUES ('1954', 'Rubber Ball', 'it\'s bouncy-tastic', '9', '55', '2', '0');
INSERT INTO catalogue_products VALUES ('1955', 'Rubber Ball', 'it\'s bouncy-tastic', '9', '56', '2', '0');
INSERT INTO catalogue_products VALUES ('1956', 'Rubber Ball', 'it\'s bouncy-tastic', '9', '57', '2', '0');
INSERT INTO catalogue_products VALUES ('1957', 'Rubber Ball', 'it\'s bouncy-tastic', '9', '58', '2', '0');
INSERT INTO catalogue_products VALUES ('1958', 'Area Quest Desk', 'For the true Habbo Scholars', '10', '59', '15', '0');
INSERT INTO catalogue_products VALUES ('1959', 'Double Bed', 'Plain and simple x2', '10', '60', '3', '0');
INSERT INTO catalogue_products VALUES ('1960', 'Single Bed', 'Plain and simple', '10', '61', '3', '0');
INSERT INTO catalogue_products VALUES ('1961', 'Bookcase', 'For nic naks and art deco books', '10', '62', '3', '0');
INSERT INTO catalogue_products VALUES ('1962', 'Two-Seater Sofa', 'Cushioned, understated comfort', '10', '63', '3', '0');
INSERT INTO catalogue_products VALUES ('1963', 'Armchair', 'Large, but worth it', '10', '64', '3', '0');
INSERT INTO catalogue_products VALUES ('1964', 'Occasional Table', 'For those random moments', '10', '65', '1', '0');
INSERT INTO catalogue_products VALUES ('1965', 'Gate (lockable)', 'Form following function', '10', '66', '6', '0');
INSERT INTO catalogue_products VALUES ('1966', 'Screen', 'Stylish sectioning', '10', '67', '3', '0');
INSERT INTO catalogue_products VALUES ('1967', 'Corner Shelf', 'Neat and natty', '10', '68', '3', '0');
INSERT INTO catalogue_products VALUES ('1968', 'Dining Chair', 'Keep it simple', '10', '69', '3', '0');
INSERT INTO catalogue_products VALUES ('1969', 'Safe Minibar', 'Totally shatter-proof!', '10', '70', '3', '0');
INSERT INTO catalogue_products VALUES ('1970', 'Bar Stool', 'Practical and convenient', '10', '71', '3', '0');
INSERT INTO catalogue_products VALUES ('1971', 'Coffee Table', 'Wipe clean and unobtrusive', '10', '72', '3', '0');
INSERT INTO catalogue_products VALUES ('1972', 'Digital TV', 'Bang up to date', '11', '73', '6', '0');
INSERT INTO catalogue_products VALUES ('1973', 'Large TV', 'For family viewing', '11', '74', '4', '0');
INSERT INTO catalogue_products VALUES ('1974', 'Portable TV', 'Don\'t miss those soaps', '11', '75', '3', '0');
INSERT INTO catalogue_products VALUES ('1975', 'Pad of stickies', 'Pad of stickies', '11', '76', '3', '0');
INSERT INTO catalogue_products VALUES ('1976', 'Pizza Box', 'You dirty Habbo', '11', '77', '3', '0');
INSERT INTO catalogue_products VALUES ('1977', 'Empty Cans', 'Are you a slob too?', '11', '78', '3', '0');
INSERT INTO catalogue_products VALUES ('1978', 'Empty Spinning Bottle', 'For interesting games!', '11', '79', '3', '0');
INSERT INTO catalogue_products VALUES ('1979', 'Holo-dice', 'What\'s your lucky number?', '11', '80', '6', '0');
INSERT INTO catalogue_products VALUES ('1980', 'Cake', 'Save me a slice!', '11', '81', '4', '0');
INSERT INTO catalogue_products VALUES ('1981', 'Menorah', 'Light up your room', '11', '82', '3', '0');
INSERT INTO catalogue_products VALUES ('1982', 'Squidgy Bunny', 'Yours to cuddle up to', '11', '83', '3', '0');
INSERT INTO catalogue_products VALUES ('1983', 'Mummy', 'Beware the curse...', '11', '84', '3', '0');
INSERT INTO catalogue_products VALUES ('1984', 'White Candle Plate', 'Simple but stylish', '11', '85', '3', '0');
INSERT INTO catalogue_products VALUES ('1985', 'Red Candle Plate', 'Simple but stylish', '11', '86', '3', '0');
INSERT INTO catalogue_products VALUES ('1986', 'Joint of Ham', 'Tuck in', '11', '87', '3', '0');
INSERT INTO catalogue_products VALUES ('1987', 'Lert', 'Set it off.', '11', '88', '5', '0');
INSERT INTO catalogue_products VALUES ('1988', 'Drakenscherm', 'Voor je eigen Grote Muur', '12', '89', '8', '0');
INSERT INTO catalogue_products VALUES ('1989', 'Voor Grote Muur', 'Stevig en vuurvast', '12', '90', '8', '0');
INSERT INTO catalogue_products VALUES ('1990', 'Lakwerk boekenkast', 'Bewaarder van je boekenschat', '12', '91', '8', '0');
INSERT INTO catalogue_products VALUES ('1991', 'Yin Yang tafel', 'Exotic and classy', '12', '92', '5', '0');
INSERT INTO catalogue_products VALUES ('1992', 'Yin Yang stoel', 'Zitten in evenwicht', '12', '93', '5', '0');
INSERT INTO catalogue_products VALUES ('1993', 'Kalligrafie', 'Een kwast, vaste hand en concentratie', '12', '94', '3', '0');
INSERT INTO catalogue_products VALUES ('1994', 'Chinese rode knopen', 'Veel geluk!', '12', '95', '5', '0');
INSERT INTO catalogue_products VALUES ('1995', 'Yin Yang bank', 'Zitten in evenwicht!', '12', '96', '10', '0');
INSERT INTO catalogue_products VALUES ('1996', 'Rode lantaarn', 'Zacht licht voor je Habbo Kamer', '12', '97', '15', '0');
INSERT INTO catalogue_products VALUES ('1997', 'Bubble Bath', 'The ultimate in pampering', '13', '98', '6', '0');
INSERT INTO catalogue_products VALUES ('1998', 'Sink', 'Hot and cold thrown in for no charge', '13', '99', '3', '0');
INSERT INTO catalogue_products VALUES ('1999', 'Rubber Duck', 'Every bather needs one', '13', '100', '1', '0');
INSERT INTO catalogue_products VALUES ('2000', 'Loo Seat', 'Loo Seat', '13', '101', '4', '0');
INSERT INTO catalogue_products VALUES ('2001', 'Loo Seat', 'Loo Seat', '13', '102', '4', '0');
INSERT INTO catalogue_products VALUES ('2002', 'Loo Seat', 'Loo Seat', '13', '103', '4', '0');
INSERT INTO catalogue_products VALUES ('2003', 'Floor Tiles', 'In a choice of colours', '13', '104', '3', '0');
INSERT INTO catalogue_products VALUES ('2004', 'Floor Tiles', 'In a choice of colours', '13', '105', '3', '0');
INSERT INTO catalogue_products VALUES ('2005', 'Floor Tiles', 'In a choice of colours', '13', '106', '3', '0');
INSERT INTO catalogue_products VALUES ('2006', 'Candy Bar/desk', 'Perfect for work or play', '14', '107', '3', '0');
INSERT INTO catalogue_products VALUES ('2007', 'Candy Corner', 'Tuck it away', '14', '108', '3', '0');
INSERT INTO catalogue_products VALUES ('2008', 'Candy Hatch (lockable)', 'All bars should have one', '14', '109', '6', '0');
INSERT INTO catalogue_products VALUES ('2009', 'Armchair', 'Think pink', '14', '110', '3', '0');
INSERT INTO catalogue_products VALUES ('2010', 'Two-seater Sofa', 'Romantic pink for two', '14', '111', '4', '0');
INSERT INTO catalogue_products VALUES ('2011', 'Pink Faux-Fur', 'Bear Rug Cute', '14', '112', '4', '0');
INSERT INTO catalogue_products VALUES ('2012', 'Armchair', 'Think pink', '14', '113', '3', '0');
INSERT INTO catalogue_products VALUES ('2013', 'Double Bed', 'Snuggle down in princess pink', '14', '114', '4', '0');
INSERT INTO catalogue_products VALUES ('2014', 'Camera', 'Smile!', '15', '115', '10', '0');
INSERT INTO catalogue_products VALUES ('2015', 'Film', 'Film for five photos', '15', '116', '6', '0');
INSERT INTO catalogue_products VALUES ('2016', 'Union Jack', 'The UK flag', '16', '117', '3', '0');
INSERT INTO catalogue_products VALUES ('2017', 'Jolly Roger', 'For pirates everywhere', '16', '118', '3', '0');
INSERT INTO catalogue_products VALUES ('2018', 'The Stars and Stripes', 'The US flag', '16', '119', '3', '0');
INSERT INTO catalogue_products VALUES ('2019', 'The Swiss flag', 'There\'s no holes in this...', '16', '120', '3', '0');
INSERT INTO catalogue_products VALUES ('2020', 'The Bundesflagge', 'The German flag', '16', '121', '3', '0');
INSERT INTO catalogue_products VALUES ('2021', 'The Maple Leaf', 'The Canadian flag', '16', '122', '3', '0');
INSERT INTO catalogue_products VALUES ('2022', 'The flag of Finland', 'To \'Finnish\' your decor...', '16', '123', '3', '0');
INSERT INTO catalogue_products VALUES ('2023', 'The French Tricolore', 'The French flag', '16', '124', '3', '0');
INSERT INTO catalogue_products VALUES ('2024', 'The Spanish flag', 'The flag of Spain', '16', '125', '3', '0');
INSERT INTO catalogue_products VALUES ('2025', 'The Jamaican flag', 'The flag of Jamaica', '16', '126', '3', '0');
INSERT INTO catalogue_products VALUES ('2026', 'The Italian flag', 'The flag of Italy', '16', '127', '3', '0');
INSERT INTO catalogue_products VALUES ('2027', 'The Dutch flag', 'The flag of The Netherlands', '16', '128', '3', '0');
INSERT INTO catalogue_products VALUES ('2028', 'The Irish flag', 'The flag of Ireland', '16', '129', '3', '0');
INSERT INTO catalogue_products VALUES ('2029', 'The Australian flag', 'Aussies rule!', '16', '130', '3', '0');
INSERT INTO catalogue_products VALUES ('2030', 'The EU flag', 'Be proud to be in the Union!', '16', '131', '3', '0');
INSERT INTO catalogue_products VALUES ('2031', 'The Swedish flag', 'Waved by Swedes everywhere', '16', '132', '3', '0');
INSERT INTO catalogue_products VALUES ('2032', 'The English flag', 'Eng-er-land', '16', '133', '3', '0');
INSERT INTO catalogue_products VALUES ('2033', 'The Scottish flag', 'Where\'s your kilt?', '16', '134', '3', '0');
INSERT INTO catalogue_products VALUES ('2034', 'The Welsh flag', 'A fiery dragon for your wall', '16', '135', '3', '0');
INSERT INTO catalogue_products VALUES ('2035', 'The Rainbow Flag', 'Every colour for everyone', '16', '136', '3', '0');
INSERT INTO catalogue_products VALUES ('2036', 'Flag of Brazil', 'The flag of Brazil', '16', '137', '3', '0');
INSERT INTO catalogue_products VALUES ('2037', 'The flag of Japan', 'The flag of Japan', '16', '138', '3', '0');
INSERT INTO catalogue_products VALUES ('2038', 'The flag of India', 'The flag of India', '16', '139', '3', '0');
INSERT INTO catalogue_products VALUES ('2039', 'Rug on the wall', 'Rug', '17', '140', '10', '0');
INSERT INTO catalogue_products VALUES ('2040', 'Rastaman', 'Rasta tarjoaa rakkautta', '17', '141', '3', '0');
INSERT INTO catalogue_products VALUES ('2041', 'Presidentin Muotokuva', 'Presidentin Muotokuva', '17', '142', '10', '0');
INSERT INTO catalogue_products VALUES ('2042', 'Hammer Cabinet', 'for emergencies only', '17', '143', '3', '0');
INSERT INTO catalogue_products VALUES ('2043', 'Skyline Poster', 'skyscrapers at night', '17', '144', '3', '0');
INSERT INTO catalogue_products VALUES ('2044', 'BW Skyline Poster', 'skyscrapers in arty black and white', '17', '145', '3', '0');
INSERT INTO catalogue_products VALUES ('2045', 'Fox Poster', 'a truly cunning design', '17', '146', '3', '0');
INSERT INTO catalogue_products VALUES ('2046', 'Butterfly Cabinet', 'beautiful reproduction butterfly', '17', '147', '3', '0');
INSERT INTO catalogue_products VALUES ('2047', 'Butterfly Cabinet (blue)', 'beautiful reproduction butterfly', '17', '148', '3', '0');
INSERT INTO catalogue_products VALUES ('2048', 'Bars', 'high security for your room', '17', '149', '3', '0');
INSERT INTO catalogue_products VALUES ('2049', 'UK Map', 'get the lovely isles on your walls', '17', '150', '3', '0');
INSERT INTO catalogue_products VALUES ('2050', 'Himalaya Poster', 'marvellous mountains', '17', '151', '3', '0');
INSERT INTO catalogue_products VALUES ('2051', 'Hoot Poster', 'The eyes follow you...', '17', '152', '3', '0');
INSERT INTO catalogue_products VALUES ('2052', 'Siva Poster', 'The Auspicious One', '17', '153', '3', '0');
INSERT INTO catalogue_products VALUES ('2053', 'Save the Panda', 'We can\'t bear to lose them', '17', '154', '3', '0');
INSERT INTO catalogue_products VALUES ('2054', 'Carrot Plaque', 'take pride in your veg!', '17', '155', '3', '0');
INSERT INTO catalogue_products VALUES ('2055', 'Fish Plaque', 'smells fishy, looks cool', '17', '156', '3', '0');
INSERT INTO catalogue_products VALUES ('2056', 'Bear Plaque', 'fake of course!', '17', '157', '3', '0');
INSERT INTO catalogue_products VALUES ('2057', 'Duck Poster', 'quacking good design!', '17', '158', '3', '0');
INSERT INTO catalogue_products VALUES ('2058', 'Ancestor Poster', 'a touch of history', '17', '159', '3', '0');
INSERT INTO catalogue_products VALUES ('2059', 'Abstract Poster', 'but is it the right way up?', '17', '160', '3', '0');
INSERT INTO catalogue_products VALUES ('2060', 'Queen Mum Poster', 'aw, bless...', '17', '161', '3', '0');
INSERT INTO catalogue_products VALUES ('2061', 'Prince Charles Poster', 'Even walls have ears', '17', '162', '3', '0');
INSERT INTO catalogue_products VALUES ('2062', 'Habbo Colours Poster', 'Habbos come in all colours', '17', '163', '3', '0');
INSERT INTO catalogue_products VALUES ('2063', 'Rainforest Poster', 'do your bit for the environment', '17', '164', '3', '0');
INSERT INTO catalogue_products VALUES ('2064', 'Eid Mubarak', 'Celebrate with us', '17', '165', '3', '0');
INSERT INTO catalogue_products VALUES ('2065', 'DJ Throne', 'He is the magic Habbo', '17', '166', '3', '0');
INSERT INTO catalogue_products VALUES ('2066', 'Green Gecko Art', 'Like a gecko it wont fall of your wall', '17', '167', '3', '0');
INSERT INTO catalogue_products VALUES ('2067', 'Certificate', 'award, charter or the Habbo Way - you decide', '17', '168', '3', '0');
INSERT INTO catalogue_products VALUES ('2068', 'Habbo Golden Record', 'For the best music-makers', '17', '169', '3', '0');
INSERT INTO catalogue_products VALUES ('2069', 'Bonnie Blonde', 'The one and only. Adore her!', '17', '170', '3', '0');
INSERT INTO catalogue_products VALUES ('2070', 'The Habbo Babes 1', 'The Hotel\'s girlband. Dream on!', '17', '171', '3', '0');
INSERT INTO catalogue_products VALUES ('2071', 'The Habbo Babes 2', 'The Hotel\'s girlband. Dream on!', '17', '172', '3', '0');
INSERT INTO catalogue_products VALUES ('2072', 'The Habbo Babes 3', 'The Hotel\'s girlband. Dream on!', '17', '173', '3', '0');
INSERT INTO catalogue_products VALUES ('2073', 'Johnny Squabble', 'The muscly movie hero', '17', '174', '3', '0');
INSERT INTO catalogue_products VALUES ('2074', 'Scamme\'d', 'Habbo-punk for the never-agreeing', '17', '175', '3', '0');
INSERT INTO catalogue_products VALUES ('2075', 'Screaming Furnies', 'The rock masters of virtual music', '17', '176', '3', '0');
INSERT INTO catalogue_products VALUES ('2076', 'Suomen kartta', 'Suomen kartta', '17', '177', '3', '0');
INSERT INTO catalogue_products VALUES ('2077', 'Smiling Headbangerz', 'For really TOUGH Habbos!', '17', '178', '3', '0');
INSERT INTO catalogue_products VALUES ('2078', 'Habbo Cola Poster', 'For serious bubblers', '17', '179', '3', '0');
INSERT INTO catalogue_products VALUES ('2079', 'The Father Of Habbo', 'The legendary founder of the Hotel', '17', '180', '3', '0');
INSERT INTO catalogue_products VALUES ('2080', 'Dodgy Geezer', 'Would you trust this man?', '17', '181', '3', '0');
INSERT INTO catalogue_products VALUES ('2081', 'System of a Ban', 'Pure and unbridled nu-metal', '17', '182', '3', '0');
INSERT INTO catalogue_products VALUES ('2082', 'Beach Tree Poster', 'Natural', '17', '183', '3', '0');
INSERT INTO catalogue_products VALUES ('2083', 'Glass shelf', 'Translucent beauty', '18', '184', '4', '0');
INSERT INTO catalogue_products VALUES ('2084', 'Glass sofa', 'Translucent beauty', '18', '185', '4', '0');
INSERT INTO catalogue_products VALUES ('2085', 'Glass table', 'Translucent beauty', '18', '186', '4', '0');
INSERT INTO catalogue_products VALUES ('2086', 'Glass chair', 'Translucent beauty', '18', '187', '3', '0');
INSERT INTO catalogue_products VALUES ('2087', 'Glass stool', 'Translucent beauty', '18', '188', '3', '0');
INSERT INTO catalogue_products VALUES ('2088', 'Glass sofa', 'Translucent beauty', '18', '189', '4', '0');
INSERT INTO catalogue_products VALUES ('2089', 'Glass table', 'Translucent beauty', '18', '190', '4', '0');
INSERT INTO catalogue_products VALUES ('2090', 'Glass chair', 'Translucent beauty', '18', '191', '3', '0');
INSERT INTO catalogue_products VALUES ('2091', 'Glass stool', 'Translucent beauty', '18', '192', '3', '0');
INSERT INTO catalogue_products VALUES ('2092', 'Glass sofa', 'Translucent beauty', '18', '193', '4', '0');
INSERT INTO catalogue_products VALUES ('2093', 'Glass table', 'Translucent beauty', '18', '194', '4', '0');
INSERT INTO catalogue_products VALUES ('2094', 'Glass chair', 'Translucent beauty', '18', '195', '3', '0');
INSERT INTO catalogue_products VALUES ('2095', 'Glass stool', 'Translucent beauty', '18', '196', '3', '0');
INSERT INTO catalogue_products VALUES ('2096', 'Glass sofa', 'Translucent beauty', '18', '197', '4', '0');
INSERT INTO catalogue_products VALUES ('2097', 'Glass table', 'Translucent beauty', '18', '198', '4', '0');
INSERT INTO catalogue_products VALUES ('2098', 'Glass chair', 'Translucent beauty', '18', '199', '3', '0');
INSERT INTO catalogue_products VALUES ('2099', 'Glass stool', 'Translucent beauty', '18', '200', '3', '0');
INSERT INTO catalogue_products VALUES ('2100', 'Glass sofa', 'Translucent beauty', '18', '201', '4', '0');
INSERT INTO catalogue_products VALUES ('2101', 'Glass table', 'Translucent beauty', '18', '202', '4', '0');
INSERT INTO catalogue_products VALUES ('2102', 'Glass chair', 'Translucent beauty', '18', '203', '3', '0');
INSERT INTO catalogue_products VALUES ('2103', 'Glass stool', 'Translucent beauty', '18', '204', '3', '0');
INSERT INTO catalogue_products VALUES ('2104', 'Glass sofa', 'Translucent beauty', '18', '205', '4', '0');
INSERT INTO catalogue_products VALUES ('2105', 'Glass table', 'Translucent beauty', '18', '206', '4', '0');
INSERT INTO catalogue_products VALUES ('2106', 'Glass chair', 'Translucent beauty', '18', '207', '3', '0');
INSERT INTO catalogue_products VALUES ('2107', 'Glass stool', 'Translucent beauty', '18', '208', '3', '0');
INSERT INTO catalogue_products VALUES ('2108', 'Glass sofa', 'Translucent beauty', '18', '209', '4', '0');
INSERT INTO catalogue_products VALUES ('2109', 'Glass table', 'Translucent beauty', '18', '210', '4', '0');
INSERT INTO catalogue_products VALUES ('2110', 'Glass chair', 'Translucent beauty', '18', '211', '3', '0');
INSERT INTO catalogue_products VALUES ('2111', 'Glass stool', 'Translucent beauty', '18', '212', '3', '0');
INSERT INTO catalogue_products VALUES ('2112', 'Glass sofa', 'Translucent beauty', '18', '213', '4', '0');
INSERT INTO catalogue_products VALUES ('2113', 'Glass table', 'Translucent beauty', '18', '214', '4', '0');
INSERT INTO catalogue_products VALUES ('2114', 'Glass chair', 'Translucent beauty', '18', '215', '3', '0');
INSERT INTO catalogue_products VALUES ('2115', 'Glass stool', 'Translucent beauty', '18', '216', '3', '0');
INSERT INTO catalogue_products VALUES ('2116', 'Glass sofa', 'Translucent beauty', '18', '217', '4', '0');
INSERT INTO catalogue_products VALUES ('2117', 'Glass table', 'Translucent beauty', '18', '218', '4', '0');
INSERT INTO catalogue_products VALUES ('2118', 'Glass chair', 'Translucent beauty', '18', '219', '3', '0');
INSERT INTO catalogue_products VALUES ('2119', 'Glass stool', 'Translucent beauty', '18', '220', '3', '0');
INSERT INTO catalogue_products VALUES ('2120', 'Red Gothic Chair', 'The head of the table', '19', '221', '10', '0');
INSERT INTO catalogue_products VALUES ('2121', 'Red Gothic Sofa', 'Not great for hiding behind', '19', '222', '7', '0');
INSERT INTO catalogue_products VALUES ('2122', 'Red Gothic Stool', 'Be calm. Be seated', '19', '223', '5', '0');
INSERT INTO catalogue_products VALUES ('2123', 'Cobbled Path', 'The route less travelled', '19', '224', '5', '0');
INSERT INTO catalogue_products VALUES ('2124', 'Dungeon Floor', 'What lies beneath?', '19', '225', '5', '0');
INSERT INTO catalogue_products VALUES ('2125', 'Gothic Table', 'A table with two heads', '19', '226', '15', '0');
INSERT INTO catalogue_products VALUES ('2126', 'Gothic Railing', 'Keep out!', '19', '227', '8', '0');
INSERT INTO catalogue_products VALUES ('2127', 'Gothic Torch', 'Keeping dungeons light', '19', '228', '10', '0');
INSERT INTO catalogue_products VALUES ('2128', 'Gothic Fountain', 'The dark side of Habbo', '19', '229', '10', '0');
INSERT INTO catalogue_products VALUES ('2129', 'Gothic Candleabra', 'Through darkness came light', '19', '230', '10', '0');
INSERT INTO catalogue_products VALUES ('2130', 'Gothic Portcullis', 'Don\'t get caught beneath!', '19', '231', '10', '0');
INSERT INTO catalogue_products VALUES ('2131', 'Industrial Turbine', 'Powerful and resilient', '19', '232', '10', '0');
INSERT INTO catalogue_products VALUES ('2132', 'Flaming Barrel', 'Beacon of light!', '20', '233', '3', '0');
INSERT INTO catalogue_products VALUES ('2133', 'Bench', 'Laid back seating', '20', '234', '3', '0');
INSERT INTO catalogue_products VALUES ('2134', 'Candle Box', 'Late night debate', '20', '235', '2', '0');
INSERT INTO catalogue_products VALUES ('2135', 'Grunge Chair', 'Alternative chair for alternative people', '20', '236', '4', '0');
INSERT INTO catalogue_products VALUES ('2136', 'Grunge Mattress', 'Beats sleeping on the floor!', '20', '237', '3', '0');
INSERT INTO catalogue_products VALUES ('2137', 'Radiator', 'Started cool but now it\'s hot!', '20', '238', '3', '0');
INSERT INTO catalogue_products VALUES ('2138', 'Grunge Bookshelf', 'Scrap books and photo albums', '20', '239', '5', '0');
INSERT INTO catalogue_products VALUES ('2139', 'Road Sign', 'Bought legitimately from an M1 cafe.', '20', '240', '3', '0');
INSERT INTO catalogue_products VALUES ('2140', 'Grunge Table', 'Students of the round table!', '20', '241', '4', '0');
INSERT INTO catalogue_products VALUES ('2141', 'Bronze Coin', 'Worth: 1 Habbo Credit', '21', '242', '1', '0');
INSERT INTO catalogue_products VALUES ('2142', 'Silver Coin', 'Worth: 5 Habbo Credits', '21', '243', '5', '0');
INSERT INTO catalogue_products VALUES ('2143', 'Gold Coin', 'Worth: 10 Habbo Credits', '21', '244', '10', '0');
INSERT INTO catalogue_products VALUES ('2144', 'Money Bag', 'Worth: 20 Habbo Credits', '21', '245', '20', '0');
INSERT INTO catalogue_products VALUES ('2145', 'Gold Bars', 'Worth: 50 Habbo Credits', '21', '246', '50', '0');
INSERT INTO catalogue_products VALUES ('2146', 'Habbowood Chair', 'null', '22', '247', '5', '0');
INSERT INTO catalogue_products VALUES ('2147', 'Rope Divider', 'null', '22', '248', '5', '0');
INSERT INTO catalogue_products VALUES ('2148', 'Spotlight', 'Light, camera, action!', '22', '249', '15', '0');
INSERT INTO catalogue_products VALUES ('2149', 'Theatre Seat', 'It\'s a Theatre Seat', '22', '250', '10', '0');
INSERT INTO catalogue_products VALUES ('2150', 'Icecream Machine', 'null', '22', '251', '25', '0');
INSERT INTO catalogue_products VALUES ('2151', 'Habbowood Mirror', 'Starts only!', '22', '252', '10', '0');
INSERT INTO catalogue_products VALUES ('2152', 'Chair', 'Sleek and chic for each cheek', '23', '253', '3', '0');
INSERT INTO catalogue_products VALUES ('2153', 'Bench', 'Two can perch comfortably', '23', '254', '3', '0');
INSERT INTO catalogue_products VALUES ('2154', 'Coffee Table', 'Elegance embodied', '23', '255', '3', '0');
INSERT INTO catalogue_products VALUES ('2155', 'Bookcase', 'For nic naks and art deco books', '23', '256', '3', '0');
INSERT INTO catalogue_products VALUES ('2156', 'iced sofachair', 'Soft iced sofachair', '23', '257', '3', '0');
INSERT INTO catalogue_products VALUES ('2157', 'iced sofa', 'A soft iced sofa', '23', '258', '4', '0');
INSERT INTO catalogue_products VALUES ('2158', 'Ice Bar-Desk', 'Strong, yet soft looking', '23', '259', '3', '0');
INSERT INTO catalogue_products VALUES ('2159', 'Ice Corner', 'Looks squishy, but isn\'t', '23', '260', '3', '0');
INSERT INTO catalogue_products VALUES ('2160', 'Door (Lockable)', 'Do go through...', '23', '261', '6', '0');
INSERT INTO catalogue_products VALUES ('2161', 'Iced Auto Shutter', 'Habbos, roll out!', '23', '262', '3', '0');
INSERT INTO catalogue_products VALUES ('2162', 'Iced Angle', 'Cool cornering for you!', '23', '263', '3', '0');
INSERT INTO catalogue_products VALUES ('2163', 'Bamboo Forest', 'Don\'t get lost', '24', '264', '25', '0');
INSERT INTO catalogue_products VALUES ('2164', 'Pillow', 'null', '24', '265', '5', '0');
INSERT INTO catalogue_products VALUES ('2165', 'Sushi Bar', 'null', '24', '266', '10', '0');
INSERT INTO catalogue_products VALUES ('2166', 'Tatami', 'null', '24', '267', '6', '0');
INSERT INTO catalogue_products VALUES ('2167', 'Tatami', 'null', '24', '268', '8', '0');
INSERT INTO catalogue_products VALUES ('2168', 'Lantern', 'null', '24', '269', '10', '0');
INSERT INTO catalogue_products VALUES ('2169', 'Drawers', 'null', '24', '270', '6', '0');
INSERT INTO catalogue_products VALUES ('2170', 'Ninjastars', 'Ouch!', '24', '271', '10', '0');
INSERT INTO catalogue_products VALUES ('2171', 'Double Bed', 'King-sized pine comfort', '25', '272', '3', '0');
INSERT INTO catalogue_products VALUES ('2172', 'Single Bed', 'Rustic charm for one', '25', '273', '3', '0');
INSERT INTO catalogue_products VALUES ('2173', 'Fireplace', 'Authentic, real flame fire', '25', '274', '4', '0');
INSERT INTO catalogue_products VALUES ('2174', 'Bardesk', 'Bar-Style Table - essential for extra guests', '25', '275', '3', '0');
INSERT INTO catalogue_products VALUES ('2175', 'Dining Table', 'For informal dining', '25', '276', '3', '0');
INSERT INTO catalogue_products VALUES ('2176', 'Bench', 'To complete the dining set', '25', '277', '3', '0');
INSERT INTO catalogue_products VALUES ('2177', 'Gate (lockable)', 'Knock, knock...', '25', '278', '6', '0');
INSERT INTO catalogue_products VALUES ('2178', 'Corner plinth', 'Good solid wood', '25', '279', '3', '0');
INSERT INTO catalogue_products VALUES ('2179', 'Room divider', 'I wooden go there', '25', '280', '3', '0');
INSERT INTO catalogue_products VALUES ('2180', 'Bookcase', 'For all those fire-side stories', '25', '281', '3', '0');
INSERT INTO catalogue_products VALUES ('2181', 'Barrel Minibar', 'It\'s a barrel of laughs and a great talking point', '25', '282', '4', '0');
INSERT INTO catalogue_products VALUES ('2182', 'Barrel Stool', 'The ultimate recycled furniture', '25', '283', '1', '0');
INSERT INTO catalogue_products VALUES ('2183', 'Table Lamp', 'Ambient lighting is essential', '25', '284', '3', '0');
INSERT INTO catalogue_products VALUES ('2184', 'Lodge Candle', 'Wax lyrical with some old-world charm', '25', '285', '3', '0');
INSERT INTO catalogue_products VALUES ('2185', 'Occasional Table', 'Practical and beautiful', '25', '286', '2', '0');
INSERT INTO catalogue_products VALUES ('2186', 'Stool', 'Rustic charm at it\'s best', '25', '287', '1', '0');
INSERT INTO catalogue_products VALUES ('2187', 'Double Bed', 'Give yourself space to stretch out', '26', '288', '4', '0');
INSERT INTO catalogue_products VALUES ('2188', 'Single Bed', 'Cot of the artistic', '26', '289', '3', '0');
INSERT INTO catalogue_products VALUES ('2189', 'Fireplace', 'Comfort in stainless steel', '26', '290', '5', '0');
INSERT INTO catalogue_products VALUES ('2190', 'Two-seater Sofa', 'Comfort for stylish couples', '26', '291', '4', '0');
INSERT INTO catalogue_products VALUES ('2191', 'Armchair', 'Loft-style comfort', '26', '292', '3', '0');
INSERT INTO catalogue_products VALUES ('2192', 'Mini-Bar', 'You naughty Habbo!', '26', '293', '5', '0');
INSERT INTO catalogue_products VALUES ('2193', 'Hatch (Lockable)', 'All bars should have one', '26', '294', '6', '0');
INSERT INTO catalogue_products VALUES ('2194', 'Bar/desk', 'Perfect for work or play', '26', '295', '3', '0');
INSERT INTO catalogue_products VALUES ('2195', 'Corner Cabinet/Desk', 'Tuck it away', '26', '296', '3', '0');
INSERT INTO catalogue_products VALUES ('2196', 'Dining Chair', 'Metallic seating experience', '26', '297', '3', '0');
INSERT INTO catalogue_products VALUES ('2197', 'Large Coffee Table', 'For larger gatherings', '26', '298', '4', '0');
INSERT INTO catalogue_products VALUES ('2198', 'Large Coffee Table', 'For larger gatherings', '26', '299', '3', '0');
INSERT INTO catalogue_products VALUES ('2199', 'Small Coffee Table', 'For serving a stylish latte', '26', '300', '1', '0');
INSERT INTO catalogue_products VALUES ('2200', 'Large Dining Table', 'For larger gatherings', '26', '301', '4', '0');
INSERT INTO catalogue_products VALUES ('2201', 'Shelf', 'Tidy up', '26', '302', '1', '0');
INSERT INTO catalogue_products VALUES ('2202', 'Bookcase', 'For the arty pad', '26', '303', '4', '0');
INSERT INTO catalogue_products VALUES ('2203', '', '', '-1', '304', '0', '0');
INSERT INTO catalogue_products VALUES ('2204', '', '', '-1', '305', '0', '0');
INSERT INTO catalogue_products VALUES ('2205', '', '', '-1', '306', '0', '0');
INSERT INTO catalogue_products VALUES ('2206', '', '', '-1', '307', '0', '0');
INSERT INTO catalogue_products VALUES ('2207', '', '', '-1', '308', '0', '0');
INSERT INTO catalogue_products VALUES ('2208', '', '', '-1', '309', '0', '0');
INSERT INTO catalogue_products VALUES ('2209', 'Vase of Flowers', 'Guaranteed to stay fresh', '28', '310', '4', '0');
INSERT INTO catalogue_products VALUES ('2210', 'Cut Roses', 'Sleek and chic', '28', '311', '3', '0');
INSERT INTO catalogue_products VALUES ('2211', 'Cut Sunflower', 'For happy Habbos', '28', '312', '3', '0');
INSERT INTO catalogue_products VALUES ('2212', 'Yukka Plant', 'Easy to care for', '28', '313', '3', '0');
INSERT INTO catalogue_products VALUES ('2213', 'Pineapple Plant', 'Needs loving glances', '28', '314', '3', '0');
INSERT INTO catalogue_products VALUES ('2214', 'Bonsai Tree', 'You can be sure it lives', '28', '315', '3', '0');
INSERT INTO catalogue_products VALUES ('2215', 'Mature Cactus', 'Habbo Dreams monster in hiding!  Shhhh', '28', '316', '3', '0');
INSERT INTO catalogue_products VALUES ('2216', 'Fruit Tree', 'Great yield and sweet fruit', '28', '317', '3', '0');
INSERT INTO catalogue_products VALUES ('2217', 'Small Cactus', 'Even less watering than the real world', '28', '318', '1', '0');
INSERT INTO catalogue_products VALUES ('2218', 'Maze shrubbery', 'Labyrinths Galore!', '28', '319', '5', '0');
INSERT INTO catalogue_products VALUES ('2219', 'Maze Shrubbery Gate', 'Labyrinths Galore!', '28', '320', '6', '0');
INSERT INTO catalogue_products VALUES ('2220', 'Bulrush', 'Ideal for the riverside', '28', '321', '3', '0');
INSERT INTO catalogue_products VALUES ('2221', 'Chair', 'Hip plastic furniture', '29', '322', '3', '0');
INSERT INTO catalogue_products VALUES ('2222', 'Chair', 'Hip plastic furniture', '29', '323', '3', '0');
INSERT INTO catalogue_products VALUES ('2223', 'Chair', 'Hip plastic furniture', '29', '324', '3', '0');
INSERT INTO catalogue_products VALUES ('2224', 'Chair', 'Hip plastic furniture', '29', '325', '3', '0');
INSERT INTO catalogue_products VALUES ('2225', 'Chair', 'Hip plastic furniture', '29', '326', '3', '0');
INSERT INTO catalogue_products VALUES ('2226', 'Chair', 'Hip plastic furniture', '29', '327', '3', '0');
INSERT INTO catalogue_products VALUES ('2227', 'Chair', 'Hip plastic furniture', '29', '328', '3', '0');
INSERT INTO catalogue_products VALUES ('2228', 'Chair', 'Hip plastic furniture', '29', '329', '3', '0');
INSERT INTO catalogue_products VALUES ('2229', 'Chair', 'Hip plastic furniture', '29', '330', '3', '0');
INSERT INTO catalogue_products VALUES ('2230', 'Chair', 'Hip plastic furniture', '29', '331', '3', '0');
INSERT INTO catalogue_products VALUES ('2231', 'Chair', 'Hip plastic furniture', '29', '332', '3', '0');
INSERT INTO catalogue_products VALUES ('2232', 'Occasional Table', 'Hip plastic furniture', '29', '333', '3', '0');
INSERT INTO catalogue_products VALUES ('2233', 'Occasional Table', 'Hip plastic furniture', '29', '334', '3', '0');
INSERT INTO catalogue_products VALUES ('2234', 'Occasional Table', 'Hip plastic furniture', '29', '335', '3', '0');
INSERT INTO catalogue_products VALUES ('2235', 'Square Dining Table', 'Hip plastic furniture', '29', '336', '3', '0');
INSERT INTO catalogue_products VALUES ('2236', 'Occasional Table', 'Hip plastic furniture', '29', '337', '3', '0');
INSERT INTO catalogue_products VALUES ('2237', 'Round Dining Table', 'Hip plastic furniture', '29', '338', '3', '0');
INSERT INTO catalogue_products VALUES ('2238', 'Square Dining Table', 'Hip plastic furniture', '29', '339', '3', '0');
INSERT INTO catalogue_products VALUES ('2239', 'Square Dining Table', 'Hip plastic furniture', '29', '340', '3', '0');
INSERT INTO catalogue_products VALUES ('2240', 'Square Dining Table', 'Hip plastic furniture', '29', '341', '3', '0');
INSERT INTO catalogue_products VALUES ('2241', 'Square Dining Table', 'Hip plastic furniture', '29', '342', '3', '0');
INSERT INTO catalogue_products VALUES ('2242', 'Square Dining Table', 'Hip plastic furniture', '29', '343', '3', '0');
INSERT INTO catalogue_products VALUES ('2243', 'Square Dining Table', 'Hip plastic furniture', '29', '344', '3', '0');
INSERT INTO catalogue_products VALUES ('2244', 'Occasional Table', 'Hip plastic furniture', '29', '345', '3', '0');
INSERT INTO catalogue_products VALUES ('2245', 'Occasional Table', 'Hip plastic furniture', '29', '346', '3', '0');
INSERT INTO catalogue_products VALUES ('2246', 'Round Dining Table', 'Hip plastic furniture', '29', '347', '3', '0');
INSERT INTO catalogue_products VALUES ('2247', 'Round Dining Table', 'Hip plastic furniture', '29', '348', '3', '0');
INSERT INTO catalogue_products VALUES ('2248', 'Round Dining Table', 'Hip plastic furniture', '29', '349', '3', '0');
INSERT INTO catalogue_products VALUES ('2249', 'Square Dining Table', 'Hip plastic furniture', '29', '350', '3', '0');
INSERT INTO catalogue_products VALUES ('2250', 'Round Dining Table', 'Hip plastic furniture', '29', '351', '3', '0');
INSERT INTO catalogue_products VALUES ('2251', 'Round Dining Table', 'Hip plastic furniture', '29', '352', '3', '0');
INSERT INTO catalogue_products VALUES ('2252', 'Round Dining Table', 'Hip plastic furniture', '29', '353', '3', '0');
INSERT INTO catalogue_products VALUES ('2253', 'Round Dining Table', 'Hip plastic furniture', '29', '354', '3', '0');
INSERT INTO catalogue_products VALUES ('2254', 'Round Dining Table', 'Hip plastic furniture', '29', '355', '3', '0');
INSERT INTO catalogue_products VALUES ('2255', 'Round Dining Table', 'Hip plastic furniture', '29', '356', '3', '0');
INSERT INTO catalogue_products VALUES ('2256', 'Occasional Table', 'Hip plastic furniture', '29', '357', '3', '0');
INSERT INTO catalogue_products VALUES ('2257', 'Occasional Table', 'Hip plastic furniture', '29', '358', '3', '0');
INSERT INTO catalogue_products VALUES ('2258', 'Square Dining Table', 'Hip plastic furniture', '29', '359', '3', '0');
INSERT INTO catalogue_products VALUES ('2259', 'Square Dining Table', 'Hip plastic furniture', '29', '360', '3', '0');
INSERT INTO catalogue_products VALUES ('2260', 'Square Dining Table', 'Hip plastic furniture', '29', '361', '3', '0');
INSERT INTO catalogue_products VALUES ('2261', 'Square Dining Table', 'Hip plastic furniture', '29', '362', '3', '0');
INSERT INTO catalogue_products VALUES ('2262', 'Square Dining Table', 'Hip plastic furniture', '29', '363', '3', '0');
INSERT INTO catalogue_products VALUES ('2263', 'Square Dining Table', 'Hip plastic furniture', '29', '364', '3', '0');
INSERT INTO catalogue_products VALUES ('2264', 'Square Dining Table', 'Hip plastic furniture', '29', '365', '3', '0');
INSERT INTO catalogue_products VALUES ('2265', 'Square Dining Table', 'Hip plastic furniture', '29', '366', '3', '0');
INSERT INTO catalogue_products VALUES ('2266', 'Square Dining Table', 'Hip plastic furniture', '29', '367', '3', '0');
INSERT INTO catalogue_products VALUES ('2267', 'Square Dining Table', 'Hip plastic furniture', '29', '368', '3', '0');
INSERT INTO catalogue_products VALUES ('2268', 'Occasional table Table', 'Hip plastic furniture', '29', '369', '3', '0');
INSERT INTO catalogue_products VALUES ('2269', 'Square Dining Table', 'Hip plastic furniture', '29', '370', '3', '0');
INSERT INTO catalogue_products VALUES ('2270', 'Round Dining Table', 'Hip plastic furniture', '29', '371', '3', '0');
INSERT INTO catalogue_products VALUES ('2271', 'Occasional Table', 'Hip plastic furniture', '29', '372', '3', '0');
INSERT INTO catalogue_products VALUES ('2272', 'Occasional Table', 'Hip plastic furniture', '29', '373', '3', '0');
INSERT INTO catalogue_products VALUES ('2273', 'Occasional Table', 'Hip plastic furniture', '29', '374', '3', '0');
INSERT INTO catalogue_products VALUES ('2274', 'Occasional Table', 'Hip plastic furniture', '29', '375', '3', '0');
INSERT INTO catalogue_products VALUES ('2275', 'Occasional Table', 'Hip plastic furniture', '29', '376', '3', '0');
INSERT INTO catalogue_products VALUES ('2276', 'Occasional table', 'Hip plastic furniture', '29', '377', '3', '0');
INSERT INTO catalogue_products VALUES ('2277', 'Occasional Table', 'Hip plastic furniture', '29', '378', '3', '0');
INSERT INTO catalogue_products VALUES ('2278', 'Occasional Table', 'Hip plastic furniture', '29', '379', '3', '0');
INSERT INTO catalogue_products VALUES ('2279', 'Occasional Table', 'Hip plastic furniture', '29', '380', '3', '0');
INSERT INTO catalogue_products VALUES ('2280', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '381', '3', '0');
INSERT INTO catalogue_products VALUES ('2281', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '382', '3', '0');
INSERT INTO catalogue_products VALUES ('2282', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '383', '3', '0');
INSERT INTO catalogue_products VALUES ('2283', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '384', '3', '0');
INSERT INTO catalogue_products VALUES ('2284', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '385', '3', '0');
INSERT INTO catalogue_products VALUES ('2285', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '386', '3', '0');
INSERT INTO catalogue_products VALUES ('2286', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '387', '3', '0');
INSERT INTO catalogue_products VALUES ('2287', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '388', '3', '0');
INSERT INTO catalogue_products VALUES ('2288', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '389', '3', '0');
INSERT INTO catalogue_products VALUES ('2289', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '390', '3', '0');
INSERT INTO catalogue_products VALUES ('2290', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '391', '3', '0');
INSERT INTO catalogue_products VALUES ('2291', 'Plastic Pod Chair', 'Hip plastic furniture', '29', '392', '3', '0');
INSERT INTO catalogue_products VALUES ('2292', 'Chair', 'Hip plastic furniture', '29', '393', '3', '0');
INSERT INTO catalogue_products VALUES ('2293', 'Pura Shelves', 'Pura Series 404 shelves', '31', '394', '3', '0');
INSERT INTO catalogue_products VALUES ('2294', 'A Pura Minibar', 'A Pura series 300 minibar', '31', '395', '4', '0');
INSERT INTO catalogue_products VALUES ('2295', 'Pura Refridgerator', 'Keep cool with a chilled snack or drink', '31', '396', '6', '0');
INSERT INTO catalogue_products VALUES ('2296', 'Pura Lamp', 'Switch on the atmosphere with this sophisticated light', '31', '397', '3', '0');
INSERT INTO catalogue_products VALUES ('2297', 'White Plain Double Bed', 'Sweet dreams for two', '31', '398', '3', '0');
INSERT INTO catalogue_products VALUES ('2298', 'White Plain Single Bed', 'All you need for a good night\'s kip', '31', '399', '3', '0');
INSERT INTO catalogue_products VALUES ('2299', 'Aqua Plain Double Bed', 'Sweet dreams for two', '31', '400', '3', '0');
INSERT INTO catalogue_products VALUES ('2300', 'Aqua Plain Single Bed', 'All you need for a good night\'s kip', '31', '401', '3', '0');
INSERT INTO catalogue_products VALUES ('2301', 'Pink Plain Double Bed', 'Sweet dreams for two', '31', '402', '3', '0');
INSERT INTO catalogue_products VALUES ('2302', 'Pink Plain Single Bed', 'All you need for a good night\'s kip', '31', '403', '3', '0');
INSERT INTO catalogue_products VALUES ('2303', 'Black Plain Double Bed', 'Sweet dreams for two', '31', '404', '3', '0');
INSERT INTO catalogue_products VALUES ('2304', 'Black Plain Single Bed', 'All you need for a good night\'s kip', '31', '405', '3', '0');
INSERT INTO catalogue_products VALUES ('2305', 'Beige Plain Double Bed', 'Sweet dreams for two', '31', '406', '3', '0');
INSERT INTO catalogue_products VALUES ('2306', 'Beige Plain Single Bed', 'All you need for a good night\'s kip', '31', '407', '3', '0');
INSERT INTO catalogue_products VALUES ('2307', 'Blue Plain Single Bed', 'Sweet dreams for two', '31', '408', '3', '0');
INSERT INTO catalogue_products VALUES ('2308', 'Blue Plain Single Bed', 'All you need for a good night\'s kip', '31', '409', '3', '0');
INSERT INTO catalogue_products VALUES ('2309', 'Green Plain Single Bed', 'Sweet dreams for two', '31', '410', '3', '0');
INSERT INTO catalogue_products VALUES ('2310', 'Green Plain Single Bed', 'All you need for a good night\'s kip', '31', '411', '3', '0');
INSERT INTO catalogue_products VALUES ('2311', 'Yellow Plain Single Bed', 'Sweet dreams for two', '31', '412', '3', '0');
INSERT INTO catalogue_products VALUES ('2312', 'Yellow Plain Single Bed', 'All you need for a good night\'s kip', '31', '413', '3', '0');
INSERT INTO catalogue_products VALUES ('2313', 'Red Plain Single Bed', 'Sweet dreams for two', '31', '414', '3', '0');
INSERT INTO catalogue_products VALUES ('2314', 'Red Plain Single Bed', 'All you need for a good night\'s kip', '31', '415', '3', '0');
INSERT INTO catalogue_products VALUES ('2315', 'Recycler Sofa', 'Handmade...', '-1', '416', '25', '0');
INSERT INTO catalogue_products VALUES ('2316', 'Recycler Chair', 'Handmade...', '-1', '417', '25', '0');
INSERT INTO catalogue_products VALUES ('2317', 'Recycler Garden', 'Give them water!', '-1', '418', '25', '0');
INSERT INTO catalogue_products VALUES ('2318', 'White Habbo Roller', 'The power of movement', '33', '419', '5', '0');
INSERT INTO catalogue_products VALUES ('2319', 'Pink Habbo Roller', 'The power of movement', '33', '420', '5', '0');
INSERT INTO catalogue_products VALUES ('2320', 'Red Habbo Roller', 'The power of movement', '33', '421', '5', '0');
INSERT INTO catalogue_products VALUES ('2321', 'Aqua Habbo Roller', 'The power of movement', '33', '422', '5', '0');
INSERT INTO catalogue_products VALUES ('2322', 'Gold Habbo Roller', 'The power of movement', '33', '423', '5', '0');
INSERT INTO catalogue_products VALUES ('2323', 'Knight Habbo Roller', 'The power of movement', '33', '424', '5', '0');
INSERT INTO catalogue_products VALUES ('2324', 'Blue Habbo Roller', 'The power of movement', '33', '425', '5', '0');
INSERT INTO catalogue_products VALUES ('2325', 'Purple Habbo Roller', 'The power of movement', '33', '426', '5', '0');
INSERT INTO catalogue_products VALUES ('2326', 'Navy Habbo Roller', 'The power of movement', '33', '427', '5', '0');
INSERT INTO catalogue_products VALUES ('2327', 'Green Habbo Roller', 'The power of movement', '33', '428', '5', '0');
INSERT INTO catalogue_products VALUES ('2328', 'Rose Quartz Grand Piano', 'Chopin\'s revolutionary instrument', '34', '429', '10', '0');
INSERT INTO catalogue_products VALUES ('2329', 'Rose Quartz Piano Stool', 'Here sat the legend of 1900', '34', '430', '2', '0');
INSERT INTO catalogue_products VALUES ('2330', 'Rose Quartz Chaise-Longue', 'Recline in continental comfort', '34', '431', '6', '0');
INSERT INTO catalogue_products VALUES ('2331', 'Rose Quartz Chair', 'Elegant seating for elegant Habbos', '34', '432', '5', '0');
INSERT INTO catalogue_products VALUES ('2332', 'Rose Quartz Screen', 'Beauty lies within', '34', '433', '6', '0');
INSERT INTO catalogue_products VALUES ('2333', 'Rose Quartz Tray Table', 'Every tray needs a table...', '34', '434', '4', '0');
INSERT INTO catalogue_products VALUES ('2334', 'Wall Mirror', 'Mirror, mirror on the wall', '34', '435', '4', '0');
INSERT INTO catalogue_products VALUES ('2335', 'Treats Tray', 'Spoil yourself', '34', '436', '5', '0');
INSERT INTO catalogue_products VALUES ('2336', 'Crystal Lamp', 'Light up your life', '34', '437', '6', '0');
INSERT INTO catalogue_products VALUES ('2337', 'Dressing Table', 'Get ready for your big date', '34', '438', '8', '0');
INSERT INTO catalogue_products VALUES ('2338', 'Floor Rug', 'Available in a variety of colours', '35', '439', '3', '0');
INSERT INTO catalogue_products VALUES ('2339', 'Floor Rug', 'Available in a variety of colours', '35', '440', '3', '0');
INSERT INTO catalogue_products VALUES ('2340', 'Floor Rug', 'Available in a variety of colours', '35', '441', '3', '0');
INSERT INTO catalogue_products VALUES ('2341', 'Floor Rug', 'Available in a variety of colours', '35', '442', '3', '0');
INSERT INTO catalogue_products VALUES ('2342', 'Floor Rug', 'Available in a variety of colours', '35', '443', '3', '0');
INSERT INTO catalogue_products VALUES ('2343', 'Floor Rug', 'Available in a variety of colours', '35', '444', '3', '0');
INSERT INTO catalogue_products VALUES ('2344', 'Floor Rug', 'Available in a variety of colours', '35', '445', '3', '0');
INSERT INTO catalogue_products VALUES ('2345', 'Floor Rug', 'Available in a variety of colours', '35', '446', '3', '0');
INSERT INTO catalogue_products VALUES ('2346', 'Floor Rug', 'Available in a variety of colours', '35', '447', '3', '0');
INSERT INTO catalogue_products VALUES ('2347', 'Floor Rug', 'Available in a variety of colours', '35', '448', '3', '0');
INSERT INTO catalogue_products VALUES ('2348', 'Floor Rug', 'Available in a variety of colours', '35', '449', '3', '0');
INSERT INTO catalogue_products VALUES ('2349', 'Soft Wool Rug', 'Soft Wool Rug', '35', '450', '3', '0');
INSERT INTO catalogue_products VALUES ('2350', 'Soft Wool Rug', 'Soft Wool Rug', '35', '451', '3', '0');
INSERT INTO catalogue_products VALUES ('2351', 'Soft Wool Rug', 'Soft Wool Rug', '35', '452', '3', '0');
INSERT INTO catalogue_products VALUES ('2352', 'Soft Wool Rug', 'Soft Wool Rug', '35', '453', '3', '0');
INSERT INTO catalogue_products VALUES ('2353', 'Soft Wool Rug', 'Soft Wool Rug', '35', '454', '3', '0');
INSERT INTO catalogue_products VALUES ('2354', 'Soft Wool Rug', 'Soft Wool Rug', '35', '455', '3', '0');
INSERT INTO catalogue_products VALUES ('2355', 'Soft Wool Rug', 'Soft Wool Rug', '35', '456', '3', '0');
INSERT INTO catalogue_products VALUES ('2356', 'Doormat', 'Welcome Habbos in style', '35', '457', '1', '0');
INSERT INTO catalogue_products VALUES ('2357', 'Doormat', 'Available in a variety of colours', '35', '458', '1', '0');
INSERT INTO catalogue_products VALUES ('2358', 'Doormat', 'Available in a variety of colours', '35', '459', '1', '0');
INSERT INTO catalogue_products VALUES ('2359', 'Doormat', 'Available in a variety of colours', '35', '460', '1', '0');
INSERT INTO catalogue_products VALUES ('2360', 'Doormat', 'Available in a variety of colours', '35', '461', '1', '0');
INSERT INTO catalogue_products VALUES ('2361', 'Doormat', 'Available in a variety of colours', '35', '462', '1', '0');
INSERT INTO catalogue_products VALUES ('2362', 'Doormat', 'Available in a variety of colours', '35', '463', '1', '0');
INSERT INTO catalogue_products VALUES ('2363', 'Doormat', 'Available in a variety of colours', '35', '464', '1', '0');
INSERT INTO catalogue_products VALUES ('2364', 'Hand-Woven Rug', 'Adds instant warmth', '35', '465', '3', '0');
INSERT INTO catalogue_products VALUES ('2365', 'Faux-Fur Bear Rug', 'For cuddling up on', '35', '466', '4', '0');
INSERT INTO catalogue_products VALUES ('2366', 'Blue Bear Rug', 'Snuggle up on a Funky bear rug...', '35', '467', '10', '0');
INSERT INTO catalogue_products VALUES ('2367', 'Yellow Bear Rug', 'Snuggle up on a Funky bear rug...', '35', '468', '10', '0');
INSERT INTO catalogue_products VALUES ('2368', 'Green Bear Rug', 'Snuggle up on a Funky bear rug...', '35', '469', '10', '0');
INSERT INTO catalogue_products VALUES ('2369', 'Hockey stick', 'whack that ball!', '36', '470', '3', '0');
INSERT INTO catalogue_products VALUES ('2370', 'Hockey stick', 'whack that ball!', '36', '471', '3', '0');
INSERT INTO catalogue_products VALUES ('2371', 'Hockey stick', 'whack that ball!', '36', '472', '3', '0');
INSERT INTO catalogue_products VALUES ('2372', 'Scoreboard', '...for keeping your score', '36', '473', '6', '0');
INSERT INTO catalogue_products VALUES ('2373', 'Basketball Trophy', 'For the winning team', '36', '474', '3', '0');
INSERT INTO catalogue_products VALUES ('2374', 'Basketball Hoop', '2 points for every basket', '36', '475', '3', '0');
INSERT INTO catalogue_products VALUES ('2375', 'Basketball Court', 'Line up your slam dunk', '36', '476', '3', '0');
INSERT INTO catalogue_products VALUES ('2376', 'Team Bench', 'For your reserve players', '36', '477', '6', '0');
INSERT INTO catalogue_products VALUES ('2377', 'Sport track straight', 'Let\'s get sporty!', '36', '478', '3', '0');
INSERT INTO catalogue_products VALUES ('2378', 'Sport track straight asphalt', 'Let\'s get sporty!', '36', '479', '3', '0');
INSERT INTO catalogue_products VALUES ('2379', 'Sport track straight grass', 'Let\'s get sporty!', '36', '480', '3', '0');
INSERT INTO catalogue_products VALUES ('2380', 'Sport corner', 'Let\'s get sporty!', '36', '481', '3', '0');
INSERT INTO catalogue_products VALUES ('2381', 'Sport corner asphalt', 'Let\'s get sporty!', '36', '482', '3', '0');
INSERT INTO catalogue_products VALUES ('2382', 'Sport corner grass', 'Let\'s get sporty!', '36', '483', '3', '0');
INSERT INTO catalogue_products VALUES ('2383', 'Sport goal', 'Let\'s get sporty!', '36', '484', '3', '0');
INSERT INTO catalogue_products VALUES ('2384', 'Sport goal grass', 'Let\'s get sporty!', '36', '485', '3', '0');
INSERT INTO catalogue_products VALUES ('2385', 'Sport goal asphalt', 'Let\'s get sporty!', '36', '486', '3', '0');
INSERT INTO catalogue_products VALUES ('2386', 'Football Lamp', 'Let\'s get sporty!', '36', '487', '10', '0');
INSERT INTO catalogue_products VALUES ('2387', 'Telephone Box', 'Dr Who?', '37', '488', '5', '0');
INSERT INTO catalogue_products VALUES ('2388', 'Portaloo', 'In a hurry?', '37', '489', '4', '0');
INSERT INTO catalogue_products VALUES ('2389', 'Wardrobe', 'Narnia this way!', '37', '490', '3', '0');
INSERT INTO catalogue_products VALUES ('2390', 'Teleport Door', 'Teleport Door', '37', '491', '6', '0');
INSERT INTO catalogue_products VALUES ('2391', 'Sound Machine', 'Creating fancy sounds', '38', '492', '8', '0');
INSERT INTO catalogue_products VALUES ('2392', 'Ambient 1', 'Chilled out beats', '38', '493', '5', '0');
INSERT INTO catalogue_products VALUES ('2393', 'Ambient 2', 'Mellow electric grooves', '38', '494', '5', '0');
INSERT INTO catalogue_products VALUES ('2394', 'Ambient 3', 'Background ambience loops', '38', '495', '5', '0');
INSERT INTO catalogue_products VALUES ('2395', 'Ambient 4', 'The dark side of Habbo', '38', '496', '5', '0');
INSERT INTO catalogue_products VALUES ('2396', 'Groove 1', 'Bollywood Beats!', '38', '497', '5', '0');
INSERT INTO catalogue_products VALUES ('2397', 'Groove 2', 'Jingle Bells will never be the same...', '38', '498', '5', '0');
INSERT INTO catalogue_products VALUES ('2398', 'Groove 3', 'Jive\'s Alive!', '38', '499', '5', '0');
INSERT INTO catalogue_products VALUES ('2399', 'Groove 4', 'Listen while you tan', '38', '500', '5', '0');
INSERT INTO catalogue_products VALUES ('2400', 'Electronic 1', 'Chilled grooves', '38', '501', '5', '0');
INSERT INTO catalogue_products VALUES ('2401', 'Electronic 2', 'Mystical ambient soundscapes', '38', '502', '5', '0');
INSERT INTO catalogue_products VALUES ('2402', 'Jukebox', 'For your Happy Days!', '39', '503', '5', '0');
INSERT INTO catalogue_products VALUES ('2403', 'Club 1', 'De bada bada bo!', '39', '504', '5', '0');
INSERT INTO catalogue_products VALUES ('2404', 'Club 2', 'Storm the UKCharts!', '39', '505', '5', '0');
INSERT INTO catalogue_products VALUES ('2405', 'Club 3', 'Sweet party beat', '39', '506', '5', '0');
INSERT INTO catalogue_products VALUES ('2406', 'Club 4', 'You will belong', '39', '507', '5', '0');
INSERT INTO catalogue_products VALUES ('2407', 'Club 5', 'The harder generation', '39', '508', '5', '0');
INSERT INTO catalogue_products VALUES ('2408', 'Club 6', 'Bop to the beat', '39', '509', '5', '0');
INSERT INTO catalogue_products VALUES ('2409', 'Dance 1', 'Actually, it\'s Partay!', '39', '510', '5', '0');
INSERT INTO catalogue_products VALUES ('2410', 'Dance 2', 'Electronic house', '39', '511', '5', '0');
INSERT INTO catalogue_products VALUES ('2411', 'Dance 3', 'House loops', '39', '512', '5', '0');
INSERT INTO catalogue_products VALUES ('2412', 'Dance 4', 'Music you can really sink your teeth into', '39', '513', '5', '0');
INSERT INTO catalogue_products VALUES ('2413', 'Dance 5', 'Let Music be the food of Habbo', '39', '514', '5', '0');
INSERT INTO catalogue_products VALUES ('2414', 'Dance 6', 'Groovelicious', '39', '515', '5', '0');
INSERT INTO catalogue_products VALUES ('2415', 'Jukebox', 'For your Happy Days!', '40', '516', '5', '0');
INSERT INTO catalogue_products VALUES ('2416', 'V-Guitar', 'V-Guitar', '40', '517', '5', '0');
INSERT INTO catalogue_products VALUES ('2417', 'Skull-Guitar', 'Skull-Guitar', '40', '518', '5', '0');
INSERT INTO catalogue_products VALUES ('2418', 'Rock 1', 'Headbanging riffs', '40', '519', '5', '0');
INSERT INTO catalogue_products VALUES ('2419', 'Rock 2', 'Head for the pit!', '40', '520', '5', '0');
INSERT INTO catalogue_products VALUES ('2420', 'Rock 3', 'Guitar solo set', '40', '521', '5', '0');
INSERT INTO catalogue_products VALUES ('2421', 'Rock 4', 'Dude? Cheese!', '40', '522', '5', '0');
INSERT INTO catalogue_products VALUES ('2422', 'Rock 5', 'For guitar heroes', '40', '523', '5', '0');
INSERT INTO catalogue_products VALUES ('2423', 'Rock 6', 'Rock and Roses!', '40', '524', '5', '0');
INSERT INTO catalogue_products VALUES ('2424', 'Rock 7', 'Rock with a roll', '40', '525', '5', '0');
INSERT INTO catalogue_products VALUES ('2425', 'Rock 8', 'Burning Riffs', '40', '526', '5', '0');
INSERT INTO catalogue_products VALUES ('2426', 'Jukebox', 'For your Happy Days!', '41', '527', '5', '0');
INSERT INTO catalogue_products VALUES ('2427', 'Habbo Sounds 1', 'Get the party started!', '41', '528', '5', '0');
INSERT INTO catalogue_products VALUES ('2428', 'Habbo Sounds 2', 'Unusual as Standard', '41', '529', '5', '0');
INSERT INTO catalogue_products VALUES ('2429', 'Habbo Sounds 3', 'Get the party started!', '41', '530', '5', '0');
INSERT INTO catalogue_products VALUES ('2430', 'Habbo Sounds 4', 'It\'s all about the Pentiums, baby!', '41', '531', '5', '0');
INSERT INTO catalogue_products VALUES ('2431', 'SFX 1', 'Beware zombies!', '41', '532', '5', '0');
INSERT INTO catalogue_products VALUES ('2432', 'SFX 2', 'Musical heaven', '41', '533', '5', '0');
INSERT INTO catalogue_products VALUES ('2433', 'SFX 3', 'With a hamper full of sounds, not sarnies', '41', '534', '5', '0');
INSERT INTO catalogue_products VALUES ('2434', 'SFX 4', 'Don\'t be afraid of the dark', '41', '535', '5', '0');
INSERT INTO catalogue_products VALUES ('2435', 'SFX 5', 'Sound effects for Furni', '41', '536', '5', '0');
INSERT INTO catalogue_products VALUES ('2436', 'Instrumental 1', 'Moments in love', '41', '537', '5', '0');
INSERT INTO catalogue_products VALUES ('2437', 'Instrumental 2', 'Piano concert set', '41', '538', '5', '0');
INSERT INTO catalogue_products VALUES ('2438', 'Latin Love 1', 'For adult minded', '42', '539', '5', '0');
INSERT INTO catalogue_products VALUES ('2439', 'Latin Love 2', 'Love and affection!', '42', '540', '5', '0');
INSERT INTO catalogue_products VALUES ('2440', 'Latin Love 3', 'Straight from the heart', '42', '541', '5', '0');
INSERT INTO catalogue_products VALUES ('2441', 'RnB Grooves 1', 'Can you fill me in?', '42', '542', '5', '0');
INSERT INTO catalogue_products VALUES ('2442', 'RnB Grooves 2', 'Get down tonight!', '42', '543', '5', '0');
INSERT INTO catalogue_products VALUES ('2443', 'RnB Grooves 3', 'Feel the groove', '42', '544', '5', '0');
INSERT INTO catalogue_products VALUES ('2444', 'RnB Grooves 4', 'Sh-shake it!', '42', '545', '5', '0');
INSERT INTO catalogue_products VALUES ('2445', 'RnB Grooves 5', 'Urban break beats', '42', '546', '5', '0');
INSERT INTO catalogue_products VALUES ('2446', 'RnB Grooves 6', 'Unadulterated essentials', '42', '547', '5', '0');
INSERT INTO catalogue_products VALUES ('2447', 'Hip Hop Beats 1', 'Made from real Boy Bands!', '42', '548', '5', '0');
INSERT INTO catalogue_products VALUES ('2448', 'Hip Hop Beats 2', 'Rock them bodies', '42', '549', '5', '0');
INSERT INTO catalogue_products VALUES ('2449', 'Hip Hop Beats 3', 'Ferry, ferry good!', '42', '550', '5', '0');
INSERT INTO catalogue_products VALUES ('2450', 'Hip Hop Beats 4', 'Shake your body!', '42', '551', '5', '0');
INSERT INTO catalogue_products VALUES ('2451', 'Champion trophy', 'Glittery gold', '43', '552', '12', '0');
INSERT INTO catalogue_products VALUES ('2452', 'Champion trophy', 'Shiny silver', '43', '553', '10', '0');
INSERT INTO catalogue_products VALUES ('2453', 'Champion trophy', 'Breathtaking bronze', '43', '554', '8', '0');
INSERT INTO catalogue_products VALUES ('2454', 'Globe trophy', 'Glittery gold', '43', '555', '12', '0');
INSERT INTO catalogue_products VALUES ('2455', 'Globe trophy', 'Shiny silver', '43', '556', '10', '0');
INSERT INTO catalogue_products VALUES ('2456', 'Globe trophy', 'Breathtaking bronze', '43', '557', '8', '0');
INSERT INTO catalogue_products VALUES ('2457', 'Fish trophy', 'Glittery gold', '43', '558', '12', '0');
INSERT INTO catalogue_products VALUES ('2458', 'Fish trophy', 'Shiny silver', '43', '559', '10', '0');
INSERT INTO catalogue_products VALUES ('2459', 'Fish trophy', 'Breathtaking bronze', '43', '560', '8', '0');
INSERT INTO catalogue_products VALUES ('2460', 'Classic trophy', 'Glittery gold', '43', '561', '12', '0');
INSERT INTO catalogue_products VALUES ('2461', 'Classic trophy', 'Shiny silver', '43', '562', '10', '0');
INSERT INTO catalogue_products VALUES ('2462', 'Classic trophy', 'Breathtaking bronze', '43', '563', '8', '0');
INSERT INTO catalogue_products VALUES ('2463', 'Duo trophy', 'Glittery gold', '43', '564', '12', '0');
INSERT INTO catalogue_products VALUES ('2464', 'Duo trophy', 'Shiny silver', '43', '565', '10', '0');
INSERT INTO catalogue_products VALUES ('2465', 'Duo trophy', 'Breathtaking bronze', '43', '566', '8', '0');
INSERT INTO catalogue_products VALUES ('2466', 'Duck trophy', 'Glittery gold', '43', '567', '12', '0');
INSERT INTO catalogue_products VALUES ('2467', 'Duck trophy', 'Shiny silver', '43', '568', '10', '0');
INSERT INTO catalogue_products VALUES ('2468', 'Duck trophy', 'Breathtaking bronze', '43', '569', '8', '0');
INSERT INTO catalogue_products VALUES ('2469', 'Duo trophy', 'Glittery gold', '43', '570', '12', '0');
INSERT INTO catalogue_products VALUES ('2470', 'Champion trophy', 'Glittery gold', '43', '571', '12', '0');
INSERT INTO catalogue_products VALUES ('2471', 'Snowman Poster', 'A new use for carrots!', '44', '572', '3', '0');
INSERT INTO catalogue_products VALUES ('2472', 'Angel Poster', 'See that halo gleam!', '44', '573', '3', '0');
INSERT INTO catalogue_products VALUES ('2473', 'Winter Wonderland Poster', 'A chilly snowy scene', '44', '574', '3', '0');
INSERT INTO catalogue_products VALUES ('2474', 'Santa Poster Poster', 'The jolly fat man himself', '44', '575', '3', '0');
INSERT INTO catalogue_products VALUES ('2475', 'Three Wise Men Poster', 'Following the star!', '44', '576', '3', '0');
INSERT INTO catalogue_products VALUES ('2476', 'Reindeer Poster', 'Doing a hard night\'s work', '44', '577', '3', '0');
INSERT INTO catalogue_products VALUES ('2477', 'Stocking', 'Hung yours up yet?', '44', '578', '3', '0');
INSERT INTO catalogue_products VALUES ('2478', 'Holly Garland', 'Deck the halls!', '44', '579', '3', '0');
INSERT INTO catalogue_products VALUES ('2479', 'Tinsel (silver)', 'A touch of festive sparkle', '44', '580', '3', '0');
INSERT INTO catalogue_products VALUES ('2480', 'Tinsel (gold)', 'A touch of festive sparkle', '44', '581', '3', '0');
INSERT INTO catalogue_products VALUES ('2481', 'Mistletoe', 'Pucker up', '44', '582', '3', '0');
INSERT INTO catalogue_products VALUES ('2482', 'Small gold star', 'Twinkle, twinkle', '44', '583', '3', '0');
INSERT INTO catalogue_products VALUES ('2483', 'Small silver star', 'Twinkle, twinkle', '44', '584', '3', '0');
INSERT INTO catalogue_products VALUES ('2484', 'Large gold star', 'All that glitters...', '44', '585', '3', '0');
INSERT INTO catalogue_products VALUES ('2485', 'Large silver star', 'All that glitters...', '44', '586', '3', '0');
INSERT INTO catalogue_products VALUES ('2486', 'Christmas Tree 1', 'Any presents under it yet?', '44', '587', '6', '0');
INSERT INTO catalogue_products VALUES ('2487', 'Christmas Tree 2', 'Any presents under it yet?', '44', '588', '6', '0');
INSERT INTO catalogue_products VALUES ('2488', 'Christmas Tree 3', 'Any presents under it yet?', '44', '589', '6', '0');
INSERT INTO catalogue_products VALUES ('2489', 'Electric Candles', 'No need to worry about wax drips', '44', '590', '3', '0');
INSERT INTO catalogue_products VALUES ('2490', 'Roast Turkey', 'Where\'s the cranberry sauce?', '44', '591', '3', '0');
INSERT INTO catalogue_products VALUES ('2491', 'Gingerbread House', 'Good enough to eat', '44', '592', '3', '0');
INSERT INTO catalogue_products VALUES ('2492', 'Christmas Pudding', 'Will you get the lucky sixpence?', '44', '593', '3', '0');
INSERT INTO catalogue_products VALUES ('2493', 'Christmas Rubber Duck', 'A right Christmas quacker!', '44', '594', '2', '0');
INSERT INTO catalogue_products VALUES ('2494', 'Pink Hyacinth', 'Beautiful bulb', '44', '595', '3', '0');
INSERT INTO catalogue_products VALUES ('2495', 'Blue Hyacinth', 'Beautiful bulb', '44', '596', '3', '0');
INSERT INTO catalogue_products VALUES ('2496', 'Poinsetta', 'Christmas in a pot', '44', '597', '3', '0');
INSERT INTO catalogue_products VALUES ('2497', 'Red Candle', 'Xmas tea light', '44', '598', '3', '0');
INSERT INTO catalogue_products VALUES ('2498', 'White Candle', 'Xmas tea light', '44', '599', '3', '0');
INSERT INTO catalogue_products VALUES ('2499', 'Wannabe bunny', 'Can you tell what it is yet?', '45', '600', '2', '0');
INSERT INTO catalogue_products VALUES ('2500', 'Pop-up Egg', 'Cheep (!) and cheerful', '45', '601', '5', '0');
INSERT INTO catalogue_products VALUES ('2501', 'Basket Of Eggs', 'Eggs-actly what you want for Easter', '45', '602', '4', '0');
INSERT INTO catalogue_products VALUES ('2502', 'Squidgy Bunny', 'Yours to cuddle up to', '45', '603', '3', '0');
INSERT INTO catalogue_products VALUES ('2503', 'Pumpkin Lamp', 'Cast a spooky glow', '46', '604', '6', '0');
INSERT INTO catalogue_products VALUES ('2504', 'Spiderweb', 'Not something you want to run into', '46', '605', '3', '0');
INSERT INTO catalogue_products VALUES ('2505', 'Chains', 'Shake, rattle and roll!', '46', '606', '4', '0');
INSERT INTO catalogue_products VALUES ('2506', 'Skull Candle Holder', 'Alas poor Yorrick...', '46', '607', '4', '0');
INSERT INTO catalogue_products VALUES ('2507', 'Skeleton', 'Needs a few more Habburgers', '46', '608', '3', '0');
INSERT INTO catalogue_products VALUES ('2508', 'Mummy', 'Beware the curse...', '46', '609', '3', '0');
INSERT INTO catalogue_products VALUES ('2509', 'Dead Duck', 'Blood, but no guts', '46', '610', '2', '0');
INSERT INTO catalogue_products VALUES ('2510', 'Dead Duck 2', 'Someone forgot to feed me...', '46', '611', '2', '0');
INSERT INTO catalogue_products VALUES ('2511', 'Dead Duck 3', 'With added ectoplasm', '46', '612', '2', '0');
INSERT INTO catalogue_products VALUES ('2512', 'Bat Poster', 'flap, flap, screech, screech...', '46', '613', '3', '0');
INSERT INTO catalogue_products VALUES ('2513', 'Jolly Roger', 'For pirates everywhere', '46', '614', '3', '0');
INSERT INTO catalogue_products VALUES ('2514', 'Eaten Ham', 'Looks like you\'re too late!', '46', '615', '3', '0');
INSERT INTO catalogue_products VALUES ('2515', 'HabboWheen Crypt', 'HabboWheen Crypt', '46', '616', '5', '0');
INSERT INTO catalogue_products VALUES ('2516', 'HabboWheen Grass', 'HabboWheen Grass', '46', '617', '5', '0');
INSERT INTO catalogue_products VALUES ('2517', 'Valentine\'s Duck', 'He\'s lovestruck', '47', '618', '2', '0');
INSERT INTO catalogue_products VALUES ('2518', 'HabboWheen Cauldron', 'HabboWheen Cauldron', '46', '619', '5', '0');
INSERT INTO catalogue_products VALUES ('2519', 'HabboWheen Grave', 'HabboWheen Grave', '46', '620', '5', '0');
INSERT INTO catalogue_products VALUES ('2520', 'Heart Sofa', 'Perfect for snuggling up on', '47', '621', '5', '0');
INSERT INTO catalogue_products VALUES ('2521', 'Cupid Statue', 'Watch out for those arrows!', '47', '622', '3', '0');
INSERT INTO catalogue_products VALUES ('2522', 'Giant Heart', 'Full of love', '47', '623', '6', '0');
INSERT INTO catalogue_products VALUES ('2523', 'Heart stickies', 'Heart stickies', '47', '624', '3', '0');
INSERT INTO catalogue_products VALUES ('2524', 'Red Carpet', 'For making an entrance.', '47', '625', '15', '0');
INSERT INTO catalogue_products VALUES ('2525', 'Valentine\'s lamp', 'Valentine\'s lamp', '47', '626', '10', '0');
INSERT INTO catalogue_products VALUES ('2526', 'Valentine rose Red', 'For a love that it true', '47', '627', '8', '0');
INSERT INTO catalogue_products VALUES ('2527', 'White Valentine Rose', 'Your secret love', '47', '628', '8', '0');
INSERT INTO catalogue_products VALUES ('2528', 'Yellow Valentine Rose', 'Relight your passions', '47', '629', '8', '0');
INSERT INTO catalogue_products VALUES ('2529', 'Pink Valentine\'s Rose', 'Be mine!', '47', '630', '8', '0');
INSERT INTO catalogue_products VALUES ('2530', 'Purple Valentine Rose', 'For that special pixel', '47', '631', '8', '0');
INSERT INTO catalogue_products VALUES ('2531', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '632', '3', '0');
INSERT INTO catalogue_products VALUES ('2532', 'Armchair', 'Large, but worth it', '48', '633', '3', '0');
INSERT INTO catalogue_products VALUES ('2533', 'Occasional Table', 'For those random moments', '48', '634', '1', '0');
INSERT INTO catalogue_products VALUES ('2534', 'Gate (lockable)', 'Form following function', '48', '635', '6', '0');
INSERT INTO catalogue_products VALUES ('2535', 'Corner Shelf', 'Neat and natty', '48', '636', '3', '0');
INSERT INTO catalogue_products VALUES ('2536', 'Dining Chair', 'Keep it simple', '48', '637', '3', '0');
INSERT INTO catalogue_products VALUES ('2537', 'Safe Minibar', 'Totally shatter-proof!', '48', '638', '3', '0');
INSERT INTO catalogue_products VALUES ('2538', 'Bar Stool', 'Practical and convenient', '48', '639', '3', '0');
INSERT INTO catalogue_products VALUES ('2539', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '640', '3', '0');
INSERT INTO catalogue_products VALUES ('2540', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '641', '3', '0');
INSERT INTO catalogue_products VALUES ('2541', 'Armchair', 'Large, but worth it', '48', '642', '3', '0');
INSERT INTO catalogue_products VALUES ('2542', 'Occasional Table', 'For those random moments', '48', '643', '1', '0');
INSERT INTO catalogue_products VALUES ('2543', 'Gate (lockable)', 'Form following function', '48', '644', '6', '0');
INSERT INTO catalogue_products VALUES ('2544', 'Corner Shelf', 'Neat and natty', '48', '645', '3', '0');
INSERT INTO catalogue_products VALUES ('2545', 'Dining Chair', 'Keep it simple', '48', '646', '3', '0');
INSERT INTO catalogue_products VALUES ('2546', 'Safe Minibar', 'Totally shatter-proof!', '48', '647', '3', '0');
INSERT INTO catalogue_products VALUES ('2547', 'Bar Stool', 'Practical and convenient', '48', '648', '3', '0');
INSERT INTO catalogue_products VALUES ('2548', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '649', '3', '0');
INSERT INTO catalogue_products VALUES ('2549', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '650', '3', '0');
INSERT INTO catalogue_products VALUES ('2550', 'Armchair', 'Large, but worth it', '48', '651', '3', '0');
INSERT INTO catalogue_products VALUES ('2551', 'Occasional Table', 'For those random moments', '48', '652', '1', '0');
INSERT INTO catalogue_products VALUES ('2552', 'Gate (lockable)', 'Form following function', '48', '653', '6', '0');
INSERT INTO catalogue_products VALUES ('2553', 'Corner Shelf', 'Neat and natty', '48', '654', '3', '0');
INSERT INTO catalogue_products VALUES ('2554', 'Dining Chair', 'Keep it simple', '48', '655', '3', '0');
INSERT INTO catalogue_products VALUES ('2555', 'Safe Minibar', 'Totally shatter-proof!', '48', '656', '3', '0');
INSERT INTO catalogue_products VALUES ('2556', 'Bar Stool', 'Practical and convenient', '48', '657', '3', '0');
INSERT INTO catalogue_products VALUES ('2557', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '658', '3', '0');
INSERT INTO catalogue_products VALUES ('2558', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '659', '3', '0');
INSERT INTO catalogue_products VALUES ('2559', 'Armchair', 'Large, but worth it', '48', '660', '3', '0');
INSERT INTO catalogue_products VALUES ('2560', 'Occasional Table', 'For those random moments', '48', '661', '1', '0');
INSERT INTO catalogue_products VALUES ('2561', 'Gate (lockable)', 'Form following function', '48', '662', '6', '0');
INSERT INTO catalogue_products VALUES ('2562', 'Corner Shelf', 'Neat and natty', '48', '663', '3', '0');
INSERT INTO catalogue_products VALUES ('2563', 'Dining Chair', 'Keep it simple', '48', '664', '3', '0');
INSERT INTO catalogue_products VALUES ('2564', 'Safe Minibar', 'Totally shatter-proof!', '48', '665', '3', '0');
INSERT INTO catalogue_products VALUES ('2565', 'Bar Stool', 'Practical and convenient', '48', '666', '3', '0');
INSERT INTO catalogue_products VALUES ('2566', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '667', '3', '0');
INSERT INTO catalogue_products VALUES ('2567', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '668', '3', '0');
INSERT INTO catalogue_products VALUES ('2568', 'Armchair', 'Large, but worth it', '48', '669', '3', '0');
INSERT INTO catalogue_products VALUES ('2569', 'Occasional Table', 'For those random moments', '48', '670', '1', '0');
INSERT INTO catalogue_products VALUES ('2570', 'Gate (lockable)', 'Form following function', '48', '671', '6', '0');
INSERT INTO catalogue_products VALUES ('2571', 'Corner Shelf', 'Neat and natty', '48', '672', '3', '0');
INSERT INTO catalogue_products VALUES ('2572', 'Dining Chair', 'Keep it simple', '48', '673', '3', '0');
INSERT INTO catalogue_products VALUES ('2573', 'Safe Minibar', 'Totally shatter-proof!', '48', '674', '3', '0');
INSERT INTO catalogue_products VALUES ('2574', 'Bar Stool', 'Practical and convenient', '48', '675', '3', '0');
INSERT INTO catalogue_products VALUES ('2575', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '676', '3', '0');
INSERT INTO catalogue_products VALUES ('2576', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '677', '3', '0');
INSERT INTO catalogue_products VALUES ('2577', 'Armchair', 'Large, but worth it', '48', '678', '3', '0');
INSERT INTO catalogue_products VALUES ('2578', 'Occasional Table', 'For those random moments', '48', '679', '1', '0');
INSERT INTO catalogue_products VALUES ('2579', 'Gate (lockable)', 'Form following function', '48', '680', '6', '0');
INSERT INTO catalogue_products VALUES ('2580', 'Corner Shelf', 'Neat and natty', '48', '681', '3', '0');
INSERT INTO catalogue_products VALUES ('2581', 'Dining Chair', 'Keep it simple', '48', '682', '3', '0');
INSERT INTO catalogue_products VALUES ('2582', 'Safe Minibar', 'Totally shatter-proof!', '48', '683', '3', '0');
INSERT INTO catalogue_products VALUES ('2583', 'Bar Stool', 'Practical and convenient', '48', '684', '3', '0');
INSERT INTO catalogue_products VALUES ('2584', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '685', '3', '0');
INSERT INTO catalogue_products VALUES ('2585', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '686', '3', '0');
INSERT INTO catalogue_products VALUES ('2586', 'Armchair', 'Large, but worth it', '48', '687', '3', '0');
INSERT INTO catalogue_products VALUES ('2587', 'Occasional Table', 'For those random moments', '48', '688', '1', '0');
INSERT INTO catalogue_products VALUES ('2588', 'Gate (lockable)', 'Form following function', '48', '689', '6', '0');
INSERT INTO catalogue_products VALUES ('2589', 'Corner Shelf', 'Neat and natty', '48', '690', '3', '0');
INSERT INTO catalogue_products VALUES ('2590', 'Dining Chair', 'Keep it simple', '48', '691', '3', '0');
INSERT INTO catalogue_products VALUES ('2591', 'Safe Minibar', 'Totally shatter-proof!', '48', '692', '3', '0');
INSERT INTO catalogue_products VALUES ('2592', 'Bar Stool', 'Practical and convenient', '48', '693', '3', '0');
INSERT INTO catalogue_products VALUES ('2593', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '694', '3', '0');
INSERT INTO catalogue_products VALUES ('2594', 'Two-Seater Sofa', 'Cushioned, understated comfort', '48', '695', '3', '0');
INSERT INTO catalogue_products VALUES ('2595', 'Armchair', 'Large, but worth it', '48', '696', '3', '0');
INSERT INTO catalogue_products VALUES ('2596', 'Occasional Table', 'For those random moments', '48', '697', '1', '0');
INSERT INTO catalogue_products VALUES ('2597', 'Gate (lockable)', 'Form following function', '48', '698', '6', '0');
INSERT INTO catalogue_products VALUES ('2598', 'Corner Shelf', 'Neat and natty', '48', '699', '3', '0');
INSERT INTO catalogue_products VALUES ('2599', 'Dining Chair', 'Keep it simple', '48', '700', '3', '0');
INSERT INTO catalogue_products VALUES ('2600', 'Safe Minibar', 'Totally shatter-proof!', '48', '701', '3', '0');
INSERT INTO catalogue_products VALUES ('2601', 'Bar Stool', 'Practical and convenient', '48', '702', '3', '0');
INSERT INTO catalogue_products VALUES ('2602', 'Coffee Table', 'Wipe clean and unobtrusive', '48', '703', '3', '0');
INSERT INTO catalogue_products VALUES ('2603', 'Chair', 'Sleek and chic for each cheek', '49', '704', '3', '0');
INSERT INTO catalogue_products VALUES ('2604', 'Bench', 'Two can perch comfortably', '49', '705', '3', '0');
INSERT INTO catalogue_products VALUES ('2605', 'Coffee Table', 'Elegance embodied', '49', '706', '3', '0');
INSERT INTO catalogue_products VALUES ('2606', 'Bookcase', 'For nic naks and art deco books', '49', '707', '3', '0');
INSERT INTO catalogue_products VALUES ('2607', 'iced sofachair', 'Soft iced sofachair', '49', '708', '3', '0');
INSERT INTO catalogue_products VALUES ('2608', 'iced sofa', 'A soft iced sofa', '49', '709', '4', '0');
INSERT INTO catalogue_products VALUES ('2609', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '710', '3', '0');
INSERT INTO catalogue_products VALUES ('2610', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '711', '3', '0');
INSERT INTO catalogue_products VALUES ('2611', 'Door (Lockable)', 'Do go through...', '49', '712', '6', '0');
INSERT INTO catalogue_products VALUES ('2612', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '713', '3', '0');
INSERT INTO catalogue_products VALUES ('2613', 'Iced Angle', 'Cool cornering for you!', '49', '714', '3', '0');
INSERT INTO catalogue_products VALUES ('2614', 'Chair', 'Sleek and chic for each cheek', '49', '715', '3', '0');
INSERT INTO catalogue_products VALUES ('2615', 'Bench', 'Two can perch comfortably', '49', '716', '3', '0');
INSERT INTO catalogue_products VALUES ('2616', 'Coffee Table', 'Elegance embodied', '49', '717', '3', '0');
INSERT INTO catalogue_products VALUES ('2617', 'Bookcase', 'For nic naks and art deco books', '49', '718', '3', '0');
INSERT INTO catalogue_products VALUES ('2618', 'iced sofachair', 'Soft iced sofachair', '49', '719', '3', '0');
INSERT INTO catalogue_products VALUES ('2619', 'iced sofa', 'A soft iced sofa', '49', '720', '4', '0');
INSERT INTO catalogue_products VALUES ('2620', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '721', '3', '0');
INSERT INTO catalogue_products VALUES ('2621', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '722', '3', '0');
INSERT INTO catalogue_products VALUES ('2622', 'Door (Lockable)', 'Do go through...', '49', '723', '6', '0');
INSERT INTO catalogue_products VALUES ('2623', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '724', '3', '0');
INSERT INTO catalogue_products VALUES ('2624', 'Iced Angle', 'Cool cornering for you!', '49', '725', '3', '0');
INSERT INTO catalogue_products VALUES ('2625', 'Chair', 'Sleek and chic for each cheek', '49', '726', '3', '0');
INSERT INTO catalogue_products VALUES ('2626', 'Bench', 'Two can perch comfortably', '49', '727', '3', '0');
INSERT INTO catalogue_products VALUES ('2627', 'Coffee Table', 'Elegance embodied', '49', '728', '3', '0');
INSERT INTO catalogue_products VALUES ('2628', 'Bookcase', 'For nic naks and art deco books', '49', '729', '3', '0');
INSERT INTO catalogue_products VALUES ('2629', 'iced sofachair', 'Soft iced sofachair', '49', '730', '3', '0');
INSERT INTO catalogue_products VALUES ('2630', 'iced sofa', 'A soft iced sofa', '49', '731', '4', '0');
INSERT INTO catalogue_products VALUES ('2631', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '732', '3', '0');
INSERT INTO catalogue_products VALUES ('2632', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '733', '3', '0');
INSERT INTO catalogue_products VALUES ('2633', 'Door (Lockable)', 'Do go through...', '49', '734', '6', '0');
INSERT INTO catalogue_products VALUES ('2634', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '735', '3', '0');
INSERT INTO catalogue_products VALUES ('2635', 'Iced Angle', 'Cool cornering for you!', '49', '736', '3', '0');
INSERT INTO catalogue_products VALUES ('2636', 'Chair', 'Sleek and chic for each cheek', '49', '737', '3', '0');
INSERT INTO catalogue_products VALUES ('2637', 'Bench', 'Two can perch comfortably', '49', '738', '3', '0');
INSERT INTO catalogue_products VALUES ('2638', 'Coffee Table', 'Elegance embodied', '49', '739', '3', '0');
INSERT INTO catalogue_products VALUES ('2639', 'Bookcase', 'For nic naks and art deco books', '49', '740', '3', '0');
INSERT INTO catalogue_products VALUES ('2640', 'iced sofachair', 'Soft iced sofachair', '49', '741', '3', '0');
INSERT INTO catalogue_products VALUES ('2641', 'iced sofa', 'A soft iced sofa', '49', '742', '4', '0');
INSERT INTO catalogue_products VALUES ('2642', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '743', '3', '0');
INSERT INTO catalogue_products VALUES ('2643', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '744', '3', '0');
INSERT INTO catalogue_products VALUES ('2644', 'Door (Lockable)', 'Do go through...', '49', '745', '6', '0');
INSERT INTO catalogue_products VALUES ('2645', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '746', '3', '0');
INSERT INTO catalogue_products VALUES ('2646', 'Iced Angle', 'Cool cornering for you!', '49', '747', '3', '0');
INSERT INTO catalogue_products VALUES ('2647', 'Chair', 'Sleek and chic for each cheek', '49', '748', '3', '0');
INSERT INTO catalogue_products VALUES ('2648', 'Bench', 'Two can perch comfortably', '49', '749', '3', '0');
INSERT INTO catalogue_products VALUES ('2649', 'Coffee Table', 'Elegance embodied', '49', '750', '3', '0');
INSERT INTO catalogue_products VALUES ('2650', 'Bookcase', 'For nic naks and art deco books', '49', '751', '3', '0');
INSERT INTO catalogue_products VALUES ('2651', 'iced sofachair', 'Soft iced sofachair', '49', '752', '3', '0');
INSERT INTO catalogue_products VALUES ('2652', 'iced sofa', 'A soft iced sofa', '49', '753', '4', '0');
INSERT INTO catalogue_products VALUES ('2653', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '754', '3', '0');
INSERT INTO catalogue_products VALUES ('2654', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '755', '3', '0');
INSERT INTO catalogue_products VALUES ('2655', 'Door (Lockable)', 'Do go through...', '49', '756', '6', '0');
INSERT INTO catalogue_products VALUES ('2656', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '757', '3', '0');
INSERT INTO catalogue_products VALUES ('2657', 'Iced Angle', 'Cool cornering for you!', '49', '758', '3', '0');
INSERT INTO catalogue_products VALUES ('2658', 'Chair', 'Sleek and chic for each cheek', '49', '759', '3', '0');
INSERT INTO catalogue_products VALUES ('2659', 'Bench', 'Two can perch comfortably', '49', '760', '3', '0');
INSERT INTO catalogue_products VALUES ('2660', 'Coffee Table', 'Elegance embodied', '49', '761', '3', '0');
INSERT INTO catalogue_products VALUES ('2661', 'Bookcase', 'For nic naks and art deco books', '49', '762', '3', '0');
INSERT INTO catalogue_products VALUES ('2662', 'iced sofachair', 'Soft iced sofachair', '49', '763', '3', '0');
INSERT INTO catalogue_products VALUES ('2663', 'iced sofa', 'A soft iced sofa', '49', '764', '4', '0');
INSERT INTO catalogue_products VALUES ('2664', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '765', '3', '0');
INSERT INTO catalogue_products VALUES ('2665', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '766', '3', '0');
INSERT INTO catalogue_products VALUES ('2666', 'Door (Lockable)', 'Do go through...', '49', '767', '6', '0');
INSERT INTO catalogue_products VALUES ('2667', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '768', '3', '0');
INSERT INTO catalogue_products VALUES ('2668', 'Iced Angle', 'Cool cornering for you!', '49', '769', '3', '0');
INSERT INTO catalogue_products VALUES ('2669', 'Chair', 'Sleek and chic for each cheek', '49', '770', '3', '0');
INSERT INTO catalogue_products VALUES ('2670', 'Bench', 'Two can perch comfortably', '49', '771', '3', '0');
INSERT INTO catalogue_products VALUES ('2671', 'Coffee Table', 'Elegance embodied', '49', '772', '3', '0');
INSERT INTO catalogue_products VALUES ('2672', 'Bookcase', 'For nic naks and art deco books', '49', '773', '3', '0');
INSERT INTO catalogue_products VALUES ('2673', 'iced sofachair', 'Soft iced sofachair', '49', '774', '3', '0');
INSERT INTO catalogue_products VALUES ('2674', 'iced sofa', 'A soft iced sofa', '49', '775', '4', '0');
INSERT INTO catalogue_products VALUES ('2675', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '776', '3', '0');
INSERT INTO catalogue_products VALUES ('2676', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '777', '3', '0');
INSERT INTO catalogue_products VALUES ('2677', 'Door (Lockable)', 'Do go through...', '49', '778', '6', '0');
INSERT INTO catalogue_products VALUES ('2678', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '779', '3', '0');
INSERT INTO catalogue_products VALUES ('2679', 'Iced Angle', 'Cool cornering for you!', '49', '780', '3', '0');
INSERT INTO catalogue_products VALUES ('2680', 'Chair', 'Sleek and chic for each cheek', '49', '781', '3', '0');
INSERT INTO catalogue_products VALUES ('2681', 'Bench', 'Two can perch comfortably', '49', '782', '3', '0');
INSERT INTO catalogue_products VALUES ('2682', 'Coffee Table', 'Elegance embodied', '49', '783', '3', '0');
INSERT INTO catalogue_products VALUES ('2683', 'Bookcase', 'For nic naks and art deco books', '49', '784', '3', '0');
INSERT INTO catalogue_products VALUES ('2684', 'iced sofachair', 'Soft iced sofachair', '49', '785', '3', '0');
INSERT INTO catalogue_products VALUES ('2685', 'iced sofa', 'A soft iced sofa', '49', '786', '4', '0');
INSERT INTO catalogue_products VALUES ('2686', 'Ice Bar-Desk', 'Strong, yet soft looking', '49', '787', '3', '0');
INSERT INTO catalogue_products VALUES ('2687', 'Ice Corner', 'Looks squishy, but isn\'t', '49', '788', '3', '0');
INSERT INTO catalogue_products VALUES ('2688', 'Door (Lockable)', 'Do go through...', '49', '789', '6', '0');
INSERT INTO catalogue_products VALUES ('2689', 'Iced Auto Shutter', 'Habbos, roll out!', '49', '790', '3', '0');
INSERT INTO catalogue_products VALUES ('2690', 'Iced Angle', 'Cool cornering for you!', '49', '791', '3', '0');
INSERT INTO catalogue_products VALUES ('2691', 'Double Bed', 'Give yourself space to stretch out', '50', '792', '4', '0');
INSERT INTO catalogue_products VALUES ('2692', 'Single Bed', 'Cot of the artistic', '50', '793', '3', '0');
INSERT INTO catalogue_products VALUES ('2693', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '794', '4', '0');
INSERT INTO catalogue_products VALUES ('2694', 'Armchair', 'Loft-style comfort', '50', '795', '3', '0');
INSERT INTO catalogue_products VALUES ('2695', 'Hatch (Lockable)', 'All bars should have one', '50', '796', '6', '0');
INSERT INTO catalogue_products VALUES ('2696', 'Bar/desk', 'Perfect for work or play', '50', '797', '3', '0');
INSERT INTO catalogue_products VALUES ('2697', 'Corner Cabinet/Desk', 'Tuck it away', '50', '798', '3', '0');
INSERT INTO catalogue_products VALUES ('2698', 'Double Bed', 'Give yourself space to stretch out', '50', '799', '4', '0');
INSERT INTO catalogue_products VALUES ('2699', 'Single Bed', 'Cot of the artistic', '50', '800', '3', '0');
INSERT INTO catalogue_products VALUES ('2700', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '801', '4', '0');
INSERT INTO catalogue_products VALUES ('2701', 'Armchair', 'Loft-style comfort', '50', '802', '3', '0');
INSERT INTO catalogue_products VALUES ('2702', 'Hatch (Lockable)', 'All bars should have one', '50', '803', '6', '0');
INSERT INTO catalogue_products VALUES ('2703', 'Bar/desk', 'Perfect for work or play', '50', '804', '3', '0');
INSERT INTO catalogue_products VALUES ('2704', 'Corner Cabinet/Desk', 'Tuck it away', '50', '805', '3', '0');
INSERT INTO catalogue_products VALUES ('2705', 'Double Bed', 'Give yourself space to stretch out', '50', '806', '4', '0');
INSERT INTO catalogue_products VALUES ('2706', 'Single Bed', 'Cot of the artistic', '50', '807', '3', '0');
INSERT INTO catalogue_products VALUES ('2707', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '808', '4', '0');
INSERT INTO catalogue_products VALUES ('2708', 'Armchair', 'Loft-style comfort', '50', '809', '3', '0');
INSERT INTO catalogue_products VALUES ('2709', 'Hatch (Lockable)', 'All bars should have one', '50', '810', '6', '0');
INSERT INTO catalogue_products VALUES ('2710', 'Bar/desk', 'Perfect for work or play', '50', '811', '3', '0');
INSERT INTO catalogue_products VALUES ('2711', 'Corner Cabinet/Desk', 'Tuck it away', '50', '812', '3', '0');
INSERT INTO catalogue_products VALUES ('2712', 'Double Bed', 'Give yourself space to stretch out', '50', '813', '4', '0');
INSERT INTO catalogue_products VALUES ('2713', 'Single Bed', 'Cot of the artistic', '50', '814', '3', '0');
INSERT INTO catalogue_products VALUES ('2714', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '815', '4', '0');
INSERT INTO catalogue_products VALUES ('2715', 'Armchair', 'Loft-style comfort', '50', '816', '3', '0');
INSERT INTO catalogue_products VALUES ('2716', 'Hatch (Lockable)', 'All bars should have one', '50', '817', '6', '0');
INSERT INTO catalogue_products VALUES ('2717', 'Bar/desk', 'Perfect for work or play', '50', '818', '3', '0');
INSERT INTO catalogue_products VALUES ('2718', 'Corner Cabinet/Desk', 'Tuck it away', '50', '819', '3', '0');
INSERT INTO catalogue_products VALUES ('2719', 'Double Bed', 'Give yourself space to stretch out', '50', '820', '4', '0');
INSERT INTO catalogue_products VALUES ('2720', 'Single Bed', 'Cot of the artistic', '50', '821', '3', '0');
INSERT INTO catalogue_products VALUES ('2721', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '822', '4', '0');
INSERT INTO catalogue_products VALUES ('2722', 'Armchair', 'Loft-style comfort', '50', '823', '3', '0');
INSERT INTO catalogue_products VALUES ('2723', 'Hatch (Lockable)', 'All bars should have one', '50', '824', '6', '0');
INSERT INTO catalogue_products VALUES ('2724', 'Bar/desk', 'Perfect for work or play', '50', '825', '3', '0');
INSERT INTO catalogue_products VALUES ('2725', 'Corner Cabinet/Desk', 'Tuck it away', '50', '826', '3', '0');
INSERT INTO catalogue_products VALUES ('2726', 'Double Bed', 'Give yourself space to stretch out', '50', '827', '4', '0');
INSERT INTO catalogue_products VALUES ('2727', 'Single Bed', 'Cot of the artistic', '50', '828', '3', '0');
INSERT INTO catalogue_products VALUES ('2728', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '829', '4', '0');
INSERT INTO catalogue_products VALUES ('2729', 'Armchair', 'Loft-style comfort', '50', '830', '3', '0');
INSERT INTO catalogue_products VALUES ('2730', 'Hatch (Lockable)', 'All bars should have one', '50', '831', '6', '0');
INSERT INTO catalogue_products VALUES ('2731', 'Bar/desk', 'Perfect for work or play', '50', '832', '3', '0');
INSERT INTO catalogue_products VALUES ('2732', 'Corner Cabinet/Desk', 'Tuck it away', '50', '833', '3', '0');
INSERT INTO catalogue_products VALUES ('2733', 'Double Bed', 'Give yourself space to stretch out', '50', '834', '4', '0');
INSERT INTO catalogue_products VALUES ('2734', 'Single Bed', 'Cot of the artistic', '50', '835', '3', '0');
INSERT INTO catalogue_products VALUES ('2735', 'Two-seater Sofa', 'Comfort for stylish couples', '50', '836', '4', '0');
INSERT INTO catalogue_products VALUES ('2736', 'Armchair', 'Loft-style comfort', '50', '837', '3', '0');
INSERT INTO catalogue_products VALUES ('2737', 'Hatch (Lockable)', 'All bars should have one', '50', '838', '6', '0');
INSERT INTO catalogue_products VALUES ('2738', 'Bar/desk', 'Perfect for work or play', '50', '839', '3', '0');
INSERT INTO catalogue_products VALUES ('2739', 'Corner Cabinet/Desk', 'Tuck it away', '50', '840', '3', '0');
INSERT INTO catalogue_products VALUES ('2740', 'Aqua Pura module 1', 'Endless fun!', '51', '841', '2', '0');
INSERT INTO catalogue_products VALUES ('2741', 'Aqua Pura module 2', 'Endless fun!', '51', '842', '2', '0');
INSERT INTO catalogue_products VALUES ('2742', 'Aqua Pura module 3', 'Endless fun!', '51', '843', '2', '0');
INSERT INTO catalogue_products VALUES ('2743', 'Aqua Pura module 4', 'Endless fun!', '51', '844', '2', '0');
INSERT INTO catalogue_products VALUES ('2744', 'Aqua Pura module 5', 'Endless fun!', '51', '845', '1', '0');
INSERT INTO catalogue_products VALUES ('2745', 'Pink Pura module 1', 'Endless fun!', '51', '846', '2', '0');
INSERT INTO catalogue_products VALUES ('2746', 'Pink Pura module 2', 'Endless fun!', '51', '847', '2', '0');
INSERT INTO catalogue_products VALUES ('2747', 'Pink Pura module 3', 'Endless fun!', '51', '848', '2', '0');
INSERT INTO catalogue_products VALUES ('2748', 'Pink Pura module 4', 'Endless fun!', '51', '849', '2', '0');
INSERT INTO catalogue_products VALUES ('2749', 'Pink Pura module 5', 'Endless fun!', '51', '850', '1', '0');
INSERT INTO catalogue_products VALUES ('2750', 'Black Pura module 1', 'Endless fun!', '51', '851', '2', '0');
INSERT INTO catalogue_products VALUES ('2751', 'Black Pura module 2', 'Endless fun!', '51', '852', '2', '0');
INSERT INTO catalogue_products VALUES ('2752', 'Black Pura module 3', 'Endless fun!', '51', '853', '2', '0');
INSERT INTO catalogue_products VALUES ('2753', 'Black Pura module 4', 'Endless fun!', '51', '854', '2', '0');
INSERT INTO catalogue_products VALUES ('2754', 'Black Pura module 5', 'Endless fun!', '51', '855', '1', '0');
INSERT INTO catalogue_products VALUES ('2755', 'White Pura module 1', 'Endless fun!', '51', '856', '2', '0');
INSERT INTO catalogue_products VALUES ('2756', 'White Pura module 2', 'Endless fun!', '51', '857', '2', '0');
INSERT INTO catalogue_products VALUES ('2757', 'White Pura module 3', 'Endless fun!', '51', '858', '2', '0');
INSERT INTO catalogue_products VALUES ('2758', 'White Pura module 4', 'Endless fun!', '51', '859', '2', '0');
INSERT INTO catalogue_products VALUES ('2759', 'White Pura module 5', 'Endless fun!', '51', '860', '1', '0');
INSERT INTO catalogue_products VALUES ('2760', 'Beige Pura module 1', 'Endless fun!', '51', '861', '2', '0');
INSERT INTO catalogue_products VALUES ('2761', 'Beige Pura module 2', 'Endless fun!', '51', '862', '2', '0');
INSERT INTO catalogue_products VALUES ('2762', 'Beige Pura module 3', 'Endless fun!', '51', '863', '2', '0');
INSERT INTO catalogue_products VALUES ('2763', 'Beige Pura module 4', 'Endless fun!', '51', '864', '2', '0');
INSERT INTO catalogue_products VALUES ('2764', 'Beige Pura module 5', 'Endless fun!', '51', '865', '1', '0');
INSERT INTO catalogue_products VALUES ('2765', 'Blue Pura module 1', 'Endless fun!', '51', '866', '2', '0');
INSERT INTO catalogue_products VALUES ('2766', 'Blue Pura module 2', 'Endless fun!', '51', '867', '2', '0');
INSERT INTO catalogue_products VALUES ('2767', 'Blue Pura module 3', 'Endless fun!', '51', '868', '2', '0');
INSERT INTO catalogue_products VALUES ('2768', 'Blue Pura module 4', 'Endless fun!', '51', '869', '2', '0');
INSERT INTO catalogue_products VALUES ('2769', 'Blue Pura module 5', 'Endless fun!', '51', '870', '1', '0');
INSERT INTO catalogue_products VALUES ('2770', 'Green Pura module 1', 'Endless fun!', '51', '871', '2', '0');
INSERT INTO catalogue_products VALUES ('2771', 'Green Pura module 2', 'Endless fun!', '51', '872', '2', '0');
INSERT INTO catalogue_products VALUES ('2772', 'Green Pura module 3', 'Endless fun!', '51', '873', '2', '0');
INSERT INTO catalogue_products VALUES ('2773', 'Green Pura module 4', 'Endless fun!', '51', '874', '2', '0');
INSERT INTO catalogue_products VALUES ('2774', 'Green Pura module 5', 'Endless fun!', '51', '875', '1', '0');
INSERT INTO catalogue_products VALUES ('2775', 'Yellow Pura module 1', 'Endless fun!', '51', '876', '2', '0');
INSERT INTO catalogue_products VALUES ('2776', 'Yellow Pura module 2', 'Endless fun!', '51', '877', '2', '0');
INSERT INTO catalogue_products VALUES ('2777', 'Yellow Pura module 3', 'Endless fun!', '51', '878', '2', '0');
INSERT INTO catalogue_products VALUES ('2778', 'Yellow Pura module 4', 'Endless fun!', '51', '879', '2', '0');
INSERT INTO catalogue_products VALUES ('2779', 'Yellow Pura module 5', 'Endless fun!', '51', '880', '1', '0');
INSERT INTO catalogue_products VALUES ('2780', 'Red Pura module 1', 'Endless fun!', '51', '881', '2', '0');
INSERT INTO catalogue_products VALUES ('2781', 'Red Pura module 2', 'Endless fun!', '51', '882', '2', '0');
INSERT INTO catalogue_products VALUES ('2782', 'Red Pura module 3', 'Endless fun!', '51', '883', '2', '0');
INSERT INTO catalogue_products VALUES ('2783', 'Red Pura module 4', 'Endless fun!', '51', '884', '2', '0');
INSERT INTO catalogue_products VALUES ('2784', 'Red Pura module 5', 'Endless fun!', '51', '885', '1', '0');
INSERT INTO catalogue_products VALUES ('2785', 'Aqua Retro Chair', 'Sitback and relax', '51', '886', '5', '0');
INSERT INTO catalogue_products VALUES ('2786', 'Pink Retro Chair', 'Sitback and relax', '51', '887', '5', '0');
INSERT INTO catalogue_products VALUES ('2787', 'Black Retro Chair', 'Sitback and relax', '51', '888', '5', '0');
INSERT INTO catalogue_products VALUES ('2788', 'White Retro Chair', 'Sitback and relax', '51', '889', '5', '0');
INSERT INTO catalogue_products VALUES ('2789', 'Beige Retro Chair', 'Sitback and relax', '51', '890', '5', '0');
INSERT INTO catalogue_products VALUES ('2790', 'Blue Retro Chair', 'Sitback and relax', '51', '891', '5', '0');
INSERT INTO catalogue_products VALUES ('2791', 'Green Retro Chair', 'Sitback and relax', '51', '892', '5', '0');
INSERT INTO catalogue_products VALUES ('2792', 'Yellow Retro Chair', 'Sitback and relax', '51', '893', '5', '0');
INSERT INTO catalogue_products VALUES ('2793', 'Red Retro Chair', 'Sitback and relax', '51', '894', '5', '0');
INSERT INTO catalogue_products VALUES ('2794', 'Rose Grand Piano', 'Rose Grand Piano', '52', '895', '10', '0');
INSERT INTO catalogue_products VALUES ('2795', 'Rose Quartz Piano Stool', 'Here sat the legend of 1900', '52', '896', '2', '0');
INSERT INTO catalogue_products VALUES ('2796', 'Rose Quartz Chair', 'Elegant seating for elegant Habbos', '52', '897', '5', '0');
INSERT INTO catalogue_products VALUES ('2797', 'Rose Romantique Divan', 'null', '52', '898', '6', '0');
INSERT INTO catalogue_products VALUES ('2798', 'Rose Quartz Screen', 'Beauty lies within', '52', '899', '6', '0');
INSERT INTO catalogue_products VALUES ('2799', 'Rose Quartz Tray Table', 'Every tray needs a table...', '52', '900', '4', '0');
INSERT INTO catalogue_products VALUES ('2800', 'Lime Grand Piano', 'Lime Grand Piano', '52', '901', '10', '0');
INSERT INTO catalogue_products VALUES ('2801', 'Lime Piano Chair', 'Let the music begin', '52', '902', '2', '0');
INSERT INTO catalogue_products VALUES ('2802', 'Lime Romantique Chair', 'null', '52', '903', '5', '0');
INSERT INTO catalogue_products VALUES ('2803', 'Emerald Chaise-Longue', 'Recline in continental comfort', '52', '904', '6', '0');
INSERT INTO catalogue_products VALUES ('2804', 'Green Screen', 'Keeping things separated', '52', '905', '6', '0');
INSERT INTO catalogue_products VALUES ('2805', 'Lime Tray Table', 'Every tray needs a table...', '52', '906', '4', '0');
INSERT INTO catalogue_products VALUES ('2806', 'Pink Grand Piano', 'Make sure you play in key!', '52', '907', '10', '0');
INSERT INTO catalogue_products VALUES ('2807', 'Turquoise Piano Chair', 'null', '52', '908', '2', '0');
INSERT INTO catalogue_products VALUES ('2808', 'Turquoise Chair', 'null', '52', '909', '5', '0');
INSERT INTO catalogue_products VALUES ('2809', 'Turquoise Divan', 'null', '52', '910', '6', '0');
INSERT INTO catalogue_products VALUES ('2810', 'Turquoise Screen', 'Keeping things separated', '52', '911', '6', '0');
INSERT INTO catalogue_products VALUES ('2811', 'Turquoise Tray Table', 'Every tray needs a table...', '52', '912', '4', '0');
INSERT INTO catalogue_products VALUES ('2812', 'Amber Grand Piano', 'Why is that key green?', '52', '913', '10', '0');
INSERT INTO catalogue_products VALUES ('2813', 'Amber Piano Stool', 'I can feel air coming through...', '52', '914', '2', '0');
INSERT INTO catalogue_products VALUES ('2814', 'Amber Chair', 'What does this button do?', '52', '915', '5', '0');
INSERT INTO catalogue_products VALUES ('2815', 'Amber Chaise-Longue', 'Is that a cape hanging there?', '52', '916', '6', '0');
INSERT INTO catalogue_products VALUES ('2816', 'Ochre Screen', 'Keeping things separated', '52', '917', '6', '0');
INSERT INTO catalogue_products VALUES ('2817', 'Amber Tray Table', 'Why is one leg different?', '52', '918', '4', '0');
INSERT INTO catalogue_products VALUES ('2818', 'Onyx Grand Piano', 'Why is that key green?', '52', '919', '10', '0');
INSERT INTO catalogue_products VALUES ('2819', 'Onyx Piano Stool', 'I can feel air coming through...', '52', '920', '2', '0');
INSERT INTO catalogue_products VALUES ('2820', 'Onyx Chair', 'What does this button do?', '52', '921', '5', '0');
INSERT INTO catalogue_products VALUES ('2821', 'Onyx Chaise-Longue', 'Is that a cape hanging there?', '52', '922', '6', '0');
INSERT INTO catalogue_products VALUES ('2822', 'Onyx Quartz Screen', 'Beauty lies within', '52', '923', '6', '0');
INSERT INTO catalogue_products VALUES ('2823', 'Onyx Tray Table', 'Why is one leg different?', '52', '924', '4', '0');
INSERT INTO catalogue_products VALUES ('2824', 'Club sofa', 'Importants habbos only', '53', '925', '25', '0');
INSERT INTO catalogue_products VALUES ('2825', 'HC chair', 'Aqua chair', '53', '926', '3', '0');
INSERT INTO catalogue_products VALUES ('2826', 'HC table', 'Aqua table', '53', '927', '3', '0');
INSERT INTO catalogue_products VALUES ('2827', 'Mochamaster', 'Wake up and smell it!', '53', '928', '25', '0');
INSERT INTO catalogue_products VALUES ('2828', 'Dicemaster', 'Click and roll!', '53', '929', '25', '0');
INSERT INTO catalogue_products VALUES ('2829', 'Tubmaster', 'Time for a soak', '53', '930', '25', '0');
INSERT INTO catalogue_products VALUES ('2830', 'Imperial Teleport', 'Let\'s go over tzar!', '53', '931', '25', '0');
INSERT INTO catalogue_products VALUES ('2831', 'Throne Sofa', 'For royal bottoms...', '53', '932', '25', '0');
INSERT INTO catalogue_products VALUES ('2832', 'Oil Lamp', 'Be enlightened', '53', '933', '25', '0');
INSERT INTO catalogue_products VALUES ('2833', 'Nordic Table', 'Perfect for banquets', '53', '934', '25', '0');
INSERT INTO catalogue_products VALUES ('2834', 'Majestic Chair', 'Royal comfort', '53', '935', '25', '0');
INSERT INTO catalogue_products VALUES ('2835', 'Study Desk', 'For Habbo scholars', '53', '936', '25', '0');
INSERT INTO catalogue_products VALUES ('2836', 'Drinks Trolley', 'For swanky dinners only', '53', '937', '25', '0');
INSERT INTO catalogue_products VALUES ('2837', 'Persian Carpet', 'Ultimate craftsmanship', '53', '938', '25', '0');
INSERT INTO catalogue_products VALUES ('2838', 'Victorian Street Light', 'Somber and atmospheric', '53', '939', '25', '0');
INSERT INTO catalogue_products VALUES ('2839', 'Antique Drapery', 'Topnotch privacy protection', '53', '940', '25', '0');
INSERT INTO catalogue_products VALUES ('2840', 'Mega TV Set', 'Forget plasma, go HC!', '53', '941', '25', '0');
INSERT INTO catalogue_products VALUES ('2841', 'Electric Butler', 'Your personal caretaker', '53', '942', '25', '0');
INSERT INTO catalogue_products VALUES ('2842', 'Medieval Bookcase', 'For the scholarly ones', '53', '943', '25', '0');
INSERT INTO catalogue_products VALUES ('2843', 'X-Ray Divider', 'Believe it or not!', '53', '944', '25', '0');
INSERT INTO catalogue_products VALUES ('2844', 'Weird Science Machine', 'By and for mad inventors', '53', '945', '25', '0');
INSERT INTO catalogue_products VALUES ('2845', 'Heavy Duty Fireplace', 'Pixel-powered for maximum heating', '53', '946', '25', '0');
INSERT INTO catalogue_products VALUES ('2846', 'The Grammophon', 'Very old skool scratch\'n\'spin', '53', '947', '25', '0');
INSERT INTO catalogue_products VALUES ('2847', 'Retro Wall Lamp', 'Tres chic!', '53', '948', '25', '0');
INSERT INTO catalogue_products VALUES ('2848', 'Moodlight', 'Turn this off when you\'re gonna bend her over', '54', '949', '25', '0');
INSERT INTO catalogue_products VALUES ('2849', 'Fire Dragon Lamp', 'George and the...', '55', '950', '25', '0');
INSERT INTO catalogue_products VALUES ('2850', 'Sea Dragon Lamp', 'Out of the deep blue!', '55', '951', '25', '0');
INSERT INTO catalogue_products VALUES ('2851', 'Jade Dragon Lamp', 'Oriental beast of legends', '55', '952', '25', '0');
INSERT INTO catalogue_products VALUES ('2852', 'Silver Dragon Lamp', 'Scary and scorching!', '55', '953', '25', '0');
INSERT INTO catalogue_products VALUES ('2853', 'Serpent of Doom', 'Scary and scorching!', '55', '954', '25', '0');
INSERT INTO catalogue_products VALUES ('2854', 'Elf Green Dragon Lamp', 'Roast your chestnuts here!', '55', '955', '25', '0');
INSERT INTO catalogue_products VALUES ('2855', 'Gold Dragon Lamp', 'Scary and scorching!', '55', '956', '25', '0');
INSERT INTO catalogue_products VALUES ('2856', 'Sky Dragon Lamp', 'Scary and scorching!', '55', '957', '25', '0');
INSERT INTO catalogue_products VALUES ('2857', 'Bronze Dragon Lamp', 'Scary and scorching!', '55', '958', '25', '0');
INSERT INTO catalogue_products VALUES ('2858', 'Purple Dragon Lamp', 'Scary and scorching!', '55', '959', '25', '0');
INSERT INTO catalogue_products VALUES ('2859', 'Festive Fan', 'As red as Rudolph\'s nose', '56', '960', '25', '0');
INSERT INTO catalogue_products VALUES ('2860', 'Blue Powered Fan', 'It\'ll blow you away!', '56', '961', '25', '0');
INSERT INTO catalogue_products VALUES ('2861', 'Green Powered Fan', 'It\'ll blow you away!', '56', '962', '25', '0');
INSERT INTO catalogue_products VALUES ('2862', 'Purple Powered Fan', 'It\'ll blow you away!', '56', '963', '25', '0');
INSERT INTO catalogue_products VALUES ('2863', 'SUPERLOVE Fan', 'Fanning the fires of SUPERLOVE...', '56', '964', '25', '0');
INSERT INTO catalogue_products VALUES ('2864', 'Yellow Powered Fan', 'It\'ll blow you away!', '56', '965', '25', '0');
INSERT INTO catalogue_products VALUES ('2865', 'Ochre Powered Fan', 'It\'ll blow you away!', '56', '966', '25', '0');
INSERT INTO catalogue_products VALUES ('2866', 'Brown Powered Fan', 'It\'ll blow you away!', '56', '967', '25', '0');
INSERT INTO catalogue_products VALUES ('2867', 'Habbo Wind Turbine', 'Stylish, Eco-Energy!', '56', '968', '25', '0');
INSERT INTO catalogue_products VALUES ('2868', 'Fucsia Powered Fan', 'It\'ll blow you away!', '56', '969', '25', '0');
INSERT INTO catalogue_products VALUES ('2869', 'Cherry Ice Cream', 'Virtual cherry rocks!', '57', '970', '25', '0');
INSERT INTO catalogue_products VALUES ('2870', 'Blueberry Ice Cream', 'Virtual blueberry rocks!', '57', '971', '25', '0');
INSERT INTO catalogue_products VALUES ('2871', 'Pistachio Ice Cream', 'Virtual pistachio rocks!', '57', '972', '25', '0');
INSERT INTO catalogue_products VALUES ('2872', 'Blackcurrant Ice Cream', 'Virtual blackcurrant rocks!', '57', '973', '25', '0');
INSERT INTO catalogue_products VALUES ('2873', 'Strawberry Ice Cream', 'Virtual strawberry rocks!', '57', '974', '25', '0');
INSERT INTO catalogue_products VALUES ('2874', 'Vanilla Ice Cream', 'Virtual vanilla rocks!', '57', '975', '25', '0');
INSERT INTO catalogue_products VALUES ('2875', 'Toffee Ice Cream', 'Virtual toffee rocks!', '57', '976', '25', '0');
INSERT INTO catalogue_products VALUES ('2876', 'Chocolate Ice Cream', 'Virtual chocolate rocks!', '57', '977', '25', '0');
INSERT INTO catalogue_products VALUES ('2877', 'Peppermint Ice Cream', 'Virtual peppermint rocks!', '57', '978', '25', '0');
INSERT INTO catalogue_products VALUES ('2878', 'Bubblegum Ice Cream', 'Virtual bubblegum rocks!', '57', '979', '25', '0');
INSERT INTO catalogue_products VALUES ('2879', 'Blue Inflatable Chair', 'Soft and stylish HC chair', '58', '980', '25', '0');
INSERT INTO catalogue_products VALUES ('2880', 'Pink Inflatable Chair', 'Soft and tearproof!', '58', '981', '25', '0');
INSERT INTO catalogue_products VALUES ('2881', 'Orange Inflatable Chair', 'Soft and tearproof!', '58', '982', '25', '0');
INSERT INTO catalogue_products VALUES ('2882', 'Ocean Inflatable Chair', 'Soft and tearproof!', '58', '983', '25', '0');
INSERT INTO catalogue_products VALUES ('2883', 'Lime Inflatable Chair', 'Soft and tearproof!', '58', '984', '25', '0');
INSERT INTO catalogue_products VALUES ('2884', 'Violet Inflatable Chair', 'Soft and tearproof!', '58', '985', '25', '0');
INSERT INTO catalogue_products VALUES ('2885', 'White Inflatable Chair', 'Soft and tearproof!', '58', '986', '25', '0');
INSERT INTO catalogue_products VALUES ('2886', 'Black Inflatable Chair', 'Soft and tearproof for HC!', '58', '987', '25', '0');
INSERT INTO catalogue_products VALUES ('2887', 'Red Laser Door', 'Energy beams. No trespassers!', '59', '988', '25', '0');
INSERT INTO catalogue_products VALUES ('2888', 'Gold Laser Gate', 'Energy beams. No trespassers!', '59', '989', '25', '0');
INSERT INTO catalogue_products VALUES ('2889', 'Blue Laser Gate', 'Get in the ring!', '59', '990', '25', '0');
INSERT INTO catalogue_products VALUES ('2890', 'Jade Sci-Fi Port', 'Energy beams. No trespassers!', '59', '991', '25', '0');
INSERT INTO catalogue_products VALUES ('2891', 'Pink Sci-Fi Port', 'Energy beams. No trespassers!', '59', '992', '25', '0');
INSERT INTO catalogue_products VALUES ('2892', 'Security Fence', 'Recovered from Roswell', '59', '993', '25', '0');
INSERT INTO catalogue_products VALUES ('2893', 'White Sci-Fi Port', 'Energy beams. No trespassers!', '59', '994', '25', '0');
INSERT INTO catalogue_products VALUES ('2894', 'Turquoise Sci-Fi Port', 'Energy beams. No trespassers!', '59', '995', '25', '0');
INSERT INTO catalogue_products VALUES ('2895', 'Purple Sci-Fi Port', 'Energy beams. No trespassers!', '59', '996', '25', '0');
INSERT INTO catalogue_products VALUES ('2896', 'Violet Sci-Fi Port', 'Energy beams. No trespassers!', '59', '997', '25', '0');
INSERT INTO catalogue_products VALUES ('2897', '', '', '-1', '998', '0', '0');

-- ----------------------------
-- Table structure for `club_subscriptions`
-- ----------------------------
DROP TABLE IF EXISTS `club_subscriptions`;
CREATE TABLE `club_subscriptions` (
  `userid` int(10) NOT NULL,
  `lastcheck` varchar(20) NOT NULL,
  `daysremaining` tinyint(2) NOT NULL,
  `remainingperiods` tinyint(3) NOT NULL,
  `periodspassed` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of club_subscriptions
-- ----------------------------
INSERT INTO club_subscriptions VALUES ('0', '21.10.2010 16:20:17', '127', '25', '0');

-- ----------------------------
-- Table structure for `console_friends`
-- ----------------------------
DROP TABLE IF EXISTS `console_friends`;
CREATE TABLE `console_friends` (
  `senderid` int(10) NOT NULL,
  `receiverid` int(10) NOT NULL,
  `accepted` enum('0','1') NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of console_friends
-- ----------------------------

-- ----------------------------
-- Table structure for `console_mail`
-- ----------------------------
DROP TABLE IF EXISTS `console_mail`;
CREATE TABLE `console_mail` (
  `id` int(15) NOT NULL,
  `fromid` int(10) NOT NULL,
  `toid` int(10) NOT NULL,
  `message` text NOT NULL,
  `time` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of console_mail
-- ----------------------------

-- ----------------------------
-- Table structure for `furniture`
-- ----------------------------
DROP TABLE IF EXISTS `furniture`;
CREATE TABLE `furniture` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'The ID of this item',
  `tid` int(10) NOT NULL DEFAULT '0' COMMENT 'The template ID of this item',
  `ownerid` int(10) NOT NULL DEFAULT '0' COMMENT 'The ID of the user that owns this item',
  `roomid` int(10) NOT NULL DEFAULT '0' COMMENT 'The room ID the item is in. If it''s 0, then it''s in the hand of OWNERID, if it''s -1, then it''s in a present and not opened yet, if it''s -2, then it''s in the Recycler',
  `x` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The X of the item in a room',
  `y` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The Y of the item in a room',
  `z` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The Z [rotation] of the item in a room',
  `h` double(4,2) NOT NULL DEFAULT '0.00' COMMENT 'The H [height, double] of the item in a room',
  `var` text COLLATE latin1_general_ci COMMENT 'The variable of the item, specifying it''s turned on/off etc, :S',
  `wallpos` varchar(200) COLLATE latin1_general_ci DEFAULT NULL COMMENT 'Wallitems only. The location on the wall where the item is',
  `visible` enum('True','False') COLLATE latin1_general_ci NOT NULL DEFAULT 'True',
  PRIMARY KEY (`id`),
  KEY `roomid` (`roomid`),
  KEY `tid` (`tid`),
  KEY `ownerid` (`ownerid`,`roomid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of furniture
-- ----------------------------

-- ----------------------------
-- Table structure for `furniture_templates`
-- ----------------------------
DROP TABLE IF EXISTS `furniture_templates`;
CREATE TABLE `furniture_templates` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `type` varchar(15) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `typeid` int(1) NOT NULL DEFAULT '0',
  `length` int(2) NOT NULL DEFAULT '0',
  `width` int(2) NOT NULL DEFAULT '0',
  `top` double(4,2) NOT NULL DEFAULT '0.00',
  `sprite` varchar(110) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `colour` varchar(100) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `tradeable` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  `recycleable` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  `door` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  `revision` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `typeid` (`typeid`)
) ENGINE=MyISAM AUTO_INCREMENT=1899 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of furniture_templates
-- ----------------------------
INSERT INTO furniture_templates VALUES ('1', '', '1', '1', '1', '0.00', 'rare_parasol*0', '#ffffff,#ffffff,#ffffff,#94f718', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('2', '', '0', '0', '0', '0.00', 'floor', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('3', '', '0', '0', '0', '0.00', 'wallpaper 1', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('4', '', '0', '0', '0', '0.00', 'wallpaper 2', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('5', '', '0', '0', '0', '0.00', 'wallpaper 3', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('6', '', '0', '0', '0', '0.00', 'wallpaper 4', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('7', '', '0', '0', '0', '0.00', 'wallpaper 5', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('8', '', '0', '0', '0', '0.00', 'wallpaper 6', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('9', '', '0', '0', '0', '0.00', 'wallpaper 7', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('10', '', '0', '0', '0', '0.00', 'wallpaper 8', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('11', '', '0', '0', '0', '0.00', 'wallpaper 9', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('12', '', '0', '0', '0', '0.00', 'wallpaper 10', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('13', '', '0', '0', '0', '0.00', 'wallpaper 11', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('14', '', '0', '0', '0', '0.00', 'wallpaper 12', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('15', '', '0', '0', '0', '0.00', 'wallpaper 13', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('16', '', '0', '0', '0', '0.00', 'wallpaper 14', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('17', '', '0', '0', '0', '0.00', 'wallpaper 15', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('18', '', '0', '0', '0', '0.00', 'wallpaper 16', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('19', '', '0', '0', '0', '0.00', 'wallpaper 17', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('20', '', '0', '0', '0', '0.00', 'wallpaper 18', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('21', '', '0', '0', '0', '0.00', 'wallpaper 19', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('22', '', '0', '0', '0', '0.00', 'wallpaper 20', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('23', '', '0', '0', '0', '0.00', 'wallpaper 21', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('24', '', '0', '0', '0', '0.00', 'wallpaper 22', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('25', '', '0', '0', '0', '0.00', 'wallpaper 23', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('26', '', '0', '0', '0', '0.00', 'wallpaper 24', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('27', '', '0', '0', '0', '0.00', 'wallpaper 25', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('28', '', '0', '0', '0', '0.00', 'wallpaper 26', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('29', '', '0', '0', '0', '0.00', 'wallpaper 27', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('30', '', '0', '0', '0', '0.00', 'wallpaper 28', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('31', '', '0', '0', '0', '0.00', 'wallpaper 29', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('32', '', '0', '0', '0', '0.00', 'wallpaper 30', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('33', '', '0', '0', '0', '0.00', 'wallpaper 31', '0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('34', '', '1', '1', '1', '0.00', 'nest', '0,0,0', '0', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('35', '', '1', '1', '1', '0.00', 'nest', '0,0,0', '0', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('36', '', '1', '1', '1', '0.00', 'nest', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('37', '', '1', '1', '1', '0.00', 'deal97', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('38', '', '1', '1', '1', '0.00', 'deal98', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('39', '', '1', '1', '1', '0.00', 'deal99', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('40', '', '1', '1', '1', '0.00', 'deal96', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('41', '', '1', '1', '1', '0.00', 'petfood1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('42', '', '1', '1', '1', '0.00', 'petfood2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('43', '', '1', '1', '1', '0.00', 'petfood3', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('44', '', '1', '1', '1', '0.00', 'petfood4', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('45', '', '1', '1', '1', '0.00', 'waterbowl*1', '#ff3f3f,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('46', '', '1', '1', '1', '0.00', 'waterbowl*2', '#3fff3f,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('47', '', '1', '1', '1', '0.00', 'waterbowl*3', '#ffff00,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('48', '', '1', '1', '1', '0.00', 'waterbowl*4', '#0099ff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('49', '', '1', '1', '1', '0.00', 'waterbowl*5', '#bf7f00,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('50', '', '1', '1', '1', '0.00', 'goodie2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('51', '', '1', '1', '1', '0.00', 'goodie1', '#ff4cbf,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('52', '', '1', '1', '1', '0.00', 'goodie1*1', '#3fffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('53', '', '1', '1', '1', '0.00', 'goodie1*2', '#ffbf00,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('54', '', '1', '1', '1', '0.00', 'toy1', '#ff0000,#ffff00,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('55', '', '1', '1', '1', '0.00', 'toy1*1', '#ff7f00,#007f00,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('56', '', '1', '1', '1', '0.00', 'toy1*2', '#003f7f,#ff00bf,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('57', '', '1', '1', '1', '0.00', 'toy1*3', '#bf1900,#00bfbf,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('58', '', '1', '1', '1', '0.00', 'toy1*4', '#000000,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('59', '', '1', '2', '1', '0.00', 'silo_studydesk', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('60', '', '3', '2', '3', '2.00', 'bed_silo_two', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('61', '', '3', '1', '3', '2.00', 'bed_silo_one', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('62', '', '1', '2', '1', '0.00', 'shelves_silo', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('63', '', '2', '2', '1', '1.10', 'sofa_silo', '#ffffff,#ffffff,#ffffff,#ffffff,#A2C6C8,#A2C6C8,#A2C6C8,#A2C6C8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('64', '', '1', '1', '1', '1.00', 'sofachair_silo', '#ffffff,#ffffff,#A2C6C8,#A2C6C8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('65', '', '1', '1', '1', '1.10', 'table_silo_small', '#ffffff,#A2C6C8,#ffffff,#A2C6C8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('66', '', '1', '1', '1', '0.00', 'divider_silo3', '#ffffff,#ffffff,#ffffff,#A2C6C8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('67', '', '1', '2', '1', '0.00', 'divider_silo2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('68', '', '1', '1', '1', '0.00', 'divider_silo1', '#ffffff,#A2C6C8,0,#A2C6C8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('69', '', '2', '1', '1', '1.10', 'chair_silo', '#ffffff,#ffffff,#A2C6C8,#A2C6C8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('70', '', '1', '1', '1', '1.20', 'safe_silo', '#ffffff,#A2C6C8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('71', '', '1', '1', '1', '0.90', 'barchair_silo', '#ffffff,#A2C6C8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('72', '', '1', '2', '2', '0.90', 'table_silo_med', '#ffffff,#8FAEAF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('73', '', '1', '1', '3', '0.00', 'tv_luxus', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('74', '', '1', '1', '2', '0.00', 'wood_tv', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('75', '', '1', '1', '1', '0.00', 'red_tv', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('76', '', '0', '0', '0', '0.00', 'post.it', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('77', '', '1', '1', '1', '0.00', 'pizza', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('78', '', '1', '1', '1', '0.00', 'drinks', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('79', '', '1', '1', '1', '0.00', 'bottle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('80', '', '1', '1', '1', '0.00', 'edice', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('81', '', '1', '1', '1', '0.00', 'habbocake', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('82', '', '1', '1', '1', '0.00', 'menorah', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('83', '', '1', '1', '1', '0.00', 'bunny', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('84', '', '0', '0', '0', '0.00', 'poster 44', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('85', '', '1', '1', '1', '0.00', 'wcandleset', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('86', '', '1', '1', '1', '0.00', 'rcandleset', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('87', '', '1', '1', '1', '0.00', 'ham', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('88', '', '1', '1', '1', '0.00', 'hockey_light', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('89', '', '1', '1', '1', '0.00', 'wall_china', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('90', '', '1', '1', '1', '0.00', 'corner_china', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('91', '', '2', '2', '1', '0.00', 'china_shelve', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('92', '', '1', '1', '1', '0.90', 'china_table', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('93', '', '2', '1', '1', '1.00', 'chair_china', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('94', '', '0', '0', '0', '0.00', 'poster 57', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('95', '', '0', '0', '0', '0.00', 'poster 58', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('96', '', '2', '3', '1', '1.00', 'cn_sofa', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('97', '', '1', '1', '1', '0.00', 'cn_lamp', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('98', '', '2', '1', '2', '1.00', 'bath', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('99', '', '1', '1', '1', '0.00', 'sink', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('100', '', '1', '1', '1', '0.00', 'duck', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('101', '', '2', '1', '1', '1.10', 'toilet', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('102', '', '2', '1', '1', '1.00', 'toilet_red', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('103', '', '2', '1', '1', '1.00', 'toilet_yell', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('104', '', '4', '4', '4', '0.00', 'tile', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('105', '', '4', '4', '4', '0.00', 'tile_red', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('106', '', '4', '4', '4', '0.00', 'tile_yell', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('107', '', '1', '2', '1', '1.00', 'bardesk_polyfon*5', '#ffffff,#ffffff,#FF9BBD,#FF9BBD', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('108', '', '1', '1', '1', '1.10', 'bardeskcorner_polyfon*5', '#ffffff,#FF9BBD', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('109', '', '1', '1', '1', '0.00', 'divider_poly3*5', '#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('110', '', '2', '1', '1', '1.00', 'sofachair_polyfon_girl', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('111', '', '2', '2', '1', '1.10', 'sofa_polyfon_girl', '#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#E', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('112', '', '4', '2', '3', '0.00', 'carpet_polar*1', '#ffbbcf,#ffbbcf,#ffddef', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('113', '', '3', '1', '3', '2.00', 'bed_polyfon_girl_one', '#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('114', '', '3', '2', '3', '2.00', 'bed_polyfon_girl', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('115', '', '1', '1', '1', '0.00', 'camera', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('116', '', '0', '0', '0', '0.00', 'photo_film', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('117', '', '0', '0', '0', '0.00', 'poster 500', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('118', '', '0', '0', '0', '0.00', 'poster 501', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('119', '', '0', '0', '0', '0.00', 'poster 502', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('120', '', '0', '0', '0', '0.00', 'poster 503', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('121', '', '0', '0', '0', '0.00', 'poster 504', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('122', '', '0', '0', '0', '0.00', 'poster 505', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('123', '', '0', '0', '0', '0.00', 'poster 506', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('124', '', '0', '0', '0', '0.00', 'poster 507', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('125', '', '0', '0', '0', '0.00', 'poster 508', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('126', '', '0', '0', '0', '0.00', 'poster 509', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('127', '', '0', '0', '0', '0.00', 'poster 510', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('128', '', '0', '0', '0', '0.00', 'poster 511', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('129', '', '0', '0', '0', '0.00', 'poster 512', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('130', '', '0', '0', '0', '0.00', 'poster 513', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('131', '', '0', '0', '0', '0.00', 'poster 514', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('132', '', '0', '0', '0', '0.00', 'poster 515', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('133', '', '0', '0', '0', '0.00', 'poster 516', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('134', '', '0', '0', '0', '0.00', 'poster 517', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('135', '', '0', '0', '0', '0.00', 'poster 518', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('136', '', '0', '0', '0', '0.00', 'poster 520', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('137', '', '0', '0', '0', '0.00', 'poster 521', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('138', '', '0', '0', '0', '0.00', 'poster 522', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('139', '', '0', '0', '0', '0.00', 'poster 523', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('140', '', '0', '0', '0', '0.00', 'poster 2001', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('141', '', '0', '0', '0', '0.00', 'poster 2004', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('142', '', '0', '0', '0', '0.00', 'poster 2002', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('143', '', '0', '0', '0', '0.00', 'poster 7', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('144', '', '0', '0', '0', '0.00', 'poster 12', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('145', '', '0', '0', '0', '0.00', 'poster 13', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('146', '', '0', '0', '0', '0.00', 'poster 14', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('147', '', '0', '0', '0', '0.00', 'poster 17', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('148', '', '0', '0', '0', '0.00', 'poster 18', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('149', '', '0', '0', '0', '0.00', 'poster 16', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('150', '', '0', '0', '0', '0.00', 'poster 1003', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('151', '', '0', '0', '0', '0.00', 'poster 15', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('152', '', '0', '0', '0', '0.00', 'poster 1006', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('153', '', '0', '0', '0', '0.00', 'poster 32', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('154', '', '0', '0', '0', '0.00', 'poster 33', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('155', '', '0', '0', '0', '0.00', 'poster 2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('156', '', '0', '0', '0', '0.00', 'poster 3', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('157', '', '0', '0', '0', '0.00', 'poster 4', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('158', '', '0', '0', '0', '0.00', 'poster 5', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('159', '', '0', '0', '0', '0.00', 'poster 1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('160', '', '0', '0', '0', '0.00', 'poster 6', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('161', '', '0', '0', '0', '0.00', 'poster 1002', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('162', '', '0', '0', '0', '0.00', 'poster 1001', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('163', '', '0', '0', '0', '0.00', 'poster 8', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('164', '', '0', '0', '0', '0.00', 'poster 9', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('165', '', '0', '0', '0', '0.00', 'poster 1004', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('166', '', '0', '0', '0', '0.00', 'poster 2006', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('167', '', '0', '0', '0', '0.00', 'poster 2008', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('168', '', '0', '0', '0', '0.00', 'poster 11', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('169', '', '0', '0', '0', '0.00', 'poster 41', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('170', '', '0', '0', '0', '0.00', 'poster 40', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('171', '', '0', '0', '0', '0.00', 'poster 35', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('172', '', '0', '0', '0', '0.00', 'poster 36', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('173', '', '0', '0', '0', '0.00', 'poster 37', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('174', '', '0', '0', '0', '0.00', 'poster 1005', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('175', '', '0', '0', '0', '0.00', 'poster 34', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('176', '', '0', '0', '0', '0.00', 'poster 39', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('177', '', '0', '0', '0', '0.00', 'poster 2000', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('178', '', '0', '0', '0', '0.00', 'poster 38', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('179', '', '0', '0', '0', '0.00', 'poster 2008', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('180', '', '0', '0', '0', '0.00', 'poster 2007', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('181', '', '0', '0', '0', '0.00', 'poster 2003', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('182', '', '0', '0', '0', '0.00', 'poster 31', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('183', '', '0', '0', '0', '0.00', 'poster 55', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('184', '', '1', '2', '1', '0.00', 'glass_shelf', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('185', '', '2', '2', '1', '1.10', 'glass_sofa', '#ffffff,#ABD0D2,#ABD0D2,#ffffff,#ffffff,#ABD0D2,#ffffff,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('186', '', '1', '2', '2', '0.90', 'glass_table', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('187', '', '2', '1', '1', '1.10', 'glass_chair', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('188', '', '2', '1', '1', '1.10', 'glass_stool', '#ffffff,#ABD0D2,#ABD0D2,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('189', '', '2', '2', '1', '1.10', 'glass_sofa*2', '#ffffff,#525252,#525252,#ffffff,#ffffff,#525252,#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('190', '', '1', '2', '2', '0.90', 'glass_table*2', '#ffffff,#525252,#525252,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('191', '', '2', '1', '1', '1.10', 'glass_chair*2', '#ffffff,#525252,#525252,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('192', '', '2', '1', '1', '1.10', 'glass_stool*2', '#ffffff,#525252,#525252,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('193', '', '2', '2', '1', '1.10', 'glass_sofa*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('194', '', '1', '2', '2', '0.90', 'glass_table*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('195', '', '2', '1', '1', '1.00', 'glass_chair*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('196', '', '2', '1', '1', '1.10', 'glass_stool*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('197', '', '2', '2', '1', '1.10', 'glass_sofa*4', '#ffffff,#F7EBBC,#F7EBBC,#ffffff,#ffffff,#F7EBBC,#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('198', '', '1', '2', '2', '0.90', 'glass_table*4', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('199', '', '2', '1', '1', '1.10', 'glass_chair*4', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('200', '', '2', '1', '1', '1.10', 'glass_stool*4', '#ffffff,#F7EBBC,#F7EBBC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('201', '', '2', '2', '1', '1.10', 'glass_sofa*5', '#ffffff,#FF99BC,#FF99BC,#ffffff,#ffffff,#FF99BC,#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('202', '', '1', '2', '2', '0.90', 'glass_table*5', '#ffffff,#FF99BC,#FF99BC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('203', '', '2', '1', '1', '1.10', 'glass_chair*5', '#ffffff,#FF99BC,#FF99BC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('204', '', '2', '1', '1', '1.10', 'glass_stool*5', '#ffffff,#FF99BC,#FF99BC,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('205', '', '2', '2', '1', '1.10', 'glass_sofa*6', '#ffffff,#5EAAF8,#5EAAF8,#ffffff,#ffffff,#5EAAF8,#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('206', '', '1', '2', '2', '0.90', 'glass_table*6', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('207', '', '2', '1', '1', '1.10', 'glass_chair*6', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('208', '', '2', '1', '1', '1.10', 'glass_stool*6', '#ffffff,#5EAAF8,#5EAAF8,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('209', '', '2', '2', '1', '1.10', 'glass_sofa*7', '#ffffff,#92D13D,#92D13D,#ffffff,#ffffff,#92D13D,#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('210', '', '1', '2', '2', '0.90', 'glass_table*7', '#ffffff,#92D13D,#92D13D,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('211', '', '2', '1', '1', '1.10', 'glass_chair*7', '#ffffff,#92D13D,#92D13D,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('212', '', '2', '1', '1', '1.10', 'glass_stool*7', '#ffffff,#92D13D,#92D13D,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('213', '', '2', '2', '1', '1.10', 'glass_sofa*8', '#ffffff,#FFD837,#FFD837,#ffffff,#ffffff,#FFD837,#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('214', '', '1', '2', '2', '0.90', 'glass_table*8', '#ffffff,#FFD837,#FFD837,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('215', '', '2', '1', '1', '1.10', 'glass_chair*8', '#ffffff,#FFD837,#FFD837,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('216', '', '2', '1', '1', '1.10', 'glass_stool*8', '#ffffff,#FFD837,#FFD837,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('217', '', '2', '2', '1', '1.10', 'glass_sofa*9', '#ffffff,#E14218,#E14218,#ffffff,#ffffff,#E14218,#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('218', '', '1', '2', '2', '0.90', 'glass_table*9', '#ffffff,#E14218,#E14218,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('219', '', '2', '1', '1', '1.10', 'glass_chair*9', '#ffffff,#E14218,#E14218,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('220', '', '2', '1', '1', '1.10', 'glass_stool*9', '#ffffff,#E14218,#E14218,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('221', '', '2', '1', '1', '1.10', 'gothic_chair*3', '#ffffff,#dd0000,#ffffff,#dd0000', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('222', '', '2', '2', '1', '1.10', 'gothic_sofa*3', '#ffffff,#dd0000,#ffffff,#ffffff,#dd0000,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('223', '', '1', '1', '1', '1.10', 'gothic_stool*3', '#ffffff,#dd0000,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('224', '', '4', '2', '4', '0.00', 'gothic_carpet', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('225', '', '4', '2', '4', '0.00', 'gothic_carpet2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('226', '', '1', '1', '5', '1.00', 'goth_table', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('227', '', '1', '2', '1', '0.00', 'gothrailing', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('228', '', '0', '0', '0', '0.00', 'torch', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('229', '', '0', '0', '0', '0.00', 'gothicfountain', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('230', '', '1', '1', '1', '0.00', 'gothiccandelabra', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('231', '', '1', '2', '1', '0.00', 'gothgate', '0,0,0', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('232', '', '0', '0', '0', '0.00', 'industrialfan', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('233', '', '1', '1', '1', '0.00', 'grunge_barrel', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('234', '', '2', '3', '1', '1.10', 'grunge_bench', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('235', '', '1', '1', '1', '0.00', 'grunge_candle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('236', '', '2', '1', '1', '1.10', 'grunge_chair', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('237', '', '2', '3', '1', '0.80', 'grunge_mattress', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('238', '', '1', '1', '1', '0.00', 'grunge_radiator', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('239', '', '1', '3', '1', '0.00', 'grunge_shelf', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('240', '', '1', '1', '1', '0.00', 'grunge_sign', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('241', '', '1', '2', '2', '1.00', 'grunge_table', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('242', '', '1', '1', '1', '0.10', 'CF_1_coin_bronze', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('243', '', '1', '1', '1', '0.10', 'CF_5_coin_silver', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('244', '', '1', '1', '1', '0.10', 'CF_10_coin_gold', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('245', '', '1', '1', '1', '1.00', 'CF_20_moneybag', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('246', '', '1', '1', '1', '0.60', 'CF_50_goldbar', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('247', '', '2', '1', '1', '1.00', 'habbowood_chair', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('248', '', '1', '2', '1', '0.00', 'rope_divider', '0,0,0', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('249', '', '1', '1', '1', '0.00', 'spotlight', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('250', '', '2', '1', '1', '1.00', 'theatre_seat', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('251', '', '1', '1', '1', '0.00', 'rare_icecream_campaign', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('252', '', '0', '0', '0', '0.00', 'habw_mirror', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('253', '', '2', '1', '1', '1.00', 'chair_norja', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('254', '', '2', '2', '1', '1.10', 'couch_norja', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('255', '', '1', '2', '2', '0.90', 'table_norja_med', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('256', '', '1', '1', '1', '0.00', 'shelves_norja', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('257', '', '2', '1', '1', '1.00', 'soft_sofachair_norja', '#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('258', '', '2', '2', '1', '1.00', 'soft_sofa_norja', '#ffffff,#F7EBBC,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('259', '', '1', '2', '1', '0.00', 'divider_nor2', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('260', '', '1', '1', '1', '0.00', 'divider_nor1', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('261', '', '1', '1', '1', '0.00', 'divider_nor3', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('262', '', '1', '2', '1', '0.00', 'divider_nor4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('263', '', '1', '1', '1', '0.00', 'divider_nor5', '#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('264', '', '4', '2', '2', '0.00', 'jp_bamboo', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('265', '', '2', '1', '1', '0.70', 'jp_pillow', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('266', '', '1', '2', '2', '0.00', 'jp_irori', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('267', '', '4', '2', '2', '0.00', 'jp_tatami', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('268', '', '4', '2', '4', '0.00', 'jp_tatami2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('269', '', '1', '1', '1', '0.00', 'jp_lantern', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('270', '', '1', '1', '1', '0.00', 'jp_drawer', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('271', '', '0', '0', '0', '0.00', 'jp_ninjastars', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('272', '', '3', '2', '3', '2.00', 'bed_armas_two', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('273', '', '3', '1', '3', '2.00', 'bed_armas_one', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('274', '', '1', '2', '1', '0.00', 'fireplace_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('275', '', '1', '1', '3', '1.20', 'bartable_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('276', '', '1', '2', '2', '1.00', 'table_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('277', '', '2', '2', '1', '1.10', 'bench_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('278', '', '1', '1', '1', '0.00', 'divider_arm3', '0,0,0', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('279', '', '1', '1', '1', '1.20', 'divider_arm1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('280', '', '1', '2', '1', '1.20', 'divider_arm2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('281', '', '1', '2', '1', '0.00', 'shelves_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('282', '', '1', '1', '1', '0.00', 'bar_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('283', '', '2', '1', '1', '1.00', 'bar_chair_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('284', '', '1', '1', '1', '0.00', 'lamp_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('285', '', '1', '1', '1', '0.00', 'lamp2_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('286', '', '1', '1', '1', '1.10', 'small_table_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('287', '', '2', '1', '1', '1.00', 'small_chair_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('288', '', '3', '2', '3', '2.00', 'bed_polyfon', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('289', '', '3', '1', '3', '2.00', 'bed_polyfon_one', 'ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('290', '', '1', '2', '1', '0.00', 'fireplace_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('291', '', '2', '2', '1', '1.10', 'sofa_polyfon', '#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('292', '', '2', '1', '1', '1.00', 'sofachair_polyfon', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('293', '', '1', '1', '1', '0.00', 'bar_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('294', '', '1', '1', '1', '0.00', 'divider_poly3', '#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('295', '', '1', '2', '1', '1.00', 'bardesk_polyfon', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('296', '', '1', '1', '1', '0.00', 'bardeskcorner_polyfon', '#ffffff,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('297', '', '2', '1', '1', '1.10', 'chair_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('298', '', '1', '2', '2', '0.80', 'table_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('299', '', '1', '2', '2', '1.00', 'table_polyfon_med', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('300', '', '1', '2', '2', '0.90', 'table_polyfon_small', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('301', '', '1', '2', '2', '0.90', 'smooth_table_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('302', '', '1', '1', '1', '0.70', 'stand_polyfon_z', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('303', '', '1', '2', '1', '0.00', 'shelves_polyfon', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('304', '', '1', '1', '1', '1.00', 'present_gen1', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('305', '', '1', '1', '1', '1.00', 'present_gen2', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('306', '', '1', '1', '1', '1.00', 'present_gen3', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('307', '', '1', '1', '1', '1.00', 'present_gen4', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('308', '', '1', '1', '1', '1.00', 'present_gen5', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('309', '', '1', '1', '1', '1.00', 'present_gen6', '0,0,0', '0', '0', '0', '0');
INSERT INTO furniture_templates VALUES ('310', '', '1', '1', '1', '0.00', 'giftflowers', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('311', '', '1', '1', '1', '0.00', 'plant_rose', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('312', '', '1', '1', '1', '0.00', 'plant_sunflower', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('313', '', '1', '1', '1', '0.00', 'plant_yukka', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('314', '', '1', '1', '1', '0.00', 'plant_pineapple', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('315', '', '1', '1', '1', '0.00', 'plant_bonsai', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('316', '', '1', '1', '1', '0.00', 'plant_big_cactus', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('317', '', '1', '1', '1', '0.00', 'plant_fruittree', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('318', '', '1', '1', '1', '0.00', 'plant_small_cactus', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('319', '', '1', '2', '1', '0.00', 'plant_maze', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('320', '', '1', '2', '1', '0.00', 'plant_mazegate', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('321', '', '1', '1', '1', '0.00', 'plant_bulrush', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('322', '', '2', '1', '1', '1.00', 'chair_plasto*16', '#ffffff,#CC3399,#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('323', '', '2', '1', '1', '1.00', 'chair_plasto*15', '#ffffff,#FF97BA,#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('324', '', '2', '1', '1', '1.00', 'chair_plasto*5', '#ffffff,#54ca00,#ffffff,#54ca00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('325', '', '2', '1', '1', '1.00', 'chair_plasto', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('326', '', '2', '1', '1', '1.00', 'chair_plasto*8', '#ffffff,#c38d1a,#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('327', '', '2', '1', '1', '1.00', 'chair_plasto*7', '#ffffff,#ff6d00,#ffffff,#ff6d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('328', '', '2', '1', '1', '1.00', 'chair_plasto*1', '#ffffff,#ff1f08,#ffffff,#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('329', '', '2', '1', '1', '1.00', 'chair_plasto*4', '#ffffff,#ccddff,#ffffff,#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('330', '', '2', '1', '1', '1.00', 'chair_plasto*6', '#ffffff,#3444ff,#ffffff,#3444ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('331', '', '2', '1', '1', '1.00', 'chair_plasto*3', '#ffffff,#ffee00,#ffffff,#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('332', '', '2', '1', '1', '1.00', 'chair_plasto*2', '#ffffff,#99DCCC,#ffffff,#99DCCc', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('333', '', '1', '1', '1', '1.10', 'table_plasto_square*15', '#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('334', '', '1', '1', '1', '1.10', 'table_plasto_square*14', '#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('335', '', '1', '1', '1', '1.10', 'table_plasto_square*1', '#ffffff,#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('336', '', '1', '1', '1', '1.10', 'table_plasto_square*7', '#ffffff,#ff6d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('337', '', '1', '1', '1', '1.10', 'table_plasto_square', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('338', '', '1', '1', '1', '1.10', 'table_plasto_square*2', '#ffffff,#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('339', '', '1', '1', '1', '1.10', 'table_plasto_square*4', '#ffffff,#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('340', '', '1', '1', '1', '1.10', 'table_plasto_square*6', '#ffffff,#3444ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('341', '', '1', '1', '1', '1.10', 'table_plasto_square*3', '#ffffff,#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('342', '', '1', '1', '1', '1.10', 'table_plasto_square*9', '#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('343', '', '1', '1', '1', '1.10', 'table_plasto_square*5', '#ffffff,#54ca00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('344', '', '1', '1', '1', '1.10', 'table_plasto_square*8', '#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('345', '', '1', '2', '2', '1.10', 'table_plasto_round*15', '#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('346', '', '1', '2', '2', '1.10', 'table_plasto_round*14', '#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('347', '', '1', '2', '2', '1.10', 'table_plasto_round*7', '#ffffff,#ff6d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('348', '', '1', '2', '2', '1.10', 'table_plasto_round*1', '#ffffff,#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('349', '', '1', '2', '2', '1.10', 'table_plasto_round*2', '#ffffff,#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('350', '', '1', '2', '2', '1.10', 'table_plasto_round*4', '#ffffff,#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('351', '', '1', '2', '2', '1.10', 'table_plasto_round*6', '#ffffff,#3444ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('352', '', '1', '2', '2', '1.10', 'table_plasto_round*3', '#ffffff,#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('353', '', '1', '2', '2', '1.10', 'table_plasto_round*9', '#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('354', '', '1', '2', '2', '1.10', 'table_plasto_round', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('355', '', '1', '2', '2', '1.10', 'table_plasto_round*5', '#ffffff,#54ca00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('356', '', '1', '2', '2', '1.10', 'table_plasto_round*8', '#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('357', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*15', '#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('358', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*14', '#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('359', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*7', '#ffffff,#ff6d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('360', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*1', '#ffffff,#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('361', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*2', '#ffffff,#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('362', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('363', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*8', '#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('364', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*5', '#ffffff,#54ca00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('365', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*9', '#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('366', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*3', '#ffffff,#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('367', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*6', '#ffffff,#3444ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('368', '', '1', '2', '2', '1.10', 'table_plasto_bigsquare*4', '#ffffff,#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('369', '', '1', '2', '2', '1.10', 'table_plasto_4leg*6', '#ffffff,#3444ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('370', '', '1', '2', '2', '1.10', 'table_plasto_4leg*1', '#ffffff,#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('371', '', '1', '2', '2', '1.10', 'table_plasto_4leg*3', '#ffffff,#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('372', '', '1', '2', '2', '1.10', 'table_plasto_4leg*9', '#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('373', '', '1', '2', '2', '1.10', 'table_plasto_4leg', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('374', '', '1', '2', '2', '1.10', 'table_plasto_4leg*5', '#ffffff,#54ca00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('375', '', '1', '2', '2', '1.10', 'table_plasto_4leg*2', '#ffffff,#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('376', '', '1', '2', '2', '1.10', 'table_plasto_4leg*8', '#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('377', '', '1', '2', '2', '1.10', 'table_plasto_4leg*7', '#ffffff,#ff6d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('378', '', '1', '2', '2', '1.10', 'table_plasto_4leg*10', '#ffffff,#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('379', '', '1', '2', '2', '1.10', 'table_plasto_4leg*15', '#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('380', '', '1', '2', '2', '1.10', 'table_plasto_4leg*16', '#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('381', '', '2', '1', '1', '1.00', 'chair_plasty', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('382', '', '2', '1', '1', '1.00', 'chair_plasty*1', '#ffffff,#8EB5D1,#ffffff,#8EB5D1', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('383', '', '2', '1', '1', '1.00', 'chair_plasty*2', '#ffffff,#ff9900,#ffffff,#ff9900', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('384', '', '2', '1', '1', '1.00', 'chair_plasty*3', '#ffffff,#ff2200,#ffffff,#ff2200', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('385', '', '2', '1', '1', '1.00', 'chair_plasty*4', '#ffffff,#00cc00,#ffffff,#00cc00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('386', '', '2', '1', '1', '1.00', 'chair_plasty*4', '#ffffff,#0033CC,#ffffff,#0033CC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('387', '', '2', '1', '1', '1.00', 'chair_plasty*4', '#ffffff,#333333,#ffffff,#333333', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('388', '', '2', '1', '1', '1.00', 'chair_plasty*7', '#ffffff,#99DCCc,#ffffff,#99DCCc', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('389', '', '2', '1', '1', '1.00', 'chair_plasty*8', '#ffffff,#c38d1a,#ffffff,#c38d1a', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('390', '', '2', '1', '1', '1.00', 'chair_plasty*9', '#ffffff,#533e10,#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('391', '', '2', '1', '1', '1.00', 'chair_plasty*10', '#ffffff,#CC3399,#ffffff,#CC3399', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('392', '', '2', '1', '1', '1.00', 'chair_plasty*11', '#ffffff,#FF97BA,#ffffff,#FF97BA', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('393', '', '2', '1', '1', '1.00', 'chair_plasto*9', '#ffffff,#533e10,#ffffff,#533e10', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('394', '', '1', '2', '1', '1.00', 'shelves_basic', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('395', '', '1', '1', '1', '0.00', 'bar_basic', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('396', '', '1', '1', '1', '0.00', 'fridge', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('397', '', '1', '1', '1', '0.00', 'lamp_basic', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('398', '', '3', '2', '3', '2.00', 'bed_budgetb', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('399', '', '3', '1', '3', '2.00', 'bed_budgetb_one', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('400', '', '3', '2', '3', '2.00', 'bed_budget', '#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('401', '', '3', '1', '3', '2.00', 'bed_budget_one', '#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('402', '', '3', '2', '3', '2.00', 'bed_budgetb', '#FFFFFF,#FFFFFF,#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('403', '', '3', '1', '3', '2.00', 'bed_budgetb_one', '#FFFFFF,#FFFFFF,#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('404', '', '3', '2', '3', '2.00', 'bed_budget', '#FFFFFF,#FFFFFF,#FFFFFF,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('405', '', '3', '1', '3', '2.00', 'bed_budget_one', '#FFFFFF,#FFFFFF,#FFFFFF,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('406', '', '3', '2', '3', '2.00', 'bed_budgetb', '#FFFFFF,#FFFFFF,#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('407', '', '3', '1', '3', '2.00', 'bed_budgetb_one', '#FFFFFF,#FFFFFF,#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('408', '', '3', '2', '3', '2.00', 'bed_budget', '#FFFFFF,#FFFFFF,#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('409', '', '3', '1', '3', '2.00', 'bed_budget_one', '#FFFFFF,#FFFFFF,#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('410', '', '3', '2', '3', '2.00', 'bed_budgetb', '#FFFFFF,#FFFFFF,#FFFFFF,#92D13D,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('411', '', '3', '1', '3', '2.00', 'bed_budgetb_one', '#FFFFFF,#FFFFFF,#FFFFFF,#92D13D,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('412', '', '3', '2', '3', '2.00', 'bed_budget', '#FFFFFF,#FFFFFF,#FFFFFF,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('413', '', '3', '1', '3', '2.00', 'bed_budget_one', '#FFFFFF,#FFFFFF,#FFFFFF,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('414', '', '3', '2', '3', '2.00', 'bed_budgetb', '#FFFFFF,#FFFFFF,#FFFFFF,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('415', '', '3', '1', '3', '2.00', 'bed_budgetb_one', '#FFFFFF,#FFFFFF,#FFFFFF,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('416', '', '2', '2', '1', '1.00', 'rclr_sofa', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('417', '', '2', '1', '1', '1.00', 'rclr_chair', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('418', '', '1', '1', '3', '0.00', 'rclr_garden', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('419', '', '1', '1', '1', '0.20', 'queue_tile1*0', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('420', '', '1', '1', '1', '0.20', 'queue_tile1*1', '#ffffff,#FF7C98,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('421', '', '1', '1', '1', '0.20', 'queue_tile1*2', '#ffffff,#FF3333,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('422', '', '1', '1', '1', '0.20', 'queue_tile1*3', '#ffffff,#67c39c,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('423', '', '1', '1', '1', '0.20', 'queue_tile1*4', '#ffffff,#FFAA2B,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('424', '', '1', '1', '1', '0.20', 'queue_tile1*5', '#ffffff,#555A37,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('425', '', '1', '1', '1', '0.20', 'queue_tile1*6', '#ffffff,#A2E8FA,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('426', '', '1', '1', '1', '0.20', 'queue_tile1*7', '#ffffff,#FC5AFF,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('427', '', '1', '1', '1', '0.20', 'queue_tile1*8', '#ffffff,#1E8AA5,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('428', '', '1', '1', '1', '0.20', 'queue_tile1*9', '#ffffff,#9AFF60,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('429', '', '1', '2', '2', '0.00', 'grand_piano*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('430', '', '2', '1', '1', '1.00', 'romantique_pianochair*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('431', '', '2', '2', '1', '0.00', 'romantique_divan*1', '#FFFFFF,#FFFFFF,#FFFFFF,#FF8B8B', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('432', '', '2', '1', '1', '1.00', 'romantique_chair*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('433', '', '1', '2', '1', '0.00', 'romantique_divider*1', '#FF8B8B,#FF8B8B,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('434', '', '1', '1', '1', '1.00', 'romantique_smalltabl*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('435', '', '0', '0', '0', '0.00', 'wallmirror', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('436', '', '1', '1', '1', '0.00', 'romantique_tray2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('437', '', '1', '1', '1', '0.00', 'rom_lamp', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('438', '', '1', '1', '1', '1.00', 'romantique_mirrortabl', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('439', '', '4', '3', '5', '0.00', 'carpet_standard', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('440', '', '4', '3', '5', '0.00', 'carpet_standard*a', '#55AC00,#55AC00,#55AC00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('441', '', '4', '3', '5', '0.00', 'carpet_standard*b', '#336666,#336666,#336666', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('442', '', '4', '3', '5', '0.00', 'carpet_standard*1', '#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('443', '', '4', '3', '5', '0.00', 'carpet_standard*2', '#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('444', '', '4', '3', '5', '0.00', 'carpet_standard*3', '#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('445', '', '4', '3', '5', '0.00', 'carpet_standard*4', '#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('446', '', '4', '3', '5', '0.00', 'carpet_standard*5', '#ddccff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('447', '', '4', '3', '5', '0.00', 'carpet_standard*6', '#777777', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('448', '', '4', '3', '5', '0.00', 'carpet_standard*7', '#99CCFF,#99CCFF,#99CCFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('449', '', '4', '3', '5', '0.00', 'carpet_standard*8', '#999966,#999966,#999966', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('450', '', '4', '2', '4', '0.00', 'carpet_soft', '', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('451', '', '4', '2', '4', '0.00', 'carpet_soft*1', '#CC3333', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('452', '', '4', '2', '4', '0.00', 'carpet_soft*2', '#66FFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('453', '', '4', '2', '4', '0.00', 'carpet_soft*3', '#FFCC99', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('454', '', '4', '2', '4', '0.00', 'carpet_soft*4', '#FFCCFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('455', '', '4', '2', '4', '0.00', 'carpet_soft*5', '#FFFF66', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('456', '', '4', '2', '4', '0.00', 'carpet_soft*6', '#669933', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('457', '', '4', '1', '1', '0.00', 'doormat_love', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('458', '', '4', '1', '1', '0.00', 'doormat_plain', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('459', '', '4', '1', '1', '0.00', 'doormat_plain*1', '#ff1f08', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('460', '', '4', '1', '1', '0.00', 'doormat_plain*2', '#99DCCC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('461', '', '4', '1', '1', '0.00', 'doormat_plain*3', '#ffee00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('462', '', '4', '1', '1', '0.00', 'doormat_plain*4', '#ccddff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('463', '', '4', '1', '1', '0.00', 'doormat_plain*5', '#ddccff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('464', '', '4', '1', '1', '0.00', 'doormat_plain*6', '#777777', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('465', '', '4', '2', '4', '0.00', 'carpet_armas', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('466', '', '4', '2', '3', '0.00', 'carpet_polar', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('467', '', '4', '2', '3', '0.00', 'carpet_polar*2', '#ccddff,#ccddff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('468', '', '4', '2', '3', '0.00', 'carpet_polar*3', '#ffee99,#ffee99,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('469', '', '4', '2', '3', '0.00', 'carpet_polar*4', '#ddffaa,#ddffaa,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('470', '', '0', '0', '0', '0.00', 'poster 52', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('471', '', '0', '0', '0', '0.00', 'poster 53', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('472', '', '0', '0', '0', '0.00', 'poster 54', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('473', '', '1', '1', '1', '0.00', 'hockey_score', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('474', '', '1', '1', '1', '0.00', 'legotrophy', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('475', '', '0', '0', '0', '0.00', 'poster 51', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('476', '', '4', '3', '3', '0.00', 'carpet_legocourt', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('477', '', '2', '4', '1', '1.00', 'bench_lego', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('478', '', '4', '2', '2', '0.00', 'sporttrack1*1', '#ffffff,#e4592d,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('479', '', '4', '2', '2', '0.00', 'sporttrack1*2', '#ffffff,#62818b,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('480', '', '4', '2', '2', '0.00', 'sporttrack1*3', '#ffffff,#5cb800,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('481', '', '4', '2', '2', '0.00', 'sporttrack2*1', '#ffffff,#e4592d,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('482', '', '4', '2', '2', '0.00', 'sporttrack2*2', '#ffffff,#62818b,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('483', '', '4', '2', '2', '0.00', 'sporttrack2*3', '#ffffff,#5cb800,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('484', '', '4', '2', '2', '0.00', 'sporttrack3*1', '#ffffff,#e4592d,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('485', '', '4', '2', '2', '0.00', 'sporttrack3*3', '#ffffff,#5cb800,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('486', '', '4', '2', '2', '0.00', 'sporttrack3*2', '#ffffff,#62818b,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('487', '', '4', '2', '2', '0.00', 'footylamp', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('488', '', '1', '1', '1', '0.00', 'door', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('489', '', '1', '1', '1', '0.00', 'doorC', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('490', '', '1', '1', '1', '0.00', 'doorB', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('491', '', '1', '1', '1', '0.00', 'teleport_door', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('492', '', '1', '1', '1', '0.00', 'sound_machine', '#FFFFFF,#FFFFFF,#828282,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('493', '', '1', '1', '1', '0.10', 'sound_set_4', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('494', '', '1', '1', '1', '0.10', 'sound_set_8', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('495', '', '1', '1', '1', '0.10', 'sound_set_6', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('496', '', '1', '1', '1', '0.10', 'sound_set_5', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('497', '', '1', '1', '1', '0.10', 'sound_set_26', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('498', '', '1', '1', '1', '0.10', 'sound_set_27', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('499', '', '1', '1', '1', '0.10', 'sound_set_17', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('500', '', '1', '1', '1', '0.10', 'sound_set_18', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('501', '', '1', '1', '1', '0.10', 'sound_set_3', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('502', '', '1', '1', '1', '0.10', 'sound_set_9', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('503', '', '1', '1', '1', '0.00', 'jukebox*1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('504', '', '1', '1', '1', '0.10', 'sound_set_46', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('505', '', '1', '1', '1', '0.10', 'sound_set_47', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('506', '', '1', '1', '1', '0.10', 'sound_set_48', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('507', '', '1', '1', '1', '0.10', 'sound_set_49', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('508', '', '1', '1', '1', '0.10', 'sound_set_50', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('509', '', '1', '1', '1', '0.10', 'sound_set_51', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('510', '', '1', '1', '1', '0.10', 'sound_set_25', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('511', '', '1', '1', '1', '0.10', 'sound_set_29', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('512', '', '1', '1', '1', '0.10', 'sound_set_31', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('513', '', '1', '1', '1', '0.10', 'sound_set_11', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('514', '', '1', '1', '1', '0.10', 'sound_set_13', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('515', '', '1', '0', '1', '0.10', 'sound_set_35', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('516', '', '0', '0', '0', '0.00', 'jukebox*1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('517', '', '0', '0', '0', '0.00', 'guitar_v', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('518', '', '0', '0', '0', '0.00', 'guitar_skull', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('519', '', '0', '0', '0', '0.10', 'sound_set_21', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('520', '', '0', '0', '0', '0.10', 'sound_set_28', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('521', '', '0', '0', '0', '0.10', 'sound_set_33', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('522', '', '0', '0', '0', '0.10', 'sound_set_40', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('523', '', '0', '0', '0', '0.10', 'sound_set_34', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('524', '', '0', '0', '0', '0.10', 'sound_set_38', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('525', '', '0', '0', '0', '0.10', 'sound_set_39', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('526', '', '0', '0', '0', '0.10', 'sound_set_41', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('527', '', '0', '0', '0', '0.00', 'jukebox*1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('528', '', '0', '0', '0', '0.10', 'sound_set_1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('529', '', '0', '0', '0', '0.10', 'sound_set_12', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('530', '', '0', '0', '0', '0.10', 'sound_set_2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('531', '', '0', '0', '0', '0.10', 'sound_set_24', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('532', '', '0', '0', '0', '0.10', 'sound_set_43', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('533', '', '0', '0', '0', '0.10', 'sound_set_20', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('534', '', '0', '0', '0', '0.10', 'sound_set_22', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('535', '', '0', '0', '0', '0.10', 'sound_set_23', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('536', '', '0', '0', '0', '0.10', 'sound_set_7', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('537', '', '0', '0', '0', '0.10', 'sound_set_30', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('538', '', '0', '0', '0', '0.10', 'sound_set_32', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('539', '', '0', '0', '0', '0.10', 'sound_set_36', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('540', '', '0', '0', '0', '0.10', 'sound_set_60', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('541', '', '0', '0', '0', '0.10', 'sound_set_61', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('542', '', '0', '0', '0', '0.10', 'sound_set_55', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('543', '', '0', '0', '0', '0.10', 'sound_set_56', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('544', '', '0', '0', '0', '0.10', 'sound_set_57', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('545', '', '0', '0', '0', '0.10', 'sound_set_58', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('546', '', '0', '0', '0', '0.10', 'sound_set_59', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('547', '', '0', '0', '0', '0.10', 'sound_set_15', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('548', '', '0', '0', '0', '0.10', 'sound_set_10', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('549', '', '0', '0', '0', '0.10', 'sound_set_14', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('550', '', '0', '0', '0', '0.10', 'sound_set_16', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('551', '', '0', '0', '0', '0.10', 'sound_set_19', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('552', '', '1', '1', '1', '0.00', 'prizetrophy6*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('553', '', '1', '1', '1', '0.00', 'prizetrophy6*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('554', '', '1', '1', '1', '0.00', 'prizetrophy6*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('555', '', '1', '1', '1', '0.00', 'prizetrophy3*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('556', '', '1', '1', '1', '0.00', 'prizetrophy3*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('557', '', '1', '1', '1', '0.00', 'prizetrophy3*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('558', '', '1', '1', '1', '0.00', 'prizetrophy4*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('559', '', '1', '1', '1', '0.00', 'prizetrophy4*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('560', '', '1', '1', '1', '0.00', 'prizetrophy4*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('561', '', '1', '1', '1', '0.00', 'prizetrophy*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('562', '', '1', '1', '1', '0.00', 'prizetrophy*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('563', '', '1', '1', '1', '0.00', 'prizetrophy*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('564', '', '1', '1', '1', '0.00', 'prizetrophy5*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('565', '', '1', '1', '1', '0.00', 'prizetrophy5*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('566', '', '1', '1', '1', '0.00', 'prizetrophy5*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('567', '', '1', '1', '1', '0.00', 'prizetrophy2*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('568', '', '1', '1', '1', '0.00', 'prizetrophy2*2', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('569', '', '1', '1', '1', '0.00', 'prizetrophy2*3', '#ffffff,#ffffff,#996600', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('570', '', '1', '1', '1', '0.00', 'prizetrophy8*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('571', '', '1', '1', '1', '0.00', 'prizetrophy9*1', '#ffffff,#ffffff,#FFDD3F', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('572', '', '0', '0', '0', '0.00', 'poster 20', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('573', '', '0', '0', '0', '0.00', 'poster 21', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('574', '', '0', '0', '0', '0.00', 'poster 22', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('575', '', '0', '0', '0', '0.00', 'poster 23', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('576', '', '0', '0', '0', '0.00', 'poster 24', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('577', '', '0', '0', '0', '0.00', 'poster 25', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('578', '', '0', '0', '0', '0.00', 'poster 26', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('579', '', '0', '0', '0', '0.00', 'poster 27', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('580', '', '0', '0', '0', '0.00', 'poster 28', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('581', '', '0', '0', '0', '0.00', 'poster 29', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('582', '', '0', '0', '0', '0.00', 'poster 30', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('583', '', '0', '0', '0', '0.00', 'poster 46', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('584', '', '0', '0', '0', '0.00', 'poster 47', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('585', '', '0', '0', '0', '0.00', 'poster 48', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('586', '', '0', '0', '0', '0.00', 'poster 49', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('587', '', '1', '1', '1', '0.00', 'tree3', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('588', '', '1', '1', '1', '0.00', 'tree4', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('589', '', '1', '1', '1', '0.00', 'tree5', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('590', '', '1', '1', '1', '0.00', 'triplecandle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('591', '', '1', '1', '1', '0.00', 'turkey', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('592', '', '1', '1', '1', '0.00', 'house', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('593', '', '1', '1', '1', '0.00', 'pudding', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('594', '', '1', '1', '1', '0.00', 'xmasduck', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('595', '', '1', '1', '1', '0.00', 'hyacinth1', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('596', '', '1', '1', '1', '0.00', 'hyacinth2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('597', '', '1', '1', '1', '0.00', 'joulutahti', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('598', '', '1', '1', '1', '0.00', 'rcandle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('599', '', '1', '1', '1', '0.00', 'wcandle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('600', '', '1', '1', '1', '0.00', 'easterduck', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('601', '', '1', '1', '1', '0.00', 'birdie', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('602', '', '1', '1', '1', '0.00', 'basket', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('603', '', '1', '1', '1', '0.00', 'bunny', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('604', '', '1', '1', '1', '0.00', 'pumpkin', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('605', '', '0', '0', '0', '0.00', 'poster 42', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('606', '', '0', '0', '0', '0.00', 'poster 43', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('607', '', '1', '1', '1', '0.00', 'skullcandle', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('608', '', '0', '0', '0', '0.00', 'poster 45', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('609', '', '0', '0', '0', '0.00', 'poster 44', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('610', '', '1', '1', '1', '0.00', 'deadduck', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('611', '', '1', '1', '1', '0.00', 'deadduck2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('612', '', '1', '1', '1', '0.00', 'deadduck3', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('613', '', '0', '0', '0', '0.00', 'poster 50', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('614', '', '0', '0', '0', '0.00', 'poster 501', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('615', '', '1', '1', '1', '0.00', 'ham2', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('616', '', '1', '2', '2', '0.00', 'habboween_crypt', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('617', '', '4', '2', '2', '0.00', 'habboween_grass', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('618', '', '1', '1', '1', '0.00', 'valeduck', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('619', '', '1', '1', '1', '0.00', 'hal_cauldron', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('620', '', '1', '1', '1', '0.00', 'hal_grave', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('621', '', '2', '2', '1', '1.00', 'heartsofa', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('622', '', '1', '1', '1', '0.00', 'statue', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('623', '', '1', '2', '1', '0.00', 'heart', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('624', '', '0', '0', '0', '0.00', 'post.it.vd', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('625', '', '4', '2', '7', '0.00', 'carpet_valentine', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('626', '', '0', '0', '0', '0.00', 'val_heart', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('627', '', '1', '1', '1', '0.00', 'plant_valentinerose*1', '#FFFFFF,#FF1E1E,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('628', '', '1', '1', '1', '0.00', 'plant_valentinerose*2', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('629', '', '1', '1', '1', '0.00', 'plant_valentinerose*3', '#FFFFFF,#ffee00,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('630', '', '1', '1', '1', '0.00', 'plant_valentinerose*4', '#FFFFFF,#ffbbcf,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('631', '', '1', '1', '1', '0.00', 'plant_valentinerose*5', '#FFFFFF,#CC3399,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('632', '', '2', '2', '1', '1.10', 'sofa_silo*2', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('633', '', '1', '1', '1', '1.00', 'sofachair_silo*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('634', '', '1', '1', '1', '1.10', 'table_silo_small*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('635', '', '1', '1', '1', '0.00', 'divider_silo3*2', '#ffffff,#ffffff,#ffffff,#525252', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('636', '', '1', '1', '1', '1.00', 'divider_silo1*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('637', '', '2', '1', '1', '1.10', 'chair_silo*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('638', '', '1', '1', '1', '1.20', 'safe_silo*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('639', '', '1', '1', '1', '0.90', 'barchair_silo*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('640', '', '1', '2', '2', '0.90', 'table_silo_med*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('641', '', '2', '2', '1', '1.10', 'sofa_silo*3', '#ffffff,#ffffff,#ffffff,#ffffff,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('642', '', '1', '1', '1', '1.00', 'sofachair_silo*3', '#ffffff,#ffffff,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('643', '', '1', '1', '1', '1.10', 'table_silo_small*3', '#ffffff,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('644', '', '1', '1', '1', '0.00', 'divider_silo3*3', '#ffffff,#ffffff,#ffffff,#FFFFFF', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('645', '', '1', '1', '1', '1.00', 'divider_silo1*3', '#ffffff,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('646', '', '2', '1', '1', '1.10', 'chair_silo*3', '#ffffff,#ffffff,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('647', '', '1', '1', '1', '1.20', 'safe_silo*3', '#ffffff,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('648', '', '1', '1', '1', '0.90', 'barchair_silo*3', '#ffffff,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('649', '', '1', '2', '2', '0.90', 'table_silo_med*3', '#ffffff,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('650', '', '2', '2', '1', '1.10', 'sofa_silo*4', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('651', '', '1', '1', '1', '1.00', 'sofachair_silo*4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('652', '', '1', '1', '1', '1.10', 'table_silo_small*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('653', '', '1', '1', '1', '0.00', 'divider_silo3*4', '#ffffff,#ffffff,#ffffff,#F7EBBC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('654', '', '1', '1', '1', '1.00', 'divider_silo1*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('655', '', '2', '1', '1', '1.10', 'chair_silo*4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('656', '', '1', '1', '1', '1.20', 'safe_silo*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('657', '', '1', '1', '1', '0.90', 'barchair_silo*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('658', '', '1', '2', '2', '0.90', 'table_silo_med*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('659', '', '2', '2', '1', '1.10', 'sofa_silo*5', '#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC,#FF99BC,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('660', '', '1', '1', '1', '1.00', 'sofachair_silo*5', '#ffffff,#ffffff,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('661', '', '1', '1', '1', '1.10', 'table_silo_small*5', '#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('662', '', '1', '1', '1', '0.00', 'divider_silo3*5', '#ffffff,#ffffff,#ffffff,#FF99BC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('663', '', '1', '1', '1', '1.00', 'divider_silo1*5', '#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('664', '', '2', '1', '1', '1.10', 'chair_silo*5', '#ffffff,#ffffff,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('665', '', '1', '1', '1', '1.20', 'safe_silo*5', '#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('666', '', '1', '1', '1', '0.90', 'barchair_silo*5', '#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('667', '', '1', '2', '2', '0.90', 'table_silo_med*5', '#ffffff,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('668', '', '2', '2', '1', '1.10', 'sofa_silo*6', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('669', '', '1', '1', '1', '1.00', 'sofachair_silo*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('670', '', '1', '1', '1', '1.10', 'table_silo_small*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('671', '', '1', '1', '1', '0.00', 'divider_silo3*6', '#ffffff,#ffffff,#ffffff,#5EAAF8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('672', '', '1', '1', '1', '1.00', 'divider_silo1*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('673', '', '2', '1', '1', '1.10', 'chair_silo*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('674', '', '1', '1', '1', '1.20', 'safe_silo*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('675', '', '1', '1', '1', '0.90', 'barchair_silo*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('676', '', '1', '2', '2', '0.90', 'table_silo_med*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('677', '', '2', '2', '1', '1.10', 'sofa_silo*7', '#ffffff,#ffffff,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('678', '', '1', '1', '1', '1.00', 'sofachair_silo*7', '#ffffff,#ffffff,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('679', '', '1', '1', '1', '1.10', 'table_silo_small*7', '#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('680', '', '1', '1', '1', '0.00', 'divider_silo3*7', '#ffffff,#ffffff,#ffffff,#92D13D', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('681', '', '1', '1', '1', '1.00', 'divider_silo1*7', '#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('682', '', '2', '1', '1', '1.10', 'chair_silo*7', '#ffffff,#ffffff,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('683', '', '1', '1', '1', '1.20', 'safe_silo*7', '#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('684', '', '1', '1', '1', '0.90', 'barchair_silo*7', '#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('685', '', '1', '2', '2', '0.90', 'table_silo_med*7', '#ffffff,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('686', '', '2', '2', '1', '1.10', 'sofa_silo*8', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('687', '', '1', '1', '1', '1.00', 'sofachair_silo*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('688', '', '1', '1', '1', '1.10', 'table_silo_small*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('689', '', '1', '1', '1', '0.00', 'divider_silo3*8', '#ffffff,#ffffff,#ffffff,#FFD837', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('690', '', '1', '1', '1', '1.00', 'divider_silo1*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('691', '', '2', '1', '1', '1.10', 'chair_silo*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('692', '', '1', '1', '1', '1.20', 'safe_silo*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('693', '', '1', '1', '1', '0.90', 'barchair_silo*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('694', '', '1', '2', '2', '0.90', 'table_silo_med*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('695', '', '2', '2', '1', '1.10', 'sofa_silo*9', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('696', '', '1', '1', '1', '1.00', 'sofachair_silo*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('697', '', '1', '1', '1', '1.10', 'table_silo_small*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('698', '', '1', '1', '1', '0.00', 'divider_silo3*9', '#ffffff,#ffffff,#ffffff,#E14218', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('699', '', '1', '1', '1', '1.00', 'divider_silo1*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('700', '', '2', '1', '1', '1.10', 'chair_silo*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('701', '', '1', '1', '1', '1.20', 'safe_silo*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('702', '', '1', '1', '1', '0.90', 'barchair_silo*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('703', '', '1', '2', '2', '0.90', 'table_silo_med*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('704', '', '2', '1', '1', '1.00', 'chair_norja*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('705', '', '2', '2', '1', '1.10', 'couch_norja*2', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('706', '', '1', '2', '2', '0.90', 'table_norja_med*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('707', '', '1', '1', '1', '0.00', 'shelves_norja*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('708', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*2', '#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('709', '', '2', '2', '1', '1.00', 'soft_sofa_norja*2', '#ffffff,#525252,#ffffff,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('710', '', '1', '2', '1', '0.00', 'divider_nor2*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('711', '', '1', '1', '1', '0.00', 'divider_nor1*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('712', '', '1', '1', '1', '0.00', 'divider_nor3*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('713', '', '1', '2', '1', '0.00', 'divider_nor4*2', '#ffffff,#ffffff,#525252,#525252,#525252,#525252', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('714', '', '1', '1', '1', '0.00', 'divider_nor5*2', '#ffffff,#525252,#525252,#525252,#525252,#525252', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('715', '', '2', '1', '1', '1.00', 'chair_norja*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('716', '', '2', '2', '1', '1.10', 'couch_norja*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('717', '', '1', '2', '2', '0.90', 'table_norja_med*3', '#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('718', '', '1', '1', '1', '0.00', 'shelves_norja*3', '#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('719', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*3', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('720', '', '2', '2', '1', '1.00', 'soft_sofa_norja*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('721', '', '1', '2', '1', '0.00', 'divider_nor2*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('722', '', '1', '1', '1', '0.00', 'divider_nor1*3', '#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('723', '', '1', '1', '1', '0.00', 'divider_nor3*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('724', '', '1', '2', '1', '0.00', 'divider_nor4*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('725', '', '1', '1', '1', '0.00', 'divider_nor5*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('726', '', '2', '1', '1', '1.00', 'chair_norja*4', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('727', '', '2', '2', '1', '1.10', 'couch_norja*4', '#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('728', '', '1', '2', '2', '0.90', 'table_norja_med*4', '#ffffff,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('729', '', '1', '1', '1', '0.00', 'shelves_norja*4', '#ffffff,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('730', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*4', '#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('731', '', '2', '2', '1', '1.00', 'soft_sofa_norja*4', '#ffffff,#ABD0D2,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('732', '', '1', '2', '1', '0.00', 'divider_nor2*4', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('733', '', '1', '1', '1', '0.00', 'divider_nor1*4', '#ffffff,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('734', '', '1', '1', '1', '0.00', 'divider_nor3*4', '#ffffff,#ffffff,#ABD0D2,#ABD0D2', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('735', '', '1', '2', '1', '0.00', 'divider_nor4*4', '#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('736', '', '1', '1', '1', '0.00', 'divider_nor5*4', '#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('737', '', '2', '1', '1', '1.00', 'chair_norja*5', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('738', '', '2', '2', '1', '1.00', 'couch_norja*5', '#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('739', '', '1', '2', '2', '0.90', 'table_norja_med*5', '#ffffff,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('740', '', '1', '1', '1', '0.00', 'shelves_norja*5', '#ffffff,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('741', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*5', '#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('742', '', '2', '2', '1', '1.00', 'soft_sofa_norja*5', '#ffffff,#EE7EA4,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('743', '', '1', '2', '1', '0.00', 'divider_nor2*5', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('744', '', '1', '1', '1', '0.00', 'divider_nor1*5', '#ffffff,#EE7EA4', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('745', '', '1', '1', '1', '0.00', 'divider_nor3*5', '#ffffff,#ffffff,#EE7EA4,#EE7EA4', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('746', '', '1', '2', '1', '0.00', 'divider_nor4*5', '#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('747', '', '1', '1', '1', '0.00', 'divider_nor5*5', '#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('748', '', '2', '1', '1', '1.00', 'chair_norja*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('749', '', '2', '2', '1', '1.10', 'couch_norja*6', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('750', '', '1', '2', '2', '0.90', 'table_norja_med*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('751', '', '1', '1', '1', '0.00', 'shelves_norja*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('752', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*6', '#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('753', '', '2', '2', '1', '1.00', 'soft_sofa_norja*6', '#ffffff,#5EAAF8,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('754', '', '1', '2', '1', '0.00', 'divider_nor2*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('755', '', '1', '1', '1', '0.00', 'divider_nor1*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('756', '', '1', '1', '1', '0.00', 'divider_nor3*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('757', '', '1', '2', '1', '0.00', 'divider_nor4*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('758', '', '1', '1', '1', '0.00', 'divider_nor5*6', '#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('759', '', '2', '1', '1', '1.00', 'chair_norja*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('760', '', '2', '2', '1', '1.10', 'couch_norja*7', '#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('761', '', '1', '2', '2', '0.90', 'table_norja_med*7', '#ffffff,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('762', '', '1', '1', '1', '0.00', 'shelves_norja*7', '#ffffff,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('763', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*7', '#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('764', '', '2', '2', '1', '1.00', 'soft_sofa_norja*7', '#ffffff,#7CB135,#ffffff,#7CB135,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('765', '', '1', '2', '1', '0.00', 'divider_nor2*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('766', '', '1', '1', '1', '0.00', 'divider_nor1*7', '#ffffff,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('767', '', '1', '1', '1', '0.00', 'divider_nor3*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('768', '', '1', '2', '1', '0.00', 'divider_nor4*7', '#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('769', '', '1', '1', '1', '0.00', 'divider_nor5*7', '#ffffff,#7CB135,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('770', '', '2', '1', '1', '1.00', 'chair_norja*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('771', '', '2', '2', '1', '1.10', 'couch_norja*8', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('772', '', '1', '2', '2', '0.90', 'table_norja_med*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('773', '', '1', '1', '1', '0.00', 'shelves_norja*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('774', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*8', '#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('775', '', '2', '2', '1', '1.00', 'soft_sofa_norja*8', '#ffffff,#FFD837,#ffffff,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('776', '', '1', '2', '1', '0.00', 'divider_nor2*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('777', '', '1', '1', '1', '0.00', 'divider_nor1*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('778', '', '1', '1', '1', '0.00', 'divider_nor3*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('779', '', '1', '2', '1', '0.00', 'divider_nor4*8', '#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('780', '', '1', '1', '1', '0.00', 'divider_nor5*8', '#ffffff,#FFD837,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('781', '', '2', '1', '1', '1.00', 'chair_norja*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('782', '', '2', '2', '1', '1.10', 'couch_norja*9', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('783', '', '1', '2', '2', '0.90', 'table_norja_med*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('784', '', '1', '1', '1', '0.00', 'shelves_norja*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('785', '', '2', '1', '1', '1.00', 'soft_sofachair_norja*9', '#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('786', '', '2', '2', '1', '1.00', 'soft_sofa_norja*9', '#ffffff,#E14218,#ffffff,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('787', '', '1', '2', '1', '0.00', 'divider_nor2*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('788', '', '1', '1', '1', '0.00', 'divider_nor1*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('789', '', '1', '1', '1', '0.00', 'divider_nor3*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('790', '', '1', '2', '1', '0.00', 'divider_nor4*9', '#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('791', '', '1', '1', '1', '0.00', 'divider_nor5*9', '#ffffff,#E14218,#E14218,#E14218,#E14218,#E14218', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('792', '', '3', '2', '3', '2.00', 'bed_polyfon*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('793', '', '3', '1', '3', '2.00', 'bed_polyfon_one*2', '#ffffff,#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('794', '', '2', '2', '1', '1.10', 'sofa_polyfon*2', '#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('795', '', '2', '1', '1', '1.00', 'sofachair_polyfon*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('796', '', '1', '1', '1', '0.00', 'divider_poly3*2', '#ffffff,#ffffff,#ffffff,#525252,#525252', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('797', '', '1', '2', '1', '1.00', 'bardesk_polyfon*2', '#ffffff,#ffffff,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('798', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*2', '#ffffff,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('799', '', '3', '2', '3', '2.00', 'bed_polyfon*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('800', '', '3', '1', '3', '2.00', 'bed_polyfon_one*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('801', '', '2', '2', '1', '1.10', 'sofa_polyfon*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('802', '', '2', '1', '1', '1.00', 'sofachair_polyfon*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('803', '', '1', '1', '1', '0.00', 'divider_poly3*3', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('804', '', '1', '2', '1', '1.00', 'bardesk_polyfon*3', '#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('805', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*3', '#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('806', '', '3', '2', '3', '2.00', 'bed_polyfon*4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('807', '', '3', '1', '3', '2.00', 'bed_polyfon_one*4', '#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('808', '', '2', '2', '1', '1.10', 'sofa_polyfon*4', '#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('809', '', '2', '1', '1', '1.00', 'sofachair_polyfon*4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('810', '', '1', '1', '1', '0.00', 'divider_poly3*4', '#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('811', '', '1', '2', '1', '1.00', 'bardesk_polyfon*4', '#ffffff,#ffffff,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('812', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*4', '#ffffff,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('813', '', '3', '2', '3', '2.00', 'bed_polyfon*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('814', '', '3', '1', '3', '2.00', 'bed_polyfon_one*6', '#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('815', '', '2', '2', '1', '1.10', 'sofa_polyfon*6', '#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('816', '', '2', '1', '1', '1.00', 'sofachair_polyfon*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('817', '', '1', '1', '1', '0.00', 'divider_poly3*6', '#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('818', '', '1', '2', '1', '1.00', 'bardesk_polyfon*6', '#ffffff,#ffffff,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('819', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*6', '#ffffff,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('820', '', '3', '2', '3', '2.00', 'bed_polyfon*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('821', '', '3', '1', '3', '2.00', 'bed_polyfon_one*7', '#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('822', '', '2', '2', '1', '1.10', 'sofa_polyfon*7', '#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('823', '', '2', '1', '1', '1.00', 'sofachair_polyfon*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('824', '', '1', '1', '1', '0.00', 'divider_poly3*7', '#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('825', '', '1', '2', '1', '1.00', 'bardesk_polyfon*7', '#ffffff,#ffffff,#7CB135,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('826', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*7', '#ffffff,#7CB135', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('827', '', '3', '2', '3', '2.00', 'bed_polyfon*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('828', '', '3', '1', '3', '2.00', 'bed_polyfon_one*8', '#ffffff,#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('829', '', '2', '2', '1', '1.10', 'sofa_polyfon*8', '#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('830', '', '2', '1', '1', '1.00', 'sofachair_polyfon*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('831', '', '1', '1', '1', '0.00', 'divider_poly3*8', '#ffffff,#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('832', '', '1', '2', '1', '1.00', 'bardesk_polyfon*8', '#ffffff,#ffffff,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('833', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*8', '#ffffff,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('834', '', '3', '2', '3', '2.00', 'bed_polyfon*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('835', '', '3', '1', '3', '2.00', 'bed_polyfon_one*9', '#ffffff,#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('836', '', '2', '2', '1', '1.10', 'sofa_polyfon*9', '#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('837', '', '2', '1', '1', '1.00', 'sofachair_polyfon*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('838', '', '1', '1', '1', '0.00', 'divider_poly3*9', '#ffffff,#ffffff,#ffffff,#E14218,#E14218', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('839', '', '1', '2', '1', '1.00', 'bardesk_polyfon*9', '#ffffff,#ffffff,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('840', '', '1', '1', '1', '1.00', 'bardeskcorner_polyfon*9', '#ffffff,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('841', '', '2', '1', '1', '1.00', 'pura_mdl1*1', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('842', '', '2', '1', '1', '1.00', 'pura_mdl2*1', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('843', '', '2', '1', '1', '1.00', 'pura_mdl3*1', '#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('844', '', '2', '1', '1', '1.00', 'pura_mdl4*1', '#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('845', '', '2', '1', '1', '1.00', 'pura_mdl5*1', '#FFFFFF,#ABD0D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('846', '', '2', '1', '1', '1.00', 'pura_mdl1*2', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('847', '', '2', '1', '1', '1.00', 'pura_mdl2*2', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('848', '', '2', '1', '1', '1.00', 'pura_mdl3*2', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('849', '', '2', '1', '1', '1.00', 'pura_mdl4*2', '#FFFFFF,#FF99BC,#FF99BC,#FF99BC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('850', '', '2', '1', '1', '1.00', 'pura_mdl5*2', '#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('851', '', '2', '1', '1', '1.00', 'pura_mdl1*3', '#FFFFFF,#525252,#525252,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('852', '', '2', '1', '1', '1.00', 'pura_mdl2*3', '#FFFFFF,#525252,#525252,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('853', '', '2', '1', '1', '1.00', 'pura_mdl3*3', '#FFFFFF,#525252,#525252,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('854', '', '2', '1', '1', '1.00', 'pura_mdl4*3', '#FFFFFF,#525252,#525252,#525252', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('855', '', '2', '1', '1', '1.00', 'pura_mdl5*3', '#FFFFFF,#525252,#525252,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('856', '', '2', '1', '1', '1.00', 'pura_mdl1*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('857', '', '2', '1', '1', '1.00', 'pura_mdl2*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('858', '', '2', '1', '1', '1.00', 'pura_mdl3*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('859', '', '2', '1', '1', '1.00', 'pura_mdl4*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('860', '', '2', '1', '1', '1.00', 'pura_mdl5*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('861', '', '2', '1', '1', '1.00', 'pura_mdl1*5', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('862', '', '2', '1', '1', '1.00', 'pura_mdl2*5', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('863', '', '2', '1', '1', '1.00', 'pura_mdl3*5', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('864', '', '2', '1', '1', '1.00', 'pura_mdl4*5', '#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('865', '', '2', '1', '1', '1.00', 'pura_mdl5*5', '#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('866', '', '2', '1', '1', '1.00', 'pura_mdl1*6', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('867', '', '2', '1', '1', '1.00', 'pura_mdl2*6', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('868', '', '2', '1', '1', '1.00', 'pura_mdl3*6', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('869', '', '2', '1', '1', '1.00', 'pura_mdl4*6', '#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('870', '', '2', '1', '1', '1.00', 'pura_mdl5*6', '#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('871', '', '2', '1', '1', '1.00', 'pura_mdl1*7', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('872', '', '2', '1', '1', '1.00', 'pura_mdl2*7', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('873', '', '2', '1', '1', '1.00', 'pura_mdl3*7', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('874', '', '2', '1', '1', '1.00', 'pura_mdl4*7', '#FFFFFF,#92D13D,#92D13D,#92D13D', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('875', '', '2', '1', '1', '1.00', 'pura_mdl5*7', '#FFFFFF,#92D13D,#92D13D,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('876', '', '2', '1', '1', '1.00', 'pura_mdl1*8', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('877', '', '2', '1', '1', '1.00', 'pura_mdl2*8', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('878', '', '2', '1', '1', '1.00', 'pura_mdl3*8', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('879', '', '2', '1', '1', '1.00', 'pura_mdl4*8', '#FFFFFF,#FFD837,#FFD837,#FFD837', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('880', '', '2', '1', '1', '1.00', 'pura_mdl5*8', '#FFFFFF,#FFD837,#FFD837,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('881', '', '2', '1', '1', '1.00', 'pura_mdl1*9', '#FFFFFF,#E14218,#E14218,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('882', '', '2', '1', '1', '1.00', 'pura_mdl2*9', '#FFFFFF,#E14218,#E14218,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('883', '', '2', '1', '1', '1.00', 'pura_mdl3*9', '#FFFFFF,#E14218,#E14218,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('884', '', '2', '1', '1', '1.00', 'pura_mdl4*9', '#FFFFFF,#E14218,#E14218,#E14218', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('885', '', '2', '1', '1', '1.00', 'pura_mdl5*9', '#FFFFFF,#E14218,#E14218,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('886', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#ABD0D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('887', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#FF99BC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('888', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#525252,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('889', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('890', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#F7EBBC,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('891', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#5EAAF8,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('892', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#92D13D,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('893', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#FFD837,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('894', '', '2', '1', '1', '1.00', 'chair_basic*1', '#FFFFFF,#E14218,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('895', '', '1', '2', '2', '0.00', 'grand_piano*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('896', '', '2', '1', '1', '1.00', 'romantique_pianochair*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('897', '', '2', '1', '1', '1.00', 'romantique_chair*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('898', '', '2', '2', '1', '0.00', 'romantique_divan*1', '#FFFFFF,#FFFFFF,#FFFFFF,#FF8B8B', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('899', '', '1', '2', '1', '0.00', 'romantique_divider*1', '#FF8B8B,#FF8B8B,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('900', '', '1', '1', '1', '0.00', 'romantique_smalltabl*1', '#FFFFFF,#FF8B8B,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('901', '', '1', '2', '2', '0.00', 'grand_piano*2', '#FFFFFF,#A1DC67,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('902', '', '2', '1', '1', '1.00', 'romantique_pianochair*2', '#FFFFFF,#A1DC67,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('903', '', '2', '1', '1', '1.00', 'romantique_chair*2', '#FFFFFF,#A1DC67,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('904', '', '2', '2', '1', '0.00', 'romantique_divan*2', '#FFFFFF,#FFFFFF,#FFFFFF,#A1DC67', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('905', '', '1', '2', '1', '0.00', 'romantique_divider*2', '#A1DC67,#A1DC67,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('906', '', '1', '1', '1', '1.00', 'romantique_smalltabl*2', '#FFFFFF,#A1DC67,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('907', '', '1', '2', '2', '0.00', 'grand_piano*3', '#FFFFFF,#5BD1D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('908', '', '2', '1', '1', '1.00', 'romantique_pianochair*3', '#FFFFFF,#5BD1D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('909', '', '2', '1', '1', '1.00', 'romantique_chair*3', '#FFFFFF,#5BD1D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('910', '', '2', '2', '1', '0.00', 'romantique_divan*3', '#FFFFFF,#FFFFFF,#FFFFFF,#5BD1D2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('911', '', '1', '2', '1', '0.00', 'romantique_divider*3', '#5BD1D2,#5BD1D2,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('912', '', '1', '1', '1', '1.00', 'romantique_smalltabl*3', '#FFFFFF,#5BD1D2,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('913', '', '1', '2', '2', '0.00', 'grand_piano*4', '#FFFFFF,#FFC924,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('914', '', '2', '1', '1', '1.00', 'romantique_pianochair*4', '#FFFFFF,#FFC924,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('915', '', '2', '1', '1', '1.00', 'romantique_chair*4', '#FFFFFF,#FFC924,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('916', '', '2', '2', '1', '0.00', 'romantique_divan*4', '#FFFFFF,#FFFFFF,#FFFFFF,#FFC924', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('917', '', '1', '2', '1', '0.00', 'romantique_divider*4', '#FFC924,#FFC924,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('918', '', '1', '1', '1', '1.00', 'romantique_smalltabl*4', '#FFFFFF,#FFC924,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('919', '', '1', '2', '2', '0.00', 'grand_piano*5', '#FFFFFF,#323C46,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('920', '', '2', '1', '1', '1.00', 'romantique_pianochair*5', '#FFFFFF,#323C46,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('921', '', '2', '1', '1', '1.00', 'romantique_chair*5', '#FFFFFF,#323C46,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('922', '', '2', '2', '1', '0.00', 'romantique_divan*5', '#FFFFFF,#FFFFFF,#FFFFFF,#323C46', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('923', '', '1', '2', '1', '0.00', 'romantique_divider*5', '#323C46,#323C46,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('924', '', '1', '1', '1', '1.00', 'romantique_smalltabl*5', '#FFFFFF,#323C46,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('925', '', '2', '2', '1', '1.00', 'club_sofa', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('926', '', '2', '1', '1', '1.00', 'chair_plasto*14', '#ffffff,#3CB4F0,#ffffff,#3CB4F0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('927', '', '1', '2', '2', '1.10', 'table_plasto_4leg*14', '#ffffff,#3CB4F0,#ffffff,#3CB4F0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('928', '', '1', '1', '1', '0.00', 'mocchamaster', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('929', '', '1', '1', '1', '0.00', 'edicehc', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('930', '', '2', '1', '2', '1.00', 'hcamme', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('931', '', '1', '1', '1', '0.00', 'doorD', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('932', '', '2', '2', '1', '1.00', 'hcsohva', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('933', '', '1', '1', '1', '0.00', 'hc_lmp', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('934', '', '1', '1', '3', '1.00', 'hc_tbl', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('935', '', '2', '1', '1', '1.00', 'hc_chr', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('936', '', '1', '1', '2', '0.00', 'hc_dsk', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('937', '', '1', '1', '2', '0.00', 'hc_trll', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('938', '', '4', '3', '5', '0.00', 'hc_crpt', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('939', '', '1', '1', '1', '0.00', 'hc_lmpst', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('940', '', '1', '2', '1', '0.00', 'hc_crtn', '0,0,0', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('941', '', '1', '2', '1', '0.00', 'hc_tv', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('942', '', '1', '1', '1', '0.00', 'hc_btlr', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('943', '', '1', '1', '4', '0.00', 'hc_bkshlf', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('944', '', '1', '2', '1', '0.00', 'hc_rntgn', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('945', '', '1', '1', '3', '0.00', 'hc_machine', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('946', '', '1', '1', '3', '0.00', 'hc_frplc', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('947', '', '1', '3', '1', '0.00', 'hc_djset', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('948', '', '0', '0', '0', '0.00', 'hc_wall_lamp', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('949', '', '0', '0', '0', '0.00', 'roomdimmer', '0,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('950', '', '1', '1', '1', '0.00', 'rare_dragonlamp*0', '#ffffff,#fa2d00,#fa2d00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('951', '', '1', '1', '1', '0.00', 'rare_dragonlamp*1', '#ffffff,#3470ff,#3470ff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('952', '', '1', '1', '1', '0.00', 'rare_dragonlamp*2', '#ffffff,#02bb70,#02bb70', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('953', '', '1', '1', '1', '0.00', 'rare_dragonlamp*3', '#ffffff,#ffffff,#ffffff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('954', '', '1', '1', '1', '0.00', 'rare_dragonlamp*4', '#ffffff,#3e3d40,#3e3d40', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('955', '', '1', '1', '1', '0.00', 'rare_dragonlamp*5', '#ffffff,#589a03,#589a03', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('956', '', '1', '1', '1', '0.00', 'rare_dragonlamp*6', '#ffffff,#ffbc00,#ffbc00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('957', '', '1', '1', '1', '0.00', 'rare_dragonlamp*7', '#ffffff,#83aeff,#83aeff', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('958', '', '1', '1', '1', '0.00', 'rare_dragonlamp*8', '#ffffff,#ff5f01,#ff5f01', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('959', '', '1', '1', '1', '0.00', 'rare_dragonlamp*9', '#FFFFFF,#B357FF,#B357FF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('960', '', '1', '1', '1', '0.00', 'rare_fan*0', '#F43100,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('961', '', '1', '1', '1', '0.00', 'rare_fan*1', '#3C75FF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('962', '', '1', '1', '1', '0.00', 'rare_fan*2', '#55CD01,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('963', '', '1', '1', '1', '0.00', 'rare_fan*3', '#BC9BFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('964', '', '1', '1', '1', '0.00', 'rare_fan*4', '#e78b8b,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('965', '', '1', '1', '1', '0.00', 'rare_fan*5', '#ffcc00,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('966', '', '1', '1', '1', '0.00', 'rare_fan*6', '#FF8000,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('967', '', '1', '1', '1', '0.00', 'rare_fan*7', '#682B00,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('968', '', '1', '1', '1', '0.00', 'rare_fan*8', '#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('969', '', '1', '1', '1', '0.00', 'rare_fan*9', '#FF60B0,#FFFFFF,#FFFFFF,#FFFFFF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('970', '', '1', '1', '1', '0.00', 'rare_icecream*0', '#FFFFFF,#d02a1f', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('971', '', '1', '1', '1', '0.00', 'rare_icecream*1', '#FFFFFF,#55c4de', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('972', '', '1', '1', '1', '0.00', 'rare_icecream*2', '#FFFFFF,#94f718', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('973', '', '1', '1', '1', '0.00', 'rare_icecream*3', '#FFFFFF,#B357FF', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('974', '', '1', '1', '1', '0.00', 'rare_icecream*4', '#FFFFFF,#e78b8b', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('975', '', '1', '1', '1', '0.00', 'rare_icecream*5', '#FFFFFF,#E1CC00', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('976', '', '1', '1', '1', '0.00', 'rare_icecream*6', '#FFFFFF,#FF8000', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('977', '', '1', '1', '1', '0.00', 'rare_icecream*7', '#FFFFFF,#97420C', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('978', '', '1', '1', '1', '0.00', 'rare_icecream*8', '#FFFFFF,#00E5E2', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('979', '', '1', '1', '1', '0.00', 'rare_icecream*9', '#FFFFFF,#FF60B0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('980', '', '2', '1', '1', '1.00', 'rubberchair*1', '#0080FF,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('981', '', '2', '1', '1', '1.00', 'rubberchair*2', '#FF8B8B,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('982', '', '2', '1', '1', '1.00', 'rubberchair*3', '#FF8000,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('983', '', '2', '1', '1', '1.00', 'rubberchair*4', '#00E5E2,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('984', '', '2', '1', '1', '1.00', 'rubberchair*5', '#A1DC67,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('985', '', '2', '1', '1', '1.00', 'rubberchair*6', '#B357FF,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('986', '', '2', '1', '1', '1.00', 'rubberchair*7', '#CFCFCF,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('987', '', '2', '1', '1', '1.00', 'rubberchair*8', '#333333,0,0', '1', '1', '0', '0');
INSERT INTO furniture_templates VALUES ('988', '', '1', '1', '1', '0.00', 'scifiport*0', '#ffffff,#F43100,#ffffff,#ffffff,#ffffff,#F43100', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('989', '', '1', '1', '1', '0.00', 'scifiport*1', '#ffffff,#ffbc00,#ffffff,#ffffff,#ffffff,#ffbc00', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('990', '', '1', '1', '1', '0.00', 'scifiport*2', '#ffffff,#5599ff,#ffffff,#ffffff,#ffffff,#5599ff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('991', '', '1', '1', '1', '0.00', 'scifiport*3', '#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('992', '', '1', '1', '1', '0.00', 'scifiport*4', '#ffffff,#e78b8b,#ffffff,#ffffff,#ffffff,#e78b8b', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('993', '', '1', '1', '1', '0.00', 'scifiport*5', '#ffffff,#555555,#ffffff,#ffffff,#ffffff,#555555', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('994', '', '1', '1', '1', '0.00', 'scifiport*6', '#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('995', '', '1', '1', '1', '0.00', 'scifiport*7', '#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('996', '', '1', '1', '1', '0.00', 'scifiport*8', '#ffffff,#bb55cc,#ffffff,#ffffff,#ffffff,#bb55cc', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('997', '', '1', '1', '1', '0.00', 'scifiport*9', '#ffffff,#B357FF,#ffffff,#ffffff,#ffffff,#B357FF', '1', '1', '1', '0');
INSERT INTO furniture_templates VALUES ('998', '', '1', '1', '1', '0.20', 'song_disk', '0,0,0', '1', '1', '0', '0');

-- ----------------------------
-- Table structure for `fuserights`
-- ----------------------------
DROP TABLE IF EXISTS `fuserights`;
CREATE TABLE `fuserights` (
  `rank` tinyint(2) NOT NULL,
  `name` varchar(30) NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of fuserights
-- ----------------------------
INSERT INTO fuserights VALUES ('1', 'fuse_default');
INSERT INTO fuserights VALUES ('3', 'fuse_receive_calls_for_help');

-- ----------------------------
-- Table structure for `habbos`
-- ----------------------------
DROP TABLE IF EXISTS `habbos`;
CREATE TABLE `habbos` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(15) NOT NULL DEFAULT '',
  `figure` varchar(30) NOT NULL DEFAULT '',
  `poolfigure` varchar(30) NOT NULL DEFAULT '',
  `gender` char(1) NOT NULL DEFAULT '',
  `motto` varchar(25) NOT NULL DEFAULT '',
  `consolemotto` varchar(25) NOT NULL DEFAULT '',
  `mail` varchar(40) NOT NULL DEFAULT '',
  `birth` varchar(11) NOT NULL DEFAULT '',
  `session` varchar(30) NOT NULL,
  `password` varchar(10) NOT NULL DEFAULT '',
  `credits` int(7) NOT NULL DEFAULT '0',
  `tickets` int(7) NOT NULL DEFAULT '0',
  `films` int(7) NOT NULL DEFAULT '0',
  `rank` tinyint(2) NOT NULL DEFAULT '0',
  `lastvisit` varchar(30) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`,`name`,`session`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of habbos
-- ----------------------------
INSERT INTO habbos VALUES ('1', 'AWA', '1000118001265012850121001', 'ch=s02/238,238,238', 'M', 'Project Chop!', '', 'a@a.com', '01.01.1990', '', 'awa123', '9', '0', '0', '5', '16.04.2011 21:33');
INSERT INTO habbos VALUES ('2', 'Adun', '1000118001265012850121001', '', 'M', 'Project Chop!', '', 'a@a.com', '01.01.1990', '', 'adun123', '1000', '0', '0', '5', '02.04.2011 14:57');

-- ----------------------------
-- Table structure for `rooms`
-- ----------------------------
DROP TABLE IF EXISTS `rooms`;
CREATE TABLE `rooms` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `description` varchar(50) DEFAULT '',
  `password` varchar(20) DEFAULT NULL,
  `owner` varchar(15) NOT NULL DEFAULT '',
  `showowner` enum('1','0') NOT NULL,
  `category` int(10) NOT NULL DEFAULT '6',
  `state` enum('2','1','0') NOT NULL DEFAULT '0',
  `floorid` int(3) NOT NULL DEFAULT '0',
  `wallid` int(3) NOT NULL DEFAULT '0',
  `model` varchar(20) NOT NULL,
  `allrights` enum('0','1') NOT NULL DEFAULT '0',
  `casts` varchar(255) DEFAULT NULL,
  `minrank` tinyint(2) NOT NULL DEFAULT '1',
  `maxvisitors` int(5) NOT NULL DEFAULT '25',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1472 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

-- ----------------------------
-- Records of rooms
-- ----------------------------
INSERT INTO rooms VALUES ('101', 'Welcome Lounge', 'welcome_lounge', '', '', '1', '7', '0', '0', '0', 'newbie_lobby', '0', 'hh_room_nlobby', '1', '35');
INSERT INTO rooms VALUES ('103', 'The Theatre', 'theatredrome', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater', '1', '80');
INSERT INTO rooms VALUES ('102', 'Lido I', 'habbo_lido', '', '', '1', '7', '0', '0', '0', 'pool_a', '0', 'hh_room_pool,hh_people_pool', '1', '25');
INSERT INTO rooms VALUES ('117', 'The Library of BobbaWorld', 'library', '', '', '1', '7', '0', '0', '0', 'library', '0', 'hh_room_library', '1', '20');
INSERT INTO rooms VALUES ('105', 'Sunset Cafe', 'sunset_cafe', '', '', '1', '7', '0', '0', '0', 'sunset_cafe', '0', 'hh_room_sunsetcafe', '1', '25');
INSERT INTO rooms VALUES ('107', 'Lido II', 'habbo_lido_ii', '', '', '1', '7', '0', '0', '0', 'pool_b', '0', 'hh_room_pool,hh_people_pool', '1', '25');
INSERT INTO rooms VALUES ('106', 'Dirty Duck Pub', 'the_dirty_duck_pub', '', '', '1', '7', '0', '0', '0', 'pub_a', '0', 'hh_room_pub', '1', '35');
INSERT INTO rooms VALUES ('108', 'Great Port of BobbaWorld', 'floatinggarden', '', '', '1', '7', '0', '0', '0', 'floatinggarden', '0', 'hh_room_floatinggarden', '1', '30');
INSERT INTO rooms VALUES ('109', 'Rooftop Rumble Pool I', 'rooftop_rumble', '', '', '1', '7', '0', '0', '0', 'md_a', '0', 'hh_room_terrace,hh_paalu,hh_people_pool,hh_people_paalu', '1', '25');
INSERT INTO rooms VALUES ('124', 'Dusty Lounge', 'dusty_lounge', '', '', '1', '7', '0', '0', '0', 'dusty_lounge', '0', 'hh_room_dustylounge', '1', '25');
INSERT INTO rooms VALUES ('120', 'Infobus Park', 'park', '', '', '1', '7', '0', '0', '0', 'park_a', '0', 'hh_room_park_uk,hh_room_park', '1', '30');
INSERT INTO rooms VALUES ('122', 'Sakura Square', 'gate', '', '', '1', '7', '0', '0', '0', 'gate_park', '0', 'hh_room_gate_park', '1', '25');
INSERT INTO rooms VALUES ('114', 'Olympic Stadium', 'ballroom', '', '', '1', '7', '0', '0', '0', 'ballroom', '0', 'hh_room_ballroom', '1', '35');
INSERT INTO rooms VALUES ('115', 'The Dudesons Picnic Area', 'picnic_dudesons', '', '', '1', '7', '0', '0', '0', 'picnic', '0', 'hh_room_picnic_dudesons', '1', '25');
INSERT INTO rooms VALUES ('116', 'Space Cafe', 'space_cafe', '', '', '1', '7', '0', '0', '0', 'space_cafe', '0', 'hh_room_space_cafe', '1', '25');
INSERT INTO rooms VALUES ('118', 'The Beauty Salon', 'beauty_salon_general', '', '', '1', '7', '0', '0', '0', 'beauty_salon0', '0', 'hh_room_beauty_salon_general', '1', '25');
INSERT INTO rooms VALUES ('119', 'Sun Terrace', 'sun_terrace', '', '', '1', '7', '0', '0', '0', 'sun_terrace', '0', 'hh_room_sun_terrace', '1', '25');
INSERT INTO rooms VALUES ('121', 'Zen Garden', 'chill/0', '', '', '1', '7', '0', '0', '0', 'chill', '0', 'hh_room_chill', '1', '25');
INSERT INTO rooms VALUES ('123', 'Rooftop Rumble Pool II', 'rooftop_rumble2', '', '', '1', '7', '0', '0', '0', 'md_a', '0', 'hh_room_terrace,hh_paalu,hh_people_pool,hh_people_paalu', '1', '25');
INSERT INTO rooms VALUES ('125', 'The Den', 'the_den', '', '', '1', '7', '0', '0', '0', 'cr_staff', '0', 'hh_room_den', '1', '25');
INSERT INTO rooms VALUES ('126', 'Halloween Theatredrome', 'theatredrome_halloween', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater_halloween', '1', '80');
INSERT INTO rooms VALUES ('129', 'Easter Theatredrome', 'theatredrome_easter', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater_easter', '1', '25');
INSERT INTO rooms VALUES ('130', 'Habbowood Theatredrome', 'theatredrome_hbwood', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater_hbowood', '1', '25');
INSERT INTO rooms VALUES ('134', 'Christmas Theatredrome', 'theatrexmas', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater_xmas', '1', '25');
INSERT INTO rooms VALUES ('133', 'Valentine Theatredrome', 'theatrevalentine', '', '', '1', '7', '0', '0', '0', 'theater', '0', 'hh_room_theater_valentine', '1', '25');
INSERT INTO rooms VALUES ('135', 'Rooftop Cafe - Outside', 'rooftop', '', '', '1', '7', '0', '0', '0', 'rooftop', '0', 'hh_room_rooftop', '1', '40');
INSERT INTO rooms VALUES ('137', 'Tea Rooms', 'tearoom', '', '', '1', '7', '0', '0', '0', 'tearoom', '0', 'hh_room_tearoom', '1', '25');
INSERT INTO rooms VALUES ('136', 'Rooftop Cafe - Inside', 'rooftop_2', '', '', '1', '7', '0', '0', '0', 'rooftop_2', '0', 'hh_room_rooftop', '1', '25');
INSERT INTO rooms VALUES ('138', 'Cafe Ole', 'cafe_ole', '', '', '1', '7', '0', '0', '0', 'taivas_cafe', '0', 'hh_room_cafe', '1', '25');
INSERT INTO rooms VALUES ('139', 'Gallery Cafe', 'ericseaterie', '', '', '1', '7', '0', '0', '0', 'cr_cafe', '0', 'hh_room_erics', '1', '25');
INSERT INTO rooms VALUES ('140', 'Main Lobby', 'mainlobby', '', '', '1', '7', '0', '0', '0', 'lobby_a', '0', 'hh_room_lobby', '1', '25');
INSERT INTO rooms VALUES ('141', 'Sky Lobby', 'skylobby', '', '', '1', '7', '0', '0', '0', 'floorlobby_c', '0', 'hh_room_floorlobbies', '1', '25');
INSERT INTO rooms VALUES ('142', 'Lido I (Calippo)', 'habbo_lido', '', '', '1', '7', '0', '0', '0', 'pool_a', '0', 'hh_room_pool_calippo,hh_people_pool', '1', '25');
INSERT INTO rooms VALUES ('143', 'Lido II (Calippo)', 'habbo_lido_ii', '', '', '1', '7', '0', '0', '4', 'pool_b', '0', 'hh_room_pool_calippo,hh_people_pool', '1', '25');
INSERT INTO rooms VALUES ('149', 'Old Skool', 'oldskool', '', '', '1', '7', '0', '0', '0', 'old_skool0', '0', 'hh_room_old_skool', '1', '25');
INSERT INTO rooms VALUES ('144', 'Median Lobby', 'medianlobby', '', '', '1', '7', '0', '0', '0', 'floorlobby_b', '0', 'hh_room_floorlobbies', '1', '25');
INSERT INTO rooms VALUES ('145', 'Basement Lobby', 'basementlobby', '', '', '1', '7', '0', '0', '0', 'floorlobby_a', '0', 'hh_room_floorlobbies', '1', '25');
INSERT INTO rooms VALUES ('147', 'Habbo Cinema', 'habbocinema', '', '', '1', '7', '0', '0', '0', 'cinema_a', '0', 'hh_room_cinema', '1', '25');
INSERT INTO rooms VALUES ('148', 'Gym', 'sport', '', '', '1', '7', '0', '0', '0', 'sport', '0', 'hh_room_sport', '1', '25');
INSERT INTO rooms VALUES ('151', 'Chromz Nightclub', 'chromz', '', '', '1', '7', '0', '0', '0', 'malja_bar_a', '0', 'hh_room_disco', '1', '25');
INSERT INTO rooms VALUES ('150', 'Old Skool - Room 2', 'oldskool', '', '', '1', '7', '0', '0', '0', 'old_skool1', '0', 'hh_room_old_skool', '1', '25');
INSERT INTO rooms VALUES ('154', 'Dance Floor', 'clubmassiva2', '', '', '1', '7', '0', '0', '0', 'bar_b', '0', 'hh_room_bar', '1', '25');
INSERT INTO rooms VALUES ('152', 'Chromz Nightclub - Room 2', 'chromz', '', '', '1', '7', '0', '0', '0', 'malja_bar_b', '0', 'hh_room_disco', '1', '25');
INSERT INTO rooms VALUES ('153', 'Chill Out Room', 'clubmassiva', '', '', '1', '7', '0', '0', '0', 'bar_a', '0', 'hh_room_bar', '1', '25');
INSERT INTO rooms VALUES ('156', 'Habburgers (Burger King)', 'habburger', '', '', '1', '7', '0', '0', '0', 'habburger', '0', 'hh_room_habburger_king', '1', '25');
INSERT INTO rooms VALUES ('155', 'Habburgers', 'habburger', '', '', '1', '7', '0', '0', '0', 'habburger', '0', 'hh_room_habburger', '1', '25');
INSERT INTO rooms VALUES ('157', 'Chill Out Room (Postbank)', 'clubmassiva', '', '', '1', '7', '0', '0', '0', 'bar_a', '0', 'hh_room_bar_postbank', '1', '25');
INSERT INTO rooms VALUES ('158', 'Dance Floor (Postbank)', 'clubmassiva2', '', '', '1', '7', '0', '0', '0', 'bar_b', '0', 'hh_room_bar_postbank', '1', '25');
INSERT INTO rooms VALUES ('159', 'Slice Of Life', 'pizza', '', '', '1', '7', '0', '0', '0', 'pizza', '0', 'hh_room_pizza', '1', '25');
INSERT INTO rooms VALUES ('160', 'The Infobus', 'park', '', '', '1', '7', '0', '0', '0', 'park_b', '0', 'hh_room_park_general,hh_room_park', '1', '25');
INSERT INTO rooms VALUES ('161', 'Picnic Park', 'picnic', '', '', '1', '7', '0', '0', '0', 'picnic', '0', 'hh_room_picnic', '1', '25');
INSERT INTO rooms VALUES ('162', 'Beginner BattleBall', 'bb_lobby_beginner_0', '', '', '1', '3', '0', '0', '0', 'bb_lobby_1', '0', 'hh_game_bb,hh_game_bb_room,hh_game_bb_ui,hh_gamesys', '1', '20');
INSERT INTO rooms VALUES ('163', 'Amateur BattleBall', 'bb_lobby_amateur_0', '', '', '1', '3', '0', '0', '0', 'bb_lobby_1', '0', 'hh_game_bb,hh_game_bb_room,hh_game_bb_ui,hh_gamesys', '1', '20');
INSERT INTO rooms VALUES ('164', 'Intermediate BattleBall', 'bb_lobby_intermediate_0', '', '', '1', '3', '0', '0', '0', 'bb_lobby_1', '0', 'hh_game_bb,hh_game_bb_room,hh_game_bb_ui,hh_gamesys', '1', '20');
INSERT INTO rooms VALUES ('165', 'Expert BattleBall', 'bb_lobby_expert_0', '', '', '1', '3', '0', '0', '0', 'bb_lobby_1', '0', 'hh_game_bb,hh_game_bb_room,hh_game_bb_ui,hh_gamesys', '1', '20');
INSERT INTO rooms VALUES ('1468', 'fssdfsdf', '', null, 'AWA', '1', '6', '0', '0', '0', 'model_a', '0', null, '1', '25');
INSERT INTO rooms VALUES ('1469', 'dsfsdf', '', '', 'AWA', '1', '6', '0', '0', '0', 'model_a', '0', null, '1', '25');
INSERT INTO rooms VALUES ('1470', '1', '', '', 'AWA', '1', '4', '0', '0', '0', 'model_n', '0', null, '1', '25');
INSERT INTO rooms VALUES ('1471', 'fhgf', '', '', 'AWA', '1', '6', '0', '0', '0', 'model_f', '0', null, '1', '25');

-- ----------------------------
-- Table structure for `room_categories`
-- ----------------------------
DROP TABLE IF EXISTS `room_categories`;
CREATE TABLE `room_categories` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `type` enum('2','0') NOT NULL,
  `mincreaterank` tinyint(2) NOT NULL,
  `minviewrank` tinyint(2) NOT NULL,
  `trading` enum('1','0') NOT NULL DEFAULT '1',
  `parent` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of room_categories
-- ----------------------------
INSERT INTO room_categories VALUES ('6', 'No Category', '2', '1', '1', '0', '1');
INSERT INTO room_categories VALUES ('3', 'Public rooms', '0', '7', '1', '0', '0');
INSERT INTO room_categories VALUES ('4', 'Flats', '2', '1', '1', '0', '0');
INSERT INTO room_categories VALUES ('5', 'Test', '2', '1', '1', '1', '4');
INSERT INTO room_categories VALUES ('7', 'More publics!', '0', '7', '1', '0', '3');

-- ----------------------------
-- Table structure for `room_modeldata`
-- ----------------------------
DROP TABLE IF EXISTS `room_modeldata`;
CREATE TABLE `room_modeldata` (
  `modelID` int(10) NOT NULL AUTO_INCREMENT,
  `model` varchar(100) COLLATE latin1_general_ci NOT NULL,
  `roomomatic_subscr_only` int(1) NOT NULL DEFAULT '0',
  `door_x` int(3) NOT NULL,
  `door_y` int(3) NOT NULL,
  `door_h` int(3) NOT NULL,
  `door_z` int(1) NOT NULL,
  `heightmap` text COLLATE latin1_general_ci NOT NULL,
  `publicroom_items` text COLLATE latin1_general_ci,
  `swimmingpool` int(11) NOT NULL,
  `specialcast_emitter` varchar(15) COLLATE latin1_general_ci NOT NULL,
  `specialcast_interval` int(10) NOT NULL,
  `specialcast_rnd_min` int(10) NOT NULL,
  `specialcast_rnd_max` int(10) NOT NULL,
  PRIMARY KEY (`modelID`,`model`)
) ENGINE=MyISAM AUTO_INCREMENT=110 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of room_modeldata
-- ----------------------------
INSERT INTO room_modeldata VALUES ('43', 'model_a', '0', '3', '5', '0', '0', 'xxxxxxxxxxxx\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('44', 'model_b', '0', '0', '5', '0', '0', 'xxxxxxxxxxxx\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('45', 'model_c', '0', '4', '7', '0', '0', 'xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('46', 'model_d', '0', '4', '7', '0', '0', 'xxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('47', 'model_e', '0', '1', '5', '0', '0', 'xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('48', 'model_f', '0', '2', '5', '0', '0', 'xxxxxxxxxxxx\rxxxxxxx0000x\rxxxxxxx0000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rx0000000000x\rx0000000000x\rx0000000000x\rx0000000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('49', 'model_g', '0', '1', '7', '1', '0', 'xxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('50', 'model_h', '0', '4', '4', '1', '0', 'xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx000000x\rxxxxx000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('51', 'model_i', '0', '0', '10', '0', '0', 'xxxxxxxxxxxxxxxxx\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('52', 'model_j', '0', '0', '10', '0', '0', 'xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('53', 'model_k', '0', '0', '13', '0', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx\r\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('54', 'model_l', '0', '0', '16', '0', '0', 'xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rxxxxxxxxxxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('55', 'model_m', '0', '0', '15', '1', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('56', 'model_n', '0', '0', '16', '0', '0', 'xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx000000xxxxxxxx000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000xxxxxxxx000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rxxxxxxxxxxxxxxxxxxxxx\r', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('57', 'model_o', '0', '0', '18', '1', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx00000000xxxx\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('58', 'model_p', '0', '0', '23', '2', '0', 'xxxxxxxxxxxxxxxxxxx\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx22222222xxxx\rxxxxxxx11111111xxxx\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx2222xx11111111xxxx\rx2222xx00000000xxxx\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rxxxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('59', 'model_q', '0', '10', '4', '2', '0', 'xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx2222xxxxxxxxxxxxxx\rx2222xxxxxxxxxxxxxx\rx2222211111xx000000\rx222221111110000000\rx222221111110000000\rx2222211111xx000000\rxx22xxx1111xxxxxxxx\rxx11xxx1111xxxxxxxx\rx1111xx1111xx000000\rx1111xx111110000000\rx1111xx111110000000\rx1111xx1111xx000000\rxxxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('60', 'model_r', '0', '10', '4', '3', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rx4444433333xxxxxxxxxxxxxx\rx4444433333xxxxxxxxxxxxxx\rx44444333333222xx000000xx\rx44444333333222xx000000xx\rxxx44xxxxxxxx22xx000000xx\rxxx33xxxxxxxx11xx000000xx\rxxx33322222211110000000xx\rxxx33322222211110000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('61', 'newbie_lobby', '0', '2', '11', '0', '2', 'xxxxxxxxxxxxxxxx000000\rxxxxx0xxxxxxxxxx000000\rxxxxx00000000xxx000000\rxxxxx000000000xx000000\r0000000000000000000000\r0000000000000000000000\r0000000000000000000000\r0000000000000000000000\r0000000000000000000000\rxxxxx000000000000000xx\rxxxxx000000000000000xx\rx0000000000000000000xx\rx0000000000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxxxx0000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxxxx000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxxx00000000000xxxxx\rxxxxx000000000000xxxxx\rxxxxx000000000000xxxxx\r', 'a160 crl_lamp 16 0 0 0 1\r\ny170 crl_sofa2c 17 0 0 4 2\r\nw180 crl_sofa2b 18 0 0 4 2\r\nv190 crl_sofa2a 19 0 0 4 2\r\na200 crl_lamp 20 0 0 0 1\r\nb161 crl_chair 16 1 0 2 2\r\na72 crl_lamp 7 2 0 0 1\r\na112 crl_lamp 11 2 0 0 1\r\nb162 crl_chair 16 2 0 2 2\r\nc53 crl_pillar 5 3 0 0 1\r\nb73 crl_chair 7 3 0 2 2\r\nu93 crl_table1b 9 3 0 0 1\r\ns113 crl_sofa1c 11 3 0 6 2\r\nb163 crl_chair 16 3 0 2 2\r\nA193 crl_table2b 19 3 0 0 1\r\nz203 crl_table2a 20 3 0 0 1\r\na04 crl_lamp 0 4 0 0 1\r\ny14 crl_sofa2c 1 4 0 4 2\r\nw24 crl_sofa2b 2 4 0 4 2\r\nv34 crl_sofa2a 3 4 0 4 2\r\na44 crl_lamp 4 4 0 0 1\r\nt94 crl_table1a 9 4 0 0 1\r\nr114 crl_sofa1b 11 4 0 6 2\r\nh154 crl_wall2a 15 4 0 0 1\r\na164 crl_lamp 16 4 0 0 1\r\nb05 crl_chair 0 5 0 2 2\r\nb75 crl_chair 7 5 0 2 2\r\nq115 crl_sofa1a 11 5 0 6 2\r\nA26 crl_table2b 2 6 0 0 1\r\nz36 crl_table2a 3 6 0 0 1\r\na116 crl_lamp 11 6 0 0 1\r\nb07 crl_chair 0 7 0 2 2\r\na08 crl_lamp 0 8 0 0 1\r\nD18 crl_sofa3c 1 8 0 0 2\r\nC28 crl_sofa3b 2 8 0 0 2\r\nB38 crl_sofa3a 3 8 0 0 2\r\na48 crl_lamp 4 8 0 0 1\r\no198 crl_barchair2 19 8 0 0 2\r\np208 crl_tablebar 20 8 0 0 1\r\no218 crl_barchair2 21 8 0 0 2\r\nE59 crl_pillar2 5 9 0 0 1\r\nc99 crl_pillar 9 9 0 0 1\r\nP815 crl_desk1a 8 15 0 0 1\r\nO915 crl_deski 9 15 0 0 1\r\nN1015 crl_deskh 10 15 0 0 1\r\nM1016 crl_deskg 10 16 0 0 1\r\nL1017 crl_deskf 10 17 0 0 1\r\nK1018 crl_deske 10 18 0 0 1\r\nK1019 crl_deske 10 19 0 0 1\r\nK1020 crl_deske 10 20 0 0 1\r\nK1021 crl_deske 10 21 0 0 1\r\nK1022 crl_deske 10 22 0 0 1\r\nK1023 crl_deske 10 23 0 0 1\r\nG724 crl_wallb 7 24 0 0 1\r\nK1024 crl_deske 10 24 0 0 1\r\nF725 crl_walla 7 25 0 0 1\r\nH825 crl_desk1b 8 25 0 0 1\r\nI925 crl_desk1c 9 25 0 0 1\r\nJ1025 crl_desk1d 10 25 0 0 1\r\nd1227 crl_lamp2 12 27 0 0 1\r\nf1327 crl_cabinet2 13 27 0 0 1\r\ne1427 crl_cabinet1 14 27 0 0 1\r\nd1527 crl_lamp2 15 27 0 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('62', 'theater', '0', '20', '27', '0', '0', 'XXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXXXXXXXXXXXXXXXXXX\rXXXXXXX111111111XXXXXXX\rXXXXXXX11111111100000XX\rXXXX00X11111111100000XX\rXXXX00x11111111100000XX\r4XXX00X11111111100000XX\r4440000XXXXXXXXX00000XX\r444000000000000000000XX\r4XX000000000000000000XX\r4XX0000000000000000000X\r44400000000000000000000\r44400000000000000000000\r44X0000000000000000O000\r44X11111111111111111000\r44X11111111111111111000\r33X11111111111111111000\r22X11111111111111111000\r22X11111111111111111000\r22X11111111111111111000\r22X11111111111111111000\r22X11111111111111111000\r22211111111111111111000\r22211111111111111111000\rXXXXXXXXXXXXXXXXXXXX00X\rXXXXXXXXXXXXXXXXXXXX00X\r', 'm1110 mic 11 10 1 0 1\r\nd211 thchair2 2 11 4 2 2\r\nd212 thchair2 2 12 4 2 2\r\nd215 thchair2 2 15 4 2 2\r\nc615 thchair1 6 15 0 0 2\r\nc715 thchair1 7 15 0 0 2\r\nc815 thchair1 8 15 0 0 2\r\nc915 thchair1 9 15 0 0 2\r\nc1015 thchair1 10 15 0 0 2\r\nc1215 thchair1 12 15 0 0 2\r\nc1315 thchair1 13 15 0 0 2\r\nc1415 thchair1 14 15 0 0 2\r\nc1515 thchair1 15 15 0 0 2\r\nc1615 thchair1 16 15 0 0 2\r\nd216 thchair2 2 16 4 2 2\r\nc620 thchair1 6 20 1 0 2\r\nc720 thchair1 7 20 1 0 2\r\nc820 thchair1 8 20 1 0 2\r\nc920 thchair1 9 20 1 0 2\r\nc1020 thchair1 10 20 1 0 2\r\nc1220 thchair1 12 20 1 0 2\r\nc1320 thchair1 13 20 1 0 2\r\nc1420 thchair1 14 20 1 0 2\r\nc1520 thchair1 15 20 1 0 2\r\nc1620 thchair1 16 20 1 0 2\r\nc623 thchair1 6 23 1 0 2\r\nc723 thchair1 7 23 1 0 2\r\nc823 thchair1 8 23 1 0 2\r\nc923 thchair1 9 23 1 0 2\r\nc1023 thchair1 10 23 1 0 2\r\nc1223 thchair1 12 23 1 0 2\r\nc1323 thchair1 13 23 1 0 2\r\nc1423 thchair1 14 23 1 0 2\r\nc1523 thchair1 15 23 1 0 2\r\nc1623 thchair1 16 23 1 0 2\r\nc626 thchair1 6 26 1 0 2\r\nc726 thchair1 7 26 1 0 2\r\nc826 thchair1 8 26 1 0 2\r\nc926 thchair1 9 26 1 0 2\r\nc1026 thchair1 10 26 1 0 2\r\nc1226 thchair1 12 26 1 0 2\r\nc1326 thchair1 13 26 1 0 2\r\nc1426 thchair1 14 26 1 0 2\r\nc1526 thchair1 15 26 1 0 2\r\nc1626 thchair1 16 26 1 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('63', 'library', '0', '20', '3', '1', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx11111xx1xx1x111111x\rxxxxxxxxxxxx111111xx1xx11111111x\rxx111xxxxxxx111111xx1xx11111111x\rxx111xxxxxxx1111111111111111111x\rxx111xxxxxxx1111111111111111111x\rxx111xxxxxxx1111111111111111111x\rxx111xxxxxxx1111111111111xxxxxxx\rxx111xxxxxx11111111111111111111x\rxx111xxxxxx11111111111111111111x\rxx111xxxxxx11111111111111111111x\rxx111xxxxxx11111111111111xxxxxxx\rxx111xxxxxxxx111111111111111111x\rxx111xx11111x111111111111111111x\rxx111xx11111x111111111111111111x\rxx111xxxxx11x11111111x111xxxxxxx\rxx111xxxxxxxx11111111xx11111111x\rxx111xxx1111111111111xxx1111111x\rxx111xxx1111111111111xxxx111111x\rxxx111xx1111111111x11xxxx000000x\rxxxxx1111xx1111111x11xxxx000000x\rxxxxxxxxxxxx111111x11xxxx000000x\rxxxxxxxxxxxx11xx11x11xxxx000000x\rxxxxxxxxxxxx11xx11x11xxxx000000x\rxxxxxxxxxxxx11xx11x11xxxx000000x\rxxxxxxxxxxxx11xx11x11xxxx000000x\rxxxxxxxxxxxx11xx11x11xxxx000000x\rxxxxxxxxxxxx11xx11x111xxx000000x\rxxxxxxxxxxxxxxxxxxxx11xxx000000x\rxxxxxxxxxxxxxxxxxxxx11xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxx22222xxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r', 'a142 libchair 14 2 1 4 2\r\na162 libchair 16 2 1 4 2\r\na262 libchair 26 2 1 4 2\r\na243 libchair 24 3 1 2 2\r\na124 libchair 12 4 1 2 2\r\na126 libchair 12 6 1 2 2\r\nb1314 libstool 13 14 1 6 2\r\nb1315 libstool 13 15 1 6 2\r\nb1316 libstool 13 16 1 6 2\r\na2827 libchair 28 27 0 4 2\r\na2729 libchair 27 29 0 2 2\r\nb2433 libstool 24 33 2 6 2\r\nb2434 libstool 24 34 2 6 2\r\nb2435 libstool 24 35 2 6 2\r\nb2136 libstool 21 36 2 0 2\r\nb2236 libstool 22 36 2 0 2\r\nb2336 libstool 23 36 2 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('64', 'floatinggarden', '0', '2', '21', '5', '0', 'xxxxxxxxxxxxxxxx333333xxxxxxxxx\rxxxxxxxxxxxxxxxx3xxxx3xxxxxxxxx\rxxxxxxxxxxxxxxxx3xxxx3xxxxxxxxx\rxxxxxxxxxxxxxxxx3xxxx3xxxxxxxxx\rxxxxxxxxxxxxxxx223xxx33xxxxxxxx\rxxxxxxxxxxxxxxx11xxx33333xxxxxx\rxxxxxxxxxxxxxxxx11xx3333333xxxx\rxxxxxxxxxxxxxxxx11xx33333333xxx\rxxxxxxxxxxxxxxxxx11xxxxxxxx3xxx\rxxxxxxxxxxxxxxxxxx11xxxx3333xxx\rxxxxxxxxxxxxxxxxxxx1xxxx33333xx\rxxxxxxxxxxxxxxxxxxx1xxx3333333x\r555xxxxxxxxxxx1111111x333333333\r555xxxxxxxxxxx21111111xxxxxx333\r555xxxxxxxxxxx22111111111xxxxxx\r555xxxxxxxxxxx222xxxxxxx111xxxx\r555xxxxxxxxxxx22xxxxxxxxxx1xxxx\r555xxxxxxxxxxx23333333333x111xx\r555xxxxxxxx33333333333333x111xx\r555xxxxxxxx333333x3333333x111xx\r555xxxxxxxx33333333333333x111xx\r555xxxxxxxx33x33333333333x111xx\r555xxxxxxxx33x33x33333333x111xx\r555xxxxxxxx33x33x33333333x111xx\r5554333333333x333x3333333x111xx\rx554333333xxxx33xxxxxxxxxx111xx\rxxxxxxxxx3xxxx333221111111111xx\rxxxxxxxxx3xxxx333221111111111xx\rxxxxxxxxx33333333xx1111x11x11xx\rxxxxxxxxx33333333111xxx11xxxxxx\rxxxxxxxxxxxxxx33311xxxx11xxxxxx\rxxxxxxxxxxxxxx33311xxxx11xxxxxx\rxxxxxxxxxxxxxx333x1xxxx11xxxxxx\rxxxxxxxxxxxxxx333x1xx111111xxxx\rxxxxxxxxxxxxxx33311xx111111xxxx\rxxxxxxxxxx333333311xx111111xxxx\rxxxxxxxxxxx33333311xx111111xxxx\rxxxxxxxxxxxxxxxx111xxxxxxxxxxxx\rxxxxxxxxxxxxxxx111xxxxxxxxxxxxx\r', 'a249 float_dummychair 24 9 3 4 2\r\na259 float_dummychair 25 9 3 4 2\r\nb2813 float_dummychair2 28 13 3 4 2\r\nb2913 float_dummychair2 29 13 3 4 2\r\ne1717 floatbench2 17 17 3 2 2\r\ne1917 floatbench2 19 17 3 6 2\r\ne2117 floatbench2 21 17 3 2 2\r\ne2317 floatbench2 23 17 3 6 2\r\ne2717 floatbench2 27 17 1 4 2\r\nd2817 floatbench1 28 17 1 4 2\r\nd1718 floatbench1 17 18 3 2 2\r\nd1918 floatbench1 19 18 3 6 2\r\nd2118 floatbench1 21 18 3 2 2\r\nd2318 floatbench1 23 18 3 6 2\r\ne2719 floatbench2 27 19 1 0 2\r\nd2819 floatbench1 28 19 1 0 2\r\ne1723 floatbench2 17 23 3 2 2\r\ne1923 floatbench2 19 23 3 6 2\r\ne2123 floatbench2 21 23 3 2 2\r\ne2323 floatbench2 23 23 3 6 2\r\ne2723 floatbench2 27 23 1 4 2\r\nd2823 floatbench1 28 23 1 4 2\r\nd1724 floatbench1 17 24 100000 2 2\r\nd1924 floatbench1 19 24 3 6 2\r\nd2124 floatbench1 21 24 3 2 2\r\nd2324 floatbench1 23 24 3 6 2\r\ne2725 floatbench2 27 25 1 0 2\r\nd2825 floatbench1 28 25 1 0 2\r\na1729 float_dummychair 17 29 1 2 2\r\na1730 float_dummychair 17 30 1 2 2\r\na1731 float_dummychair 17 31 1 2 2\r\na2133 float_dummychair 21 33 1 2 2\r\na2633 float_dummychair 26 33 1 6 2\r\na2134 float_dummychair 21 34 1 2 2\r\na2634 float_dummychair 26 34 1 6 2\r\na1735 float_dummychair 17 35 1 2 2\r\na2135 float_dummychair 21 35 1 2 2\r\na2635 float_dummychair 26 35 1 6 2\r\na1736 float_dummychair 17 36 1 2 2\r\na2136 float_dummychair 21 36 1 2 2\r\na2636 float_dummychair 26 36 1 6 2\r\na1537 float_dummychair 15 37 100000 4 2\r\na1637 float_dummychair 16 37 1 4 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('65', 'sunset_cafe', '0', '34', '40', '0', '4', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000xxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx00000xx00000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxx0000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxxx000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx0000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n', 'd3221 chairup4 32 21 0 3 2\r\nf3321 chairup6 33 21 0 4 2\r\nf3421 chairup6 34 21 0 4 2\r\nf3521 chairup6 35 21 0 4 2\r\nf3621 chairup6 36 21 0 4 2\r\ng3721 chairup7 37 21 0 4 2\r\nb3222 chairup2 32 22 0 2 2\r\ne2523 chairup5 25 23 0 4 2\r\nf2623 chairup6 26 23 0 4 2\r\nf2723 chairup6 27 23 0 4 2\r\nf2823 chairup6 28 23 0 4 2\r\ng2923 chairup7 29 23 0 4 2\r\na3223 chairup1 32 23 0 2 2\r\nA2424 counter5 24 24 0 7 1\r\nr2524 table2 25 24 0 7 1\r\nq2624 table1 26 24 0 7 1\r\np2425 counter3 24 25 0 7 1\r\nz2426 counter4 24 26 0 7 1\r\np2427 counter3 24 27 0 7 1\r\np2428 counter3 24 28 0 7 1\r\ny2928 palms4 29 28 0 7 1\r\np2429 counter3 24 29 0 7 1\r\nx2929 palms3 29 29 0 7 1\r\np2430 counter3 24 30 0 7 1\r\nw2930 palms2 29 30 0 7 1\r\nn2231 counter1 22 31 0 7 1\r\nn2331 counter1 23 31 0 7 1\r\no2431 counter2 24 31 0 7 1\r\nv2931 palms1 29 31 0 7 1\r\ne3031 chairup5 30 31 0 4 2\r\nf3131 chairup6 31 31 0 4 2\r\nf3231 chairup6 32 31 0 4 2\r\nf3331 chairup6 33 31 0 4 2\r\nf3431 chairup6 34 31 0 4 2\r\nf3531 chairup6 35 31 0 4 2\r\nf3631 chairup6 36 31 0 4 2\r\nj3731 chairright3 37 31 0 5 2\r\nc2132 chairup3 21 32 0 2 2\r\nt2232 table4 22 32 0 7 1\r\nr3032 table2 30 32 0 7 1\r\nq3132 table1 31 32 0 7 1\r\nr3332 table2 33 32 0 7 1\r\nq3432 table1 34 32 0 7 1\r\ni3732 chairright2 37 32 0 6 2\r\nb2133 chairup2 21 33 0 2 2\r\ns2233 table3 22 33 0 7 1\r\ni3733 chairright2 37 33 0 6 2\r\nb2134 chairup2 21 34 0 2 2\r\nt3634 table4 36 34 0 7 1\r\ni3734 chairright2 37 34 0 6 2\r\nb2135 chairup2 21 35 0 2 2\r\nr2435 table2 24 35 0 7 1\r\nq2535 table1 25 35 0 7 1\r\nr2735 table2 27 35 0 7 1\r\nq2835 table1 28 35 0 7 1\r\nu3335 palm 33 35 0 7 1\r\ns3635 table3 36 35 0 7 1\r\ni3735 chairright2 37 35 0 6 2\r\nm2136 chairleft3 21 36 0 1 2\r\nl2236 chairleft2 22 36 0 0 2\r\nl2336 chairleft2 23 36 0 0 2\r\nl2436 chairleft2 24 36 0 0 2\r\nl2536 chairleft2 25 36 0 0 2\r\nl2636 chairleft2 26 36 0 0 2\r\nl2736 chairleft2 27 36 0 0 2\r\nk2836 chairleft1 28 36 0 0 2\r\ni3736 chairright2 37 36 0 6 2\r\nt3637 table4 36 37 0 7 1\r\ni3737 chairright2 37 37 0 6 2\r\ns3638 table3 36 38 0 7 1\r\nh3738 chairright1 37 38 0 6 2', '0', 'sf', '5000', '1', '6');
INSERT INTO room_modeldata VALUES ('66', 'pool_a', '0', '2', '25', '7', '2', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx7xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx777xxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxx7777777xxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx777777777xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx7xxx777777xxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx7x777777777xxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx7xxx77777777xxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx7x777777777x7xxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx7xxx7777777777xxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx777777777777xxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx77777777777x2111xxxxxxxxxxxx\rxxxxxxxxxxxxxxx7777777777x221111xxxxxxxxxxx\rxxxxxxxxx7777777777777777x2211111xxxxxxxxxx\rxxxxxxxxx7777777777777777x22211111xxxxxxxxx\rxxxxxxxxx7777777777777777x222211111xxxxxxxx\rxxxxxx77777777777777777777x222211111xxxxxxx\rxxxxxx7777777xx777777777777x222211111xxxxxx\rxxxxxx7777777xx77777777777772222111111xxxxx\rxxxxxx777777777777777777777x22221111111xxxx\rxx7777777777777777777777x322222211111111xxx\r77777777777777777777777x33222222111111111xx\r7777777777777777777777x333222222211111111xx\rxx7777777777777777777x333322222222111111xxx\rxx7777777777777777777333332222222221111xxxx\rxx777xxx777777777777733333222222222211xxxxx\rxx777x7x77777777777773333322222222222xxxxxx\rxx777x7x7777777777777x33332222222222xxxxxxx\rxxx77x7x7777777777777xx333222222222xxxxxxxx\rxxxx77777777777777777xxx3222222222xxxxxxxxx\rxxxxx777777777777777777xx22222222xxxxxxxxxx\rxxxxxx777777777777777777x2222222xxxxxxxxxxx\rxxxxxxx777777777777777777222222xxxxxxxxxxxx\rxxxxxxxx7777777777777777722222xxxxxxxxxxxxx\rxxxxxxxxx77777777777777772222xxxxxxxxxxxxxx\rxxxxxxxxxx777777777777777222xxxxxxxxxxxxxxx\rxxxxxxxxxxx77777777777777x2xxxxxxxxxxxxxxxx\rxxxxxxxxxxxx77777777777777xxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx777777777777xxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxx7777777777xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxx777777xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx7777xxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxx77xxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r', null, '1', '', '0', '0', '0');
INSERT INTO room_modeldata VALUES ('67', 'pub_a', '0', '15', '25', '0', '6', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxx2222222211111xxx\rxxxxxxxxx2222222211111xxx\rxxxxxxxxx2222222211111xxx\rxxxxxxxxx2222222211111xxx\rxxxxxxxxx2222222222111xxx\rxxxxxxxxx2222222222111xxx\rxxxxxxxxx2222222222000xxx\rxxxxxxxxx2222222222000xxx\rxxxxxxxxx2222222222000xxx\rxxxxxxxxx2222222222000xxx\rx333333332222222222000xxx\rx333333332222222222000xxx\rx333333332222222222000xxx\rx333333332222222222000xxx\rx333333332222222222000xxx\rx333332222222222222000xxx\rx333332222222222222000xxx\rx333332222222222222000xxx\rx333332222222222222000xxx\rx333333332222222222000xxx\rxxxxx31111112222222000xxx\rxxxxx31111111000000000xxx\rxxxxx31111111000000000xxx\rxxxxx31111111000000000xxx\rxxxxx31111111000000000xxx\rxxxxxxxxxxxxxxx00xxxxxxxx\rxxxxxxxxxxxxxxx00xxxxxxxx\rxxxxxxxxxxxxxxx00xxxxxxxx\rxxxxxxxxxxxxxxx00xxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxx\r', 'S191 pub_sofa2 19 1 1 4 1\r\ns201 pub_sofa 20 1 1 4 2\r\ns211 pub_sofa 21 1 1 4 2\r\nq112 bardesk1 11 2 2 0 1\r\nc122 pub_chair 12 2 2 6 2\r\nQ113 bardesk2 11 3 2 0 1\r\nq114 bardesk1 11 4 2 0 1\r\nc124 pub_chair 12 4 2 6 2\r\nQ115 bardesk2 11 5 2 0 1\r\nf185 pub_fence 18 5 2 1 1\r\nq116 bardesk1 11 6 2 0 1\r\nc126 pub_chair 12 6 2 6 2\r\nf186 pub_fence 18 6 2 0 1\r\nQ117 bardesk2 11 7 2 0 1\r\nf187 pub_fence 18 7 2 0 1\r\nq118 bardesk1 11 8 2 0 1\r\nc128 pub_chair 12 8 2 6 2\r\nf188 pub_fence 18 8 2 0 1\r\nw109 bardesk4 10 9 2 0 1\r\nW119 bardesk3 11 9 2 0 1\r\nf189 pub_fence 18 9 2 0 1\r\nf1810 pub_fence 18 10 2 0 1\r\nC211 pub_chair2 2 11 3 4 2\r\nC311 pub_chair2 3 11 3 4 2\r\nC511 pub_chair2 5 11 3 4 2\r\nC611 pub_chair2 6 11 3 4 2\r\nf811 pub_fence 8 11 3 1 1\r\nf1811 pub_fence 18 11 2 0 1\r\nf812 pub_fence 8 12 3 0 1\r\nf1812 pub_fence 18 12 2 0 1\r\nf813 pub_fence 8 13 3 0 1\r\nC913 pub_chair2 9 13 2 2 2\r\nk1413 pub_chair3 14 13 2 2 2\r\nT1513 pub_table2 15 13 2 1 1\r\nk1613 pub_chair3 16 13 2 6 2\r\nf1813 pub_fence 18 13 2 0 1\r\nf814 pub_fence 8 14 3 2 1\r\nC914 pub_chair2 9 14 2 2 2\r\nk1414 pub_chair3 14 14 2 2 2\r\nT1514 pub_table2 15 14 2 2 1\r\nk1614 pub_chair3 16 14 2 6 2\r\nf1814 pub_fence 18 14 2 0 1\r\nt115 pub_table 1 15 3 0 1\r\nf515 pub_fence 5 15 3 1 1\r\nf1815 pub_fence 18 15 2 0 1\r\nS116 pub_sofa2 1 16 3 2 2\r\nf516 pub_fence 5 16 3 0 1\r\nf1816 pub_fence 18 16 2 0 1\r\ns117 pub_sofa 1 17 3 2 2\r\nf517 pub_fence 5 17 3 0 1\r\nk1317 pub_chair3 13 17 2 4 2\r\nk1417 pub_chair3 14 17 2 4 2\r\nk1517 pub_chair3 15 17 2 4 2\r\nk1617 pub_chair3 16 17 2 4 2\r\nf1817 pub_fence 18 17 2 0 1\r\ns118 pub_sofa 1 18 3 2 2\r\nf518 pub_fence 5 18 3 0 1\r\nT1318 pub_table2 13 18 2 5 1\r\nT1418 pub_table2 14 18 2 6 1\r\nT1518 pub_table2 15 18 2 6 1\r\nT1618 pub_table2 16 18 2 4 1\r\nf1818 pub_fence 18 18 2 0 1\r\ns219 pub_sofa 2 19 3 0 2\r\nS319 pub_sofa2 3 19 3 0 2\r\nf519 pub_fence 5 19 3 0 1\r\nk1319 pub_chair3 13 19 2 0 2\r\nk1419 pub_chair3 14 19 2 0 2\r\nk1519 pub_chair3 15 19 2 0 2\r\nk1619 pub_chair3 16 19 2 0 2\r\nf1819 pub_fence 18 19 2 0 1\r\nf120 pub_fence 1 20 3 5 1\r\nf220 pub_fence 2 20 3 6 1\r\nf320 pub_fence 3 20 3 6 1\r\nf420 pub_fence 4 20 3 6 1\r\nf520 pub_fence 5 20 3 3 1\r\nf1820 pub_fence 18 20 2 0 1\r\nS721 pub_sofa2 7 21 1 4 2\r\ns821 pub_sofa 8 21 1 4 2\r\nf1221 pub_fence 12 21 2 5 1\r\nf1321 pub_fence 13 21 2 6 1\r\nf1421 pub_fence 14 21 2 6 1\r\nf1521 pub_fence 15 21 2 6 1\r\nf1621 pub_fence 16 21 2 6 1\r\nf1721 pub_fence 17 21 2 6 1\r\nf1821 pub_fence 18 21 2 3 1\r\nS622 pub_sofa2 6 22 1 2 2\r\nt1522 pub_table 15 22 0 0 1\r\nC1622 pub_chair2 16 22 0 4 2\r\nC1722 pub_chair2 17 22 0 4 2\r\ns623 pub_sofa 6 23 1 2 2\r\nT823 pub_table2 8 23 1 1 1\r\ns624 pub_sofa 6 24 1 2 2\r\nT824 pub_table2 8 24 1 0 1\r\ns625 pub_sofa 6 25 1 2 2\r\nT825 pub_table2 8 25 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('68', 'md_a', '0', '1', '5', '7', '2', 'xxxxxxxx77xxxxxxxxxxxxxxxx\rxxxxxxxx77xxxxxxxxxxxxxxxx\rxxxxxx77777x77xxxxxxxxxxxx\rxxx77777777777xxx44xxxxxxx\r77777777777777xx444444444x\r777777777777777xx44444444x\rxxx777777777777xx44444444x\rxxxx7777777777xxx44444444x\r7777777777777777744448444x\r7777777777777x4x744448444x\r777777777777x444444448444x\r7777777777774444444448444x\r7777777777774444444448444x\r777777777777x444444448444x\r7777777777777x44444448444x\rxxx777777777777x444448444x\rxxx7777777777777444448444x\rxxx7777777777777444448444x\rxxx777777777777x444448444x\rxxx77777777777x4444444444x\rxxxx777777777444444444444x\rxxxxxxxxxxxxxxxxxxxxxxxxxx\r', 'A43 mntdwchair 4 3 7 4 2\r\nA53 mntdwchair 5 3 7 4 2\r\nM28 barmask 2 8 7 0 1\r\ns78 mntdwsofa2 7 8 7 2 2\r\nt88 mntdwtable2 8 8 7 0 2\r\ns98 mntdwsofa2 9 8 7 6 2\r\ny218 paalu5 21 8 8 0 1\r\nM29 barmask 2 9 7 0 1\r\nS79 mntdwsofa1 7 9 7 2 2\r\nT89 mntdwtable1 8 9 7 0 2\r\nS99 mntdwsofa1 9 9 7 6 2\r\ny219 paalu5 21 9 8 0 1\r\nM210 barmask 2 10 7 0 1\r\ny2110 paalu5 21 10 8 0 1\r\nM211 barmask 2 11 7 0 1\r\ny2111 paalu5 21 11 8 0 1\r\nM212 barmask 2 12 7 0 1\r\ns712 mntdwsofa2 7 12 7 4 2\r\nS812 mntdwsofa1 8 12 7 4 2\r\ne2112 paalu3 21 12 8 0 1\r\nM213 barmask 2 13 7 0 1\r\nt713 mntdwtable2 7 13 7 2 1\r\nT813 mntdwtable1 8 13 7 2 1\r\ne2113 paalu3 21 13 8 0 1\r\nM214 barmask 2 14 7 0 1\r\ns714 mntdwsofa2 7 14 7 0 2\r\nS814 mntdwsofa1 8 14 7 0 2\r\ne2114 paalu3 21 14 8 0 1\r\nM215 barmask 2 15 100000 0 1\r\nq2115 paalu1 21 15 8 0 1\r\nM216 barmask 2 16 100000 0 1\r\ns1216 mntdwsofa2 12 16 7 4 2\r\nS1316 mntdwsofa1 13 16 7 4 2\r\nq2116 paalu1 21 16 8 0 1\r\nA317 mntdwchair 3 17 7 2 2\r\ns617 mntdwsofa2 6 17 7 2 2\r\nt717 mntdwtable2 7 17 7 0 1\r\ns817 mntdwsofa2 8 17 7 6 2\r\nt1217 mntdwtable2 12 17 7 2 1\r\nT1317 mntdwtable1 13 17 7 2 1\r\nq2117 paalu1 21 17 8 0 1\r\nA318 mntdwchair 3 18 7 2 2\r\nS618 mntdwsofa1 6 18 7 2 2\r\nT718 mntdwtable1 7 18 7 0 1\r\nS818 mntdwsofa1 8 18 7 6 2\r\ns1218 mntdwsofa2 12 18 7 0 2\r\nS1318 mntdwsofa1 13 18 7 0 2\r\nq2118 paalu1 21 18 8 0 1', '1', 'cam1', '4500', '1', '4');
INSERT INTO room_modeldata VALUES ('69', 'picnic', '0', '16', '5', '2', '4', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxx22222xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r22xxxxxxxxxxxxx22xxxxxxxxxxxxxxxxxxxxx\r2222222222222222222x222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222xxx222222222222222222222222\r2222222222xx33x22222222222222222222222\r222222222xx3333x2222222222222222222222\r222222222x333333x222222222222222222222\r222222222x333333x222222222222222222222\r2222222222x3332x2222222222222222222222\r22222222222x33x22222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222x22222xxxx22222222222222222222\r22222222222222xxxx22222222222222222222\r22222222222222xxx222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r22222222222222222222222222222222222222\r', 'h107 hedge7 10 7 2 4 1\r\nh117 hedge7 11 7 2 4 1\r\nh127 hedge7 12 7 2 4 1\r\nh137 hedge7 13 7 2 4 1\r\ny147 hedge8 14 7 2 4 1\r\ns187 hedge2 18 7 2 4 1\r\nh197 hedge7 19 7 2 4 1\r\nh207 hedge7 20 7 2 4 1\r\nh217 hedge7 21 7 2 4 1\r\nz148 hedge9 14 8 2 4 1\r\nz188 hedge9 18 8 2 4 1\r\nv39 hedge5 3 9 2 4 1\r\nz310 hedge9 3 10 2 4 1\r\nc1211 picnic_dummychair1 12 11 3 4 2\r\nc1311 picnic_dummychair1 13 11 3 4 2\r\nc1411 picnic_dummychair1 14 11 100000 4 2\r\nc1013 picnic_dummychair1 10 13 3 2 2\r\nc1513 picnic_dummychair1 15 13 3 6 2\r\nb2113 picnic_ground 21 13 2 4 2\r\nb714 picnic_ground 7 14 2 4 2\r\nc1014 picnic_dummychair1 10 14 3 2 2\r\nc1514 picnic_dummychair1 15 14 3 6 2\r\nb1915 picnic_ground 19 15 2 2 2\r\nb2315 picnic_ground 23 15 2 6 2\r\nb516 picnic_ground 5 16 2 2 2\r\nb916 picnic_ground 9 16 2 6 2\r\nL2016 picnic_cloth1 20 16 2 2 1\r\nL617 picnic_cloth1 6 17 2 2 1\r\nb2117 picnic_ground 21 17 2 0 2\r\nb718 picnic_ground 7 18 2 0 2\r\na019 picnic_redbench2 0 19 2 2 2\r\nA020 picnic_redbench1 0 20 2 2 2\r\nw1120 hedge6 11 20 2 4 1\r\nh1220 hedge7 12 20 2 4 1\r\nh1320 hedge7 13 20 2 4 1\r\nt1420 hedge3 14 20 2 4 1\r\nu1720 hedge4 17 20 2 4 1\r\nh1820 hedge7 18 20 2 4 1\r\nh1920 hedge7 19 20 2 4 1\r\ny2020 hedge8 20 20 2 4 1\r\nv1121 hedge5 11 21 2 4 1\r\nM1221 picnic_bench1 12 21 2 4 2\r\nN1321 picnic_bench2 13 21 2 4 2\r\nO1421 picnic_bench3 14 21 2 4 2\r\nM1721 picnic_bench1 17 21 2 4 2\r\nN1821 picnic_bench2 18 21 2 4 2\r\nO1921 picnic_bench3 19 21 2 4 2\r\nv2021 hedge5 20 21 2 4 1\r\na022 picnic_redbench2 0 22 2 2 2\r\nv1122 hedge5 11 22 2 4 1\r\nv2022 hedge5 20 22 2 4 1\r\nb2522 picnic_ground 25 22 2 4 1\r\nA023 picnic_redbench1 0 23 2 2 2\r\nv1123 hedge5 11 23 2 4 1\r\nM1223 picnic_bench1 12 23 2 2 2\r\nM1923 picnic_bench1 19 23 2 6 2\r\nv2023 hedge5 20 23 2 4 1\r\nc624 picnic_dummychair1 6 24 2 4 2\r\nd724 picnic_dummychair4 7 24 2 4 2\r\ne824 picnic_dummychair6 8 24 2 4 2\r\nv1124 hedge5 11 24 2 4 1\r\nN1224 picnic_bench2 12 24 2 2 2\r\nN1924 picnic_bench2 19 24 2 6 2\r\nv2024 hedge5 20 24 2 4 1\r\nb2324 picnic_ground 23 24 2 2 2\r\nb2724 picnic_ground 27 24 2 6 2\r\nK525 picnic_stump 5 25 2 2 2\r\nv1125 hedge5 11 25 2 4 1\r\nN1225 picnic_bench2 12 25 2 2 2\r\nN1925 picnic_bench2 19 25 2 6 2\r\nv2025 hedge5 20 25 2 4 1\r\nG2425 picnic_cloth2 24 25 2 2 1\r\nK726 picnic_stump 7 26 2 0 2\r\nv1126 hedge5 11 26 2 4 1\r\nO1226 picnic_bench3 12 26 2 2 2\r\nH1426 picnic_fireplace1 14 26 2 0 1\r\nI1626 picnic_fireplace2 16 26 2 2 1\r\nO1926 picnic_bench3 19 26 2 6 2\r\nv2026 hedge5 20 26 2 4 1\r\nb2526 picnic_ground 25 26 2 0 1\r\nz1127 hedge9 11 27 2 4 1\r\nQ1227 picnic_lemonade 12 27 2 4 1\r\nz2027 hedge9 20 27 2 4 1\r\nE829 picnic_firewood2 8 29 2 0 1\r\na030 picnic_redbench2 0 30 2 2 2\r\nD830 picnic_firewood1 8 30 2 0 1\r\nA031 picnic_redbench1 0 31 2 2 2\r\nD831 picnic_firewood1 8 31 2 0 1\r\nM1231 picnic_bench1 12 31 2 4 2\r\nN1331 picnic_bench2 13 31 2 4 2\r\nO1431 picnic_bench3 14 31 2 4 2\r\nM1831 picnic_bench1 18 31 2 4 2\r\nN1931 picnic_bench2 19 31 2 4 2\r\nO2031 picnic_bench3 20 31 2 4 2\r\nf2731 picnic_carrot 27 31 2 0 1\r\nf2831 picnic_carrot 28 31 2 0 1\r\nf2931 picnic_carrot 29 31 2 0 1\r\nf3031 picnic_carrot 30 31 2 0 1\r\nf3131 picnic_carrot 31 31 2 0 1\r\nD832 picnic_firewood1 8 32 2 0 1\r\nF1232 picnic_table2 12 32 2 2 1\r\nP1432 picnic_table 14 32 2 2 1\r\nF1832 picnic_table2 18 32 2 2 1\r\nP2032 picnic_table 20 32 2 2 1\r\nr333 hedge1 3 33 2 4 1\r\nD833 picnic_firewood1 8 33 2 0 1\r\nM1233 picnic_bench1 12 33 2 0 2\r\nN1333 picnic_bench2 13 33 2 0 2\r\nO1433 picnic_bench3 14 33 2 0 2\r\nM1833 picnic_bench1 18 33 2 0 2\r\nN1933 picnic_bench2 19 33 2 0 2\r\nO2033 picnic_bench3 20 33 2 0 2\r\ng2733 picnic_cabbage 27 33 2 0 1\r\ng2833 picnic_cabbage 28 33 2 0 1\r\ng2933 picnic_cabbage 29 33 2 0 1\r\nv334 hedge5 3 34 2 4 1\r\nD834 picnic_firewood1 8 34 2 0 1\r\nv335 hedge5 3 35 2 4 1\r\nD835 picnic_firewood1 8 35 2 0 1\r\nv336 hedge5 3 36 2 4 1\r\nD836 picnic_firewood1 8 36 2 0 1\r\nD837 picnic_firewood1 8 37 2 0 1\r\nM1237 picnic_bench1 12 37 2 4 2\r\nN1337 picnic_bench2 13 37 2 4 2\r\nO1437 picnic_bench3 14 37 2 4 2\r\nM1837 picnic_bench1 18 37 2 4 2\r\nN1937 picnic_bench2 19 37 2 4 2\r\nO2037 picnic_bench3 20 37 2 4 2\r\nD838 picnic_firewood1 8 38 2 0 1\r\nF1238 picnic_table2 12 38 2 2 1\r\nP1438 picnic_table 14 38 2 2 1\r\nF1838 picnic_table2 18 38 2 2 1\r\nP2038 picnic_table 20 38 2 2 1\r\nJ839 picnic_firewood3 8 39 2 0 1\r\nM1239 picnic_bench1 12 39 2 0 2\r\nN1339 picnic_bench2 13 39 2 0 2\r\nO1439 picnic_bench3 14 39 2 0 2\r\nM1839 picnic_bench1 18 39 2 0 2\r\nN1939 picnic_bench2 19 39 2 0 2\r\nO2039 picnic_bench3 20 39 2 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('70', 'park_a', '0', '2', '15', '0', '6', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0xxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00xxxxxxxxxxxx\rxxxxxxxxxxxxx0x00xxxxxxxxxxx0x000xxxxxxxxxxx\rxxxxxxxxxxxx0000000000000000000000xxxxxxxxxx\rxxxxxxxxxxx000000000000000000000000xxxxxxxxx\rxxxxxxxxxxx0000000000000000000000000xxxxxxxx\rxxxxxxxxxxx00000000000000000000000000xxxxxxx\rxxxxxxxx000000000000000000000000000000xxxxxx\rxxxxxxx00000000000000000000000000000000xxxxx\rxxxxxxx000000000000000000000000000000000xxxx\rxxxxxxx0000000000000000000000000000000000xxx\rxxxxxxxxx000000000000000000000000000000000xx\r00000000000000000000xx00000000000000000000xx\r0000000000000000000xxxx00000000000xxxxxxx0xx\r0000000000000000000xxxx00000000000x00000xxxx\rxxxxx00x0000000000xxxxx0xxxxxx0000x0000000xx\rxxxxx0000000000000xxxxx0xx000x0000x000000xxx\rxxxxx0000000000000xxxxx0x000000000x00000xxxx\rxxxxx000000x0000000xxxx0x000000000xxx00xxxxx\rxxxxxxxx000x0000000xxx00xxx000000x0000xxxxxx\rxxxxxxxx000x000000xxxx0x0000000000000xxxxxxx\rxxxxxxxx000x000000011100000000000000xxxxxxxx\rxxxxxxxx000x00000001110000000000000xxxxxxxxx\rxxxxxxxxx00x0000000111x00000000x00xxxxxxxxxx\rxxxxxxxxxx0x0000000xxx0000000xxxxxxxxxxxxxxx\rxxxxxxxxxxxx000000xxxx0000000xxxxxxxxxxxxxxx\rxxxxxxxxxxxx000000xxx00xxxxx00xxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx0xxx0xx000x00xxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx0xxx0x000000xxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx0xxx0x00000xxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx0xxxxx00xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx0xxxxx0xxxxxxxxxxxxxxxxxxxx\r', 'L89 bench2 8 9 0 4 2\r\nK99 bench 9 9 0 4 2\r\nL711 bench2 7 11 0 2 2\r\nK712 bench 7 12 0 2 2\r\nL3516 bench2 35 16 0 2 2\r\nL3716 bench2 37 16 0 4 2\r\nK3816 bench 38 16 0 4 2\r\nK3517 bench 35 17 0 2 2\r\nL2718 bench2 27 18 0 4 2\r\nK2818 bench 28 18 0 4 2\r\nL3518 bench2 35 18 0 2 2\r\nL2519 bench2 25 19 0 2 2\r\nK3519 bench 35 19 0 2 2\r\nK2520 bench 25 20 0 2 2\r\nL2529 bench2 25 29 0 4 2\r\nK2629 bench 26 29 0 4 2\r\nL2330 bench2 23 30 0 2 2\r\nK2331 bench 23 31 0 2 2', '0', '', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('71', 'park_b', '0', '11', '2', '0', '6', '0000x0000000\r0000xx000000\r000000000000\r00000000000x\r000000000000\r00x0000x0000\r', 'C00 cornerchair2 0 0 0 4 2\r\nB10 cornerchair1 1 0 0 4 2\r\nA20 chair1 2 0 0 4 2\r\nA30 chair1 3 0 0 4 2\r\nH50 table1 5 0 0 4 1\r\nE60 chair1line 6 0 0 4 2\r\nA70 chair1 7 0 0 4 2\r\nF80 chair1frontend 8 0 0 4 2\r\nJ100 hububar 10 0 0 4 1\r\nB01 cornerchair1 0 1 0 2 2\r\nA02 chair1 0 2 0 2 2\r\nA03 chair1 0 3 0 2 2\r\nA04 chair1 0 4 0 2 2\r\nF05 chair1frontend 0 5 0 2 2\r\nI35 table2 3 5 0 4 1\r\nD55 modchair 5 5 0 0 2\r\nI85 table2 8 5 0 4 1', '0', '', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('72', 'pool_b', '0', '9', '21', '7', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx7xxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx777xxxxxxxxxxx\rxxxxxxxxxxxxxxxxxx8888888x7xxx77777xxxxxxxxxx\rxxxxxxxxxxxxxxxxxx8888888x7xxx777777xxxxxxxxx\rxxxxxxxxxxxxxxxx88xxxxx77x7x777777777xxxxxxxx\rxxxxxxxxxxxxxxxx88x7777777777777777777xxxxxxx\rxxxxxxxxxxxxxxxx88x77777777777777777777xxxxxx\rxxxxxxxxxxxxxx9988x77777777777777777777xxxxxx\rxxxxxxxxxxxxxx9988x7777777777777777777x00xxxx\rxxxxxxxxxxxxxx9988x777777777777777777x0000xxx\rxxxxxxxxxxxxxx9988x7777777x0000000000000000xx\rxxxxxxxxxxxxxx9988x777777x000000000000000000x\r7777777777xxxx9988777777x0x0000000000000000xx\rx7777777777xxx998877777x000x00000000000000xxx\rxx7777777777xx99887777x00000x000000000000xxxx\rxxx7777777777x9988777x0000000x0000000000xxxxx\rxxxx777777777x777777x00000000x000000000xxxxxx\rxxxxx777777777777777000000000x00000000xxxxxxx\rxxxxxx77777777777777000000000x0000000xxxxxxxx\rxxxxxxx777777x7777770000000000xxxx00xxxxxxxxx\rxxxxxxxx77777777777xx0000000000000xxxxxxxxxxx\rxxxxxxxxx777777110000x000000000000xxxxxxxxxxx\rxxxxxxxxxx7x77x1100000x0000000000xxxxxxxxxxxx\rxxxxxxxxxxx777x11000000x00000000xxxxxxxxxxxxx\rxxxxxxxxxxxx771110000000x000000xxxxxxxxxxxxxx\rxxxxxxxxxxxxx111100000000x0000xxxxxxxxxxxxxxx\rxxxxxxxxxxxxxx11100000000x000xxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxx1100000000x00xxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxx110000000x0xxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx110000000xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxx1100000xxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxx11000xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxx110xxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'u332 umbrella2 33 2 7 0 1\r\nb183 pool_2sofa2 18 3 8 4 2\r\nB193 pool_2sofa1 19 3 8 4 2\r\nb203 pool_2sofa2 20 3 8 4 2\r\nB213 pool_2sofa1 21 3 8 4 2\r\nb223 pool_2sofa2 22 3 8 4 2\r\nB233 pool_2sofa1 23 3 8 4 2\r\nc333 pool_chair2 33 3 7 4 2\r\nc324 pool_chair2 32 4 7 2 2\r\nt334 pool_table2 33 4 7 0 1\r\nc344 pool_chair2 34 4 7 6 2\r\nb165 pool_2sofa2 16 5 8 2 2\r\nc335 pool_chair2 33 5 7 0 2\r\nB166 pool_2sofa1 16 6 8 2 2\r\nb167 pool_2sofa2 16 7 8 2 2\r\nc357 pool_chair2 35 7 7 4 2\r\nf148 flower1 14 8 9 0 1\r\nB168 pool_2sofa1 16 8 8 2 2\r\nu338 umbrella2 33 8 7 0 1\r\nc348 pool_chair2 34 8 7 2 2\r\nt358 pool_table2 35 8 7 0 1\r\nc368 pool_chair2 36 8 7 6 2\r\nb149 pool_2sofa2 14 9 9 2 2\r\nb169 pool_2sofa2 16 9 8 2 2\r\nc359 pool_chair2 35 9 7 0 2\r\nB1410 pool_2sofa1 14 10 9 2 2\r\nB1610 pool_2sofa1 16 10 8 2 2\r\nb1411 pool_2sofa2 14 11 9 2 2\r\nb1611 pool_2sofa2 16 11 8 2 2\r\nB1412 pool_2sofa1 14 12 9 2 2\r\nB1612 pool_2sofa1 16 12 8 2 2\r\nR313 flower2b 3 13 7 2 1\r\nr413 flower2a 4 13 7 2 1\r\nb1413 pool_2sofa2 14 13 9 2 2\r\nb1613 pool_2sofa2 16 13 8 2 2\r\nB1414 pool_2sofa1 14 14 9 2 2\r\nB1614 pool_2sofa1 16 14 8 2 2', '1', 'cam1', '4500', '1', '4');
INSERT INTO room_modeldata VALUES ('73', 'ballroom', '0', '13', '6', '0', '0', 'xxxx4444444444444444444\r\nxxxx4444444444444444444\r\nxxxx4444444444444444444\r\nxxxx33x2222444442222x33\r\nxxxx2222222x00xx2222222\r\nxxxx22222220000x2222222\r\nxxxx11x0000x000x0000x11\r\nxxxx0000000000000000000\r\n11100000000000000000000\r\n11100000000000000000000\r\n11100000000000000000000\r\nxxxx0000000000000000000\r\n22210000000000000000000\r\n22210000000000000000000\r\n22210000000000000000000\r\nxxxx0000000000000000000\r\n11100000000000000000000\r\n11100000000000000000000\r\n11100000000000000000000\r\nxxxxx000x11111111x0000x\r\nxxxxxx00x1111x111x000xx\r\nxxxxxxx0x11111111x00xxx\r\nxxxxxxxxx11111111x0xxxx\r\nxxxxxxxxx11111111xxxxxx \r\n', 'j40 broom_bench1 4 0 4 4 2\r\nk50 broom_bench2 5 0 4 4 2\r\nl60 broom_bench3 6 0 4 4 2\r\nj70 broom_bench1 7 0 4 4 2\r\nk80 broom_bench2 8 0 4 4 2\r\nk90 broom_bench2 9 0 4 4 2\r\nl100 broom_bench3 10 0 4 4 2\r\nj110 broom_bench1 11 0 4 4 2\r\nk120 broom_bench2 12 0 4 4 2\r\nk130 broom_bench2 13 0 4 4 2\r\nk140 broom_bench2 14 0 4 4 2\r\nl150 broom_bench3 15 0 4 4 2\r\nj160 broom_bench1 16 0 4 4 2\r\nk170 broom_bench2 17 0 4 4 2\r\nk180 broom_bench2 18 0 4 4 2\r\nl190 broom_bench3 19 0 4 4 2\r\nj200 broom_bench1 20 0 4 4 2\r\nk210 broom_bench2 21 0 4 4 2\r\nl220 broom_bench3 22 0 4 4 2\r\nf73 broom_seatb1 7 3 2 4 2\r\ng83 broom_seatb2 8 3 2 4 2\r\nh93 broom_seatb3 9 3 2 4 2\r\ni103 broom_seatb4 10 3 2 4 2\r\nb163 broom_seat1 16 3 2 4 2\r\nc173 broom_seat2 17 3 2 4 2\r\nd183 broom_seat3 18 3 2 4 2\r\ne193 broom_seat4 19 3 2 4 2\r\nf76 broom_seatb1 7 6 0 4 2\r\ng86 broom_seatb2 8 6 0 4 2\r\nh96 broom_seatb3 9 6 0 4 2\r\ni106 broom_seatb4 10 6 0 4 2\r\nb166 broom_seat1 16 6 0 4 2\r\nc176 broom_seat2 17 6 0 4 2\r\nd186 broom_seat3 18 6 0 4 2\r\ne196 broom_seat4 19 6 0 4 2\r\na1910 broom_chair 19 10 0 4 2\r\na2010 broom_chair 20 10 0 4 2\r\na2110 broom_chair 21 10 0 4 2\r\nn1911 broom_table1 19 11 0 0 1\r\no2011 broom_table2 20 11 0 0 1\r\np2111 broom_table3 21 11 0 0 1\r\na1912 broom_chair 19 12 0 0 2\r\na2012 broom_chair 20 12 0 0 2\r\na2112 broom_chair 21 12 0 0 2\r\na1915 broom_chair 19 15 0 4 2\r\na2015 broom_chair 20 15 0 4 2\r\na2115 broom_chair 21 15 0 4 2\r\nn1916 broom_table1 19 16 0 0 1\r\no2016 broom_table2 20 16 0 0 1\r\np2116 broom_table3 21 16 0 0 1\r\na1917 broom_chair 19 17 0 0 2\r\na2017 broom_chair 20 17 0 0 2\r\na2117 broom_chair 21 17 0 0 2\r\nm920 broom_stool 9 20 1 2 2\r\nm921 broom_stool 9 21 1 2 2\r\nm922 broom_stool 9 22 1 2 2\r\nm923 broom_stool 9 23 1 2 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('74', 'spa', '0', '9', '29', '0', '0', 'xxxxxxxxxx1111xxxxxxx\r\nxxxxxxxxxx11111xxxxxx\r\nxxxxxxxxxx111111xxxxx\r\nxx111111111111111xxxx\r\nx11111111111111111xxx\r\n1111111111111111111xx\r\n11111111111111111111x\r\n111111111111111111111\r\n111111111111111111111\r\n1111111111111x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000x1111111\r\n1111111000000xxx00000\r\n111111100000000000000\r\n111111100000000000000\r\n111111100000000000000\r\n111111100000000xxxxx0\r\n11111110000000xxxxxx0\r\n11111110000000xxxxxx0\r\n11111110000000xxxxxxx\r\nx1111110000000xxxxxxx\r\nxxxxxxxx0000000000xxx\r\nxxxxxxxx000xxxxxxxxxx\r\nxxxxxxxx000xxxxxxxxxx\r\nxxxxxxxx000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx', 'c53 gold_chair 5 3 1 2\r\nt63 gold_table_small1 6 3 1 6\r\nc73 gold_chair 7 3 1 6\r\n5103 gold_bardesk5 10 3 1 0\r\n4113 gold_bardesk4 11 3 1 0\r\n3123 gold_bardesk3 12 3 1 0\r\n2133 gold_bardesk2 13 3 1 0\r\n1143 gold_bardesk1 14 3 1 0\r\nc54 gold_chair 5 4 1 2\r\ny64 gold_table_small2 6 4 1 6\r\nc74 gold_chair 7 4 1 6\r\nc05 gold_chair 0 5 1 2\r\nt15 gold_table_small1 1 5 1 6\r\nc25 gold_chair 2 5 1 6\r\nc06 gold_chair 0 6 1 2\r\ny16 gold_table_small2 1 6 1 6\r\nc26 gold_chair 2 6 1 6\r\nc56 gold_chair 5 6 1 2\r\nt66 gold_table_small1 6 6 1 6\r\nc76 gold_chair 7 6 1 6\r\nc57 gold_chair 5 7 1 2\r\ny67 gold_table_small2 6 7 1 6\r\nc77 gold_chair 7 7 1 6\r\nc08 gold_chair 0 8 1 2\r\nt18 gold_table_small1 1 8 1 6\r\nc28 gold_chair 2 8 1 6\r\nc198 gold_chair 19 8 1 4\r\nc208 gold_chair 20 8 1 4\r\nc09 gold_chair 0 9 1 2\r\ny19 gold_table_small2 1 9 1 6\r\nc29 gold_chair 2 9 1 6\r\nc149 gold_chair 14 9 1 4\r\nc159 gold_chair 15 9 1 4\r\nt1910 gold_table_small1 19 10 1 0\r\ny2010 gold_table_small2 20 10 1 0\r\nt1411 gold_table_small1 14 11 1 0\r\ny1511 gold_table_small2 15 11 1 0\r\np012 gold_plant 0 12 1 0\r\nc112 gold_chair 1 12 1 0\r\nc212 gold_chair 2 12 1 0\r\nc312 gold_chair 3 12 1 0\r\nc1912 gold_chair 19 12 1 0\r\nc2012 gold_chair 20 12 1 0\r\np013 gold_plant 0 13 1 0\r\nc113 gold_chair 1 13 1 4\r\nc213 gold_chair 2 13 1 4\r\nc313 gold_chair 3 13 1 4\r\nc1413 gold_chair 14 13 1 0\r\nc1513 gold_chair 15 13 1 0\r\nc014 gold_chair 0 14 1 2\r\nc1414 gold_chair 14 14 1 4\r\nc1514 gold_chair 15 14 1 4\r\nc015 gold_chair 0 15 1 2\r\nt215 gold_table_small1 2 15 1 0\r\ny315 gold_table_small2 3 15 1 0\r\nc016 gold_chair 0 16 1 2\r\nt1416 gold_table_small1 14 16 1 0\r\ny1516 gold_table_small2 15 16 1 0\r\np017 gold_plant 0 17 1 0\r\nc117 gold_chair 1 17 1 0\r\nc217 gold_chair 2 17 1 0\r\nc317 gold_chair 3 17 1 0\r\np018 gold_plant 0 18 1 0\r\nc118 gold_chair 1 18 1 4\r\nc218 gold_chair 2 18 1 4\r\nc318 gold_chair 3 18 1 4\r\nc1418 gold_chair 14 18 1 0\r\nc1518 gold_chair 15 18 1 0\r\nc019 gold_chair 0 19 1 2\r\nc020 gold_chair 0 20 1 2\r\nt220 gold_table_small1 2 20 1 0\r\ny320 gold_table_small2 3 20 1 0\r\nc021 gold_chair 0 21 1 2\r\np022 gold_plant 0 22 1 0\r\nc122 gold_chair 1 22 1 0\r\nc222 gold_chair 2 22 1 0\r\nc322 gold_chair 3 22 1 0\r\np023 gold_plant 0 23 1 0\r\nc123 gold_chair 1 23 1 4\r\nc223 gold_chair 2 23 1 4\r\nc323 gold_chair 3 23 1 4\r\nc024 gold_chair 0 24 1 2\r\nc025 gold_chair 0 25 1 2\r\nt225 gold_table_small1 2 25 1 0\r\ny325 gold_table_small2 3 25 1 0\r\nc026 gold_chair 0 26 1 2\r\nc127 gold_chair 1 27 1 0\r\nc227 gold_chair 2 27 1 0\r\nc327 gold_chair 3 27 1 0', '1', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('75', 'cafe', '0', '30', '40', '0', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000xxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx00000xx00000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxx0000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxxx000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx0000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx00000000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'd3221 chairup4 32 21 0 3\r\nf3321 chairup6 33 21 0 4\r\nf3421 chairup6 34 21 0 4\r\nf3521 chairup6 35 21 0 4\r\nf3621 chairup6 36 21 0 4\r\ng3721 chairup7 37 21 0 4\r\nb3222 chairup2 32 22 0 2\r\ne2523 chairup5 25 23 0 4\r\nf2623 chairup6 26 23 0 4\r\nf2723 chairup6 27 23 0 4\r\nf2823 chairup6 28 23 0 4\r\ng2923 chairup7 29 23 0 4\r\na3223 chairup1 32 23 0 2\r\nA2424 counter5 24 24 0 7\r\nr2524 table2 25 24 0 7\r\nq2624 table1 26 24 0 7\r\np2425 counter3 24 25 0 7\r\nz2426 counter4 24 26 0 7\r\np2427 counter3 24 27 0 7\r\np2428 counter3 24 28 0 7\r\ny2928 palms4 29 28 0 7\r\np2429 counter3 24 29 0 7\r\nx2929 palms3 29 29 0 7\r\np2430 counter3 24 30 0 7\r\nw2930 palms2 29 30 0 7\r\nn2231 counter1 22 31 0 7\r\nn2331 counter1 23 31 0 7\r\no2431 counter2 24 31 0 7\r\nv2931 palms1 29 31 0 7\r\ne3031 chairup5 30 31 0 4\r\nf3131 chairup6 31 31 0 4\r\nf3231 chairup6 32 31 0 4\r\nf3331 chairup6 33 31 0 4\r\nf3431 chairup6 34 31 0 4\r\nf3531 chairup6 35 31 0 4\r\nf3631 chairup6 36 31 0 4\r\nj3731 chairright3 37 31 0 5\r\nc2132 chairup3 21 32 0 2\r\nt2232 table4 22 32 0 7\r\nr3032 table2 30 32 0 7\r\nq3132 table1 31 32 0 7\r\nr3332 table2 33 32 0 7\r\nq3432 table1 34 32 0 7\r\ni3732 chairright2 37 32 0 6\r\nb2133 chairup2 21 33 0 2\r\ns2233 table3 22 33 0 7\r\ni3733 chairright2 37 33 0 6\r\nb2134 chairup2 21 34 0 2\r\nt3634 table4 36 34 0 7\r\ni3734 chairright2 37 34 0 6\r\nb2135 chairup2 21 35 0 2\r\nr2435 table2 24 35 0 7\r\nq2535 table1 25 35 0 7\r\nr2735 table2 27 35 0 7\r\nq2835 table1 28 35 0 7\r\nu3335 palm 33 35 0 7\r\ns3635 table3 36 35 0 7\r\ni3735 chairright2 37 35 0 6\r\nm2136 chairleft3 21 36 0 1\r\nl2236 chairleft2 22 36 0 0\r\nl2336 chairleft2 23 36 0 0\r\nl2436 chairleft2 24 36 0 0\r\nl2536 chairleft2 25 36 0 0\r\nl2636 chairleft2 26 36 0 0\r\nl2736 chairleft2 27 36 0 0\r\nk2836 chairleft1 28 36 0 0\r\ni3736 chairright2 37 36 0 6\r\nt3637 table4 36 37 0 7\r\ni3737 chairright2 37 37 0 6\r\ns3638 table3 36 38 0 7\r\nh3738 chairright1 37 38 0 6', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('76', 'cinema', '0', '20', '27', '1', '0', 'xxxxxxx1xx11111111xxxxxx\r\nxxx1111111111111111xxxxx\r\nxxx111xxxx1111111111xxxx\r\nxxxx2xxxxxxxxxxxxxxxxxxx\r\nxx3x3x333311xxxxxxxxxx11\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111122111\r\nxx3333333311x22222222111\r\nxx3333333311x22222222111\r\nxx3333333311xxxxxxxxx111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\n333333332111111xxxx11111\r\n333333332111111111111111\r\n333333332111111111111111\r\n333333332111111111111111\r\nxx3333332111111111111111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111', 'C24 orange 2 4 3 0\r\nA74 loungey_chair 7 4 3 2\r\nV84 loungey_tablebigb 8 4 3 0\r\nA94 loungey_chair 9 4 3 6\r\nA25 loungey_chair 2 5 3 4\r\nA75 loungey_chair 7 5 3 2\r\nU85 loungey_tablebiga 8 5 3 0\r\nA95 loungey_chair 9 5 3 6\r\nB26 loungey_table 2 6 3 0\r\nA27 loungey_chair 2 7 3 0\r\nh137 theater_chair 13 7 1 0\r\nh147 theater_chair 14 7 1 0\r\nh157 theater_chair 15 7 1 0\r\nh167 theater_chair 16 7 1 0\r\nh177 theater_chair 17 7 1 0\r\nh187 theater_chair 18 7 1 0\r\nz217 stair 21 7 1 0\r\nL98 lightpole 9 8 3 0\r\nq138 pomomaski 13 8 2 2\r\nq148 pomomaski 14 8 2 0\r\nq158 pomomaski 15 8 2 0\r\nq168 pomomaski 16 8 2 0\r\nq178 pomomaski 17 8 2 0\r\nq188 pomomaski 18 8 2 0\r\nq198 pomomaski 19 8 2 1\r\nz218 stair 21 8 1 0\r\nC29 orange 2 9 3 0\r\nh139 theater_chair 13 9 2 0\r\nh149 theater_chair 14 9 2 0\r\nh159 theater_chair 15 9 2 0\r\nh169 theater_chair 16 9 2 0\r\nh179 theater_chair 17 9 2 0\r\nh189 theater_chair 18 9 2 0\r\nh199 theater_chair 19 9 2 0\r\nh209 theater_chair 20 9 2 0\r\nz219 stair 21 9 1 0\r\nA210 loungey_chair 2 10 3 4\r\nA910 loungey_chair 9 10 3 4\r\nB211 loungey_table 2 11 3 0\r\nB911 loungey_table 9 11 3 0\r\nA212 loungey_chair 2 12 3 0\r\nA912 loungey_chair 9 12 3 0\r\nd1712 cubicb_chair 17 12 1 6\r\nc1912 cubico_chair 19 12 1 2\r\nd1513 cubicb_chair 15 13 1 2\r\nL1913 lightpole 19 13 1 0\r\nd2013 cubicb_chair 20 13 1 6\r\nL914 lightpole 9 14 3 0\r\nA215 loungey_chair 2 15 3 4\r\nd1415 cubicb_chair 14 15 1 4\r\nc1915 cubico_chair 19 15 1 4\r\nB216 loungey_table 2 16 3 0\r\nA716 loungey_chair 7 16 3 2\r\nB816 loungey_table 8 16 3 2\r\nA916 loungey_chair 9 16 3 6\r\nd1316 cubicb_chair 13 16 1 2\r\nd1416 cubicb_chair 14 16 1 6\r\nC1916 orange 19 16 1 0\r\nA217 loungey_chair 2 17 3 0\r\nA717 loungey_chair 7 17 3 2\r\nB817 loungey_table 8 17 3 2\r\nA917 loungey_chair 9 17 3 6\r\nd1917 cubicb_chair 19 17 1 2\r\nC218 orange 2 18 3 0\r\nd1418 cubicb_chair 14 18 1 4\r\nK219 bardesque 2 19 3 0\r\nK220 bardesque 2 20 3 1\r\nb320 bar_chair 3 20 3 6\r\nL920 lightpole 9 20 3 0\r\nd1420 cubicb_chair 14 20 1 0\r\nd1920 cubicb_chair 19 20 1 2\r\nc2020 cubico_chair 20 20 1 6\r\nK221 bardesque 2 21 3 1\r\nb321 bar_chair 3 21 3 6\r\nd1921 cubicb_chair 19 21 1 0\r\nK222 bardesque 2 22 3 1\r\nb322 bar_chair 3 22 3 6\r\nL1622 lightpole 16 22 1 0\r\nc1822 cubico_chair 18 22 1 0\r\nK223 bardesque 2 23 3 1\r\nb323 bar_chair 3 23 3 6\r\nK224 bardesque 2 24 3 1\r\nb324 bar_chair 3 24 3 6\r\nK225 bardesque 2 25 3 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('77', 'den', '0', '3', '22', '0', '0', '00000000xxxxxxxx\r\n0000000000000000\r\n0000000000000000\r\n000000000000xx00\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx', 'l70 crs_lamptable 7 0 0 0\r\ng141 tvtable 14 1 0 2\r\nt02 crs_trash 0 2 0 0\r\ns22 crs_sofag_start 2 2 0 4\r\nm32 crs_sofag_mid 3 2 0 4\r\nm42 crs_sofag_mid 4 2 0 4\r\nS52 crs_sofag_end 5 2 0 4\r\nR124 crs_roundwoodtable 12 4 0 2 2\r\nW154 crs_woodchair 15 4 0 6\r\nW105 crs_woodchair 10 5 0 2\r\nW156 crs_woodchair 15 6 0 6\r\nW77 crs_woodchair 7 7 0 4\r\nW138 crs_woodchair 13 8 0 4\r\nW158 crs_woodchair 15 8 0 4\r\nW59 crs_woodchair 5 9 0 2\r\nF010 crs_fridge 0 10 0 0\r\nV710 ctable2 7 10 0 2\r\nY1310 crs_woodtable_end 13 10 0 1 2\r\ny1410 crs_woodtable_start 14 10 0 2 2\r\nW511 crs_woodchair 5 11 0 2\r\nB112 crs_box 1 12 0 2\r\nB113 crs_box 1 13 0 2\r\nv713 ctable1 7 13 0 2\r\nW1313 crs_woodchair 13 13 0 0\r\nW1513 crs_woodchair 15 13 0 0\r\nB115 crs_box 1 15 0 2\r\nP117 crs_boxopen 1 17 0 2\r\ni1517 crs_stomp 15 17 0 0\r\nB118 crs_box 1 18 0 2\r\ni1518 crs_stomp 15 18 0 0\r\nb119 crs_boxtwo 1 19 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('78', 'gardens', '0', '2', '15', '0', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00xxxxxxxxxxxx\r\nxxxxxxxxxxxxx0x00xxxxxxxxxxx0x000xxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxx000000000000000000000000xxxxxxxxx\r\nxxxxxxxxxxx0000000000000000000000000xxxxxxxx\r\nxxxxxxxxxxx00000000000000000000000000xxxxxxx\r\nxxxxxxxx000000000000000000000000000000xxxxxx\r\nxxxxxxx00000000000000000000000000000000xxxxx\r\nxxxxxxx000000000000000000000000000000000xxxx\r\nxxxxxxx0000000000000000000000000000000000xxx\r\nxxxxxxxxx000000000000000000000000000000000xx\r\n00000000000000000000xx00000000000000000000xx\r\n0000000000000000000xxxx00000000000xxxxxxx0xx\r\n0000000000000000000xxxx00000000000x00000xxxx\r\nxxxxx00x0000000000xxxxx0xxxxxx0000x0000000xx\r\nxxxxx0000000000000xxxxx0xx000x0000x000000xxx\r\nxxxxx0000000000000xxxxx0x000000000x00000xxxx\r\nxxxxx000000x0000000xxxx0x000000000xxx00xxxxx\r\nxxxxxxxx000x0000000xxx00xxx000000x0000xxxxxx\r\nxxxxxxxx000x000000xxxx0x0000000000000xxxxxxx\r\nxxxxxxxx000x000000011100000000000000xxxxxxxx\r\nxxxxxxxx000x00000001110000000000000xxxxxxxxx\r\nxxxxxxxxx00x0000000111x00000000x00xxxxxxxxxx\r\nxxxxxxxxxx0x0000000xxx0000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx000000xxxx0000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx000000xxx00xxxxx00xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxx0xx000x00xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxx0x000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxx0x00000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxxxx00xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxxxx0xxxxxxxxxxxxxxxxxxxx', 'L89 bench2 8 9 0 4\r\nK99 bench 9 9 0 4\r\nL711 bench2 7 11 0 2\r\nK712 bench 7 12 0 2\r\nL3516 bench2 35 16 0 2\r\nL3716 bench2 37 16 0 4\r\nK3816 bench 38 16 0 4\r\nK3517 bench 35 17 0 2\r\nL2718 bench2 27 18 0 4\r\nK2818 bench 28 18 0 4\r\nL3518 bench2 35 18 0 2\r\nL2519 bench2 25 19 0 2\r\nK3519 bench 35 19 0 2\r\nK2520 bench 25 20 0 2\r\nL2529 bench2 25 29 0 4\r\nK2629 bench 26 29 0 4\r\nL2330 bench2 23 30 0 2\r\nK2331 bench 23 31 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('79', 'gate_park', '0', '17', '26', '0', '0', 'xxxxxxxxx222xx222222xxx222xxxxxx\r\nxxxxxxxxx222xx2222222xx222xxxxxx\r\nxxxxxxxxx22222222222222222xxxxxx\r\nxxxxxxxxx22222222222222222xxxxxx\r\nxxxxxxxxx22222222222222222xxxxxx\r\nxxxxxxxxx22222x22222x22222xxxxxx\r\nxxxxxxxxx11111x22222x11111xxxxxx\r\n0000000xx00000x22222x00000xxxxxx\r\n0000000xx00000000000000000xxxxxx\r\n000000000000000000000000000xx00x\r\n000000000000xxx00000xxx00000000x\r\n000000000000xxx00000xxx00000000x\r\n000000000000xxx00000xxx000000000\r\n00000000000000000000000000000000\r\nx0000000000000000000000000000000\r\nxxx00000000000000000000000000000\r\nxxxxx000000000000000000000000000\r\nxxxxx000000000000000000000000000\r\nxxxxx000000000000000000000000xxx\r\nxxxxxx00000000000000000000000xxx\r\nxxxxxxx000000000000000000000xxxx\r\nxxxxxxxxxx00000000000000000xxxxx\r\nxxxxxxxxxx0000000000000000xxxxxx\r\nxxxxxxxxxx000000000000000xxxxxxx\r\nxxxxxxxxxxxxx00000000000xxxxxxxx\r\nxxxxxxxxxxxxxx000000000xxxxxxxxx\r\nxxxxxxxxxxxxxxxx000xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx000xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx000xxxxxxxxxxxxx', 'd155 gate_table1 15 5 2 2 1\r\nd195 gate_table1 19 5 2 6 1\r\ne156 gate_table2 15 6 2 2 1\r\ne196 gate_table2 19 6 2 6 1\r\nd27 gate_table1 2 7 0 4 1\r\ne37 gate_table2 3 7 0 4 1\r\nf47 gate_table3 4 7 0 4 1\r\nf157 gate_table3 15 7 2 2 1\r\nf197 gate_table3 19 7 2 6 1\r\nd210 gate_table1 2 10 0 0 1\r\ne310 gate_table2 3 10 0 0 1\r\nf410 gate_table3 4 10 0 0 1\r\nd211 gate_table1 2 11 0 4 1\r\ne311 gate_table2 3 11 0 4 1\r\nf411 gate_table3 4 11 0 4 1\r\nb2913 gate_drumchair 29 13 0 4 2\r\nb3013 gate_drumchair 30 13 0 4 2\r\nd214 gate_table1 2 14 0 0 1\r\ne314 gate_table2 3 14 0 0 1\r\nf414 gate_table3 4 14 0 0 1\r\nb1214 gate_drumchair 12 14 0 4 2\r\nb1714 gate_drumchair 17 14 0 4 2\r\nb2214 gate_drumchair 22 14 0 4 2\r\nh815 gate_lantern 8 15 0 0 1\r\nb1115 gate_drumchair 11 15 0 2 2\r\nc1215 gate_table 12 15 0 0 1\r\nb1315 gate_drumchair 13 15 0 6 2\r\nb1615 gate_drumchair 16 15 0 2 2\r\nc1715 gate_table 17 15 0 0 1\r\nb1815 gate_drumchair 18 15 0 6 2\r\nb2115 gate_drumchair 21 15 0 2 2\r\nc2215 gate_table 22 15 0 0 1\r\nb2315 gate_drumchair 23 15 0 6 2\r\nh2615 gate_lantern 26 15 0 0 1\r\nb1216 gate_drumchair 12 16 0 0 2\r\nb1716 gate_drumchair 17 16 0 0 2\r\nb2216 gate_drumchair 22 16 0 0 2\r\nb2917 gate_drumchair 29 17 0 0 2\r\nb3017 gate_drumchair 30 17 0 0 2\r\ni1018 gate_rockchair1 10 18 0 2 2\r\ni1418 gate_rockchair1 14 18 0 6 2\r\na2018 gate_trashcan 20 18 0 0 1\r\nk2118 gate_rockchair3 21 18 0 4 2\r\nj2218 gate_rockchair2 22 18 0 4 2\r\ni2318 gate_rockchair1 23 18 0 4 2\r\nj1019 gate_rockchair2 10 19 0 2 2\r\nk1419 gate_rockchair3 14 19 0 6 2\r\nj2019 gate_rockchair2 20 19 0 2 2\r\nk1020 gate_rockchair3 10 20 0 2 2\r\nj1420 gate_rockchair2 14 20 0 6 2\r\nk2020 gate_rockchair3 20 20 0 2 2\r\ni1021 gate_rockchair1 10 21 0 2 2\r\ni2021 gate_rockchair1 20 21 0 2 2\r\ng1022 gate_talltree 10 22 0 0 1\r\ng1023 gate_talltree 10 23 0 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('80', 'square_2', '0', '17', '23', '0', '0', 'xxxxxxxxxxx111111111111xxxxxxxxxxxx\r\nxxxxxxxxxx11111111111111xxxxxxxxxxx\r\nxxxxxxxxxx11111111111111xxxxxxxxxxx\r\nxxxxxxxxxx11xxxx11xxxx11xxxxxxxxxxx\r\nxxxxxxxxxx00xxxx00xxxx00xxxxxxxxxxx\r\nxxxxxxx0000000000000000000xxxxxxxxx\r\nxxxxxx000000000000000000000xxxxxxxx\r\nxxxxx0000000000000000000x000xxxxxxx\r\nxxxx00000000000000000000xx000xxxxxx\r\nxxxx00000000000000000000xxx000xxxxx\r\nxxxx00000000000000000000xxxx00xxxxx\r\n000000000000000000000000000000xxxxx\r\n0000000000000000000000000000000xxxx\r\n000000000000000000000000000000xxxxx\r\n000000000000000000000000000000xxxxx\r\n000000000000000000000000000000xxxxx\r\nxx00000000000000000000000000000000x\r\nxxx000xxxx00000000000000xxxx0000000\r\nxxx0000xxx00000000000000xxx00000000\r\nxxxx0000xx00000000000000xx000000000\r\nxxxxx0000x00000000000000x00000000xx\r\nxxxxxx00000000000000000000000xxxxxx\r\nxxxxxxx00000x000000000000000x0xxxxx\r\nxxxxxxxx0000xxx0000xxx000000xxxxxxx\r\nxxxxxxxxx000xxx0000xxx000000xxxxxxx\r\nxxxxxxxxxxxxxxx0000xxx000000xxxxxxx\r\nxxxxxxxxxxxxxxxx000xxx000000xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxx00000xxxxxxxx', 'd120 gate_table1 12 0 1 4\r\ne130 gate_table2 13 0 1 4\r\nf140 gate_table3 14 0 1 4\r\nd160 gate_table1 16 0 1 4\r\nf170 gate_table3 17 0 1 4\r\nd190 gate_table1 19 0 1 4\r\ne200 gate_table2 20 0 1 4\r\nf210 gate_table3 21 0 1 4\r\ng97 gate_talltree 9 7 0 0\r\nb148 gate_drumchair 14 8 0 4\r\nb198 gate_drumchair 19 8 0 4\r\ng99 gate_talltree 9 9 0 0\r\nb139 gate_drumchair 13 9 0 2\r\nc149 gate_table 14 9 0 0\r\nb159 gate_drumchair 15 9 0 6\r\nb189 gate_drumchair 18 9 0 2\r\nc199 gate_table 19 9 0 0\r\nb209 gate_drumchair 20 9 0 6\r\ng610 gate_talltree 6 10 0 0\r\ng810 gate_talltree 8 10 0 0\r\nb1410 gate_drumchair 14 10 0 0\r\nb1910 gate_drumchair 19 10 0 0\r\nk611 gate_rockchair3 6 11 0 2\r\nj811 gate_rockchair2 8 11 0 6\r\nb112 gate_drumchair 1 12 0 4\r\nb212 gate_drumchair 2 12 0 4\r\ni612 gate_rockchair1 6 12 0 2\r\ng2712 gate_talltree 27 12 0 0\r\ng3012 gate_talltree 30 12 0 0\r\nb114 gate_drumchair 1 14 0 0\r\nb214 gate_drumchair 2 14 0 0\r\ni615 gate_rockchair1 6 15 0 2\r\na2715 gate_trashcan 27 15 0 0\r\nj616 gate_rockchair2 6 16 0 2\r\nk816 gate_rockchair3 8 16 0 6\r\nd3116 gate_table1 31 16 0 4\r\nf3216 gate_table3 32 16 0 4\r\nb1417 gate_drumchair 14 17 0 4\r\nb1917 gate_drumchair 19 17 0 4\r\nb1318 gate_drumchair 13 18 0 2\r\nc1418 gate_table 14 18 0 0\r\nb1518 gate_drumchair 15 18 0 6\r\nb1818 gate_drumchair 18 18 0 2\r\nc1918 gate_table 19 18 0 0\r\nb2018 gate_drumchair 20 18 0 6\r\nb1419 gate_drumchair 14 19 0 0\r\nb1919 gate_drumchair 19 19 0 0\r\nd3119 gate_table1 31 19 0 0\r\nf3219 gate_table3 32 19 0 0\r\nh2922 gate_lantern 29 22 0 0\r\na823 gate_trashcan 8 23 0 0\r\nd2324 gate_table1 23 24 0 2\r\nd2624 gate_table1 26 24 0 6\r\nf2325 gate_table3 23 25 0 2\r\nf2625 gate_table3 26 25 0 6', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('81', 'rumble', '0', '1', '5', '7', '0', 'xxxxxxxx77xxxxxxxxxxxxxxxx\r\nxxxxxxxx77xxxxxxxxxxxxxxxx\r\nxxxxxx77777x77xxxxxxxxxxxx\r\nxxx77777777777xxx44xxxxxxx\r\n77777777777777xx444444444x\r\n777777777777777xx44444444x\r\nxxx777777777777xx44444444x\r\nxxxx7777777777xxx44444444x\r\n7777777777777777744448444x\r\n7777777777777x4x744448444x\r\n777777777777x444444448444x\r\n7777777777774444444448444x\r\n7777777777774444444448444x\r\n777777777777x444444448444x\r\n7777777777777x44444448444x\r\nxxx777777777777x444448444x\r\nxxx7777777777777444448444x\r\nxxx7777777777777444448444x\r\nxxx777777777777x444448444x\r\nxxx77777777777x4444444444x\r\nxxxx777777777444444444444x\r\nxxxxxxxxxxxxxxxxxxxxxxxxxx', 'A43 mntdwchair 4 3 7 4\r\nA53 mntdwchair 5 3 7 4\r\nM28 barmask 2 8 7 0\r\ns78 mntdwsofa2 7 8 7 2\r\nt88 mntdwtable2 8 8 7 0\r\ns98 mntdwsofa2 9 8 7 6\r\ny218 paalu5 21 8 8 0\r\nM29 barmask 2 9 7 0\r\nS79 mntdwsofa1 7 9 7 2\r\nT89 mntdwtable1 8 9 7 0\r\nS99 mntdwsofa1 9 9 7 6\r\ny219 paalu5 21 9 8 0\r\nM210 barmask 2 10 7 0\r\ny2110 paalu5 21 10 8 0\r\nM211 barmask 2 11 7 0\r\ny2111 paalu5 21 11 8 0\r\nM212 barmask 2 12 7 0\r\ns712 mntdwsofa2 7 12 7 4\r\nS812 mntdwsofa1 8 12 7 4\r\ne2112 paalu3 21 12 8 0\r\nM213 barmask 2 13 7 0\r\nt713 mntdwtable2 7 13 7 2\r\nT813 mntdwtable1 8 13 7 2\r\ne2113 paalu3 21 13 8 0\r\nM214 barmask 2 14 7 0\r\ns714 mntdwsofa2 7 14 7 0\r\nS814 mntdwsofa1 8 14 7 0\r\ne2114 paalu3 21 14 8 0\r\nM215 barmask 2 15 100000 0\r\nq2115 paalu1 21 15 8 0\r\nM216 barmask 2 16 100000 0\r\ns1216 mntdwsofa2 12 16 7 4\r\nS1316 mntdwsofa1 13 16 7 4\r\nq2116 paalu1 21 16 8 0\r\nA317 mntdwchair 3 17 7 2\r\ns617 mntdwsofa2 6 17 7 2\r\nt717 mntdwtable2 7 17 7 0\r\ns817 mntdwsofa2 8 17 7 6\r\nt1217 mntdwtable2 12 17 7 2\r\nT1317 mntdwtable1 13 17 7 2\r\nq2117 paalu1 21 17 8 0\r\nA318 mntdwchair 3 18 7 2\r\nS618 mntdwsofa1 6 18 7 2\r\nT718 mntdwtable1 7 18 7 0\r\nS818 mntdwsofa1 8 18 7 6\r\ns1218 mntdwsofa2 12 18 7 0\r\nS1318 mntdwsofa1 13 18 7 0\r\nq2118 paalu1 21 18 8 0', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('82', 'sun_terrace', '0', '9', '17', '0', '0', 'xxxxxx21000000000xxxxxxxx\r\nxxxxxx3xxx000xx000xxxxxxx\r\nxxxxxx4xxx000xxx000xxxxxx\r\nxxxxxx44xx000x00x000xxxxx\r\nxxxxxx44xx0000xx00000xxxx\r\nxxxxxx44xx000000000000xxx\r\nxxxxxx44xx0000000000000xx\r\nxxxxxxx4xxxxxxx00000000xx\r\nxxxxxxx4xxxxxxx0000000xxx\r\nxxxxxx444432222xxx00xxxxx\r\nxxxxxx444432222x0000000xx\r\nxxxxxx444432222x0000000xx\r\nxxxxxx44400x222x0000000xx\r\nxxxxxx444000x11x0000000xx\r\nxxxxxx444000000x0000000xx\r\nxxxxxx444000000x0000000xx\r\nxxxxxx440000000000000000x\r\nxxxxxx4400000000000000000\r\nx8876x444000000x000000000\r\nx8xx6x444000000x000000000\r\nx9xx6x444000000x000000000\r\n999x65444000000x000000000\r\n999xxx444xxxxxxxxxx000000\r\n999xxx444xxxxxxxxxxx00000\r\n999xxx333xxxxxxxxxxxx0000\r\n999xxx222222222222222x000\r\nxxxxxx222222222222222xx00\r\nxxxxxx222222222222222xxx0\r\nxxxxxx222222222222222xxxx\r\nxxxxxxx22222222222222xxxx\r\nxxxxxxxx2222222222222xxxx\r\n', 'a1611 sun_chair 16 11 0 2 2\r\na2011 sun_chair 20 11 0 2 2\r\na1612 sun_chair 16 12 0 2 2\r\na2012 sun_chair 20 12 0 2 2\r\nb1013 blusun_chair 10 13 0 4 2\r\na1613 sun_chair 16 13 0 2 2\r\na2013 sun_chair 20 13 0 2 2\r\nc1014 sun_table 10 14 0 0 1\r\na2014 sun_chair 20 14 0 2 2\r\nb1015 blusun_chair 10 15 0 0 2\r\na118 sun_chair 1 18 8 2 2\r\na418 sun_chair 4 18 6 2 2\r\nb1118 blusun_chair 11 18 0 4 2\r\nb1019 blusun_chair 10 19 0 2 2\r\nc1119 sun_table 11 19 0 0 1\r\nb1219 blusun_chair 12 19 0 6 2\r\na1819 sun_chair 18 19 0 2 2\r\na2219 sun_chair 22 19 0 2 2\r\nb1120 blusun_chair 11 20 0 0 2\r\na1820 sun_chair 18 20 0 2 2\r\na2220 sun_chair 22 20 0 2 2\r\na421 sun_chair 4 21 6 2 2\r\na621 sun_chair 6 21 4 2 2\r\na1821 sun_chair 18 21 0 2 2\r\na2221 sun_chair 22 21 0 2 2\r\nb222 blusun_chair 2 22 9 4 2\r\na2222 sun_chair 22 22 0 2 2\r\nb123 blusun_chair 1 23 9 2 2\r\nd223 sun_table2 2 23 9 0 1\r\nb224 blusun_chair 2 24 9 0 2\r\na1125 sun_chair 11 25 2 4 2\r\na1225 sun_chair 12 25 2 4 2\r\na1325 sun_chair 13 25 2 4 2\r\nc1425 sun_table 14 25 2 0 1\r\na1525 sun_chair 15 25 2 4 2\r\na1625 sun_chair 16 25 2 4 2\r\na1725 sun_chair 17 25 2 4 2\r\na1329 sun_chair 13 29 2 2 2\r\na1529 sun_chair 15 29 2 2 2\r\na1729 sun_chair 17 29 2 2 2\r\na1330 sun_chair 13 30 2 2 2\r\na1530 sun_chair 15 30 2 2 2\r\na1730 sun_chair 17 30 2 2 2 ', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('83', 'space_cafe', '0', '21', '17', '1', '0', 'x3333x333211111xxxxxxxxx\r\nx3333x333211111xx3333333\r\nxxxxxx333211111xx3333333\r\n33333333xx11111xx3333333\r\n33333333xx11111xx3333333\r\n33x333xxxx11111xx3333333\r\nxxx222xxx111111xx3333333\r\n22222222xx11111xx3333333\r\n22222222xxx1111xx3333333\r\n22222222xxxx1111x2222222\r\n22222222xxxx1111x1111111\r\n22222222xxxx111111111111\r\n22222222xxxx111111111111\r\nxxx222xxxxx1111111111111\r\nxxxx33xxxx11111111111111\r\nxxx333321111111111111111\r\nxxx333321111111111111111\r\nxxx333321111111111111111\r\nxxxxxxxxxxxxx1111xxxx11x\r\nxxxxxxxxxxxxx0000xxxx11x\r\nxxxxxxxxxx0000000xxxx11x\r\nxxxxxxxxxx0000000xxxxxxx\r\nxxxxxxxxxx0000000xxxxxxx\r\nxxxxxxxxxx0000000xxxxxxx\r\nxxxxxxxxxx0000000xxxxxxx\r\nxxxxxxxxxx0000000xxxxxxx\r\n', 'a191 space_stool 19 1 3 4 2\r\na231 space_stool 23 1 3 4 2\r\na182 space_stool 18 2 3 2 2\r\nf192 smalltable 19 2 3 0 1\r\na202 space_stool 20 2 3 6 2\r\na222 space_stool 22 2 3 2 2\r\nf232 smalltable 23 2 3 0 1\r\na193 space_stool 19 3 3 0 2\r\na233 space_stool 23 3 3 0 2\r\na175 space_stool 17 5 3 4 2\r\na215 space_stool 21 5 3 4 2\r\nf176 smalltable 17 6 3 0 1\r\na186 space_stool 18 6 3 6 2\r\na206 space_stool 20 6 3 2 2\r\nf216 smalltable 21 6 3 0 1\r\na226 space_stool 22 6 3 6 2\r\na177 space_stool 17 7 3 0 2\r\na217 space_stool 21 7 3 0 2\r\nb08 bluesofab 0 8 2 4 2\r\nc18 bluesofaa 1 8 2 4 2\r\nd68 redsofab 6 8 2 4 2\r\ne78 redsofaa 7 8 2 4 2\r\ni09 bigtabled 0 9 2 0 1\r\nj19 bigtablec 1 9 2 0 1\r\nb29 bluesofab 2 9 2 6 2\r\nd59 redsofab 5 9 2 2 2\r\ni69 bigtabled 6 9 2 0 1\r\nj79 bigtablec 7 9 2 0 1\r\nk010 bigtableb 0 10 2 0 1\r\nl110 bigtablea 1 10 2 0 1\r\nc210 bluesofaa 2 10 2 6 2\r\ne510 redsofaa 5 10 2 2 2\r\nk610 bigtableb 6 10 2 0 1\r\nl710 bigtablea 7 10 2 0 1\r\nb011 bluesofab 0 11 2 0 2\r\nc111 bluesofaa 1 11 2 0 2\r\nd611 redsofab 6 11 2 0 2\r\ne711 redsofaa 7 11 2 0 2\r\nd1813 redsofab 18 13 1 2 2\r\ng1913 midtableb 19 13 1 6 1\r\nd2013 redsofab 20 13 1 6 2\r\ne1814 redsofaa 18 14 1 2 2\r\nh1914 midtablea 19 14 1 6 1\r\ne2014 redsofaa 20 14 1 6 2\r\na315 space_stool 3 15 3 2 2\r\nf316 smalltable 3 16 3 0 1\r\na317 space_stool 3 17 3 2 2\r\nd1021 redsofab 10 21 0 2 2\r\ne1022 redsofaa 10 22 0 2 2\r\nb1322 bluesofab 13 22 0 4 2\r\nc1422 bluesofaa 14 22 0 4 2\r\nf1023 smalltable 10 23 0 0 1\r\ng1323 midtableb 13 23 0 0 1\r\nh1423 midtablea 14 23 0 0 1\r\nd1024 redsofab 10 24 0 2 2\r\nb1324 bluesofab 13 24 0 0 2\r\nc1424 bluesofaa 14 24 0 0 2\r\ne1025 redsofaa 10 25 0 2 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('84', 'beauty_salon0', '0', '4', '3', '0', '0', 'xxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxx0000000000000xxxxxxxx\r\nxxx00000000000000xxxxxxx\r\nxxxxxx000000000000xxxxxx\r\nxxxxxxxxxxxxx0000xxxxxxx\r\nxxxx0x0000x00000000xxxxx\r\nxxx00xxxxxx0000000xxxxxx\r\nxx000x000xx0000000xxxxxx\r\nxx000xxxxx00000000xxxxxx\r\nxx000x000000000000xxxxxx\r\nxx000x000000000000xxxxxx\r\nxx00xx000000000000xxxxxx\r\nxx00xx00x0000000000xxxxx\r\nxx00xx00x0000000000xxxxx\r\nxx00xx0000000000000xxxxx\r\nxx00xx0000000000000xxxxx\r\nxx000x0xx0000000000xxxxx\r\nxx000x0x00000000000xxxxx\r\nxx000x0x00x00000000xxxxx\r\nxx000x0x00000000000xxxxx\r\nxx000x0x00x00000000xxxxx\r\nxx000xx000000000000xxxxx\r\nxx00000000000000000000xx\r\nxx00000000000000000000xx\r\nxxxxxx0000000000000000xx \r\n', 'd116 pinkchair 11 6 0 6 2\r\nd117 pinkchair 11 7 0 6 2\r\nd38 pinkchair 3 8 0 4 2\r\nd610 pinkchair 6 10 0 0 2\r\nd710 pinkchair 7 10 0 0 2\r\nd810 pinkchair 8 10 0 0 2\r\nd411 pinkchair 4 11 0 4 2\r\ni913 directorchair 9 13 0 4 2\r\ni1613 directorchair 16 13 0 2 2\r\ni1813 directorchair 18 13 0 4 2\r\ni1614 directorchair 16 14 0 2 2\r\ne1316 longchair1 13 16 0 4 2\r\nf1416 longchair2 14 16 0 4 2\r\nf1516 longchair2 15 16 0 4 2\r\ng1616 longchair3 16 16 0 4 2\r\nb217 table2 2 17 0 2 1\r\ne1217 longchair1 12 17 0 2 2\r\ne1717 longchair1 17 17 0 6 2\r\nb218 table2 2 18 0 2 1\r\nb818 table2 8 18 0 2 1\r\nf1218 longchair2 12 18 0 2 2\r\nf1718 longchair2 17 18 0 6 2\r\nb219 table2 2 19 0 2 1\r\nb819 table2 8 19 0 2 1\r\nf1219 longchair2 12 19 0 2 2\r\nf1719 longchair2 17 19 0 6 2\r\nb220 table2 2 20 0 2 1\r\nb820 table2 8 20 0 2 1\r\ng1220 longchair3 12 20 0 2 2\r\ng1720 longchair3 17 20 0 6 2\r\nb821 table2 8 21 0 2 1\r\ne1321 longchair1 13 21 0 0 2\r\nf1421 longchair2 14 21 0 0 2\r\nf1521 longchair2 15 21 0 0 2\r\ng1621 longchair3 16 21 0 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('85', 'chill', '0', '22', '22', '0', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx00xxxxxxxx\r\nxxxxxxxxxxx000000xxxxxxxx\r\nxxxxxxxxxxx000000xxxxxxxx\r\nxxxxxxxxxxxxxx000xxxxxxxx\r\nxxxxxxxxxxxxxxxx0xxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxx\r\nxxxxxxxx000000xxxxxxxxxxx\r\nxxxxxxxx000000xxxxxxxxxxx\r\nxxxxxxxx000000xxxxxxxxxxx\r\nxxxxxxxx000000xxxxxxxxxxx\r\nxxxxxxxx000000xxxxxxxxxxx\r\nxxxxxxxx0000000xxxxxxxxxx\r\nxxxxxxxx00000000xxxxxxxxx\r\nxxxxxxxx0000000000xxxxxxx\r\nxxxxxxxx0000000000xxxxxxx\r\nxxxxxxxx0000000000xxxxxxx\r\nxxxxxxxx0000000000xxxxxxx\r\nxx000000000000xxxxxxxxxxx\r\nxx000000000000000000000xx\r\nxx000000000000000000000xx\r\nxx000000000xx0000000000xx\r\nxx000000000xxxxx000000000\r\nxx000000000xxx0x000000000\r\nxx00000x000xxx0x000000000\r\nxx000000000xxxxx0000000xx\r\nxx000000000000000000000xx\r\nxx000000000000000000000xx\r\nxx000000000000000000000xx\r\nxx000000000000xxxxxxxxxxx\r\n', 'f113 stone 11 3 0 4 2\r\nf97 stone 9 7 0 4 2\r\nf137 stone 13 7 0 4 2\r\nf88 stone 8 8 0 2 2\r\nf138 stone 13 8 0 2 2\r\nf1310 stone 13 10 0 2 2\r\nf1413 stone 14 13 0 2 2\r\nf1514 stone 15 14 0 0 2\r\nf1715 stone 17 15 0 0 2\r\ne1319 jap_stool 13 19 0 4 2\r\nd420 jap_chair 4 20 0 2 2\r\na520 jap_table 5 20 0 2 1\r\nd620 jap_chair 6 20 0 6 2\r\nd421 jap_chair 4 21 0 2 2\r\nc521 jap_table3 5 21 0 2 1\r\nd621 jap_chair 6 21 0 6 2\r\nd324 jap_chair 3 24 0 4 2\r\nd424 jap_chair 4 24 0 4 2\r\nd524 jap_chair 5 24 0 4 2\r\ne1624 jap_stool 16 24 0 6 2\r\na325 jap_table 3 25 0 0 1\r\nb425 jap_table2 4 25 0 0 1\r\nc525 jap_table3 5 25 0 0 1\r\ne1625 jap_stool 16 25 0 6 2\r\nd326 jap_chair 3 26 0 0 2\r\nd426 jap_chair 4 26 0 0 2\r\nd526 jap_chair 5 26 0 0 2\r\ne1626 jap_stool 16 26 0 6 2\r\nd329 jap_chair 3 29 0 4 2\r\nd429 jap_chair 4 29 0 4 2\r\na330 jap_table 3 30 0 0 1\r\nc430 jap_table3 4 30 0 0 1\r\nd530 jap_chair 5 30 0 6 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('86', 'dusty_lounge', '0', '14', '1', '2', '0', 'xxxxxxxxxxxxxx22xxxxxxxxxxxxx\r\nxxxxxxxxxx222x222x2xxxxxxxxxx\r\nxxxxxxx33322222222223xxxxxxx3\r\nxxxxxxx33322222222223xxxxxxx3\r\nxxxxxxx33322222222223x33333x3\r\nxxxxxxx33322222222223x33333x3\r\nxx111xx33322222222223xxxxxxx3\r\nxx111xxx332222222222333333333\r\nxx111xxxx32222222222333333333\r\nxx111xxxxxx222222222333333333\r\nxx111xxxxxxx1111111x333333333\r\nxx111xxxxxxx1111111x222222222\r\nxx111xxxxxx111111111111111111\r\nxx111xxxxxx111111111111111111\r\n11111xxxxxx111111111111111111\r\n11111xxxxxx111111111111111111\r\n11x11xxxxxx111111111111111111\r\n11xxxxxxxxx11111111111111111x\r\nx11xxxxxxxxx1111111x1111111xx\r\nxx11xxxxxxx111111111111111xxx\r\nxxx11xxxxxx11111111111111xxxx\r\nxxxx11111111111111111111xxxxx\r\nxxxxx11111111111111xxxxxxxxxx\r\nxxxxxxxxxxx11111111xxxxxxxxxx\r\nxxxxxxxxxxx11111111xxxxxxxxxx\r\n', 'c84 greenchair2 8 4 3 4 2\r\nd94 greenchair1 9 4 3 4 2\r\nc86 greenchair2 8 6 3 0 2\r\nd96 greenchair1 9 6 3 0 2\r\na206 dustylamp 20 6 3 2 1\r\na286 dustylamp 28 6 3 2 1\r\nc37 greenchair2 3 7 1 4 2\r\nd47 greenchair1 4 7 1 4 2\r\nc39 greenchair2 3 9 1 0 2\r\nd49 greenchair1 4 9 1 0 2\r\nb2110 yellowchair 21 10 3 2 2\r\nb2310 yellowchair 23 10 3 6 2\r\nb2610 yellowchair 26 10 3 2 2\r\nb2810 yellowchair 28 10 3 6 2\r\nc1112 greenchair2 11 12 1 2 2\r\nc313 greenchair2 3 13 1 4 2\r\nd413 greenchair1 4 13 1 4 2\r\nd1113 greenchair1 11 13 1 2 2\r\na1114 dustylamp 11 14 1 2 1\r\nc315 greenchair2 3 15 1 0 2\r\nd415 greenchair1 4 15 1 0 2\r\nc1115 greenchair2 11 15 1 2 2\r\nb2415 yellowchair 24 15 1 4 2\r\nd1116 greenchair1 11 16 1 2 2\r\nb2217 yellowchair 22 17 1 2 2\r\na2417 dustylamp 24 17 1 2 1\r\nb2617 yellowchair 26 17 1 6 2\r\na1119 dustylamp 11 19 1 2 1\r\nb2419 yellowchair 24 19 1 0 2\r\nc1223 greenchair2 12 23 1 2 2\r\nc1423 greenchair2 14 23 1 6 2\r\nd1224 greenchair1 12 24 1 2 2\r\nd1424 greenchair1 14 24 1 6 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('87', 'cr_staff', '0', '3', '22', '0', '0', '00000000xxxxxxxx\r\n0000000000000000\r\n0000000000000000\r\n000000000000xx00\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx\r\n', 'l70 crs_lamptable 7 0 0 0 1\r\ng141 tvtable 14 1 0 2 1\r\nt02 crs_trash 0 2 0 0 1\r\ns22 crs_sofag_start 2 2 0 4 2\r\nm32 crs_sofag_mid 3 2 0 4 2\r\nm42 crs_sofag_mid 4 2 0 4 2\r\nS52 crs_sofag_end 5 2 0 4 2\r\nR124 crs_roundwoodtable 12 4 0 2 2 1\r\nW154 crs_woodchair 15 4 0 6 2\r\nW105 crs_woodchair 10 5 0 2 2\r\nW156 crs_woodchair 15 6 0 6 2\r\nW77 crs_woodchair 7 7 0 4 2\r\nW138 crs_woodchair 13 8 0 4 2\r\nW158 crs_woodchair 15 8 0 4 2\r\nW59 crs_woodchair 5 9 0 2 2\r\nF010 crs_fridge 0 10 0 0 1\r\nV710 ctable2 7 10 0 2 1\r\nY1310 crs_woodtable_end 13 10 0 1 2 1\r\ny1410 crs_woodtable_start 14 10 0 2 2 1\r\nW511 crs_woodchair 5 11 0 2 2\r\nB112 crs_box 1 12 0 2 1\r\nB113 crs_box 1 13 0 2 1\r\nv713 ctable1 7 13 0 2 1\r\nW1313 crs_woodchair 13 13 0 0 2\r\nW1513 crs_woodchair 15 13 0 0 2\r\nB115 crs_box 1 15 0 2 1\r\nP117 crs_boxopen 1 17 0 2 1\r\ni1517 crs_stomp 15 17 0 0 1\r\nB118 crs_box 1 18 0 2 1\r\ni1518 crs_stomp 15 18 0 0 1\r\nb119 crs_boxtwo 1 19 0 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('88', 'rooftop', '0', '17', '12', '4', '0', '44xxxxxxxxxxxxxxxxxx\r\n444xxxxxxxxxxx444444\r\n4444xxxxxxxxxx444444\r\n44444xxxx4xxxx444444\r\n444444xxx44xxx444444\r\n44444444444444444444\r\n44444444444444444444\r\n44444444444444444444\r\n44444444xx44xx44xx44\r\n44444444xx44xx44xx44\r\n44444444444444444444\r\n44444444444444444444\r\n44444444444444444444\r\nx444444x444444xx4444\r\nx444444x444444xx333x\r\nx444444x444444xx222x\r\nx444444x444444xx11xx\r\nx444444x444444xxxxxx\r\n', 'a01 rooftop_minichair 0 1 4 4 2\r\nd161 rooftop_flatcurb 16 1 4 4 2\r\ne171 rooftop_flatcurb2 17 1 4 4 2\r\nc02 rooftop_rodtable 0 2 4 0 1\r\na12 rooftop_minichair 1 2 4 6 2\r\na03 rooftop_minichair 0 3 4 0 2\r\nd164 rooftop_flatcurb 16 4 4 0 2\r\ne174 rooftop_flatcurb2 17 4 4 0 2\r\na26 rooftop_minichair 2 6 4 4 2\r\na17 rooftop_minichair 1 7 4 2 2\r\nc27 rooftop_rodtable 2 7 4 0 1\r\na37 rooftop_minichair 3 7 4 6 2\r\na28 rooftop_minichair 2 8 4 0 2\r\na09 rooftop_minichair 0 9 4 4 2\r\nb010 rooftop_emptytable 0 10 4 0 1\r\na011 rooftop_minichair 0 11 4 0 2\r\nd113 rooftop_flatcurb 1 13 4 2 2\r\nd613 rooftop_flatcurb 6 13 4 6 2\r\nd813 rooftop_flatcurb 8 13 4 2 2\r\nd1313 rooftop_flatcurb 13 13 4 6 2\r\nf114 rooftop_flatcurb3 1 14 4 2 2\r\nf614 rooftop_flatcurb3 6 14 4 6 2\r\nf814 rooftop_flatcurb3 8 14 4 2 2\r\nf1314 rooftop_flatcurb3 13 14 4 6 2\r\nf115 rooftop_flatcurb3 1 15 4 2 2\r\nf615 rooftop_flatcurb3 6 15 4 6 2\r\nf815 rooftop_flatcurb3 8 15 4 2 2\r\nf1315 rooftop_flatcurb3 13 15 4 6 2\r\nf116 rooftop_flatcurb3 1 16 4 2 2\r\nf616 rooftop_flatcurb3 6 16 4 6 2\r\nf816 rooftop_flatcurb3 8 16 4 2 2\r\nf1316 rooftop_flatcurb3 13 16 4 6 2\r\ng117 rooftop_flatcurb4 1 17 4 0 2\r\nf217 rooftop_flatcurb3 2 17 4 0 2\r\nf317 rooftop_flatcurb3 3 17 4 0 2\r\nf417 rooftop_flatcurb3 4 17 4 0 2\r\nf517 rooftop_flatcurb3 5 17 4 0 2\r\nh617 rooftop_flatcurb5 6 17 4 0 2\r\ng817 rooftop_flatcurb4 8 17 4 0 2\r\nf917 rooftop_flatcurb3 9 17 4 0 2\r\nf1017 rooftop_flatcurb3 10 17 4 0 2\r\nf1117 rooftop_flatcurb3 11 17 4 0 2\r\nf1217 rooftop_flatcurb3 12 17 4 0 2\r\nh1317 rooftop_flatcurb5 13 17 4 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('89', 'rooftop_2', '0', '4', '9', '0', '0', 'x0000x000\r\nxxxxxx000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\nxxx000xxx\r\nxxx000xxx\r\n', 'k80 rooftop_bigchair 8 0 0 4 2\r\nl81 rooftop_bigtable 8 1 0 0 1\r\nj02 rooftop_sofab 0 2 0 4 2\r\ni12 rooftop_sofa 1 2 0 4 2\r\nk82 rooftop_bigchair 8 2 0 0 2\r\nk83 rooftop_bigchair 8 3 0 4 2\r\nl84 rooftop_bigtable 8 4 0 0 1\r\nj05 rooftop_sofab 0 5 0 0 2\r\ni15 rooftop_sofa 1 5 0 0 2\r\nk85 rooftop_bigchair 8 5 0 0 2\r\nj06 rooftop_sofab 0 6 0 4 2\r\ni16 rooftop_sofa 1 6 0 4 2\r\nj76 rooftop_sofab 7 6 0 4 2\r\ni86 rooftop_sofa 8 6 0 4 2\r\nj09 rooftop_sofab 0 9 0 0 2\r\ni19 rooftop_sofa 1 9 0 0 2\r\nj79 rooftop_sofab 7 9 0 0 2\r\ni89 rooftop_sofa 8 9 0 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('90', 'tearoom', '0', '21', '19', '1', '0', 'xxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxx3333x33333333x\r\n333333xx3333x33333333x\r\n3333333x3333x33333333x\r\n3333333x3333x33333333x\r\n3333333xxxxxx33333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333111x333333333x\r\n33333333111x333333333x\r\n33333333111x333333333x\r\nxxxxxxxx111xxxxxxxxxxx\r\n11111111111111111111xx\r\n1111111111111111111111\r\n1111111111111111111111\r\n11111111111111111111xx\r\n', 'h131 hardwoodsofa1 13 1 3 4 2\r\ni141 hardwoodsofa2 14 1 3 4 2 \r\nj151 hardwoodsofa3 15 1 3 4 2\r\nc161 teabamboo 16 1 3 0 1\r\nh181 hardwoodsofa1 18 1 3 4 2\r\ni191 hardwoodsofa2 19 1 3 4 2\r\nj201 hardwoodsofa3 20 1 3 4 2\r\nl133 teasmalltable1 13 3 3 0 1\r\nk153 teasmalltable2 15 3 3 0 1\r\nl183 teasmalltable1 18 3 3 0 1\r\nk203 teasmalltable2 20 3 3 0 1\r\ne26 teastool 2 6 3 4 2\r\ne36 teastool 3 6 3 4 2\r\nf86 chinastoolred 8 6 3 4 2\r\nf96 chinastoolred 9 6 3 4 2\r\nf106 chinastoolred 10 6 3 4 2\r\nf116 chinastoolred 11 6 3 4 2\r\na28 teatable1 2 8 3 0 1\r\nb38 teatable2 3 8 3 0 1\r\nm29 teastool2 2 9 3 0 2\r\nm39 teastool2 3 9 3 0 2\r\ne169 teastool 16 9 3 4 2\r\ne179 teastool 17 9 3 4 2\r\na1611 teatable1 16 11 3 0 1\r\nb1711 teatable2 17 11 3 0 1\r\ne212 teastool 2 12 3 4 2\r\ne312 teastool 3 12 3 4 2\r\nm1612 teastool2 16 12 3 0 2\r\nm1712 teastool2 17 12 3 0 2\r\na214 teatable1 2 14 3 0 1\r\nb314 teatable2 3 14 3 0 1\r\nm215 teastool2 2 15 3 0 2\r\nm315 teastool2 3 15 3 0 2\r\nd018 teavase 0 18 1 0 1 \r\ng019 chinastoolgreen 0 19 1 2 2\r\ng020 chinastoolgreen 0 20 1 2 2\r\nd021 teavase 0 21 1 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('91', 'taivas_cafe', '0', '14', '29', '0', '0', 'XXXXXXXXXXXXX111111X\r\nXXXXXXXXXXXXX1111111\r\nXXXXXXXXXXXXX1111111\r\nXXXXXXXXXXXXX1111111\r\nXXXXXXXXXXXXX1111111\r\nXXX11111111111111111\r\nXXX11111111111111111\r\nXX111111111111111111\r\nXX111111111111111111\r\nXX111111111111111111\r\nXXX11111111111111111\r\n111111111XXXXXXX1111\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\n111111111X0000000000\r\nX11111111X0000000000\r\nXX1111111X0000000000\r\nXXX111111X0000000000\r\nXXXX11111X0000000000\r\nXXXXX111110000000000\r\nXXXXXX11110000000000\r\nXXXXXXX1110000000000\r\nXXXXXXXX11000000000X\r\nXXXXXXXXXX00000000XX\r\nXXXXXXXXXXXXXX00XXXX\r\nXXXXXXXXXXXXXX00XXXX\r\n', 'W150 cafe_table_largeb 15 0 1 0 1\r\nc141 cafe_chair 14 1 1 2 2\r\nc171 cafe_chair 17 1 1 6 2\r\nc142 cafe_chair 14 2 1 2 2\r\nV152 cafe_table_largea 15 2 1 0 1\r\nc172 cafe_chair 17 2 1 6 2\r\ny134 plant_yucca 13 4 1 0 1\r\nq45 cafe_desk5 4 5 1 0 1\r\nf55 plant_ftree 5 5 1 0 1\r\nc85 cafe_chair 8 5 1 2 2\r\nc115 cafe_chair 11 5 1 6 2\r\no46 cafe_desk4 4 6 1 0 1\r\nb56 cafe_barchair 5 6 1 6 2\r\nc86 cafe_chair 8 6 1 2 2\r\nm106 cafe_table_mid 10 6 1 0 1\r\nc116 cafe_chair 11 6 1 6 2\r\no47 cafe_desk4 4 7 1 0 1\r\nb57 cafe_barchair 5 7 1 6 2\r\no48 cafe_desk4 4 8 1 0 1\r\no49 cafe_desk4 4 9 1 0 1\r\no410 cafe_desk4 4 10 1 0 1\r\nc1210 cafe_chair 12 10 1 2 2\r\nt1310 cafe_table_small 13 10 1 0 1\r\nc1410 cafe_chair 14 10 1 6 2\r\nr011 roommatic 0 11 1 4 1\r\nr111 roommatic 1 11 1 4 1\r\nr211 roommatic 2 11 1 4 1\r\nk311 cafe_desk1 3 11 1 2 1\r\nn411 cafe_desk3 4 11 1 2 1\r\nJ911 cafe_fence4 9 11 1 0 1 \r\nI1011 cafe_fence3 10 11 1 2 1\r\nH1111 cafe_fence2 11 11 1 2 1\r\nI1211 cafe_fence3 12 11 1 2 1\r\nH1311 cafe_fence2 13 11 1 2 1\r\nI1411 cafe_fence3 14 11 1 2 1\r\nG1511 cafe_fence1 15 11 1 2 1\r\nb012 cafe_barchair 0 12 1 0 2\r\nb112 cafe_barchair 1 12 1 0 2\r\nb212 cafe_barchair 2 12 1 0 2\r\nc812 cafe_chair 8 12 1 4 2\r\nI912 cafe_fence3 9 12 1 0 1\r\ny1012 plant_yucca 10 12 0 0 1\r\nt813 cafe_table_small 8 13 1 0 1\r\nH913 cafe_fence2 9 13 1 0 1\r\nc814 cafe_chair 8 14 1 0 2\r\nI914 cafe_fence3 9 14 1 0 1\r\nc1214 cafe_chair 12 14 0 4 2\r\ni015 cafe_pianoc 0 15 1 0 1\r\nH915 cafe_fence2 9 15 1 0 1\r\nW1215 cafe_table_largeb 12 15 0 0 1\r\nh016 cafe_pianob 0 16 1 0 1\r\nb116 cafe_barchair 1 16 1 6 2\r\nW416 cafe_table_largeb 4 16 1 0 1\r\nI916 cafe_fence3 9 16 1 0 1\r\nc1116 cafe_chair 11 16 0 2 2\r\nc1416 cafe_chair 14 16 0 6 2\r\ng017 cafe_pianoa 0 17 1 0 1\r\nc317 cafe_chair 3 17 1 2 2\r\nc617 cafe_chair 6 17 1 6 2\r\nH917 cafe_fence2 9 17 1 0 1\r\nc1117 cafe_chair 11 17 0 2 2\r\nV1217 cafe_table_largea 12 17 0 0 1\r\nc1417 cafe_chair 14 17 0 6 2\r\nc318 cafe_chair 3 18 1 2 2\r\nV418 cafe_table_largea 4 18 1 0 1\r\nc618 cafe_chair 6 18 1 6 2\r\nI918 cafe_fence3 9 18 1 0 1\r\nf019 plant_ftree 0 19 1 0 1\r\nH919 cafe_fence2 9 19 1 0 1\r\nc1219 cafe_chair 12 19 0 0 2\r\nf020 plant_ftree 0 20 1 0 1\r\nc820 cafe_chair 8 20 1 4 2\r\nI920 cafe_fence3 9 20 1 0 1\r\nt821 cafe_table_small 8 21 1 0 1\r\nH921 cafe_fence2 9 21 1 0 1\r\nc822 cafe_chair 8 22 1 0 2\r\nI922 cafe_fence3 9 22 1 0 1\r\nH923 cafe_fence2 9 23 1 0 1\r\nc1223 cafe_chair 12 23 0 2 2\r\nt1323 cafe_table_small 13 23 0 0 1\r\nc1423 cafe_chair 14 23 0 6 2\r\nG924 cafe_fence1 9 24 1 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('92', 'cr_cafe', '0', '20', '10', '0', '0', '0000000000000000000xx\r\nx000000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxxxx000000000000000xx\r\n0000000000000000000xx\r\n0000000000000000000xx\r\nx000000000000000000xx\r\nxx00000000000000000xx\r\nxxxx00000000000000000\r\nxxx000000000000000000\r\nxxx0000000000000000xx\r\nxxx0000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\nxx00000000000000000xx\r\n', 'D00 drawer_end 0 0 0 4 1\r\nT30 koc_table 3 0 0 0 1\r\nl60 koc_smalltable 6 0 0 0 1\r\nd120 drawer_start 12 0 0 4 1\r\nD130 drawer_end 13 0 0 4 1\r\nT81 koc_table 8 1 0 0 1\r\nc91 koc_chair 9 1 0 6 2\r\nr22 coatrack 2 2 0 0 1\r\nP62 pillar 6 2 0 4 1\r\nc82 koc_chair 8 2 0 0 2\r\nc122 koc_chair 12 2 0 2 2\r\nT132 koc_table 13 2 0 0 1\r\nc142 koc_chair 14 2 0 6 2\r\nP162 pillar 16 2 0 4 1\r\nD23 drawer_end 2 3 0 2 1\r\nc133 koc_chair 13 3 0 0 2\r\nc125 koc_chair 12 5 0 4 2\r\nc175 koc_chair 17 5 0 4 2\r\nd16 drawer_start 1 6 0 4 1\r\nD26 drawer_end 2 6 0 4 1\r\nc86 koc_chair 8 6 0 4 2\r\nc116 koc_chair 11 6 0 2 2\r\nT126 koc_table 12 6 0 0 1\r\nc136 koc_chair 13 6 0 6 2\r\nT176 koc_table 17 6 0 0 1\r\nc186 koc_chair 18 6 0 6 2\r\nT87 koc_table 8 7 0 0 1\r\nc97 koc_chair 9 7 0 6 2\r\nc127 koc_chair 12 7 0 0 2\r\nc177 koc_chair 17 7 0 0 2\r\nc88 koc_chair 8 8 0 0 2\r\nB59 koc_bartable_end 5 9 0 6 1\r\nb69 koc_bartable 6 9 0 5 1\r\nb610 koc_bartable 6 10 0 4 1\r\ns710 koc_stool 7 10 0 6 2\r\nb611 koc_bartable 6 11 0 4 1\r\ns711 koc_stool 7 11 0 6 2\r\nD312 drawer_end 3 12 0 2 1\r\nb612 koc_bartable 6 12 0 4 1\r\nd313 drawer_start 3 13 0 2 1\r\nb613 koc_bartable 6 13 0 4 1\r\ns713 koc_stool 7 13 0 6 2\r\nB614 koc_bartable_end 6 14 0 4 1\r\nP615 pillar 6 15 0 4 1\r\nc1315 koc_chair 13 15 0 4 2\r\nP1615 pillar 16 15 0 7 1\r\nC216 cupboard 2 16 0 0 1\r\nT816 koc_table 8 16 0 0 1\r\nc916 koc_chair 9 16 0 6 2\r\nT1316 koc_table 13 16 0 0 1\r\nc1416 koc_chair 14 16 0 6 2\r\nC217 cupboard 2 17 0 4 1\r\nc817 koc_chair 8 17 0 0 2\r\nc1317 koc_chair 13 17 0 0 2\r\nD218 drawer_end 2 18 0 2 1\r\nd219 drawer_start 2 19 0 2 1\r\nD319 drawer_end 3 19 0 0 1\r\nd419 drawer_start 4 19 0 0 1\r\nD519 drawer_end 5 19 0 0 1\r\nd619 drawer_start 6 19 0 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('93', 'lobby_a', '0', '12', '27', '1', '0', 'XXXXXXXXX77777777777XXXXX\r\nXXXXXXXXX777777777777XXXX\r\nXXXXXXXXX777777777766XXXX\r\nXXXXXXXXX777777777755XXXX\r\nXX333333333333333334433XX\r\nXX333333333333333333333XX\r\nXX333333333333333333333XX\r\n33333333333333333333333XX\r\n333333XXXXXXX3333333333XX\r\n333333XXXXXXX2222222222XX\r\n333333XXXXXXX2222222222XX\r\nXX3333XXXXXXX2222222222XX\r\nXX3333XXXXXXX222222221111\r\nXX3333XXXXXXX111111111111\r\n333333XXXXXXX111111111111\r\n3333333222211111111111111\r\n3333333222211111111111111\r\n3333333222211111111111111\r\nXX33333222211111111111111\r\nXX33333222211111111111111\r\nXX3333322221111111XXXXXXX\r\nXXXXXXX22221111111XXXXXXX\r\nXXXXXXX22221111111XXXXXXX\r\nXXXXXXX22221111111XXXXXXX\r\nXXXXXXX22221111111XXXXXXX\r\nXXXXXXX222X1111111XXXXXXX\r\nXXXXXXX222X1111111XXXXXXX\r\nXXXXXXXXXXXX11XXXXXXXXXXX\r\nXXXXXXXXXXXX11XXXXXXXXXXX\r\nXXXXXXXXXXXX11XXXXXXXXXXX\r\nXXXXXXXXXXXX11XXXXXXXXXXX\r\n', 'f90 flower1 9 0 7 0 1\r\nS110 chairf2b 11 0 7 4 2\r\ns120 chairf2 12 0 7 4 2\r\nt130 table1 13 0 7 2 1\r\nS140 chairf2b 14 0 7 4 2\r\ns150 chairf2 15 0 7 4 2\r\nw160 watermatic 16 0 7 4 1\r\nT92 telkka 9 2 7 2 1 \r\nf93 flower1 9 3 7 0 1\r\nZ113 chairf2d 11 3 7 0 2\r\ns123 chairf2 12 3 7 0 2\r\nt133 table1 13 3 7 2 1\r\nZ143 chairf2d 14 3 7 0 2\r\ns153 chairf2 15 3 7 0 2\r\nf124 flower1 12 4 3 0 1\r\nf164 flower1 16 4 3 0 1\r\nS07 chairf2b 0 7 3 4 2\r\ns17 chairf2 1 7 3 4 2\r\nZ010 chairf2d 0 10 3 0 2\r\ns110 chairf2 1 10 3 0 2\r\nr2112 roommatic 21 12 1 4 1\r\nr2212 roommatic 22 12 1 4 1\r\nr2312 roommatic 23 12 1 4 1\r\nr2412 roommatic 24 12 1 4 1\r\nS014 chairf2b 0 14 3 4 2\r\ns114 chairf2 1 14 3 4 2\r\nw1314 watermatic 13 14 1 2 1\r\nw1215 watermatic 12 15 1 4 1\r\nc1916 chairf1 19 16 1 4 2\r\nC2116 table2c 21 16 1 2 1\r\nc2316 chairf1 23 16 1 4 2\r\nZ017 chairf2d 0 17 3 0 2\r\ns117 chairf2 1 17 3 0 2\r\nD2117 table2b 21 17 1 2 1\r\nc1918 chairf1 19 18 1 0 2\r\nd2118 table2 21 18 1 2 1\r\nc2318 chairf1 23 18 1 0 2\r\nS721 chairf2b 7 21 2 2 2\r\nz722 chairf2c 7 22 2 2 2\r\nz723 chairf2c 7 23 2 2 2\r\nz724 chairf2c 7 24 2 2 2\r\ns725 chairf2 7 25 2 2 2\r\nt726 table1 7 26 2 2 1\r\ne1026 flower2 10 26 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('94', 'floorlobby_c', '0', '9', '21', '0', '0', 'XXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXX0000000000000000XXXXXXX0\r\nXXX000000000000000000XXXX00\r\nX00000000000000000000000000\r\nX00000000000000000000000000\r\nXXX000000000000000000000000\r\nXXXXXXX00000000000000000000\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\n', 'p32 moneyplant 3 2 0 0 1\r\nr52 roommatic 5 2 0 4 1\r\nr72 roommatic 7 2 0 4 1\r\nr92 roommatic 9 2 0 4 1\r\nr112 roommatic 11 2 0 4 1\r\nr132 roommatic 13 2 0 4 1\r\nw262 watermatic 26 2 0 4 1\r\ne148 edgec1 14 8 1 6 1\r\ne158 edgec1 15 8 1 0 1\r\ne168 edgec1 16 8 1 0 1\r\ne178 edgec1 17 8 1 0 1\r\ne188 edgec1 18 8 1 0 1\r\ne198 edgec1 19 8 1 0 1\r\ne208 edgec1 20 8 1 0 1\r\ne218 edgec1 21 8 1 0 1\r\ne228 edgec1 22 8 1 0 1\r\ne238 edgec1 23 8 1 0 1\r\ne248 edgec1 24 8 1 0 1\r\ne258 edgec1 25 8 1 0 1\r\ne268 edgec1 26 8 1 2 1\r\nc39 chairg1 3 9 1 2 2\r\nc59 chairg1 5 9 1 6 2\r\np159 moneyplant 15 9 1 0 1\r\nS169 chairg2b 16 9 1 4 2\r\nz179 chairg2c 17 9 1 4 2\r\ns189 chairg2 18 9 1 4 2\r\np199 moneyplant 19 9 1 4 1\r\np219 moneyplant 21 9 1 0 1\r\nS229 chairg2b 22 9 1 4 2\r\nz239 chairg2c 23 9 1 4 2\r\ns249 chairg2 24 9 1 4 2\r\np259 moneyplant 25 9 1 4 1\r\nc311 chairg1 3 11 1 2 2\r\nc511 chairg1 5 11 1 6 2\r\nt312 newtable2 3 12 1 0 1\r\nc1614 chairg1 16 14 1 4 2\r\nc1814 chairg1 18 14 1 4 2\r\nc2214 chairg1 22 14 1 4 2\r\nc2414 chairg1 24 14 1 4 2\r\nt1715 newtable2 17 15 1 0 1\r\nt2315 newtable2 23 15 1 0 1\r\nt316 newtable2 3 16 1 0 1\r\nc1616 chairg1 16 16 1 0 2\r\nc1816 chairg1 18 16 1 0 2\r\nc2216 chairg1 22 16 1 0 2\r\nc2416 chairg1 24 16 1 0 2\r\nc317 chairg1 3 17 1 2 2\r\nc517 chairg1 5 17 1 6 2\r\nE1418 edgec2 14 18 1 6 1\r\nE1518 edgec2 15 18 1 0 1\r\nE1618 edgec2 16 18 1 0 1\r\nE1718 edgec2 17 18 1 0 1\r\nE1818 edgec2 18 18 1 0 1\r\nE1918 edgec2 19 18 1 0 1\r\nE2018 edgec2 20 18 1 0 1\r\nE2118 edgec2 21 18 1 0 1\r\nE2218 edgec2 22 18 1 0 1\r\nE2318 edgec2 23 18 1 0 1\r\nE2418 edgec2 24 18 1 0 1\r\nE2518 edgec2 25 18 1 0 1\r\nE2618 edgec2 26 18 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('95', 'floorlobby_b', '0', '9', '21', '0', '0', 'XXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXX0000000000000000XXXXXXX0\r\nXXX000000000000000000XXXX00\r\nX00000000000000000000000000\r\nX00000000000000000000000000\r\nXXX000000000000000000000000\r\nXXXXXXX00000000000000000000\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\n', 'p32 moneyplant 3 2 0 0 1\r\nr52 roommatic 5 2 0 4 1\r\nr72 roommatic 7 2 0 4 1\r\nr92 roommatic 9 2 0 4 1\r\nr112 roommatic 11 2 0 4 1\r\nr132 roommatic 13 2 0 4 1\r\nw262 watermatic 26 2 0 4 1\r\nl38 standinglamp 3 8 1 0 1\r\ne148 edgeb1 14 8 1 6 1\r\ne158 edgeb1 15 8 1 0 1\r\ne168 edgeb1 16 8 1 0 1\r\ne178 edgeb1 17 8 1 0 1\r\ne188 edgeb1 18 8 1 0 1\r\ne198 edgeb1 19 8 1 0 1\r\ne208 edgeb1 20 8 1 0 1\r\ne218 edgeb1 21 8 1 0 1\r\ne228 edgeb1 22 8 1 0 1\r\ne238 edgeb1 23 8 1 0 1\r\ne248 edgeb1 24 8 1 0 1\r\ne258 edgeb1 25 8 1 0 1\r\ne268 edgeb1 26 8 1 2 1\r\nS39 chairf2b 3 9 1 4 2\r\nz49 chairf2c 4 9 1 4 2\r\ns59 chairf2 5 9 1 4 2\r\np159 moneyplant 15 9 1 0 1\r\nS169 chairf2b 16 9 1 4 2\r\nz179 chairf2c 17 9 1 4 2\r\ns189 chairf2 18 9 1 4 2\r\np199 moneyplant 19 9 1 4 1\r\np219 moneyplant 21 9 1 0 1\r\nS229 chairf2b 22 9 1 4 2\r\nz239 chairf2c 23 9 1 4 2\r\ns249 chairf2 24 9 1 4 2\r\np259 moneyplant 25 9 1 4 1\r\nc311 chairf1 3 11 1 0 2\r\nt411 newtable1 4 11 1 0 1\r\nc511 chairf1 5 11 1 0 2\r\nc1614 chairf1 16 14 1 2 2\r\nc1814 chairf1 18 14 1 6 2\r\nc2214 chairf1 22 14 1 2 2\r\nc2414 chairf1 24 14 1 6 2\r\nt1715 newtable1 17 15 1 0 1\r\nt2315 newtable1 23 15 1 0 1\r\nt316 newtable1 3 16 1 0 1\r\nc1616 chairf1 16 16 1 2 2\r\nc1816 chairf1 18 16 1 6 2\r\nc2216 chairf1 22 16 1 2 2\r\nc2416 chairf1 24 16 1 6 2\r\nc317 chairf1 3 17 1 2 2\r\nc517 chairf1 5 17 1 6 2\r\nl318 standinglamp 3 18 1 0 1\r\nE1418 edgeb2 14 18 1 6 1\r\nE1518 edgeb2 15 18 1 0 1\r\nE1618 edgeb2 16 18 1 0 1\r\nE1718 edgeb2 17 18 1 0 1\r\nE1818 edgeb2 18 18 1 0 1\r\nE1918 edgeb2 19 18 1 0 1\r\nE2018 edgeb2 20 18 1 0 1\r\nE2118 edgeb2 21 18 1 0 1\r\nE2218 edgeb2 22 18 1 0 1\r\nE2318 edgeb2 23 18 1 0 1\r\nE2418 edgeb2 24 18 1 0 1\r\nE2518 edgeb2 25 18 1 0 1\r\nE2618 edgeb2 26 18 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('96', 'floorlobby_a', '0', '9', '21', '0', '0', 'XXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXXXXXXXXXXXXXXXXXXXXXXXXXX\r\nXXX0000000000000000XXXXXXX0\r\nXXX000000000000000000XXXX00\r\nX00000000000000000000000000\r\nX00000000000000000000000000\r\nXXX000000000000000000000000\r\nXXXXXXX00000000000000000000\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX1XX100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXX111100000011111111111111\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\nXXXXXXXX0000XXXXXXXXXXXXXXX\r\n', 'p32 moneyplant 3 2 0 0 1\r\nr52 roommatic 5 2 0 4 1\r\nr72 roommatic 7 2 0 4 1\r\nr92 roommatic 9 2 0 4 1\r\nr112 roommatic 11 2 0 4 1\r\nr132 roommatic 13 2 0 4 1\r\nw262 watermatic 26 2 0 4 1\r\nl38 standinglamp 3 8 1 0 1\r\ne148 edge1 14 8 1 6 1\r\ne158 edge1 15 8 1 0 1\r\ne168 edge1 16 8 1 0 1\r\ne178 edge1 17 8 1 0 1\r\ne188 edge1 18 8 1 0 1\r\ne198 edge1 19 8 1 0 1\r\ne208 edge1 20 8 1 0 1\r\ne218 edge1 21 8 1 0 1\r\ne228 edge1 22 8 1 0 1\r\ne238 edge1 23 8 1 0 1\r\ne248 edge1 24 8 1 0 1\r\ne258 edge1 25 8 1 0 1\r\ne268 edge1 26 8 1 2 1\r\nc39 chairf1 3 9 1 2 2\r\nc59 chairf1 5 9 1 6 2\r\np159 moneyplant 15 9 1 0 1\r\nS169 chairf2b 16 9 1 4 2\r\nz179 chairf2c 17 9 1 4 2\r\ns189 chairf2 18 9 1 4 2\r\np199 moneyplant 19 9 1 4 1\r\np219 moneyplant 21 9 1 0 1\r\nS229 chairf2b 22 9 1 4 2\r\nz239 chairf2c 23 9 1 4 2\r\ns249 chairf2 24 9 1 4 2\r\np259 moneyplant 25 9 1 4 1\r\nc311 chairf1 3 11 1 2 2\r\nc511 chairf1 5 11 1 6 2\r\nt312 newtable1 3 12 1 0 1\r\nc1614 chairf1 16 14 1 4 2\r\nc1814 chairf1 18 14 1 4 2\r\nc2214 chairf1 22 14 1 4 2\r\nc2414 chairf1 24 14 1 4 2\r\nt1715 newtable1 17 15 1 0 1\r\nt2315 newtable1 23 15 1 0 1\r\nt316 newtable1 3 16 1 0 1\r\nc1616 chairf1 16 16 1 0 2\r\nc1816 chairf1 18 16 1 0 2\r\nc2216 chairf1 22 16 1 0 2\r\nc2416 chairf1 24 16 1 0 2\r\nc317 chairf1 3 17 1 2 2\r\nc517 chairf1 5 17 1 6 2\r\nl318 standinglamp 3 18 1 0 1\r\nE1418 edge2 14 18 1 6 1\r\nE1518 edge2 15 18 1 0 1\r\nE1618 edge2 16 18 1 0 1\r\nE1718 edge2 17 18 1 0 1\r\nE1818 edge2 18 18 1 0 1\r\nE1918 edge2 19 18 1 0 1\r\nE2018 edge2 20 18 1 0 1\r\nE2118 edge2 21 18 1 0 1\r\nE2218 edge2 22 18 1 0 1\r\nE2318 edge2 23 18 1 0 1\r\nE2418 edge2 24 18 1 0 1\r\nE2518 edge2 25 18 1 0 1\r\nE2618 edge2 26 18 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('97', 'cinema_a', '0', '20', '27', '1', '0', 'xxxxxxx1xx11111111xxxxxx\r\nxxx1111111111111111xxxxx\r\nxxx111xxxx1111111111xxxx\r\nxxxx2xxxxxxxxxxxxxxxxxxx\r\nxx3x3x333311xxxxxxxxxx11\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111122111\r\nxx3333333311x22222222111\r\nxx3333333311x22222222111\r\nxx3333333311xxxxxxxxx111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\n333333332111111xxxx11111\r\n333333332111111111111111\r\n333333332111111111111111\r\n333333332111111111111111\r\nxx3333332111111111111111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111\r\n', 'C24 orange 2 4 3 0 1\r\nA74 loungey_chair 7 4 3 2 2\r\nV84 loungey_tablebigb 8 4 3 0 1\r\nA94 loungey_chair 9 4 3 6 2\r\nA25 loungey_chair 2 5 3 4 2\r\nA75 loungey_chair 7 5 3 2 2\r\nU85 loungey_tablebiga 8 5 3 0 1\r\nA95 loungey_chair 9 5 3 6 2\r\nB26 loungey_table 2 6 3 0 1\r\nA27 loungey_chair 2 7 3 0 2\r\nh137 theater_chair 13 7 1 0 2\r\nh147 theater_chair 14 7 1 0 2\r\nh157 theater_chair 15 7 1 0 2\r\nh167 theater_chair 16 7 1 0 2\r\nh177 theater_chair 17 7 1 0 2\r\nh187 theater_chair 18 7 1 0 2\r\nz217 stair 21 7 1 0 1\r\nL98 lightpole 9 8 3 0 1\r\nq138 pomomaski 13 8 2 2 1\r\nq148 pomomaski 14 8 2 0 1\r\nq158 pomomaski 15 8 2 0 1\r\nq168 pomomaski 16 8 2 0 1\r\nq178 pomomaski 17 8 2 0 1\r\nq188 pomomaski 18 8 2 0 1\r\nq198 pomomaski 19 8 2 1 1\r\nz218 stair 21 8 1 0 1\r\nC29 orange 2 9 3 0 1\r\nh139 theater_chair 13 9 2 0 2\r\nh149 theater_chair 14 9 2 0 2\r\nh159 theater_chair 15 9 2 0 2\r\nh169 theater_chair 16 9 2 0 2\r\nh179 theater_chair 17 9 2 0 2\r\nh189 theater_chair 18 9 2 0 2\r\nh199 theater_chair 19 9 2 0 2\r\nh209 theater_chair 20 9 2 0 2 \r\nz219 stair 21 9 1 0 1\r\nA210 loungey_chair 2 10 3 4 2\r\nA910 loungey_chair 9 10 3 4 2\r\nB211 loungey_table 2 11 3 0 1\r\nB911 loungey_table 9 11 3 0 1\r\nA212 loungey_chair 2 12 3 0 2\r\nA912 loungey_chair 9 12 3 0 2\r\nd1712 cubicb_chair 17 12 1 6 2\r\nc1912 cubico_chair 19 12 1 2 2\r\nd1513 cubicb_chair 15 13 1 2 2\r\nL1913 lightpole 19 13 1 0 1\r\nd2013 cubicb_chair 20 13 1 6 2\r\nL914 lightpole 9 14 3 0 1\r\nA215 loungey_chair 2 15 3 4 2\r\nd1415 cubicb_chair 14 15 1 4 2\r\nc1915 cubico_chair 19 15 1 4 2\r\nB216 loungey_table 2 16 3 0 1\r\nA716 loungey_chair 7 16 3 2 2\r\nB816 loungey_table 8 16 3 2 1\r\nA916 loungey_chair 9 16 3 6 2\r\nd1316 cubicb_chair 13 16 1 2 2\r\nd1416 cubicb_chair 14 16 1 6 2\r\nC1916 orange 19 16 1 0 1\r\nA217 loungey_chair 2 17 3 0 2\r\nA717 loungey_chair 7 17 3 2 2\r\nB817 loungey_table 8 17 3 2 1\r\nA917 loungey_chair 9 17 3 6 2\r\nd1917 cubicb_chair 19 17 1 2 2\r\nC218 orange 2 18 3 0 1\r\nd1418 cubicb_chair 14 18 1 4 2\r\nK219 bardesque 2 19 3 0 1\r\nK220 bardesque 2 20 3 1 1\r\nb320 bar_chair 3 20 3 6 2\r\nL920 lightpole 9 20 3 0 1\r\nd1420 cubicb_chair 14 20 1 0 2\r\nd1920 cubicb_chair 19 20 1 2 2\r\nc2020 cubico_chair 20 20 1 6 2\r\nK221 bardesque 2 21 3 1 1\r\nb321 bar_chair 3 21 3 6 2\r\nd1921 cubicb_chair 19 21 1 0 2\r\nK222 bardesque 2 22 3 1 1\r\nb322 bar_chair 3 22 3 6 2\r\nL1622 lightpole 16 22 1 0 1\r\nc1822 cubico_chair 18 22 1 0 2\r\nK223 bardesque 2 23 3 1 1\r\nb323 bar_chair 3 23 3 6 2\r\nK224 bardesque 2 24 3 1 1\r\nb324 bar_chair 3 24 3 6 2\r\nK225 bardesque 2 25 3 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('98', 'sport', '0', '0', '0', '1', '0', '111222222222222222x2222\r\nx11222222222222222x2222\r\nx11222222222222222x2222\r\nxx1x2222222222222211111\r\nx11xx222222222222211111\r\nx11xx222222x22222211111\r\nx11xx222222x222222x1111\r\nx11xx222222x222222x1111\r\nx11xx2222222222222x1111\r\nx11xxxxxxxxxxxxxxxx1111\r\nx1111111111111111111111\r\nx1111111111111111111111\r\nx1111111111111111111111\r\nx1111111111111111111111\r\nxxxx1111111111111x1111x\r\n111x1111111111111x1111x\r\n111x1111111111111x1111x\r\n111x1111111111111x1111x\r\n111x11111xxxxxxxxxxxxxx\r\nx11x1111xxxxxxxxxxxxxxx\r\nxxxx111xxxxxxxxxxxxxxxx\r\n', 'c60 sodagreen 6 0 2 0 1\r\nd80 sodapink 8 0 2 0 1\r\nb90 sportchair 9 0 2 4 2\r\nb100 sportchair 10 0 2 4 2\r\ne202 dummychair 20 2 2 4 2\r\ne212 dummychair 21 2 2 4 2\r\ne222 dummychair 22 2 2 4 2\r\nb15 sportchair 1 5 1 4 2\r\nb75 sportchair 7 5 2 4 2\r\nb155 sportchair 15 5 2 4 2\r\na16 sporttable 1 6 1 0 1\r\nb66 sportchair 6 6 2 2 2\r\na76 sporttable 7 6 2 0 1\r\nf86 sportchair2 8 6 2 6 2\r\nb146 sportchair 14 6 2 2 2\r\na156 sporttable 15 6 2 0 1\r\nf166 sportchair2 16 6 2 6 2\r\ng17 sportchair3 1 7 1 0 2\r\ng77 sportchair3 7 7 2 0 2\r\ng157 sportchair3 15 7 2 0 2\r\nb110 sportchair 1 10 1 4 2\r\na111 sporttable 1 11 1 0 1\r\ng112 sportchair3 1 12 1 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('99', 'old_skool0', '0', '2', '1', '0', '0', 'xx0xxxxxxxxxxxxxx\r\n0000000xxx00000xx\r\n0000000x0000000xx\r\n0000000xxxxxxxxxx\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n00000000000000000\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n', 'k94 mobiles_chair3 9 4 0 0 2\r\nk104 mobiles_chair3 10 4 0 0 2\r\nk114 mobiles_chair3 11 4 0 0 2\r\nk124 mobiles_chair3 12 4 0 0 2\r\ne110 mobiles_chair1 1 10 0 4 2\r\ne1010 mobiles_chair1 10 10 0 4 2\r\ne011 mobiles_chair1 0 11 0 2 2\r\nb111 mobiles_table2 1 11 0 0 1\r\nc211 mobiles_table3 2 11 0 0 1\r\ne311 mobiles_chair1 3 11 0 6 2\r\nb1011 mobiles_table2 10 11 0 0 1\r\nc1111 mobiles_table3 11 11 0 0 1\r\na112 mobiles_table1 1 12 0 0 1\r\nd212 mobiles_table4 2 12 0 0 1\r\ne912 mobiles_chair1 9 12 0 2 2\r\na1012 mobiles_table1 10 12 0 0 1\r\nd1112 mobiles_table4 11 12 0 0 1\r\ne1212 mobiles_chair1 12 12 0 6 2\r\ne113 mobiles_chair1 1 13 0 0 2\r\ne1113 mobiles_chair1 11 13 0 0 2\r\ne015 mobiles_chair1 0 15 0 4 2\r\ne017 mobiles_chair1 0 17 0 2 2\r\nb117 mobiles_table2 1 17 0 0 1\r\nc217 mobiles_table3 2 17 0 0 1\r\ne317 mobiles_chair1 3 17 0 6 2\r\na118 mobiles_table1 1 18 0 0 1\r\nd218 mobiles_table4 2 18 0 0 1\r\ne219 mobiles_chair1 2 19 0 0 2\r\ne121 mobiles_chair1 1 21 0 4 2\r\nb621 mobiles_table2 6 21 0 0 1\r\nc721 mobiles_table3 7 21 0 0 1\r\ne1221 mobiles_chair1 12 21 0 4 2\r\ne022 mobiles_chair1 0 22 0 2 2\r\nb122 mobiles_table2 1 22 0 0 1\r\nc222 mobiles_table3 2 22 0 0 1\r\ne322 mobiles_chair1 3 22 0 6 2\r\ne522 mobiles_chair1 5 22 0 2 2\r\na622 mobiles_table1 6 22 0 0 1\r\nd722 mobiles_table4 7 22 0 0 1\r\ne822 mobiles_chair1 8 22 0 6 2\r\ne1122 mobiles_chair1 11 22 0 2 2\r\nb1222 mobiles_table2 12 22 0 0 1\r\nc1322 mobiles_table3 13 22 0 0 1\r\ne1422 mobiles_chair1 14 22 0 6 2\r\na123 mobiles_table1 1 23 0 0 1\r\nd223 mobiles_table4 2 23 0 0 1\r\na1223 mobiles_table1 12 23 0 0 1\r\nd1323 mobiles_table4 13 23 0 0 1\r\ne124 mobiles_chair1 1 24 0 0 2\r\ne724 mobiles_chair1 7 24 0 4 2\r\ne1324 mobiles_chair1 13 24 0 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('100', 'old_skool1', '0', '1', '7', '6', '0', 'x6666666665432100\r\nx6666666665432100\r\nx6600000000000x00\r\nx6600000000000000\r\nx6600000000000000\r\nx6600000000000000\r\nx660000000000x000\r\n666000000000x1111\r\nx66000000000xx111\r\nx66000000000x1111\r\nx66000000000x1111\r\nx55000000000x1111\r\nx44000000000x1111\r\nx33000000000x1111\r\nx22000000000xx111\r\nx11x00000000x1111\r\nx00000000000x1111\r\nx00000000000xx111\r\n', 'j42 mobiles_chair2 4 2 0 4 2\r\nj92 mobiles_chair2 9 2 0 4 2\r\ng43 mobiles_table6 4 3 0 0 1\r\nh53 mobiles_table7 5 3 0 0 1\r\nj73 mobiles_chair2 7 3 0 2 2\r\ng83 mobiles_table6 8 3 0 0 1\r\nh93 mobiles_table7 9 3 0 0 1\r\nj34 mobiles_chair2 3 4 0 2 2\r\nf44 mobiles_table5 4 4 0 0 1\r\ni54 mobiles_table8 5 4 0 0 1\r\nf84 mobiles_table5 8 4 0 0 1\r\ni94 mobiles_table8 9 4 0 0 1\r\nj85 mobiles_chair2 8 5 0 0 2\r\nj56 mobiles_chair2 5 6 0 4 2\r\nj37 mobiles_chair2 3 7 0 2 2\r\ng47 mobiles_table6 4 7 0 0 1\r\nh57 mobiles_table7 5 7 0 0 1\r\nf48 mobiles_table5 4 8 0 0 1\r\ni58 mobiles_table8 5 8 0 0 1\r\nj49 mobiles_chair2 4 9 0 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('101', 'malja_bar_a', '0', '4', '24', '1', '0', 'xxxxxxxxxxx44444\r\nxxxx444444444444\r\nxxxx444444444444\r\nxxxx444444444444\r\nxxxx444444444444\r\nxxxx444444444444\r\nxxxxxxxxxxxxx333\r\n1111111111111222\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n111111111xxxxxxx\r\nxxx11111xxxxxxxx\r\n11111111xxxxxxxx\r\n11111111xxxxxxxx\r\n11111111xxxxxxxx\r\n11111111xxxxxxxx\r\n', 'c131 bar_chair_green 13 1 4 4 2\r\nc72 bar_chair_green 7 2 4 4 2\r\nc53 bar_chair_green 5 3 4 2 2\r\nt63 bar_table_green 6 3 4 2 2 1\r\nc84 bar_chair_green 8 4 4 6 2\r\nc75 bar_chair_green 7 5 4 0 2\r\n8107 bar_bare 10 7 1 0 1\r\n7108 bar_bard 10 8 1 0 1\r\n409 bar_bara 0 9 1 0 1\r\n519 bar_barb 1 9 1 0 1\r\n529 bar_barb 2 9 1 0 1\r\n539 bar_barb 3 9 1 0 1\r\n549 bar_barb 4 9 1 0 1\r\n559 bar_barb 5 9 1 0 1\r\n569 bar_barb 6 9 1 0 1\r\n579 bar_barb 7 9 1 0 1\r\n589 bar_barb 8 9 1 0 1\r\n599 bar_barb 9 9 1 0 1\r\n6109 bar_barc 10 9 1 0 1 \r\nc713 bar_chair_green 7 13 1 4 2\r\nt714 bar_table_green 7 14 1 2 2 1\r\nc1314 bar_chair_green 13 14 1 4 2\r\nc115 bar_chair_green 1 15 1 4 2\r\nc615 bar_chair_green 6 15 1 2 2\r\nc915 bar_chair_green 9 15 1 6 2\r\nt1315 bar_table_green 13 15 1 2 2 1\r\nc016 bar_chair_green 0 16 1 2 2\r\nt116 bar_table_green 1 16 1 2 2 1\r\nc716 bar_chair_green 7 16 1 0 2\r\nc1216 bar_chair_green 12 16 1 2 2\r\nc1516 bar_chair_green 15 16 1 6 2\r\nc317 bar_chair_green 3 17 1 6 2\r\nc1417 bar_chair_green 14 17 1 0 2\r\nc218 bar_chair_green 2 18 1 0 2\r\nc021 bar_chair_green 0 21 1 2 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('102', 'malja_bar_b', '0', '4', '24', '3', '0', '6666333333333333\r\n6666333333333333\r\n6666333333333333\r\n7766333333333333\r\n7755333333333333\r\n8855333333332223\r\n8844333311111111\r\n9944333311111111\r\n9933333311111111\r\n9933333311111111\r\n9933333311111111\r\n9933333311111111\r\n9933333311111111\r\n9933333311111111\r\n9933333211111111\r\n9933333211111111\r\n9933333211111111\r\n9933333311111111\r\n99333333xxxxxxxx\r\n99333333xxxxxxxx\r\nxxx33333xxxxxxxx\r\nxxx33333xxxxxxxx\r\n3xx33333xxxxxxxx\r\nxxx33333xxxxxxxx\r\nxxx33333xxxxxxxx\r\nxxx33333xxxxxxxx\r\n', 'C40 bar_chair_blue 4 0 3 4 2\r\nC80 bar_chair_blue 8 0 3 2 2\r\nw90 bar_table_small_blue 9 0 3 0 1\r\nC100 bar_chair_blue 10 0 3 6 2\r\nT41 bar_table_blue 4 1 3 2 2 1\r\nD131 bar_djbooth 13 1 3 1 1\r\nC62 bar_chair_blue 6 2 3 6 2\r\nD132 bar_djbooth 13 2 3 2 1\r\nD142 bar_djbooth 14 2 3 3 1\r\nD152 bar_djbooth 15 2 3 4 1\r\nz13 stair 1 3 7 0 1\r\nC43 bar_chair_blue 4 3 3 0 2\r\nz14 stair 1 4 7 0 1\r\nz24 stair 2 4 5 0 1\r\nz34 stair 3 4 5 0 1\r\nz125 stair 12 5 2 0 1\r\nz135 stair 13 5 2 0 1\r\nz145 stair 14 5 2 0 1\r\nz36 stair 3 6 4 0 1\r\nz126 stair 12 6 1 0 1\r\nz136 stair 13 6 1 0 1\r\nz146 stair 14 6 1 0 1\r\nz37 stair 3 7 4 0 1\r\nz28 stair 2 8 3 0 1\r\nz38 stair 3 8 3 0 1\r\nC78 bar_chair_blue 7 8 3 4 2\r\nw79 bar_table_small_blue 7 9 3 0 1\r\nC710 bar_chair_blue 7 10 3 0 2\r\nC211 bar_chair_blue 2 11 3 4 2\r\nw212 bar_table_small_blue 2 12 3 0 1\r\nC213 bar_chair_blue 2 13 3 0 2\r\nC014 bar_chair_blue 0 14 9 2 2\r\nC015 bar_chair_blue 0 15 9 2 2\r\nC016 bar_chair_blue 0 16 9 2 2\r\nC216 bar_chair_blue 2 16 3 4 2\r\nC316 bar_chair_blue 3 16 3 4 2\r\nC017 bar_chair_blue 0 17 9 2 2\r\nT217 bar_table_blue 2 17 3 2 2 1\r\nC417 bar_chair_blue 4 17 3 6 2\r\nC018 bar_chair_blue 0 18 9 2 2\r\nC418 bar_chair_blue 4 18 3 6 2\r\nC019 bar_chair_blue 0 19 9 2 2\r\nC219 bar_chair_blue 2 19 3 0 2\r\nG022 goldfish_bar 0 22 3 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('103', 'bar_a', '0', '5', '1', '7', '0', 'xxxx8888xxxxxxxxxxx\r\nxxxx7777xxxxxxxxxxx\r\nxxxx6666xxxxxxxxxxx\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555555555\r\nxxx6666666555xxxxxx\r\nxxx6666666555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555xxxxxx\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555555555\r\nxxx5555555555xxxxxx\r\nxxxx555555555555555\r\n55xx555555555555555\r\n55xx555555555555555\r\n5555555555555555555\r\n5555555555555555555\r\nxxxxxxxx55555xxxxxx\r\nxxxxxxxxx5555xxxxxx\r\nxxxxxxxxx5555xxxxxx\r\nxxxxxxxxx5555xxxxxx\r\nxxxxxxxxx4444xxxxxx\r\nxxxxxxxxx3333xxxxxx\r\n', 'a123 lounge_chair_small 12 3 5 2 2\r\nD133 lounge_table_one 13 3 5 0 1\r\na143 lounge_chair_small 14 3 5 6 2\r\na134 lounge_chair_small 13 4 5 0 2\r\na185 lounge_chair_small 18 5 5 4 2\r\na176 lounge_chair_small 17 6 5 2 2\r\nD186 lounge_table_one 18 6 5 0 1\r\na187 lounge_chair_small 18 7 5 0 2\r\nd1311 lounge_private_bigback 13 11 5 3 1\r\ne1411 lounge_private_bigsofaback 14 11 5 4 2\r\ne1511 lounge_private_bigsofaback 15 11 5 4 2\r\ne1611 lounge_private_bigsofaback 16 11 5 4 2\r\ne1711 lounge_private_bigsofaback 17 11 5 4 2 \r\nd1811 lounge_private_bigback 18 11 5 5 1\r\nb1812 lounge_private_bigsofa 18 12 5 6 2\r\nA1413 lounge_table_threea 14 13 5 0 1\r\nB1513 lounge_table_threeb 15 13 5 0 1\r\nC1613 lounge_table_threec 16 13 5 0 1\r\nb1813 lounge_private_bigsofa 18 13 5 6 2\r\nb1814 lounge_private_bigsofa 18 14 5 6 2\r\nc1315 lounge_private_bigcorner 13 15 5 1 1\r\nb1415 lounge_private_bigsofa 14 15 5 0 2\r\nb1515 lounge_private_bigsofa 15 15 5 0 2\r\nb1615 lounge_private_bigsofa 16 15 5 0 2\r\nb1715 lounge_private_bigsofa 17 15 5 0 2\r\nc1815 lounge_private_bigcorner 18 15 5 7 1\r\na316 lounge_chair_small 3 16 5 4 2\r\na816 lounge_chair_small 8 16 5 4 2\r\nD317 lounge_table_one 3 17 5 0 1\r\na417 lounge_chair_small 4 17 5 6 2\r\na717 lounge_chair_small 7 17 5 2 2\r\nD817 lounge_table_one 8 17 5 0 1\r\na917 lounge_chair_small 9 17 5 6 2\r\nc1317 lounge_private_bigcorner 13 17 5 3 1\r\nb1417 lounge_private_bigsofa 14 17 5 4 2\r\nb1517 lounge_private_bigsofa 15 17 5 4 2\r\nb1617 lounge_private_bigsofa 16 17 5 4 2\r\nb1717 lounge_private_bigsofa 17 17 5 4 2\r\nc1817 lounge_private_bigcorner 18 17 5 5 1\r\na318 lounge_chair_small 3 18 5 0 2\r\na818 lounge_chair_small 8 18 5 0 2\r\nb1818 lounge_private_bigsofa 18 18 5 6 2\r\nA1419 lounge_table_threea 14 19 5 0 1\r\nB1519 lounge_table_threeb 15 19 5 0 1\r\nC1619 lounge_table_threec 16 19 5 0 1\r\nb1819 lounge_private_bigsofa 18 19 5 6 2\r\nb1820 lounge_private_bigsofa 18 20 5 6 2\r\nc1321 lounge_private_bigcorner 13 21 5 1 1\r\nb1421 lounge_private_bigsofa 14 21 5 0 2\r\nb1521 lounge_private_bigsofa 15 21 5 0 2\r\nb1621 lounge_private_bigsofa 16 21 5 0 2\r\nb1721 lounge_private_bigsofa 17 21 5 0 2\r\nc1821 lounge_private_bigcorner 18 21 5 7 1\r\n1423 lounge_bara 4 23 5 6 1\r\n1523 lounge_bara 5 23 5 5 1\r\n1623 lounge_bara 6 23 5 4 1\r\n1723 lounge_bara 7 23 5 3 1\r\nc1323 lounge_private_bigcorner 13 23 5 3 1\r\nb1423 lounge_private_bigsofa 14 23 5 4 2\r\nb1523 lounge_private_bigsofa 15 23 5 4 2\r\nb1623 lounge_private_bigsofa 16 23 5 4 2\r\nb1723 lounge_private_bigsofa 17 23 5 4 2\r\nc1823 lounge_private_bigcorner 18 23 5 5 1\r\n1724 lounge_bara 7 24 5 2 1\r\nb1824 lounge_private_bigsofa 18 24 5 6 2\r\n1725 lounge_bara 7 25 5 2 1\r\nA1425 lounge_table_threea 14 25 5 0 1\r\nB1525 lounge_table_threeb 15 25 5 0 1\r\nC1625 lounge_table_threec 16 25 5 0 1\r\nb1825 lounge_private_bigsofa 18 25 5 6 2\r\n1726 lounge_bara 7 26 5 2 1\r\nb1826 lounge_private_bigsofa 18 26 5 6 2\r\n1727 lounge_bara 7 27 5 2 1\r\nc1327 lounge_private_bigcorner 13 27 5 1 1\r\nb1427 lounge_private_bigsofa 14 27 5 0 2\r\nb1527 lounge_private_bigsofa 15 27 5 0 2\r\nb1627 lounge_private_bigsofa 16 27 5 0 2\r\nb1727 lounge_private_bigsofa 17 27 5 0 2\r\nc1827 lounge_private_bigcorner 18 27 5 7 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('104', 'bar_b', '0', '2', '12', '4', '0', 'xxxxx4xxxxxxxxxxxx\r\nxxxx4444444xxxxxxx\r\nxxxx4444444xxxxxxx\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\n654444444444444444\r\n654444444444444444\r\n654444444444444444\r\n654444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxx444444444444444\r\nxxxx44444444444444\r\nxxxx33444444444444\r\nxxxx22444444444444\r\nxxxx2222222222xx44\r\nxxxx2222222222xx44\r\nxxxxx222222222xxxx\r\nxxxxxx22222222xxxx\r\nxxxxxx22222222xxxx\r\nxxxxxx22222222xxxx\r\nxxxxxx22222222xxxx\r\nxxxxxx22222222xxxx\r\nxxxxxx22222222xxxx\r\n', 'z42 stair 4 2 4 2 1\r\nz52 stair 5 2 4 2 1\r\nz62 stair 6 2 4 2 1\r\nz72 stair 7 2 4 2 1\r\nz82 stair 8 2 4 2 1\r\nz92 stair 9 2 4 2 1\r\nz102 stair 10 2 4 2 1\r\nz112 stair 11 2 100000 2 1\r\nf33 pub_pineapple_small 3 3 4 0 1\r\nj123 fatsblox 12 3 4 4 1\r\ng133 fatsofaa 13 3 4 4 2\r\ng143 fatsofaa 14 3 4 4 2\r\ng153 fatsofaa 15 3 4 4 2\r\ng163 fatsofaa 16 3 4 4 2\r\nj173 fatsblox 17 3 4 0 1\r\nj34 fatsblox 3 4 4 2 1\r\ng35 fatsofaa 3 5 4 2 2\r\ng36 fatsofaa 3 6 4 2 2\r\na86 lounge_chair_small 8 6 4 2 2\r\nD96 lounge_table_one 9 6 4 0 1\r\na106 lounge_chair_small 10 6 4 6 2\r\ng37 fatsofaa 3 7 4 2 2\r\na97 lounge_chair_small 9 7 4 0 2\r\ng38 fatsofaa 3 8 4 2 2\r\na158 lounge_chair_small 15 8 4 4 2\r\nj39 fatsblox 3 9 4 6 1\r\na149 lounge_chair_small 14 9 4 2 2\r\nD159 lounge_table_one 15 9 4 0 1\r\na1510 lounge_chair_small 15 10 4 0 2\r\na1011 lounge_chair_small 10 11 4 4 2\r\na912 lounge_chair_small 9 12 4 2 2\r\nD1012 lounge_table_one 10 12 4 0 1\r\na1112 lounge_chair_small 11 12 4 6 2\r\na1013 lounge_chair_small 10 13 4 0 2\r\na1514 lounge_chair_small 15 14 4 4 2\r\na1415 lounge_chair_small 14 15 4 2 2\r\nD1515 lounge_table_one 15 15 4 0 1\r\na816 lounge_chair_small 8 16 4 4 2\r\na1516 lounge_chair_small 15 16 4 0 2\r\nD817 lounge_table_one 8 17 4 0 1\r\na818 lounge_chair_small 8 18 4 0 2\r\nz419 stair 4 19 4 0 1\r\nz519 stair 5 19 4 0 1\r\na1219 lounge_chair_small 12 19 4 2 2\r\nD1319 lounge_table_one 13 19 4 0 1\r\na1419 lounge_chair_small 14 19 4 6 2\r\nz420 stair 4 20 3 0 1\r\nz520 stair 5 20 3 0 1\r\nz421 stair 4 21 2 0 1\r\nz521 stair 5 21 2 0 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('105', 'habburger', '0', '22', '10', '0', '0', '22222222222222222222xxx\r\n22222222222222222222xxx\r\n22222222222222222222xxx\r\n22222222222222222222xxx\r\nxxxxxxxxxxxxxxxx1111xxx\r\nxxxxxxxxxxxxxxxx0000xxx\r\nxxx00000000000000000xxx\r\n00000000000000000000xxx\r\n00000000000000000000xxx\r\n00000000000000000000000\r\n00000000000000000000000\r\n00000000000000000000xxx\r\n00000000000000000000xxx\r\n00000000000000000000xxx\r\nxxx00000000000000000xxx\r\n', 's00 sofa 0 0 2 2 2\r\nt10 table 1 0 2 4 1\r\ns20 sofa 2 0 2 6 2\r\ns60 sofa 6 0 2 2 2\r\nk70 tablesp 7 0 2 4 1\r\ns80 sofa 8 0 2 6 2\r\ns120 sofa 12 0 2 2 2\r\nt130 table 13 0 2 4 1\r\ns140 sofa 14 0 2 6 2\r\nc150 trashcan 15 0 2 0 1\r\nS01 sofa2 0 1 2 2 2\r\nT11 table2 1 1 2 4 1\r\nS21 sofa2 2 1 2 6 2\r\nS61 sofa2 6 1 2 2 2\r\nT71 table2 7 1 2 4 1\r\nS81 sofa2 8 1 2 6 2\r\nS121 sofa2 12 1 2 2 2\r\nT131 table2 13 1 2 4 1\r\nS141 sofa2 14 1 2 6 2\r\np27 bardesk3 2 7 0 0 1\r\ns77 sofa 7 7 0 4 2\r\nS87 sofa2 8 7 0 4 2\r\ns127 sofa 12 7 0 4 2\r\nS137 sofa2 13 7 0 4 2\r\nP28 bardesk4 2 8 0 0 1\r\nk78 tablesp 7 8 0 2 1\r\nT88 table2 8 8 0 2 1\r\nt128 table 12 8 0 2 1\r\nT138 table2 13 8 0 2 1\r\nd29 bardesk 2 9 0 0 1\r\ns79 sofa 7 9 0 0 2\r\nS89 sofa2 8 9 0 0 2\r\ns129 sofa 12 9 0 0 2\r\nS139 sofa2 13 9 0 0 2\r\nD210 bardesk2 2 10 0 0 1\r\nd211 bardesk 2 11 0 0 1\r\nd212 bardesk 2 12 0 0 1\r\ns712 sofa 7 12 0 4 2\r\nS812 sofa2 8 12 0 4 2\r\ns1212 sofa 12 12 0 4 2\r\nS1312 sofa2 13 12 0 4 2\r\nd213 bardesk 2 13 0 0 1\r\nt713 table 7 13 0 2 1\r\nT813 table2 8 13 0 2 1\r\nk1213 tablesp 12 13 0 2 1\r\nT1313 table2 13 13 0 2 1\r\ns714 sofa 7 14 0 0 2\r\nS814 sofa2 8 14 0 0 2\r\ns1214 sofa 12 14 0 0 2\r\nS1314 sofa2 13 14 0 0 2', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('106', 'pizza', '0', '5', '27', '1', '0', 'xxxxxxxxx0000000\r\nx11111x1xx000000\r\n11xxxxx111x00000\r\n11x1111111xx0000\r\n11x1111111100000\r\nxxx1111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n11111111111xxxxx\r\n1111111111xxxxxx\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n11xx11xx11111111\r\nxxxx11xxxxxxxxxx\r\nxxxx11xxxxxxxxxx\r\n', 'a150 pizza_plant1 15 0 0 2 1\r\ne143 pizza_sofa1 14 3 0 4 2\r\nE153 pizza_sofa2 15 3 0 4 2\r\nc155 pizza_table 15 5 0 2 1\r\nb06 pizza_plant2 0 6 1 2 1\r\nf146 pizza_sofa3 14 6 0 0 2\r\nF156 pizza_sofa4 15 6 0 0 2\r\nd18 pizza_chair 1 8 1 4 2\r\nd28 pizza_chair 2 8 1 4 2\r\nc210 pizza_table 2 10 1 2 1\r\ne1410 pizza_sofa1 14 10 0 4 2\r\nE1510 pizza_sofa2 15 10 0 4 2\r\nd111 pizza_chair 1 11 1 0 2\r\nd211 pizza_chair 2 11 1 0 2\r\nc1512 pizza_table 15 12 0 2 1\r\nf1413 pizza_sofa3 14 13 0 0 2\r\nF1513 pizza_sofa4 15 13 0 0 2\r\nd116 pizza_chair 1 16 1 4 2\r\nd216 pizza_chair 2 16 1 4 2\r\nc218 pizza_table 2 18 1 2 1\r\nd119 pizza_chair 1 19 1 0 2\r\nd219 pizza_chair 2 19 1 0 2\r\nd1121 pizza_chair 11 21 1 2 2\r\nd1421 pizza_chair 14 21 1 6 2\r\nd1122 pizza_chair 11 22 1 2 2\r\nc1322 pizza_table 13 22 1 0 1\r\nd1422 pizza_chair 14 22 1 6 2\r\na025 pizza_plant1 0 25 1 2 1\r\na1525 pizza_plant1 15 25 1 2 1', '0', '0', '1', '0', '0');
INSERT INTO room_modeldata VALUES ('107', 'bb_lobby_1', '0', '14', '19', '0', '0', 'xxx2222222222222222x\r\nxxx2222222222222222x\r\nxxx2222222222222222x\r\nxxx2222222222222222x\r\nxxx11111111111111111\r\n11x11111111111111111\r\n11x11111111111111111\r\n11x11111111111111111\r\nx1x11111111111111111\r\nxxx11111111111111111\r\nxxx11111111111111111\r\nxxx11111111111111111\r\nxxx11111111111111111\r\nxxx11111111111111111\r\nxxxxxxxxx00000000000\r\nxxxxxxxxx00000000000\r\nxxxxxxxxx00000000000\r\nxxxxxxxxx00000000000\r\nxxxxxxxxx00000000000\r\nxxxxxxxxx00000000000\r\nxxxxxxxxxxxxx000xxxx\r\nxxxxxxxxxxxxx000xxxx\r\nxxxxxxxxxxxxx000xxxx', 'n30 bb_crossrd 3 0 2 2 1\r\nb40 bb_bench1 4 0 2 4 2\r\nc50 bb_bench2 5 0 2 4 2\r\nh80 bb_plant1 8 0 2 0 1\r\nd90 bb_sofa1 9 0 2 4 2\r\ne100 bb_sofa2 10 0 2 4 2\r\nh110 bb_plant1 11 0 2 0 1\r\nd120 bb_sofa1 12 0 2 4 2\r\ne130 bb_sofa2 13 0 2 4 2\r\nh140 bb_plant1 14 0 2 0 1\r\nb160 bb_bench1 16 0 2 4 2\r\nc170 bb_bench2 17 0 2 4 2\r\nk180 bb_corner1out 18 0 2 0 1\r\nb31 bb_bench1 3 1 2 2 2\r\no181 bb_wallend1in 18 1 2 2 1\r\nc32 bb_bench2 3 2 2 2 2\r\no182 bb_wallend1in 18 2 2 2 1\r\nj33 bb_plant3 3 3 2 0 1\r\nt73 bb_special 7 3 2 6 1\r\no83 bb_wallend1in 8 3 2 6 1\r\no93 bb_wallend1in 9 3 2 6 1\r\no103 bb_wallend1in 10 3 2 6 1\r\no113 bb_wallend1in 11 3 2 6 1\r\nn123 bb_crossrd 12 3 2 2 1\r\nn163 bb_crossrd 16 3 2 0 1\r\no173 bb_wallend1in 17 3 2 6 1\r\nn183 bb_crossrd 18 3 2 2 1\r\np34 bb_wallend2in 3 4 1 4 1\r\no74 bb_wallend1in 7 4 1 4 1\r\nb84 bb_bench1 8 4 1 4 2\r\nc94 bb_bench2 9 4 1 4 2\r\nb104 bb_bench1 10 4 1 4 2\r\nc114 bb_bench2 11 4 1 4 2\r\np124 bb_wallend2in 12 4 1 4 1\r\no164 bb_wallend1in 16 4 1 4 1\r\nb174 bb_bench1 17 4 1 4 2\r\nc184 bb_bench2 18 4 1 4 2\r\nm194 bb_wallendout 19 4 1 4 1\r\na75 bb_stool 7 5 1 2 2\r\na125 bb_stool 12 5 1 6 2\r\nb195 bb_bench1 19 5 1 6 2\r\na36 bb_stool 3 6 1 6 2\r\nc196 bb_bench2 19 6 1 6 2\r\nf97 bb_chair 9 7 1 4 2\r\nf107 bb_chair 10 7 1 4 2\r\nb177 bb_bench1 17 7 1 0 2\r\nc187 bb_bench2 18 7 1 0 2\r\nm197 bb_wallendout 19 7 1 0 1\r\na38 bb_stool 3 8 1 6 2\r\nu178 bb_extra 17 8 1 4 1\r\nu188 bb_extra 18 8 1 2 1\r\nn198 bb_crossrd 19 8 1 6 1\r\na39 bb_stool 3 9 1 6 2\r\nf99 bb_chair 9 9 1 0 2\r\nf109 bb_chair 10 9 1 0 2\r\nb179 bb_bench1 17 9 1 4 2\r\nc189 bb_bench2 18 9 1 4 2\r\nm199 bb_wallendout 19 9 1 4 1\r\nb1910 bb_bench1 19 10 1 6 2\r\na711 bb_stool 7 11 1 2 2\r\na1211 bb_stool 12 11 1 6 2\r\nc1911 bb_bench2 19 11 1 6 2\r\no712 bb_wallend1in 7 12 1 0 1\r\nb812 bb_bench1 8 12 1 0 2\r\nc912 bb_bench2 9 12 1 0 2\r\nb1012 bb_bench1 10 12 1 0 2\r\nc1112 bb_bench2 11 12 1 0 2\r\np1212 bb_wallend2in 12 12 1 0 1\r\nb1712 bb_bench1 17 12 1 0 2\r\nc1812 bb_bench2 18 12 1 0 2\r\nm1912 bb_wallendout 19 12 1 0 1\r\nk713 bb_corner1out 7 13 1 4 1\r\nl813 bb_wallout 8 13 1 6 1\r\nl913 bb_wallout 9 13 1 6 1\r\nl1013 bb_wallout 10 13 1 6 1\r\nl1113 bb_wallout 11 13 1 6 1\r\nt1213 bb_special 12 13 1 2 1\r\nm1613 bb_wallendout 16 13 1 6 1\r\nl1713 bb_wallout 17 13 1 6 1\r\nl1813 bb_wallout 18 13 1 6 1\r\nk1913 bb_corner1out 19 13 1 2 1\r\ng914 bb_plant0 9 14 0 6 1\r\nd1014 bb_sofa1 10 14 0 4 2\r\ne1114 bb_sofa2 11 14 0 4 2\r\ni1214 bb_plant2 12 14 0 0 1\r\ni1614 bb_plant2 16 14 0 6 1\r\nd1714 bb_sofa1 17 14 0 4 2\r\ne1814 bb_sofa2 18 14 0 4 2\r\ng1914 bb_plant0 19 14 0 0 1\r\nd915 bb_sofa1 9 15 0 2 2\r\nd1915 bb_sofa1 19 15 0 6 2\r\ne916 bb_sofa2 9 16 0 2 2\r\ne1916 bb_sofa2 19 16 0 6 2\r\nd917 bb_sofa1 9 17 0 2 2\r\nd1917 bb_sofa1 19 17 0 6 2\r\ne918 bb_sofa2 9 18 0 2 2\r\ne1918 bb_sofa2 19 18 0 6 2\r\ng919 bb_plant0 9 19 0 4 1\r\nd1019 bb_sofa1 10 19 0 0 2\r\ne1119 bb_sofa2 11 19 0 0 2\r\nj1219 bb_plant3 12 19 0 2 1\r\nj1619 bb_plant3 16 19 0 4 1\r\nd1719 bb_sofa1 17 19 0 0 2\r\ne1819 bb_sofa2 18 19 0 0 2\r\ng1919 bb_plant0 19 19 0 2 1', '0', '', '0', '0', '0');
INSERT INTO room_modeldata VALUES ('108', 'snowwar_lobby_1', '0', '41', '36', '1', '0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx11111xx1xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx11111xx1111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx111111xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxx111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxx1111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxx111111111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxx1111x1111111111xxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'a3118 sw_barrellchair 31 18 1 6 2\r\na3119 sw_barrellchair 31 19 1 6 2\r\na3020 sw_barrellchair 30 20 1 0 2\r\na3720 sw_barrellchair 37 20 1 0 2\r\na3920 sw_barrellchair 39 20 1 0 2\r\na4120 sw_barrellchair 41 20 1 0 2\r\nd3024 sw_chair1 30 24 1 4 2\r\nc3124 sw_chair2 31 24 1 4 2\r\nc3224 sw_chair2 32 24 1 4 2\r\nc3324 sw_chair2 33 24 1 4 2\r\nb3424 sw_chair3 34 24 1 4 2\r\ni3025 sw_table1 30 25 1 0 1\r\nh3125 sw_table2 31 25 1 0 1\r\ng3225 sw_table3 32 25 1 0 1\r\nf3325 sw_table4 33 25 1 0 1\r\ne3425 sw_table5 34 25 1 0 1\r\nd3026 sw_chair1 30 26 1 0 2\r\nc3126 sw_chair2 31 26 1 0 2\r\nc3226 sw_chair2 32 26 1 0 2\r\nc3326 sw_chair2 33 26 1 0 2\r\nb3426 sw_chair3 34 26 1 0 2\r\nd3029 sw_chair1 30 29 1 4 2\r\nc3129 sw_chair2 31 29 1 4 2\r\nc3229 sw_chair2 32 29 1 4 2\r\nc3329 sw_chair2 33 29 1 4 2\r\nb3429 sw_chair3 34 29 1 4 2\r\ni3030 sw_table1 30 30 1 0 1\r\nh3130 sw_table2 31 30 1 0 1\r\ng3230 sw_table3 32 30 1 0 1\r\nf3330 sw_table4 33 30 1 0 1\r\ne3430 sw_table5 34 30 1 0 1\r\nd3031 sw_chair1 30 31 1 0 2\r\nc3131 sw_chair2 31 31 1 0 2\r\nc3231 sw_chair2 32 31 1 0 2\r\nc3331 sw_chair2 33 31 1 0 2\r\nb3431 sw_chair3 34 31 1 0 2\r\nx2732 invisichair 27 32 1 2 2\r\nx2733 invisichair 27 33 1 2 2\r\nx2734 invisichair 27 34 1 2 2\r\nx2836 invisichair 28 36 1 0 2\r\nx2936 invisichair 29 36 1 0 2\r\nx3036 invisichair 30 36 1 0 2\r\nx3136 invisichair 31 36 1 0 2', '0', '', '0', '0', '0');
INSERT INTO room_modeldata VALUES ('109', 'bb_arena_5', '0', '12', '12', '0', '0', 'xxxx000000000000000xxxx\rxxxx000000000000000xxxx\rxxxx000000000000000xxxx\rxxxx000000000000000xxxx\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\r00000000000000000000000\rxxxx000000000000000xxxx\rxxxx000000000000000xxxx\rxxxx000000000000000xxxx\rxxxx000000000000000xxxx\r', null, '0', '0', '0', '0', '0');

-- ----------------------------
-- Table structure for `room_modeldata_triggers`
-- ----------------------------
DROP TABLE IF EXISTS `room_modeldata_triggers`;
CREATE TABLE `room_modeldata_triggers` (
  `name` varchar(30) NOT NULL,
  `model` varchar(20) NOT NULL,
  `x` tinyint(2) NOT NULL,
  `y` tinyint(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of room_modeldata_triggers
-- ----------------------------
INSERT INTO room_modeldata_triggers VALUES ('curtains1', 'pool_a', '17', '11');
INSERT INTO room_modeldata_triggers VALUES ('curtains2', 'pool_a', '17', '9');

-- ----------------------------
-- Table structure for `vouchers`
-- ----------------------------
DROP TABLE IF EXISTS `vouchers`;
CREATE TABLE `vouchers` (
  `code` varchar(15) NOT NULL,
  `reward` int(7) NOT NULL,
  `onlyweb` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of vouchers
-- ----------------------------
